/******************************************************************************
ļ  : Drv_ADC.c
  : ѹ⣬¶ȴ
  :
޸  : 2014-09-26      

******************************************************************************/

#include "Drv_Adc.h"
#include "math.h"

typedef enum
{
  eAdcNum_Cc00 = 0,
  eAdcNum_Cc01,

  eAdcNum_CcEnd
}EnumCcAdcNum;

typedef enum
{
  eAdcNum_Temp00 = 0,
  eAdcNum_Temp01,
  eAdcNum_Temp02,
  eAdcNum_Temp03,

  eAdcNum_TempEnd
}EnumTempAdcNum;


#define CcAdcAverageSize (32)

#define TempAdcAverageSize (32)

static u16 CcAdcValueAlign[CcAdcAverageSize][eAdcNum_CcEnd];
static u16 CcAdcValue[eAdcNum_CcEnd];

static u16 TempAdcValueAlign[TempAdcAverageSize][eAdcNum_TempEnd];
static u16 TempAdcValue[eAdcNum_TempEnd];

/******************************************************************************
  : CcAdcInit
  : ѹ¶ AD ʼ
  : 
  : 
******************************************************************************/
static void CcAdcInit(void)
{
  GPIO_InitTypeDef       GPIO_InitStructure;
  DMA_InitTypeDef        DMA_InitStructure;
  ADC_InitTypeDef        ADC_InitStructure;
  ADC_CommonInitTypeDef  ADC_CommonInitStructure;

  /* Enable peripheral clocks *************************************************/
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Cc00_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Cc00_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cc00_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Cc01_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Cc01_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cc01_ADC_GPIO_PORT, &GPIO_InitStructure);

  /* DMA2 Stream0 channel0 configuration **************************************/
  Cc_ADC_DMA_CLK_INIT(Cc_ADC_DMA_CLK, ENABLE);
  DMA_InitStructure.DMA_Channel = Cc_ADC_DMA_CHANNEL;
  DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&Cc_ADC->DR;
  DMA_InitStructure.DMA_Memory0BaseAddr = (u32)&CcAdcValueAlign;
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralToMemory;
  DMA_InitStructure.DMA_BufferSize = sizeof(CcAdcValueAlign)/sizeof(CcAdcValueAlign[0][0]);
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_FIFOMode = DMA_FIFOMode_Disable;
  DMA_InitStructure.DMA_FIFOThreshold = DMA_FIFOThreshold_HalfFull;
  DMA_InitStructure.DMA_MemoryBurst = DMA_MemoryBurst_Single;
  DMA_InitStructure.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;
  DMA_Init(Cc_ADC_DMA_STREAM, &DMA_InitStructure);

  /* DMA2_Stream0 enable */
  DMA_Cmd(Cc_ADC_DMA_STREAM, ENABLE);

  Cc_ADC_CLK_INIT(Cc_ADC_CLK, ENABLE);
  /* ADC Common configuration *************************************************/
  ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
  ADC_CommonInitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_5Cycles;
  ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled;
  ADC_CommonInitStructure.ADC_Prescaler = ADC_Prescaler_Div4;
  ADC_CommonInit(&ADC_CommonInitStructure);

  /* ADC1 regular channel 12 configuration ************************************/
  ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;
  ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;
  ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_T4_CC4;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfConversion = eAdcNum_CcEnd;
  ADC_Init(Cc_ADC, &ADC_InitStructure);

  ADC_RegularChannelConfig(Cc_ADC, Cc00_ADC_CHANNEL, eAdcNum_Cc00+1, ADC_SampleTime_112Cycles);
  ADC_RegularChannelConfig(Cc_ADC, Cc01_ADC_CHANNEL, eAdcNum_Cc01+1, ADC_SampleTime_112Cycles);

  /* Enable DMA request after last transfer (Single-ADC mode) */
  ADC_DMARequestAfterLastTransferCmd(Cc_ADC, ENABLE);

  /* Enable ADC1 DMA */
  ADC_DMACmd(Cc_ADC, ENABLE);

  /* Enable ADC1 **************************************************************/
  ADC_Cmd(Cc_ADC, ENABLE);

  /* Start ADC1 Software Conversion */
  ADC_SoftwareStartConv(Cc_ADC);
}

/******************************************************************************
  : TempAdcInit
  : ѹ¶ AD ʼ
  : 
  : 
******************************************************************************/
static void TempAdcInit(void)
{
  GPIO_InitTypeDef       GPIO_InitStructure;
  DMA_InitTypeDef        DMA_InitStructure;
  ADC_InitTypeDef        ADC_InitStructure;
  ADC_CommonInitTypeDef  ADC_CommonInitStructure;

  /* Enable peripheral clocks *************************************************/
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Cc00_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Cc00_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cc00_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Cc01_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Cc01_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Cc01_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Temp00_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Temp00_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Temp00_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Temp01_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Temp01_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Temp01_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Temp02_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Temp02_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Temp02_ADC_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Temp03_ADC_PIN;
  RCC_AHB1PeriphClockCmd(Temp03_ADC_GPIO_CLK, ENABLE);
  GPIO_Init(Temp03_ADC_GPIO_PORT, &GPIO_InitStructure);

  /* DMA2 Stream0 channel0 configuration **************************************/
  Temp_ADC_DMA_CLK_INIT(Temp_ADC_DMA_CLK, ENABLE);
  DMA_InitStructure.DMA_Channel = Temp_ADC_DMA_CHANNEL;
  DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&Temp_ADC->DR;
  DMA_InitStructure.DMA_Memory0BaseAddr = (u32)&TempAdcValueAlign;
  DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralToMemory;
  DMA_InitStructure.DMA_BufferSize = sizeof(TempAdcValueAlign)/sizeof(TempAdcValueAlign[0][0]);
  DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStructure.DMA_Priority = DMA_Priority_High;
  DMA_InitStructure.DMA_FIFOMode = DMA_FIFOMode_Disable;
  DMA_InitStructure.DMA_FIFOThreshold = DMA_FIFOThreshold_HalfFull;
  DMA_InitStructure.DMA_MemoryBurst = DMA_MemoryBurst_Single;
  DMA_InitStructure.DMA_PeripheralBurst = DMA_PeripheralBurst_Single;
  DMA_Init(Temp_ADC_DMA_STREAM, &DMA_InitStructure);

  /* DMA2_Stream0 enable */
  DMA_Cmd(Temp_ADC_DMA_STREAM, ENABLE);

  Temp_ADC_CLK_INIT(Temp_ADC_CLK, ENABLE);
  /* ADC Common configuration *************************************************/
  ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;
  ADC_CommonInitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_5Cycles;
  ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled;
  ADC_CommonInitStructure.ADC_Prescaler = ADC_Prescaler_Div4;
  ADC_CommonInit(&ADC_CommonInitStructure);

  /* ADC1 regular channel 12 configuration ************************************/
  ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;
  ADC_InitStructure.ADC_ScanConvMode = ENABLE;
  ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;
  ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;
  ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_T4_CC4;
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStructure.ADC_NbrOfConversion = eAdcNum_TempEnd;
  ADC_Init(Temp_ADC, &ADC_InitStructure);

  ADC_RegularChannelConfig(Temp_ADC, Temp00_ADC_CHANNEL, eAdcNum_Temp00+1, ADC_SampleTime_84Cycles);
  ADC_RegularChannelConfig(Temp_ADC, Temp01_ADC_CHANNEL, eAdcNum_Temp01+1, ADC_SampleTime_84Cycles);
  ADC_RegularChannelConfig(Temp_ADC, Temp02_ADC_CHANNEL, eAdcNum_Temp02+1, ADC_SampleTime_84Cycles);
  ADC_RegularChannelConfig(Temp_ADC, Temp03_ADC_CHANNEL, eAdcNum_Temp03+1, ADC_SampleTime_84Cycles);

  /* Enable DMA request after last transfer (Single-ADC mode) */
   ADC_DMARequestAfterLastTransferCmd(Temp_ADC, ENABLE);

  /* Enable ADC1 DMA */
  ADC_DMACmd(Temp_ADC, ENABLE);

  /* Enable ADC1 **************************************************************/
  ADC_Cmd(Temp_ADC, ENABLE);

  /* Start ADC1 Software Conversion */
  ADC_SoftwareStartConv(Temp_ADC);
}

/******************************************************************************
  : TempAdcAverage
  : ѹ¶ AD ֵƽ˲
  : 
  : 
******************************************************************************/
static void AdcAverageHandle(void const *Param)
{
  u8 i, j;
  u32 AdcValue;

  for(i=0; i<(sizeof(CcAdcValue)/sizeof(CcAdcValue[0])); i++)
  {
    AdcValue = 0;
    for(j=0; j<(sizeof(CcAdcValueAlign)/sizeof(CcAdcValueAlign[0])); j++)
      AdcValue += CcAdcValueAlign[j][i];
    CcAdcValue[i] = AdcValue/(sizeof(CcAdcValueAlign)/sizeof(CcAdcValueAlign[0]));
  }

  for(i=0; i<(sizeof(TempAdcValue)/sizeof(TempAdcValue[0])); i++)
  {
    AdcValue = 0;
    for(j=0; j<(sizeof(TempAdcValueAlign)/sizeof(TempAdcValueAlign[0])); j++)
      AdcValue += TempAdcValueAlign[j][i];
    TempAdcValue[i] = AdcValue/(sizeof(TempAdcValueAlign)/sizeof(TempAdcValueAlign[0]));
  }
}

/******************************************************************************
  : AdcCheckInit
  : ADCʼ
  : 
  : 
******************************************************************************/
void AdcCheckInit(void)
{
  osTimerId AdcTimer;

  CcAdcInit();

  TempAdcInit();

  /* Create Touch screen Timer */
  osTimerDef(AdcTimer, AdcAverageHandle);
  AdcTimer = osTimerCreate(osTimer(AdcTimer), osTimerPeriodic, (void *)0);

  /* Start the TS Timer */
  osTimerStart(AdcTimer, 7);
}

EnumSwitchStatus CcStatusRead(void)
{
  if((CcAdcValue[eAdcNum_Cc00] < 1280) && (CcAdcValue[eAdcNum_Cc00] > 500))
    return eSwSta_On;
  else
    return eSwSta_Off;
}
EnumSwitchStatus CcStatusRead_B(void)
{
  if((CcAdcValue[eAdcNum_Cc01] < 1280) && (CcAdcValue[eAdcNum_Cc01] > 500))
    return eSwSta_On;
  else
    return eSwSta_Off;
}
EnumSwitchStatus CcStatusRead_AB(void)
{
  if((eSwSta_On == CcStatusRead()) && (eSwSta_On == CcStatusRead_B()))
    return eSwSta_On;
  else
    return eSwSta_Off;
}
/**********************************************************/
/*70϶     ֵ1263.75ŷ        AD 62                 */
/*80϶     ֵ1300.95ŷ        AD 64                 */
/*90϶     ֵ1338.02ŷ        AD 65.7                 */
/*100϶    ֵ1374.98ŷ        AD 67.5                 */
/*********************************************************
EnumSwitchStatus PosPlugTempOverSta(void)
{
  EnumSwitchStatus lastSta = eSwSta_Off;
  if((TempAdcValue[eAdcNum_Temp02] > 67) || ((TempAdcValue[eAdcNum_Temp02] > 65) && (eSwSta_On == lastSta))
    lastSta = eSwSta_On;
  else
    lastSta = eSwSta_Off;
  return lastSta;
}
EnumSwitchStatus NegPlugTempOverSta(void)
{
  EnumSwitchStatus lastSta = eSwSta_Off;
  if((TempAdcValue[eAdcNum_Temp03] > 67) || ((TempAdcValue[eAdcNum_Temp03] > 65) && (eSwSta_On == lastSta))
    lastSta = eSwSta_On;
  else
    lastSta = eSwSta_Off;
  return lastSta;
}
EnumSwitchStatus PlugTempOverSta(void)
{
  if((eSwSta_On == PosPlugTempOverSta()) || ((eSwSta_On == NegPlugTempOverSta()))
    return eSwSta_On;
  else
    return eSwSta_Off;
}
*/

/******************************************************************************
  :
  : NTC¶ȼ
  : 
  : 
******************************************************************************/

//const float Rp = 10000.0; //10K
const float T2 = (273.15+25.0);//T2
//const float Bx = 3470.0;//B
const float Ka = 273.15;

static s16 EnviTemp = -27300;
static s16 EnviTempN = -27300;
static s16 EnviTempB_P = -27300;
static s16 EnviTempB_N = -27300;




#if 0
u8 NtcRetToTemp(u32 NtcDVal,u16 NtcBVal)//ֵֶBֵ
{
  float Reg;

  if(TempAdcValue[eAdcNum_Temp00] > 4000)
  {
    return FALSE;
  }

  Reg = ((((float)(TempAdcValue[eAdcNum_Temp00])*82.0) / (4096 - TempAdcValue[eAdcNum_Temp00]) - 0.2) * 1000);

  EnviTemp =(s16)((1 / (log(Reg/NtcDVal)/NtcBVal + (1/T2)) - Ka) * 100);

  return TRUE;
}
#else
u8 PT1000RetToTemp(void)//¶Ȼȡ
{
  float Reg;

  if(TempAdcValue[eAdcNum_Temp02] > 2230)//200
  {
    EnviTemp = -27300;
    return FALSE;
  }


  Reg = ((((float)(TempAdcValue[eAdcNum_Temp02])*1.5) / (4096 - TempAdcValue[eAdcNum_Temp02]) - 0.017) * 1000);
  if(Reg >= 1000)
  EnviTemp = (s16)((Reg-1000)/3.862);
  else if((Reg > 800)&&(Reg < 1000))
  EnviTemp = (s16)(-(1000- Reg )/3.862);
  else
  {
   EnviTemp = -27300;
   return FALSE;
  }

  return TRUE;
}
u8 PT1000RetToTempN(void)//¶Ȼȡ
{
  float Reg;

  if(TempAdcValue[eAdcNum_Temp03] > 2230)//200
  {
     EnviTempN= -27300;
    return FALSE;
  }
  Reg = ((((float)(TempAdcValue[eAdcNum_Temp03])*1.5) / (4096 - TempAdcValue[eAdcNum_Temp03]) - 0.017) * 1000);
  if(Reg >= 1000)
  EnviTempN=(s16)((Reg-1000)/3.862);
  else if((Reg > 800)&&(Reg < 1000))
  EnviTempN= (s16)(-(1000- Reg )/3.862);
  else
  {
   EnviTempN = -27300;
   return FALSE;
  }

  return TRUE;
}
u8 PT1000RetToTempB_P(void)//¶Ȼȡ
{
  float Reg;

  if(TempAdcValue[eAdcNum_Temp00] > 2230)//200
  {
    EnviTempB_P = -27300;
    return FALSE;
  }


  Reg = ((((float)(TempAdcValue[eAdcNum_Temp00])*1.5) / (4096 - TempAdcValue[eAdcNum_Temp00]) - 0.017) * 1000);
  if(Reg >= 1000)
  EnviTempB_P= (s16)((Reg-1000)/3.862);
  else if((Reg > 800)&&(Reg < 1000))
  EnviTempB_P= (s16)(-(1000- Reg )/3.862);
  else
  {
   EnviTempB_P= -27300;
   return FALSE;
  }

  return TRUE;
}
u8 PT1000RetToTempB_N(void)//¶Ȼȡ
{
  float Reg;

 if(TempAdcValue[eAdcNum_Temp01] > 2230)//200
  {
    EnviTempB_N = -27300;
    return FALSE;
  }


  Reg = ((((float)(TempAdcValue[eAdcNum_Temp01])*1.5) / (4096 - TempAdcValue[eAdcNum_Temp01]) - 0.017) * 1000);

  if(Reg >= 1000)
  EnviTempB_N= (s16)((Reg-1000)/3.862);
  else if((Reg > 800)&&(Reg < 1000))
  EnviTempB_N= (s16)(-(1000- Reg )/3.862);
  else
  {
   EnviTempB_N = -27300;
   return FALSE;
  }
  return TRUE;
}

#endif
s16 Adc_GetNtcTemp(void)
{
  return EnviTemp;
}
s16 Adc_Get_a_PTemp(void)
{
  return EnviTemp ;
}
s16 Adc_Get_a_NTemp(void)
{
  return EnviTempN;
}
s16 Adc_Get_B_PTemp(void)
{
  return EnviTempB_P;
}
s16 Adc_Get_B_NTemp(void)
{
  return EnviTempB_N;
}



