
#include "Drv_BmsComm.h"

EnumChgVersion ChgVer = eChgVer_2011;
EnumChgVersion ChgVer_B = eChgVer_2011;

osMessageQId BmsMsg = 0;


StructBHM BhmMsg = {0};
StructBRM BrmMsg = {0};
StructBCP BcpMsg = {0};
StructBRO BroMsg = {0};
StructBCL BclMsg = {0};
StructBCS BcsMsg = {0};
StructBSM BsmMsg = {0};
StructBMV BmvMsg = {0};
StructBMT BmtMsg = {0};
StructBSP BspMsg = {0};
StructBST BstMsg = {0};
StructBSD BsdMsg = {0};
StructBEM BemMsg = {0};


StructCST CstMsg = {0};
StructCSD CsdMsg = {0};
StructCEM CemMsg = {0};



void BhmMsgMake(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BhmMsg.ImdMaxVolt = Temp;

  ChgVer = eChgVer_2015;
  BhmMsg.RecvTick = GetSystemTick();
  BhmMsg.Valid = 1;
}

void BrmMsgMake(u8 *pBuff, u16 Len)
{
  u8 i;
  u16 Temp;
  u32 u32Temp;

  BrmMsg.CommVer.L = *pBuff++;
  BrmMsg.CommVer.M = *pBuff++;
  BrmMsg.CommVer.H = *pBuff++;
  BrmMsg.BatType = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BrmMsg.BatRateCap = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BrmMsg.BatRateVolt = Temp;
  BrmMsg.Manufacturer[0] = *pBuff++;
  BrmMsg.Manufacturer[1] = *pBuff++;
  BrmMsg.Manufacturer[2] = *pBuff++;
  BrmMsg.Manufacturer[3] = *pBuff++;
  BrmMsg.ProduceNum[0] = *pBuff++;
  BrmMsg.ProduceNum[1] = *pBuff++;
  BrmMsg.ProduceNum[2] = *pBuff++;
  BrmMsg.ProduceNum[3] = *pBuff++;
  BrmMsg.ProduceYear = *pBuff++;
  BrmMsg.ProduceMon = *pBuff++;
  BrmMsg.ProduceDay = *pBuff++;
  u32Temp = *pBuff++;
  u32Temp |= ((u32)*pBuff++) << 8;
  u32Temp |= ((u32)*pBuff++) << 16;
  BrmMsg.ChgCount = u32Temp;
  BrmMsg.BatOwn = *pBuff++;
  BrmMsg.Reserve = *pBuff++;
  for(i=0; i<17; i++)
    BrmMsg.Vin[i] = *pBuff++;

  if(49 == Len)
  {
    for(i=0; i<8; i++)
      BrmMsg.BmsVer[i] = *pBuff++;
  }
  else
  {
    for(i=0; i<8; i++)
      BrmMsg.BmsVer[i] = 0xFF;
  }

  if(0 != BhmMsg.Valid)
    ChgVer = eChgVer_2015;
  else if((0x01 == BrmMsg.CommVer.L) && (0x01 == BrmMsg.CommVer.M) && (49 == Len))
    ChgVer = eChgVer_2015;
  else
    ChgVer = eChgVer_2011;
  BrmMsg.RecvTick = GetSystemTick();
  BrmMsg.Valid = 1;
}

void BcpMsgMake(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.PerBatMaxVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.ChgMaxCurrt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.BatEnergy = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.ChgMaxVolt = Temp;
  BcpMsg.MaxTemp = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.StartSoc = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg.StartVolt = Temp;

  BcpMsg.RecvTick = GetSystemTick();
  BcpMsg.Valid = 1;
}

void BroMsgMake(u8 *pBuff)
{
  BroMsg.Status = *pBuff++;

  BroMsg.RecvTick = GetSystemTick();
  BroMsg.Valid = 1;
}

void BclMsgMake(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BclMsg.NeedVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BclMsg.NeedCurrt = Temp;
  BclMsg.ChgType = *pBuff++;

  BclMsg.RecvTick = GetSystemTick();
  BclMsg.Valid = 1;
}

void BcsMsgMake(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg.ChgVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg.ChgCurrt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg.BatVoltAndGroup.Mult = Temp;
  BcsMsg.CurSoc = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg.RemainMin = Temp;

  BcsMsg.RecvTick = GetSystemTick();
  BcsMsg.Valid = 1;
}

void BsmMsgMake(u8 *pBuff)
{
  BsmMsg.HighTempBatNum = *pBuff++;
  BsmMsg.HighTemp = *pBuff++;
  BsmMsg.HighTempPointNum = *pBuff++;
  BsmMsg.LowTemp = *pBuff++;
  BsmMsg.LowTempPointNum = *pBuff++;
  BsmMsg.BatSta.Mult = *pBuff++;
  BsmMsg.ChgSta.Mult = *pBuff++;

  BsmMsg.RecvTick = GetSystemTick();
  BsmMsg.Valid = 1;
}

void BmvMsgMake(u8 *pBuff, u16 Len)
{
  u16 i;
  u16 Temp;

  if(Len > 512)
    Len = 512;

  for(i=0; i<(Len/2); i++)
  {
    Temp = *pBuff++;
    Temp |= ((u32)*pBuff++) << 8;
    BmvMsg.BatVoltAndGroup[i].Mult = Temp;
  }
  for( ; i<256; i++)
    BmvMsg.BatVoltAndGroup[i].Mult = 0xFFFF;

  BmvMsg.RecvTick = GetSystemTick();
  BmvMsg.Valid = 1;
}

void BmtMsgMake(u8 *pBuff, u16 Len)
{
  u16 i;

  if(Len > 128)
    Len = 128;

  for(i=0; i<Len; i++)
    BmtMsg.Temp[i] = *pBuff++;

  for( ; i<128; i++)
    BmtMsg.Temp[i] = 0xFF;

  BmtMsg.RecvTick = GetSystemTick();
  BmtMsg.Valid = 1;
}

void BspMsgMake(u8 *pBuff, u16 Len)
{
  u16 i;

  if(Len > 16)
    Len = 16;

  for(i=0; i<Len; i++)
    BspMsg.Bsp[i] = *pBuff++;

  for( ; i<16; i++)
    BspMsg.Bsp[i] = 0xFF;

  BspMsg.RecvTick = GetSystemTick();
  BspMsg.Valid = 1;
}

void BstMsgMake(u8 *pBuff)
{
  u16 Temp;

  BstMsg.StopReason.Mult = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BstMsg.StopTruble.Mult = Temp;
  BstMsg.StopFault.Mult = *pBuff++;

//  BstMsg.RecvTick = GetSystemTick();
  BstMsg.Valid = 1;
}

void BsdMsgMake(u8 *pBuff)
{
  u16 Temp;

  BsdMsg.StopSOC= *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BsdMsg.PerMinVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BsdMsg.PerMaxVolt = Temp;
  BsdMsg.MinTemp = *pBuff++;
  BsdMsg.MaxTemp = *pBuff++;

//  BsdMsg.RecvTick = GetSystemTick();
  BsdMsg.Valid = 1;
}

void BemMsgMake(u8 *pBuff)
{
  u32 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  Temp |= ((u32)*pBuff++) << 16;
  Temp |= ((u32)*pBuff++) << 24;
  BemMsg.Bem.Mult = Temp;

  BemMsg.Valid = 1;
}

StructTransProt TransProt = {0};

/**************************************************************************************************
** : CAN1_SendMessage
** 䡡: ulCanId----ID ulCanDataA----ݵĵ4ֽڣ  ulCanDataB----ݵĸ4ֽ
** 䡡: ȡ״̬
**   : ͨCANͨ
** ա: 2010/08/19
**************************************************************************************************/
u8 BmsCommSendMsg(StructChargeSend *pMsg)
{
  CanTxMsg TxMessage;
  u8 TransmitMailbox = 0;

  TxMessage.ExtId = pMsg->Id.Mult;// 趨չʶ
  TxMessage.IDE = CAN_ID_EXT;// 趨Ϣʶ
  TxMessage.RTR = CAN_RTR_DATA;// 趨Ϣ֡
  TxMessage.DLC = pMsg->Len; //趨Ϣ֡
  TxMessage.Data[0] = pMsg->Data[0];// ˴
  TxMessage.Data[1] = pMsg->Data[1];// ˴
  TxMessage.Data[2] = pMsg->Data[2];// ˴
  TxMessage.Data[3] = pMsg->Data[3];// ˴
  TxMessage.Data[4] = pMsg->Data[4];// ˴
  TxMessage.Data[5] = pMsg->Data[5];// ˴
  TxMessage.Data[6] = pMsg->Data[6];// ˴
  TxMessage.Data[7] = pMsg->Data[7];// ˴
  TransmitMailbox = CAN_Transmit(BmsComm_Can, &TxMessage);//ʼһϢĴ

  if(CAN_TxStatus_NoMailBox == TransmitMailbox)
    return FALSE;				//δͳɹFALSE

  return TRUE;
}

void NACK_Send(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = ACK>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x01;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[0];
  FrameSend.Data[6] = pFrameRecv->Data[1];
  FrameSend.Data[7] = pFrameRecv->Data[2];
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void TPCM_AbortSendBegin(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0xFF;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[5];
  FrameSend.Data[6] = pFrameRecv->Data[6];
  FrameSend.Data[7] = pFrameRecv->Data[7];
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void TPCM_Cts(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x11;
  FrameSend.Data[1] = pFrameRecv->Data[3];
  FrameSend.Data[2] = 0x01;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[5];
  FrameSend.Data[6] = pFrameRecv->Data[6];
  FrameSend.Data[7] = pFrameRecv->Data[7];
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void TPCM_AbortSending(StructTransProt *pTransProt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x13;
  FrameSend.Data[1] = pTransProt->RecvDataCnt;
  FrameSend.Data[2] =  pTransProt->RecvDataCnt>> 8;
  FrameSend.Data[3] = pTransProt->RecvFrameCnt;
  FrameSend.Data[4] = 0xFe;
  FrameSend.Data[5] = (u8)(pTransProt->Pgn>>0);
  FrameSend.Data[6] = (u8)(pTransProt->Pgn>>8);
  FrameSend.Data[7] = (u8)(pTransProt->Pgn>>16);
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}
void TPCM_EndOfMsgAck(StructTransProt *pTransProt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x13;
  FrameSend.Data[1] = pTransProt->RecvDataCnt;
  FrameSend.Data[2] = pTransProt->RecvDataCnt>> 8;
  FrameSend.Data[3] = pTransProt->RecvFrameCnt;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = (u8)(pTransProt->Pgn>>0);
  FrameSend.Data[6] = (u8)(pTransProt->Pgn>>8);
  FrameSend.Data[7] = (u8)(pTransProt->Pgn>>16);
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void CHM_Send(void)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CHM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x01;
  FrameSend.Data[1] = 0x01;
  FrameSend.Data[2] = 0x00;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 3;

  BmsCommSendMsg(&FrameSend);
}

void CRM_Send(u8 Recog)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CRM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Recog;//0x00,0xAA
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void CTS_Send(void)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CTS>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0xFF;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 7;

  BmsCommSendMsg(&FrameSend);
}

void CML_Send(u16 MaxVolt, u16 MinVolt, u16 MaxCurrt, u16 MinCurrt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CML>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = (u8)(MaxVolt);//ѹV
  FrameSend.Data[1] = (u8)((u32)MaxVolt>>8);//ݷֱʣ 0.1 V /λ0 VƫݷΧ0~+750 V
  FrameSend.Data[2] = (u8)(MinVolt);//ѹV
  FrameSend.Data[3] = (u8)((u32)MinVolt>>8);//ݷֱʣ 0.1 V /λ0 VƫݷΧ0~+750 V
  FrameSend.Data[4] = (u8)(MaxCurrt);//A
  FrameSend.Data[5] = (u8)((u32)(MaxCurrt)>>8);//ݷֱʣ0.1 A/λ-400 Aƫ
  FrameSend.Data[6] = (u8)(MinCurrt);////СA
  FrameSend.Data[7] = (u8)((u32)(MinCurrt)>>8);////ݷֱʣ0.1 A/λ-400 Aƫ
  if(eChgVer_2011 == ChgVer)
    FrameSend.Len = 6;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void CRO_Send(u8 Status)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 4;
  FrameSend.Id.Disp.PF = CRO>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Status;//0x00,0xAA
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 1;

  BmsCommSendMsg(&FrameSend);
}

void CCS_Send(u16 Volt, u16 Currt, u16 Min, u16 ChgEnable)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CCS>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Volt;//0x00,0xAA
  FrameSend.Data[1] = Volt>>8;
  FrameSend.Data[2] = Currt;
  FrameSend.Data[3] = Currt>>8;
  FrameSend.Data[4] = Min;
  FrameSend.Data[5] = Min>>8;;
  FrameSend.Data[6] = 0xFC | (0x03 & ChgEnable);
  FrameSend.Data[7] = 0xFF;

  if(eChgVer_2011 == ChgVer)
    FrameSend.Len = 6;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void CST_Send(StructCST *pCst)
{
  StructChargeSend FrameSend;
  StructCST TempCst;

  TempCst = *pCst;
  TempCst.StopTruble.Value.Reserve = 0x0F;
  TempCst.StopFault.Value.Reserve = 0x0F;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 4;
  FrameSend.Id.Disp.PF = CST>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = TempCst.StopReason.Mult;
  FrameSend.Data[1] = TempCst.StopTruble.Mult;
  FrameSend.Data[2] = TempCst.StopTruble.Mult>>8;
  FrameSend.Data[3] = TempCst.StopFault.Mult;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg(&FrameSend);
}

void CSD_Send(StructCSD *pCsd)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CSD>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = pCsd->ChgMin;
  FrameSend.Data[1] = pCsd->ChgMin>>8;
  FrameSend.Data[2] = pCsd->ChgEnergy;
  FrameSend.Data[3] = pCsd->ChgEnergy>>8;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  if(eChgVer_2011 == ChgVer)
    FrameSend.Len = 5;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg(&FrameSend);
}

void CEM_Send(StructCEM *pCem)
{
  StructChargeSend FrameSend;
  StructCEM TempCem;

  TempCem = *pCem;
  TempCem.Cem.Value.Reserve1 = 0x3F;
  TempCem.Cem.Value.Reserve2 = 0x0F;
  TempCem.Cem.Value.Reserve3 = 0x03;
  TempCem.Cem.Value.Other = 0x3F;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 2;
  FrameSend.Id.Disp.PF = CEM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = TempCem.Cem.Mult;
  FrameSend.Data[1] = TempCem.Cem.Mult>>8;
  FrameSend.Data[2] = TempCem.Cem.Mult>>16;
  FrameSend.Data[3] = TempCem.Cem.Mult>>24;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg(&FrameSend);
}

void DM1_Send(u32 Dtc)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = DM1>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Dtc;
  FrameSend.Data[1] = Dtc>>8;
  FrameSend.Data[2] = Dtc>>16;
  FrameSend.Data[3] = Dtc>>24;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg(&FrameSend);
}

void DM3_Send(u16 Num)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = DM3>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Num;
  FrameSend.Data[1] = Num>>8;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 2;

  BmsCommSendMsg(&FrameSend);
}

void BmsComm_Can_IRQHandler(void)
{
  CanRxMsg RxMessage;
  Union1939Id Id1939 = {.Mult = 0,};
  StructPgnRecv Frame;

  CAN_Receive(BmsComm_Can, CAN_FIFO0, &RxMessage);

  if((CAN_ID_STD == RxMessage.IDE) || (CAN_RTR_REMOTE == RxMessage.RTR))
    return;
  Id1939.Mult = RxMessage.ExtId;
  if(1 == Id1939.Disp.R)
    return;

  if(1 == Id1939.Disp.DP)
    return;
  if((Id1939.Disp.DA_PS != Charger1939Addr) || (Id1939.Disp.SA != Card1939Addr))
    return;

  if(Id1939.Disp.PF < 240)
  {
    Frame.DA = Id1939.Disp.DA_PS;

    Frame.Pgn = Id1939.Disp.PF << 8;
    if(Id1939.Disp.DP)
      Frame.Pgn += 0x010000;
  }
  else
  {
    Frame.DA = 0xFF;
    Frame.Pgn = (Id1939.Disp.PF << 8) + Id1939.Disp.DA_PS;
    if(Id1939.Disp.DP)
      Frame.Pgn += 0x010000;
  }

  switch(Frame.Pgn)
  {
    case BHM:
    //case BRM:

    //case BCP:
    case BRO:

    case BCL:
    //case BCS:
    case BSM:
    case BMV:
    case BMT:
    case BSP:
    case BST:

    case BSD:

    case BEM:

    //case DM1:
    //case DM2:
    //case DM3:
    //case DM4:
    //case DM5:
    //case DM6:

    case TPCM:
    case TPDT:
    case REQ:
      Frame.Prio = Id1939.Disp.Prio;
      Frame.DP = Id1939.Disp.DP;
      Frame.PF = Id1939.Disp.PF;
      Frame.SA = Id1939.Disp.SA;
      Frame.Len = RxMessage.DLC;
      if(Frame.Len > 8)
        Frame.Len = 8;
      Frame.Data[0] = RxMessage.Data[0];
      Frame.Data[1] = RxMessage.Data[1];
      Frame.Data[2] = RxMessage.Data[2];
      Frame.Data[3] = RxMessage.Data[3];
      Frame.Data[4] = RxMessage.Data[4];
      Frame.Data[5] = RxMessage.Data[5];
      Frame.Data[6] = RxMessage.Data[6];
      Frame.Data[7] = RxMessage.Data[7];

      //osMessagePut(BmsMsg, &Frame, 0);
      {
        portBASE_TYPE taskWoken = pdFALSE;
        if(pdTRUE == xQueueSendFromISR(BmsMsg, &Frame, &taskWoken))
          portEND_SWITCHING_ISR(taskWoken);
      }
      break;

    case ACK:
    default:
      break;
  }
}

s32 ChgPgnRecv(StructPgnRecv *pPgnRecv)
{
  u32 TP_Pgn = 0;
  s32 RetPgn = -1;

  if(pdTRUE != xQueueReceive(BmsMsg, pPgnRecv, 0))
    return RetPgn;

  switch(pPgnRecv->Pgn)
  {
    case BHM:
      BhmMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BRO:
      BroMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BCL:
      BclMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSM:
      BsmMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BMV:
      BmvMsgMake(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BMT:
      BmtMsgMake(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSP:
      BspMsgMake(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BST:
      BstMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSD:
      BsdMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BEM:
      BemMsgMake(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case REQ:
      NACK_Send(pPgnRecv);
      RetPgn = pPgnRecv->Pgn;
      break;
    case TPCM:
      switch(pPgnRecv->Data[0])
      {
        case 0x10:
          TP_Pgn = (pPgnRecv->Data[7]<<16) + (pPgnRecv->Data[6]<<8) + pPgnRecv->Data[5];
          switch(TP_Pgn)
          {
            case BRM:
            case BCP:
            case BCS:
            case BMV:
            case BMT:
            case BSP:
              TransProt.FrameDataLen = ((u32)pPgnRecv->Data[2]<<8) + pPgnRecv->Data[1];
              TransProt.FrameMaxNum = pPgnRecv->Data[3];
              TransProt.Pgn = TP_Pgn;
              TransProt.RecvFrameCnt = 0;
              TransProt.RecvDataCnt = 0;

              if((TransProt.FrameDataLen < 9)|| (TransProt.FrameDataLen > 1785))
              {
                TransProt.Flag = 0x00;
                TPCM_AbortSendBegin(pPgnRecv);
              }
              else if(0 == TransProt.FrameMaxNum)
              {
                TransProt.Flag = 0x00;
                TPCM_AbortSendBegin(pPgnRecv);
              }
              else if(TransProt.FrameDataLen > MaxDataSize1939)
              {
                TransProt.Flag = 0x00;
                TPCM_AbortSendBegin(pPgnRecv);
              }
              else
              {
                TransProt.Flag = 0x10;
                TPCM_Cts(pPgnRecv);
              }
              break;

            default:
              TPCM_AbortSendBegin(pPgnRecv);
              TransProt.Flag = 0x00;
              break;
          }
          break;
        case 0xFF:
          TP_Pgn = (pPgnRecv->Data[7]<<16) + (pPgnRecv->Data[6]<<8) + pPgnRecv->Data[5];
          if(TransProt.Pgn == TP_Pgn)
            TransProt.Flag = 0x00;
          break;
        default:
          break;
      }
      break;
    case TPDT:
     // if(0x10 == TransProt.Flag)//ִ
      {
         if(pPgnRecv->Data[0] == 1)
         {
		  TransProt.RecvFrameCnt = 0;
          TransProt.RecvDataCnt = 0;
		  
         }
        if((TransProt.RecvFrameCnt+1) == pPgnRecv->Data[0])
        {
          u8 i;

          for(i=1; i<8; i++)
          {
            TransProt.RecvBuff[TransProt.RecvDataCnt] = pPgnRecv->Data[i];
            TransProt.RecvDataCnt++;
            if(TransProt.RecvDataCnt >= TransProt.FrameDataLen)
              break;
          }
          TransProt.RecvFrameCnt++;

          if((TransProt.RecvFrameCnt >= TransProt.FrameMaxNum)
            || (TransProt.RecvDataCnt >= TransProt.FrameDataLen))
          {
            TransProt.Flag = 0x13;
            TPCM_EndOfMsgAck(&TransProt);

            switch(TransProt.Pgn)
            {
              case BRM:
                BrmMsgMake(TransProt.RecvBuff, TransProt.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BCP:
                BcpMsgMake(TransProt.RecvBuff);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BCS:
                BcsMsgMake(TransProt.RecvBuff);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BMV:
                BmvMsgMake(TransProt.RecvBuff, TransProt.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BMT:
                BmtMsgMake(TransProt.RecvBuff, TransProt.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BSP:
                BspMsgMake(TransProt.RecvBuff, TransProt.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              default:
                break;
            }
          }
        }
        else
        {
          TransProt.RecvFrameCnt =0;
          TransProt.Flag = 0x00;
          TPCM_AbortSending(&TransProt);
        }
      }
      break;
    default:
      break;
  }
  return RetPgn;
}


void BmsCanInit(void)
{
  CAN_InitTypeDef CAN_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  CAN_FilterInitTypeDef CAN_FilterInitStructure;
  RCC_ClocksTypeDef RCC_ClocksStatus;

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsComm_Can_TX_PIN;
  RCC_AHB1PeriphClockCmd(BmsComm_Can_TX_GPIO_CLK, ENABLE);
  GPIO_Init(BmsComm_Can_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsComm_Can_RX_PIN;
  RCC_AHB1PeriphClockCmd(BmsComm_Can_RX_GPIO_CLK, ENABLE);
  GPIO_Init(BmsComm_Can_RX_GPIO_PORT, &GPIO_InitStructure);

  /* CAN register init */
  //CAN_DeInit(BmsComm_Can);

  /* Enable Can clock */
  BmsComm_Can_CLK_INIT(BmsComm_Can_CLK, ENABLE);

  /* Connect CAN pins to AF9 */
  GPIO_PinAFConfig(BmsComm_Can_TX_GPIO_PORT, BmsComm_Can_TX_SOURCE, BmsComm_Can_TX_AF);
  GPIO_PinAFConfig(BmsComm_Can_RX_GPIO_PORT, BmsComm_Can_RX_SOURCE, BmsComm_Can_RX_AF);


  CAN_StructInit(&CAN_InitStructure);
  /* CAN cell init */
  CAN_InitStructure.CAN_TTCM = DISABLE;//ֹʱ䴥ͨģʽ
  CAN_InitStructure.CAN_ABOM = ENABLE;//CAN_MCR ĴINRQ λ1 0 һӲ
  //128 11 λλ˳״̬
  CAN_InitStructure.CAN_AWUM = DISABLE;//˯ģʽͨCAN_MCR ĴSLEEP λ
  CAN_InitStructure.CAN_NART = ENABLE;// CAN ֻ1 Σܷ͵ĽΣɹٲöʧ
  CAN_InitStructure.CAN_RFLM = DISABLE;//ڽʱFIFO δFIFO ıδһյıĻḲԭеı
  CAN_InitStructure.CAN_TXFP = DISABLE;//FIFO ȼɱĵıʶ

  CAN_InitStructure.CAN_Mode = CAN_Mode_Normal;//CAN_Mode_LoopBack;//CAN_Mode_Normal; //CAN Ӳģʽ
  CAN_InitStructure.CAN_SJW = CAN_SJW_1tq;//ͬԾ1 ʱ䵥λ
  CAN_InitStructure.CAN_BS1 = CAN_BS1_16tq;//ʱ1 Ϊ8 ʱ䵥λ
  CAN_InitStructure.CAN_BS2 = CAN_BS2_4tq;//ʱ2 Ϊ7 ʱ䵥λ

  /* Configure the USART Baud Rate */
  RCC_GetClocksFreq(&RCC_ClocksStatus);
  CAN_InitStructure.CAN_Prescaler = RCC_ClocksStatus.PCLK1_Frequency/((1+16+4)*BmsComm_BaudRate); //(pclk1/((1+8+7)*9)) = 36Mhz/16/9 = 250Kbits 趨һʱ䵥λĳ9
  CAN_Init(BmsComm_Can, &CAN_InitStructure);

  CAN_FilterInitStructure.CAN_FilterNumber = 0;//ָ˴ʼĹ0
  CAN_FilterInitStructure.CAN_FilterMode = CAN_FilterMode_IdMask;//ָ˹ʼģʽʶλģʽ
  CAN_FilterInitStructure.CAN_FilterScale = CAN_FilterScale_32bit;//˹λ1 32 λ
  CAN_FilterInitStructure.CAN_FilterIdHigh = 0x0000;//趨ʶ32 λλʱΪ߶λ16 λλʱΪһ
  CAN_FilterInitStructure.CAN_FilterIdLow = 0x0000;//趨ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterMaskIdHigh = 0x0000;//趨αʶ߹ʶ32 λλʱΪ߶λ16 λλʱΪһ)
  CAN_FilterInitStructure.CAN_FilterMaskIdLow = 0x0000;//趨αʶ߹ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterFIFOAssignment = CAN_FIFO0;//趨ָFIFO0
  CAN_FilterInitStructure.CAN_FilterActivation = ENABLE;//ʹܹ
  CAN_FilterInit(&CAN_FilterInitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = BmsComm_Can_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  CAN_ITConfig(BmsComm_Can, CAN_IT_FMP0, ENABLE);//ʹָCAN ж

}

u8 BmsCommInit(void)
{
  /* Create Storage Message Queue */
  BmsMsg = NULL;
  osMessageQDef(BmsMsg, 64, StructPgnRecv);
  BmsMsg = osMessageCreate(osMessageQ(BmsMsg), NULL);

  BmsCanInit();

  return TRUE;
}
/************************************************************************/
//                                                                      //
//                                                                      //
//                                                                      //
//                                                                      //
//                                                                      //
//                                                                      //
/************************************************************************/

osMessageQId BmsMsg_B = 0;


StructBHM BhmMsg_B = {0};
StructBRM BrmMsg_B = {0};
StructBCP BcpMsg_B = {0};
StructBRO BroMsg_B = {0};
StructBCL BclMsg_B = {0};
StructBCS BcsMsg_B = {0};
StructBSM BsmMsg_B = {0};
StructBMV BmvMsg_B = {0};
StructBMT BmtMsg_B = {0};
StructBSP BspMsg_B = {0};
StructBST BstMsg_B = {0};
StructBSD BsdMsg_B = {0};
StructBEM BemMsg_B = {0};


StructCST CstMsg_B = {0};
StructCSD CsdMsg_B = {0};
StructCEM CemMsg_B = {0};

void BhmMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BhmMsg_B.ImdMaxVolt = Temp;

  ChgVer_B= eChgVer_2015;
  BhmMsg_B.RecvTick = GetSystemTick();
  BhmMsg_B.Valid = 1;
}

void BrmMsgMake_B(u8 *pBuff, u16 Len)
{
  u8 i;
  u16 Temp;
  u32 u32Temp;

  BrmMsg_B.CommVer.L = *pBuff++;
  BrmMsg_B.CommVer.M = *pBuff++;
  BrmMsg_B.CommVer.H = *pBuff++;
  BrmMsg_B.BatType = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BrmMsg_B.BatRateCap = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BrmMsg_B.BatRateVolt = Temp;
  BrmMsg_B.Manufacturer[0] = *pBuff++;
  BrmMsg_B.Manufacturer[1] = *pBuff++;
  BrmMsg_B.Manufacturer[2] = *pBuff++;
  BrmMsg_B.Manufacturer[3] = *pBuff++;
  BrmMsg_B.ProduceNum[0] = *pBuff++;
  BrmMsg_B.ProduceNum[1] = *pBuff++;
  BrmMsg_B.ProduceNum[2] = *pBuff++;
  BrmMsg_B.ProduceNum[3] = *pBuff++;
  BrmMsg_B.ProduceYear = *pBuff++;
  BrmMsg_B.ProduceMon = *pBuff++;
  BrmMsg_B.ProduceDay = *pBuff++;
  u32Temp = *pBuff++;
  u32Temp |= ((u32)*pBuff++) << 8;
  u32Temp |= ((u32)*pBuff++) << 16;
  BrmMsg_B.ChgCount = u32Temp;
  BrmMsg_B.BatOwn = *pBuff++;
  BrmMsg_B.Reserve = *pBuff++;
  for(i=0; i<17; i++)
    BrmMsg_B.Vin[i] = *pBuff++;

  if(49 == Len)
  {
    for(i=0; i<8; i++)
      BrmMsg_B.BmsVer[i] = *pBuff++;
  }
  else
  {
    for(i=0; i<8; i++)
      BrmMsg_B.BmsVer[i] = 0xFF;
  }

  if(0 != BhmMsg_B.Valid)
    ChgVer_B= eChgVer_2015;
  else if((0x01 == BrmMsg_B.CommVer.L) && (0x01 == BrmMsg_B.CommVer.M) && (49 == Len))
    ChgVer_B = eChgVer_2015;
  else
    ChgVer_B = eChgVer_2011;
  BrmMsg_B.RecvTick = GetSystemTick();
  BrmMsg_B.Valid = 1;
}

void BcpMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.PerBatMaxVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.ChgMaxCurrt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.BatEnergy = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.ChgMaxVolt = Temp;
  BcpMsg_B.MaxTemp = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.StartSoc = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcpMsg_B.StartVolt = Temp;

  BcpMsg_B.RecvTick = GetSystemTick();
  BcpMsg_B.Valid = 1;
}

void BroMsgMake_B(u8 *pBuff)
{
  BroMsg_B.Status = *pBuff++;

  BroMsg_B.RecvTick = GetSystemTick();
  BroMsg_B.Valid = 1;
}

void BclMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BclMsg_B.NeedVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BclMsg_B.NeedCurrt = Temp;
  BclMsg_B.ChgType = *pBuff++;

  BclMsg_B.RecvTick = GetSystemTick();
  BclMsg_B.Valid = 1;
}

void BcsMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg_B.ChgVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg_B.ChgCurrt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg_B.BatVoltAndGroup.Mult = Temp;
  BcsMsg_B.CurSoc = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BcsMsg_B.RemainMin = Temp;

  BcsMsg_B.RecvTick = GetSystemTick();
  BcsMsg_B.Valid = 1;
}

void BsmMsgMake_B(u8 *pBuff)
{
  BsmMsg_B.HighTempBatNum = *pBuff++;
  BsmMsg_B.HighTemp = *pBuff++;
  BsmMsg_B.HighTempPointNum = *pBuff++;
  BsmMsg_B.LowTemp = *pBuff++;
  BsmMsg_B.LowTempPointNum = *pBuff++;
  BsmMsg_B.BatSta.Mult = *pBuff++;
  BsmMsg_B.ChgSta.Mult = *pBuff++;

  BsmMsg_B.RecvTick = GetSystemTick();
  BsmMsg_B.Valid = 1;
}

void BmvMsgMake_B(u8 *pBuff, u16 Len)
{
  u16 i;
  u16 Temp;

  if(Len > 512)
    Len = 512;

  for(i=0; i<(Len/2); i++)
  {
    Temp = *pBuff++;
    Temp |= ((u32)*pBuff++) << 8;
    BmvMsg_B.BatVoltAndGroup[i].Mult = Temp;
  }
  for( ; i<256; i++)
    BmvMsg_B.BatVoltAndGroup[i].Mult = 0xFFFF;

  BmvMsg_B.RecvTick = GetSystemTick();
  BmvMsg_B.Valid = 1;
}

void BmtMsgMake_B(u8 *pBuff, u16 Len)
{
  u16 i;

  if(Len > 128)
    Len = 128;

  for(i=0; i<Len; i++)
    BmtMsg_B.Temp[i] = *pBuff++;

  for( ; i<128; i++)
    BmtMsg_B.Temp[i] = 0xFF;

  BmtMsg_B.RecvTick = GetSystemTick();
  BmtMsg_B.Valid = 1;
}

void BspMsgMake_B(u8 *pBuff, u16 Len)
{
  u16 i;

  if(Len > 16)
    Len = 16;

  for(i=0; i<Len; i++)
    BspMsg_B.Bsp[i] = *pBuff++;

  for( ; i<16; i++)
    BspMsg_B.Bsp[i] = 0xFF;

  BspMsg_B.RecvTick = GetSystemTick();
  BspMsg_B.Valid = 1;
}

void BstMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  BstMsg_B.StopReason.Mult = *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BstMsg_B.StopTruble.Mult = Temp;
  BstMsg_B.StopFault.Mult = *pBuff++;

//  BstMsg.RecvTick = GetSystemTick();
  BstMsg_B.Valid = 1;
}

void BsdMsgMake_B(u8 *pBuff)
{
  u16 Temp;

  BsdMsg_B.StopSOC= *pBuff++;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BsdMsg_B.PerMinVolt = Temp;
  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  BsdMsg_B.PerMaxVolt = Temp;
  BsdMsg_B.MinTemp = *pBuff++;
  BsdMsg_B.MaxTemp = *pBuff++;

//  BsdMsg.RecvTick = GetSystemTick();
  BsdMsg_B.Valid = 1;
}

void BemMsgMake_B(u8 *pBuff)
{
  u32 Temp;

  Temp = *pBuff++;
  Temp |= ((u32)*pBuff++) << 8;
  Temp |= ((u32)*pBuff++) << 16;
  Temp |= ((u32)*pBuff++) << 24;
  BemMsg_B.Bem.Mult = Temp;

  BemMsg_B.Valid = 1;
}

StructTransProt TransProt_B = {0};

/**************************************************************************************************
** : CAN1_SendMessage
** 䡡: ulCanId----ID ulCanDataA----ݵĵ4ֽڣ  ulCanDataB----ݵĸ4ֽ
** 䡡: ȡ״̬
**   : ͨCANͨ
** ա: 2010/08/19
**************************************************************************************************/
u8 BmsCommSendMsg_B(StructChargeSend *pMsg)
{
  CanTxMsg TxMessage;
  u8 TransmitMailbox = 0;

  TxMessage.ExtId = pMsg->Id.Mult;// 趨չʶ
  TxMessage.IDE = CAN_ID_EXT;// 趨Ϣʶ
  TxMessage.RTR = CAN_RTR_DATA;// 趨Ϣ֡
  TxMessage.DLC = pMsg->Len; //趨Ϣ֡
  TxMessage.Data[0] = pMsg->Data[0];// ˴
  TxMessage.Data[1] = pMsg->Data[1];// ˴
  TxMessage.Data[2] = pMsg->Data[2];// ˴
  TxMessage.Data[3] = pMsg->Data[3];// ˴
  TxMessage.Data[4] = pMsg->Data[4];// ˴
  TxMessage.Data[5] = pMsg->Data[5];// ˴
  TxMessage.Data[6] = pMsg->Data[6];// ˴
  TxMessage.Data[7] = pMsg->Data[7];// ˴
  TransmitMailbox = CAN_Transmit(BmsComm_B_Can, &TxMessage);//ʼһϢĴ

  if(CAN_TxStatus_NoMailBox == TransmitMailbox)
    return FALSE;				//δͳɹFALSE

  return TRUE;
}

void NACK_Send_B(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = ACK>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x01;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[0];
  FrameSend.Data[6] = pFrameRecv->Data[1];
  FrameSend.Data[7] = pFrameRecv->Data[2];
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void TPCM_AbortSendBegin_B(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0xFF;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[5];
  FrameSend.Data[6] = pFrameRecv->Data[6];
  FrameSend.Data[7] = pFrameRecv->Data[7];
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void TPCM_Cts_B(StructPgnRecv *pFrameRecv)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x11;
  FrameSend.Data[1] = pFrameRecv->Data[3];
  FrameSend.Data[2] = 0x01;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = pFrameRecv->Data[5];
  FrameSend.Data[6] = pFrameRecv->Data[6];
  FrameSend.Data[7] = pFrameRecv->Data[7];
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void TPCM_AbortSending_B(StructTransProt *pTransProt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x13;
  FrameSend.Data[1] = pTransProt->RecvDataCnt;
  FrameSend.Data[2] =  pTransProt->RecvDataCnt>> 8;
  FrameSend.Data[3] = pTransProt->RecvFrameCnt;
  FrameSend.Data[4] = 0xFe;
  FrameSend.Data[5] = (u8)(pTransProt->Pgn>>0);
  FrameSend.Data[6] = (u8)(pTransProt->Pgn>>8);
  FrameSend.Data[7] = (u8)(pTransProt->Pgn>>16);
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}
void TPCM_EndOfMsgAck_B(StructTransProt *pTransProt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 7;
  FrameSend.Id.Disp.PF = TPCM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x13;
  FrameSend.Data[1] = pTransProt->RecvDataCnt;
  FrameSend.Data[2] = pTransProt->RecvDataCnt>> 8;
  FrameSend.Data[3] = pTransProt->RecvFrameCnt;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = (u8)(pTransProt->Pgn>>0);
  FrameSend.Data[6] = (u8)(pTransProt->Pgn>>8);
  FrameSend.Data[7] = (u8)(pTransProt->Pgn>>16);
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void CHM_Send_B(void)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CHM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0x01;
  FrameSend.Data[1] = 0x01;
  FrameSend.Data[2] = 0x00;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 3;

  BmsCommSendMsg_B(&FrameSend);
}

void CRM_Send_B(u8 Recog)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CRM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Recog;//0x00,0xAA
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void CTS_Send_B(void)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CTS>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = 0xFF;
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 7;

  BmsCommSendMsg_B(&FrameSend);
}

void CML_Send_B(u16 MaxVolt, u16 MinVolt, u16 MaxCurrt, u16 MinCurrt)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CML>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = (u8)(MaxVolt);//ѹV
  FrameSend.Data[1] = (u8)((u32)MaxVolt>>8);//ݷֱʣ 0.1 V /λ0 VƫݷΧ0~+750 V
  FrameSend.Data[2] = (u8)(MinVolt);//ѹV
  FrameSend.Data[3] = (u8)((u32)MinVolt>>8);//ݷֱʣ 0.1 V /λ0 VƫݷΧ0~+750 V
  FrameSend.Data[4] = (u8)(MaxCurrt);//A
  FrameSend.Data[5] = (u8)((u32)(MaxCurrt)>>8);//ݷֱʣ0.1 A/λ-400 Aƫ
  FrameSend.Data[6] = (u8)(MinCurrt);////СA
  FrameSend.Data[7] = (u8)((u32)(MinCurrt)>>8);////ݷֱʣ0.1 A/λ-400 Aƫ
  if(eChgVer_2011 == ChgVer_B)
    FrameSend.Len = 6;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void CRO_Send_B(u8 Status)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 4;
  FrameSend.Id.Disp.PF = CRO>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Status;//0x00,0xAA
  FrameSend.Data[1] = 0xFF;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 1;

  BmsCommSendMsg_B(&FrameSend);
}

void CCS_Send_B(u16 Volt, u16 Currt, u16 Min, u16 ChgEnable)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CCS>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Volt;//0x00,0xAA
  FrameSend.Data[1] = Volt>>8;
  FrameSend.Data[2] = Currt;
  FrameSend.Data[3] = Currt>>8;
  FrameSend.Data[4] = Min;
  FrameSend.Data[5] = Min>>8;;
  FrameSend.Data[6] = 0xFC | (0x03 & ChgEnable);
  FrameSend.Data[7] = 0xFF;

  if(eChgVer_2011 == ChgVer_B)
    FrameSend.Len = 6;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void CST_Send_B(StructCST *pCst)
{
  StructChargeSend FrameSend;
  StructCST TempCst;

  TempCst = *pCst;
  TempCst.StopTruble.Value.Reserve = 0x0F;
  TempCst.StopFault.Value.Reserve = 0x0F;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 4;
  FrameSend.Id.Disp.PF = CST>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = TempCst.StopReason.Mult;
  FrameSend.Data[1] = TempCst.StopTruble.Mult;
  FrameSend.Data[2] = TempCst.StopTruble.Mult>>8;
  FrameSend.Data[3] = TempCst.StopFault.Mult;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg_B(&FrameSend);
}

void CSD_Send_B(StructCSD *pCsd)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = CSD>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = pCsd->ChgMin;
  FrameSend.Data[1] = pCsd->ChgMin>>8;
  FrameSend.Data[2] = pCsd->ChgEnergy;
  FrameSend.Data[3] = pCsd->ChgEnergy>>8;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  if(eChgVer_2011 == ChgVer_B)
    FrameSend.Len = 5;
  else
    FrameSend.Len = 8;

  BmsCommSendMsg_B(&FrameSend);
}

void CEM_Send_B(StructCEM *pCem)
{
  StructChargeSend FrameSend;
  StructCEM TempCem;

  TempCem = *pCem;
  TempCem.Cem.Value.Reserve1 = 0x3F;
  TempCem.Cem.Value.Reserve2 = 0x0F;
  TempCem.Cem.Value.Reserve3 = 0x03;
  TempCem.Cem.Value.Other = 0x3F;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 2;
  FrameSend.Id.Disp.PF = CEM>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = TempCem.Cem.Mult;
  FrameSend.Data[1] = TempCem.Cem.Mult>>8;
  FrameSend.Data[2] = TempCem.Cem.Mult>>16;
  FrameSend.Data[3] = TempCem.Cem.Mult>>24;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg_B(&FrameSend);
}

void DM1_Send_B(u32 Dtc)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = DM1>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Dtc;
  FrameSend.Data[1] = Dtc>>8;
  FrameSend.Data[2] = Dtc>>16;
  FrameSend.Data[3] = Dtc>>24;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 4;

  BmsCommSendMsg_B(&FrameSend);
}

void DM3_Send_B(u16 Num)
{
  StructChargeSend FrameSend;

  FrameSend.Id.Mult = 0;
  FrameSend.Id.Disp.Prio = 6;
  FrameSend.Id.Disp.PF = DM3>>8;
  FrameSend.Id.Disp.DA_PS = Card1939Addr;
  FrameSend.Id.Disp.SA = Charger1939Addr;
  FrameSend.Data[0] = Num;
  FrameSend.Data[1] = Num>>8;
  FrameSend.Data[2] = 0xFF;
  FrameSend.Data[3] = 0xFF;
  FrameSend.Data[4] = 0xFF;
  FrameSend.Data[5] = 0xFF;
  FrameSend.Data[6] = 0xFF;
  FrameSend.Data[7] = 0xFF;
  FrameSend.Len = 2;

  BmsCommSendMsg_B(&FrameSend);
}

void BmsComm_B_Can_IRQHandler(void)
{
  CanRxMsg RxMessage;
  Union1939Id Id1939 = {.Mult = 0,};
  StructPgnRecv Frame;

  CAN_Receive(BmsComm_B_Can, CAN_FIFO0, &RxMessage);

  if((CAN_ID_STD == RxMessage.IDE) || (CAN_RTR_REMOTE == RxMessage.RTR))
    return;
  Id1939.Mult = RxMessage.ExtId;
  if(1 == Id1939.Disp.R)
    return;

  if(1 == Id1939.Disp.DP)
    return;
  if((Id1939.Disp.DA_PS != Charger1939Addr) || (Id1939.Disp.SA != Card1939Addr))
    return;

  if(Id1939.Disp.PF < 240)
  {
    Frame.DA = Id1939.Disp.DA_PS;

    Frame.Pgn = Id1939.Disp.PF << 8;
    if(Id1939.Disp.DP)
      Frame.Pgn += 0x010000;
  }
  else
  {
    Frame.DA = 0xFF;
    Frame.Pgn = (Id1939.Disp.PF << 8) + Id1939.Disp.DA_PS;
    if(Id1939.Disp.DP)
      Frame.Pgn += 0x010000;
  }

  switch(Frame.Pgn)
  {
    case BHM:
    //case BRM:

    //case BCP:
    case BRO:

    case BCL:
    //case BCS:
    case BSM:
    case BMV:
    case BMT:
    case BSP:
    case BST:

    case BSD:

    case BEM:

    //case DM1:
    //case DM2:
    //case DM3:
    //case DM4:
    //case DM5:
    //case DM6:

    case TPCM:
    case TPDT:
    case REQ:
      Frame.Prio = Id1939.Disp.Prio;
      Frame.DP = Id1939.Disp.DP;
      Frame.PF = Id1939.Disp.PF;
      Frame.SA = Id1939.Disp.SA;
      Frame.Len = RxMessage.DLC;
      if(Frame.Len > 8)
        Frame.Len = 8;
      Frame.Data[0] = RxMessage.Data[0];
      Frame.Data[1] = RxMessage.Data[1];
      Frame.Data[2] = RxMessage.Data[2];
      Frame.Data[3] = RxMessage.Data[3];
      Frame.Data[4] = RxMessage.Data[4];
      Frame.Data[5] = RxMessage.Data[5];
      Frame.Data[6] = RxMessage.Data[6];
      Frame.Data[7] = RxMessage.Data[7];

      //osMessagePut(BmsMsg, &Frame, 0);
      {
        portBASE_TYPE taskWoken = pdFALSE;
        if(pdTRUE == xQueueSendFromISR(BmsMsg_B, &Frame, &taskWoken))
          portEND_SWITCHING_ISR(taskWoken);
      }
      break;

    case ACK:
    default:
      break;
  }
}

s32 ChgPgnRecv_B(StructPgnRecv *pPgnRecv)
{
  u32 TP_Pgn = 0;
  s32 RetPgn = -1;

  if(pdTRUE != xQueueReceive(BmsMsg_B, pPgnRecv, 0))
    return RetPgn;

  switch(pPgnRecv->Pgn)
  {
    case BHM:
      BhmMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BRO:
      BroMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BCL:
      BclMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSM:
      BsmMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BMV:
      BmvMsgMake_B(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BMT:
      BmtMsgMake_B(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSP:
      BspMsgMake_B(pPgnRecv->Data, pPgnRecv->Len);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BST:
      BstMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BSD:
      BsdMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case BEM:
      BemMsgMake_B(pPgnRecv->Data);
      RetPgn = pPgnRecv->Pgn;
      break;
    case REQ:
      NACK_Send_B(pPgnRecv);
      RetPgn = pPgnRecv->Pgn;
      break;
    case TPCM:
      switch(pPgnRecv->Data[0])
      {
        case 0x10:
          TP_Pgn = (pPgnRecv->Data[7]<<16) + (pPgnRecv->Data[6]<<8) + pPgnRecv->Data[5];
          switch(TP_Pgn)
          {
            case BRM:
            case BCP:
            case BCS:
            case BMV:
            case BMT:
            case BSP:
              TransProt_B.FrameDataLen = ((u32)pPgnRecv->Data[2]<<8) + pPgnRecv->Data[1];
              TransProt_B.FrameMaxNum = pPgnRecv->Data[3];
              TransProt_B.Pgn = TP_Pgn;
              TransProt_B.RecvFrameCnt = 0;
              TransProt_B.RecvDataCnt = 0;

              if((TransProt_B.FrameDataLen < 9)|| (TransProt_B.FrameDataLen > 1785))
              {
                TransProt_B.Flag = 0x00;
                TPCM_AbortSendBegin_B(pPgnRecv);
              }
              else if(0 == TransProt_B.FrameMaxNum)
              {
                TransProt_B.Flag = 0x00;
                TPCM_AbortSendBegin_B(pPgnRecv);
              }
              else if(TransProt_B.FrameDataLen > MaxDataSize1939)
              {
                TransProt_B.Flag = 0x00;
                TPCM_AbortSendBegin_B(pPgnRecv);
              }
              else
              {
                TransProt_B.Flag = 0x10;
                TPCM_Cts_B(pPgnRecv);
              }
              break;

            default:
              TPCM_AbortSendBegin_B(pPgnRecv);
              TransProt_B.Flag = 0x00;
              break;
          }
          break;
        case 0xFF:
          TP_Pgn = (pPgnRecv->Data[7]<<16) + (pPgnRecv->Data[6]<<8) + pPgnRecv->Data[5];
          if(TransProt_B.Pgn == TP_Pgn)
            TransProt_B.Flag = 0x00;
          break;
        default:
          break;
      }
      break;
    case TPDT:
     // if(0x10 == TransProt_B.Flag)
      {
         if(pPgnRecv->Data[0] == 1)
         {
		  TransProt_B.RecvFrameCnt = 0;
          TransProt_B.RecvDataCnt = 0;
         }
        if((TransProt_B.RecvFrameCnt+1) == pPgnRecv->Data[0])
        {
          u8 i;

          for(i=1; i<8; i++)
          {
            TransProt_B.RecvBuff[TransProt_B.RecvDataCnt] = pPgnRecv->Data[i];
            TransProt_B.RecvDataCnt++;
            if(TransProt_B.RecvDataCnt >= TransProt_B.FrameDataLen)
              break;
          }
          TransProt_B.RecvFrameCnt++;

          if((TransProt_B.RecvFrameCnt >= TransProt_B.FrameMaxNum)
            || (TransProt_B.RecvDataCnt >= TransProt_B.FrameDataLen))
          {
            TransProt_B.Flag = 0x13;
            TPCM_EndOfMsgAck_B(&TransProt_B);

            switch(TransProt_B.Pgn)
            {
              case BRM:
                BrmMsgMake_B(TransProt_B.RecvBuff, TransProt_B.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BCP:
                BcpMsgMake_B(TransProt_B.RecvBuff);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BCS:
                BcsMsgMake_B(TransProt_B.RecvBuff);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BMV:
                BmvMsgMake_B(TransProt_B.RecvBuff, TransProt_B.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BMT:
                BmtMsgMake_B(TransProt_B.RecvBuff, TransProt_B.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              case BSP:
                BspMsgMake_B(TransProt_B.RecvBuff, TransProt_B.FrameDataLen);
                RetPgn = pPgnRecv->Pgn;
                break;
              default:
                break;
            }
          }
        }
        else
        {
          TransProt_B.Flag = 0x00;
		  TransProt_B.RecvFrameCnt = 0;
          TransProt_B.RecvDataCnt = 0;
          TPCM_AbortSending_B(&TransProt_B);
        }
      }
      break;
    default:
      break;
  }
  return RetPgn;
}


void BmsCanInit_B(void)
{
  CAN_InitTypeDef CAN_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;
  CAN_FilterInitTypeDef CAN_FilterInitStructure;
  RCC_ClocksTypeDef RCC_ClocksStatus;

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsComm_B_Can_TX_PIN;
  RCC_AHB1PeriphClockCmd(BmsComm_B_Can_TX_GPIO_CLK, ENABLE);
  GPIO_Init(BmsComm_B_Can_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsComm_B_Can_RX_PIN;
  RCC_AHB1PeriphClockCmd(BmsComm_B_Can_RX_GPIO_CLK, ENABLE);
  GPIO_Init(BmsComm_B_Can_RX_GPIO_PORT, &GPIO_InitStructure);

  /* CAN register init */
  //CAN_DeInit(BmsComm_B_Can);

  /* Enable Can clock */
  BmsComm_B_Can_CLK_INIT(BmsComm_B_Can_CLK, ENABLE);

  /* Connect CAN pins to AF9 */
  GPIO_PinAFConfig(BmsComm_B_Can_TX_GPIO_PORT, BmsComm_B_Can_TX_SOURCE, BmsComm_B_Can_TX_AF);
  GPIO_PinAFConfig(BmsComm_B_Can_RX_GPIO_PORT, BmsComm_B_Can_RX_SOURCE, BmsComm_B_Can_RX_AF);


  CAN_StructInit(&CAN_InitStructure);
  /* CAN cell init */
  CAN_InitStructure.CAN_TTCM = DISABLE;//ֹʱ䴥ͨģʽ
  CAN_InitStructure.CAN_ABOM = ENABLE;//CAN_MCR ĴINRQ λ1 0 һӲ
  //128 11 λλ˳״̬
  CAN_InitStructure.CAN_AWUM = DISABLE;//˯ģʽͨCAN_MCR ĴSLEEP λ
  CAN_InitStructure.CAN_NART = ENABLE;//CAN ֻ1 Σܷ͵ĽΣɹٲöʧ
  CAN_InitStructure.CAN_RFLM = DISABLE;//ڽʱFIFO δFIFO ıδһյıĻḲԭеı
  CAN_InitStructure.CAN_TXFP = DISABLE;//FIFO ȼɱĵıʶ

  CAN_InitStructure.CAN_Mode = CAN_Mode_Normal;//CAN_Mode_LoopBack;//CAN_Mode_Normal; //CAN Ӳģʽ
  CAN_InitStructure.CAN_SJW = CAN_SJW_1tq;//ͬԾ1 ʱ䵥λ
  CAN_InitStructure.CAN_BS1 = CAN_BS1_16tq;//ʱ1 Ϊ8 ʱ䵥λ
  CAN_InitStructure.CAN_BS2 = CAN_BS2_4tq;//ʱ2 Ϊ7 ʱ䵥λ

  /* Configure the USART Baud Rate */
  RCC_GetClocksFreq(&RCC_ClocksStatus);
  CAN_InitStructure.CAN_Prescaler = RCC_ClocksStatus.PCLK1_Frequency/((1+16+4)*BmsComm_BaudRate); //(pclk1/((1+8+7)*9)) = 36Mhz/16/9 = 250Kbits 趨һʱ䵥λĳ9
  CAN_Init(BmsComm_B_Can, &CAN_InitStructure);

  CAN_FilterInitStructure.CAN_FilterNumber = 14;//ָ˴ʼĹ0
  CAN_FilterInitStructure.CAN_FilterMode = CAN_FilterMode_IdMask;//ָ˹ʼģʽʶλģʽ
  CAN_FilterInitStructure.CAN_FilterScale = CAN_FilterScale_32bit;//˹λ1 32 λ
  CAN_FilterInitStructure.CAN_FilterIdHigh = 0x0000;//趨ʶ32 λλʱΪ߶λ16 λλʱΪһ
  CAN_FilterInitStructure.CAN_FilterIdLow = 0x0000;//趨ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterMaskIdHigh = 0x0000;//趨αʶ߹ʶ32 λλʱΪ߶λ16 λλʱΪһ)
  CAN_FilterInitStructure.CAN_FilterMaskIdLow = 0x0000;//趨αʶ߹ʶ32 λλʱΪͶλ16 λλʱΪڶ
  CAN_FilterInitStructure.CAN_FilterFIFOAssignment = CAN_FIFO0;//趨ָFIFO0
  CAN_FilterInitStructure.CAN_FilterActivation = ENABLE;//ʹܹ
  CAN_FilterInit(&CAN_FilterInitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = BmsComm_B_Can_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  CAN_ITConfig(BmsComm_B_Can, CAN_IT_FMP0, ENABLE);//ʹָCAN ж

}

u8 BmsCommInit_B(void)
{
  /* Create Storage Message Queue */
  BmsMsg_B = NULL;
  osMessageQDef(BmsMsg_B, 64, StructPgnRecv);
  BmsMsg_B = osMessageCreate(osMessageQ(BmsMsg_B), NULL);

  BmsCanInit_B();

  return TRUE;
}


