
#ifndef __DRV_BMSCOMM_H__
#define __DRV_BMSCOMM_H__

#include "Global.h"

#define BmsComm_BaudRate              (250000)

#define BmsComm_Can                   CAN1
#define BmsComm_Can_CLK               RCC_APB1Periph_CAN1
#define BmsComm_Can_CLK_INIT          RCC_APB1PeriphClockCmd
#define BmsComm_Can_IRQn              CAN1_RX0_IRQn
#define BmsComm_Can_IRQHandler        CAN1_RX0_IRQHandler

#define BmsComm_Can_TX_PIN                    GPIO_Pin_1
#define BmsComm_Can_TX_GPIO_PORT              GPIOD
#define BmsComm_Can_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define BmsComm_Can_TX_SOURCE                 GPIO_PinSource1
#define BmsComm_Can_TX_AF                     GPIO_AF_CAN1

#define BmsComm_Can_RX_PIN                    GPIO_Pin_0
#define BmsComm_Can_RX_GPIO_PORT              GPIOD
#define BmsComm_Can_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define BmsComm_Can_RX_SOURCE                 GPIO_PinSource0
#define BmsComm_Can_RX_AF                     GPIO_AF_CAN1

#define BmsComm_B_Can                   CAN2
#define BmsComm_B_Can_CLK               RCC_APB1Periph_CAN2
#define BmsComm_B_Can_CLK_INIT          RCC_APB1PeriphClockCmd
#define BmsComm_B_Can_IRQn              CAN2_RX0_IRQn
#define BmsComm_B_Can_IRQHandler        CAN2_RX0_IRQHandler

#define BmsComm_B_Can_TX_PIN                    GPIO_Pin_13
#define BmsComm_B_Can_TX_GPIO_PORT              GPIOB
#define BmsComm_B_Can_TX_GPIO_CLK               RCC_AHB1Periph_GPIOB
#define BmsComm_B_Can_TX_SOURCE                 GPIO_PinSource13
#define BmsComm_B_Can_TX_AF                     GPIO_AF_CAN2

#define BmsComm_B_Can_RX_PIN                    GPIO_Pin_12
#define BmsComm_B_Can_RX_GPIO_PORT              GPIOB
#define BmsComm_B_Can_RX_GPIO_CLK               RCC_AHB1Periph_GPIOB
#define BmsComm_B_Can_RX_SOURCE                 GPIO_PinSource12
#define BmsComm_B_Can_RX_AF                     GPIO_AF_CAN2


/*
ı 		PGN	PGNHex	Ȩ	ݳbyte		Դַ-Ŀĵַ
CHM		9728	002600H	6	3	250ms	-BMS
BHM		9984	002700H	6	2	250ms	BMS-
CRM	ʶ	256	000100H	6	8	250ms	-BMS
BRM	BMSͳʶ	512	000200H	7	41	250ms	BMS-

BCP	س	1536	000600H	7	13	500ms	BMS-
CTS	ʱͬϢ	1792	000700H	6	7	500ms	-BMS
CML		2048	000800H	6	8	250ms	-BMS
BRO	س׼״̬	2304	000900H	4	1	250ms	BMS-
CRO	׼״̬	2560	000A00H	4	1	250ms	-BMS

BCL	س	4096	001000H	6	5	50ms	BMS-
BCS	س״̬	4352	001100H	7	9	250ms	BMS-
CCS	״̬	4608	001200H	6	6	50ms	-BMS
BSM	״̬Ϣ	4864	001400H	6	7	250ms	BMS-
BMV	嶯صѹ	5376	001500H	7		10s	BMS-
BMT	¶	5632	001600H	7		10s	BMS-
BSP	Ԥ	5888	001700H	7		10s	BMS-
BST	BMSֹ	6400	001900H	4	4	10ms	BMS-
CST	ֹ	6656	001A00H	4	4	10ms	-BMS

BSD	BMSͳ	7168	001C00H	6	7	250ms	BMS-
CSD	ͳ	7424	001D00H	6	8	250ms	-BMS

BEM	BMS	7680	001E00H	2	4	250ms	BMS-
CEM		7936	001F00H	2	4	250ms	-BMS

DM1	ǰ	8192	002000H	6		¼Ӧ
DM2	ʷ	8448	002100H	6		¼Ӧ
DM3	׼	8704	002200H	6	2ֽ	¼Ӧ
DM4	ǰ/λ	8906	002300H	6	0	¼Ӧ
DM5	ʷ/λ	9216	002400H	6	0	¼Ӧ
DM6	ͣ֡	9472	002500H	6		¼Ӧ


*/

typedef enum
{
  CHM = 0x002600,// CHM		9728	002600H	6	3	250ms	-BMS
  BHM = 0x002700,// BHM		9984	002700H	6	2	250ms	BMS-
  CRM = 0x000100,// CRM	ʶ	256	000100H	6	8	250ms	-BMS
  BRM = 0x000200,// BRM	BMSͳʶ	512	000200H	7	41	250ms	BMS-

  BCP = 0x000600,// BCP	س	1536	000600H	7	13	500ms	BMS-
  CTS = 0x000700,// CTS	ʱͬϢ	1792	000700H	6	7	500ms	-BMS
  CML = 0x000800,// CML		2048	000800H	6	8	250ms	-BMS
  BRO = 0x000900,// BRO	س׼״̬	2304	000900H	4	1	250ms	BMS-
  CRO = 0x000A00,// CRO	׼״̬	2560	000A00H	4	1	250ms	-BMS

  BCL = 0x001000,// BCL	س	4096	001000H	6	5	50ms	BMS-
  BCS = 0x001100,// BCS	س״̬	4352	001100H	7	9	250ms	BMS-
  CCS = 0x001200,// CCS	״̬	4608	001200H	6	6	50ms	-BMS
  BSM = 0x001300,// BSM	״̬Ϣ	4864	001400H	6	7	250ms	BMS-
  BMV = 0x001500,// BMV	嶯صѹ	5376	001500H	7		10s	BMS-
  BMT = 0x001600,// BMT	¶	5632	001600H	7		10s	BMS-
  BSP = 0x001700,// BSP	Ԥ	5888	001700H	7		10s	BMS-
  BST = 0x001900,// BST	BMSֹ	6400	001900H	4	4	10ms	BMS-
  CST = 0x001A00,// CST	ֹ	6656	001A00H	4	4	10ms	-BMS

  BSD = 0x001C00,// BSD	BMSͳ	7168	001C00H	6	7	250ms	BMS-
  CSD = 0x001D00,// CSD	ͳ	7424	001D00H	6	8	250ms	-BMS

  BEM = 0x001E00,// BEM	BMS	7680	001E00H	2	4	250ms	BMS-
  CEM = 0x001F00,// CEM		7936	001F00H	2	4	250ms	-BMS

  DM1 = 0x002000,// DM1	ǰ	8192	002000H	6		¼Ӧ
  DM2 = 0x002100,// DM2	ʷ	8448	002100H	6		¼Ӧ
  DM3 = 0x002200,// DM3	׼	8704	002200H	6	2ֽ	¼Ӧ
  DM4 = 0x002300,// DM4	ǰ/λ	8906	002300H	6	0	¼Ӧ
  DM5 = 0x002400,// DM5	ʷ/λ	9216	002400H	6	0	¼Ӧ
  DM6 = 0x002500,// DM6	ͣ֡	9472	002500H	6		¼Ӧ

  REQ  = 0x00EA00,//
  ACK  = 0x00E800,//ȷ
  TPCM = 0x00EC00,//Э--ӹ
  TPDT = 0x00EB00,//Э--ݴ
}EnumBmsCommPgn;

#define Card1939Addr    (0xF4)
#define Charger1939Addr (0x56)

#define MaxDataSize1939  (512)

typedef struct
{
  u8  Flag;
  u8  FrameMaxNum;
  u8  RecvFrameCnt;
  u8  RecvBuff[MaxDataSize1939];
  u16 RecvDataCnt;
  u16 FrameDataLen;
  u32 Pgn;
}StructTransProt;

typedef union
{
  u32 Mult;
  struct
  {
    u32 SA      : 8;
    u32 DA_PS   : 8;
    u32 PF      : 8;
    u32 DP      : 1;
    u32 R       : 1;
    u32 Prio    : 3;
    u32 Reserve : 3;
  }Disp;
}Union1939Id;

typedef struct
{
  u8 Prio;
  u8 DP;
  u8 PF;
  u8 DA;
  u8 SA;
  u8 Len;
  u8 Data[8];
  u32 Pgn;
}StructPgnRecv;

typedef struct
{
  u8 Len;
  u8 Data[8];
  Union1939Id Id;
}StructChargeSend;

typedef struct
{
  u8 Valid;

  u16 ImdMaxVolt;

  u32 RecvTick;//ĽTick
}StructBHM;

typedef struct
{
  u8  Valid;
  struct
  {
    u32 L : 8;
    u32 M : 8;
    u32 H : 8;
  }CommVer;//3ֽ BMSͨЭ汾ţ׼涨ǰ汾ΪV1.0ʾΪbyte3byte20001Hbyte100H 
  u8  BatType;//1ֽ ͣ01HǦأ02Hأ03H﮵أ04H﮵أ05H﮵أ06HԪϵأ07Hۺӵأ08H﮵أFFH 
  u16 BatRateCap;//2ֽ ϵͳ/Ah0.1Ah/λ0AhƫݷΧ01000Ah 
  u16 BatRateVolt;//2ֽ ϵͳܵѹ/V0.1V/λ0VƫݷΧ0750V 
  u8  Manufacturer[4];//4ֽ ƣ׼ASCII ѡ
  u8  ProduceNum[4];//4ֽ ţԤɳж ѡ
  u8  ProduceYear;//1ֽ ڣ꣬1/λ1985ƫݷΧ19852235 ѡ
  u8  ProduceMon;//1ֽ ڣ£1/λ0ƫݷΧ112 ѡ
  u8  ProduceDay;//1ֽ ڣգ1/λ0ƫݷΧ131 ѡ
  u32 ChgCount;//3ֽ 1/λ0ƫBMSͳΪ׼ ѡ
  u8  BatOwn;//1ֽ Ȩʶ<0>=ޣ<1>=Уѡ
  u8  Reserve;// ѡ
  u8  Vin[17];//17ֽ ʶ루VINѡ
  u8  BmsVer[8];

  u32 RecvTick;//ĽTick
}StructBRM;

typedef struct
{
  u8  Valid;

  u16 PerBatMaxVolt; //嶯ѹ ݷֱʣ0.01 V/λ0 Vƫ ݷΧ0~24 V
  s16 ChgMaxCurrt;// ݷֱʣ0.1 A/λ-400 Aƫ ݷΧ-400 A~0 A
  u16 BatEnergy;//ر ݷֱʣ0.1 kWh/λ0 kWhƫ ݷΧ0~1000 kWh
  u16 ChgMaxVolt;//ܵѹ ݷֱʣ0.1 V/λ0 VƫݷΧ0~750 V
  u8  MaxTemp;//¶ ݷֱʣ1oC/λ-50 oCƫݷΧ-50 oC ~+200 oC 
  u16 StartSoc;//غɵ״̬SOCݷֱʣ0.1%/λ0%ƫݷΧ0~100%
  u16 StartVolt;//صǰصѹ ݷֱʣ0.1 V/λ0 VƫݷΧ0~750 V

  u32 RecvTick;//ĽTick
}StructBCP;

typedef struct
{
  u8 Valid;

  u8 Status;//BMSǷ׼ã<0x00 >=BMSδó׼) ; <0xAA >=BMSɳ׼<0xFF>=Ч)

  u32 RecvTick;
}StructBRO;

typedef struct
{
  u8  Valid;

  u16 NeedVolt; //ѹ ݷֱʣ0.1 V/λ0 VƫݷΧ0~750 V
  u16 NeedCurrt;// ݷֱʣ0.1 A/λ-400 Aƫ
  u8  ChgType;//ģʽ0x01ѹ磻0x02磩

  u32 RecvTick;//ĽTick
}StructBCL;

typedef union
{
  u16 Mult;
  struct
  {
    u16 Volt  : 12;//1-12λ嶯صѹݷֱʣ0.01 V/λ0 VƫݷΧ0~24 V
    u16 Group : 4;//13-16λطţݷֱʣ1/λ1ƫݷΧ1~16
  }Value;
}UnionBatVoltAndGroup;
typedef struct
{
  u8  Valid;

  u16 ChgVolt; //ѹֵ ݷֱʣ0.1 V/λ0 VƫݷΧ0~750 V
  u16 ChgCurrt;//ֵ ݷֱʣ0.1 A/λ-400 Aƫ
  UnionBatVoltAndGroup BatVoltAndGroup;//ߵ嶯صѹ 1-12λߵ嶯صѹݷֱʣ0.01 V/λ0 VƫݷΧ0~24 V13-16λߵ嶯صѹţݷֱʣ1/λ0ƫݷΧ0~15
  u8  CurSoc;//ǰɵ״̬SOC ݷֱʣ1%/λ0%ƫݷΧ0~100%
  u16 RemainMin;//ʣʱ䣬BMSʵʵΪ׼вʣʱ䳬600 minʱ600 min͡ݷֱʣ1 min/λ0 minƫݷΧ0~600 min

  u32 RecvTick;//ĽTick
}StructBCS;

typedef union
{
  u8 Mult;
  struct
  {
    u8 Volt : 2;//嶯صѹ/(<00>=; <01>=; <10>=) 
    u8 Soc  : 2;//غɵ״̬SOC/(<00>=; <01>=; <10>=) 
    u8 Currt: 2;//س(<00>=; <01>=; <10>=״̬) 
    u8 Temp : 2;//¶ȹ(<00>=; <01>=; <10>=״̬) 
  }Value;
}UnionBatStatus;
typedef union
{
  u8 Mult;
  struct
  {
    u8 Imd : 2;//ؾԵ״̬(<00>=; <01>=; <10>=״̬) 
    u8 Connect  : 2;//״̬(<00>=; <01>=; <10>=״̬) 
    u8 ChgEnable : 2;//(<00>=ֹ; <01>=; ) 
  }Value;
}UnionChargeStatus;
typedef struct
{
  u8  Valid;
  u8  HighTempBatNum; //ߵ嶯صѹڱ ݷֱʣ1/λ1ƫݷΧ1~256
  u8  HighTemp;//߶¶ ݷֱʣ1oC/λ-50 oCƫݷΧ-50 oC ~+200 oC
  u8  HighTempPointNum; //¶ȼ ݷֱʣ1/λ1ƫݷΧ1~128
  u8  LowTemp;//Ͷ¶ ݷֱʣ1oC/λ-50 oCƫݷΧ-50 oC ~+200 oC
  u8  LowTempPointNum;//¶ȼ ݷֱʣ1/λ1ƫݷΧ1~128
  UnionBatStatus BatSta;//
  UnionChargeStatus ChgSta;//

  u32 RecvTick;//ĽTick
}StructBSM;

typedef struct
{
  u8  Valid;

  UnionBatVoltAndGroup BatVoltAndGroup[256];//ֱӦ#1~#256嶯صѹ

  u32 RecvTick;//ĽTick
}StructBMV;

typedef struct
{
  u8  Valid;

  u8  Temp[128];//1~128¶ ݷֱʣ1oC/λ-50 oCƫݷΧ-50 oC ~+200 oCѡ

  u32 RecvTick;//ĽTick
}StructBMT;

typedef struct
{
  u8  Valid;

  u8  Bsp[16];//Ԥֶ16

  u32 RecvTick;//ĽTick
}StructBSP;

typedef union
{
  u8 Mult;
  struct
  {
    u8 NeedSoc : 2;//ﵽSOCĿֵ <00>=δﵽSOCĿֵ<01>=ﵽSOCĿֵ<10>=״̬
    u8 SetVolt  : 2;//ﵽܵѹ趨ֵ <00>=δﵽܵѹ趨ֵ<01>=ﵽܵѹ趨ֵ<10>=״̬
    u8 PerSetVolt: 2;//ﵽѹ趨ֵ <00>=δﵽѹ趨ֵ<01>=ﵽѹ趨ֵ<10>=״̬
    u8 ChgStop : 2;//ֹ <00>=<01>=ֹ(յCST֡)<10>=״̬
  }Value;
}UnionBmsStopReason;
typedef union
{
  u16 Mult;
  struct
  {
    u16 Imd : 2;//Ե <00>=<01>=ϣ<10>=״̬
    u16 OutletTemp  : 2;//<00>=<01>=ϣ<10>=״̬
    u16 ComponentTemp: 2;//BMSԪ<00>=<01>=ϣ<10>=״̬
    u16 ChgGun : 2;// <00>=<01>=ϣ<10>=״̬
    u16 BatPackTemp : 2;//¶ȹ߹ <00>=¶<01>=¶ȹߣ<10>=״̬
    u16 Other : 2;// <00>=<01>=ϣ<10>=״̬
  }Value;
}UnionBmsStopTruble;
typedef union
{
  u8 Mult;
  struct
  {
    u8 Currt : 2;// <00>=<01>=ֵ<10>=״̬
    u8 Volt  : 2;//ѹ쳣 <00>=<01>=ѹ쳣<10>=״̬
  }Value;
}UnionBmsStopFault;
typedef struct
{
  u8 Valid;

  UnionBmsStopReason StopReason;//BMSֹԭ 
  UnionBmsStopTruble StopTruble;//BMSֹԭ 
  UnionBmsStopFault  StopFault;//BMSֹԭ 

//  u32 RecvTick;//ĽTick
}StructBST;

typedef struct
{
  u8  Valid;

  u8  StopSOC;//ֹɵ״̬SOC% 
  u16 PerMinVolt;//ص͵ѹV 
  u16 PerMaxVolt;//صߵѹV 
  u8  MinTemp;//¶ȣoC 
  u8  MaxTemp;//¶ȣoC 

//  u32 RecvTick;//ĽTick
}StructBSD;

typedef union
{
  u32 Mult;
  struct
  {
    u32 Crm_00  : 2;//SPN2560=0x00ĳʶĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Crm_AA  : 2;//SPN2560=0xAAĳʶĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve1  : 4;
    u32 Cml_Cts : 2;//ճʱͬͳĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Cro     : 2;//ճɳ׼ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve2  : 4;
    u32 Ccs     : 2;//ճ״̬ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Cst     : 2;//ճֹ籨ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve3  : 4;
    u32 Csd     : 2;//ճͳƱĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Other   : 6;
  }Value;
}UnionBEM;
typedef struct
{
  u8  Valid;

  UnionBEM Bem;//BMSģBEM

//  u32 RecvTick;//ĽTick
}StructBEM;

typedef union
{
  u8 Mult;
  struct
  {
    u8 AutoSet : 2;//ﵽ趨ֹ <00>=<01>=ﵽ趨ֹ<10>=״̬
    u8 Manual  : 2;//˹ֹ <00>=<01>=˹ֹ<10>=״̬
    u8 Truble  : 2;//ֹ <00>=<01>=ֹ<10>=״̬
    u8 BmsStop : 2;//BMSֹ <00>=<01>=BMSֹ(յBST֡)<10>=״̬
  }Value;
}UnionChgStopReason;
typedef union
{
  u16 Mult;
  struct
  {
    u16 PillarTemp : 2;//¹ <00>=¶<01>=£<10>=״̬
    u16 ChgGun  : 2;// <00>=<01>=ϣ<10>=״̬
    u16 ModTemp: 2;//ڲ¹ <00>=ڲ¶<01>=ڲ£<10>=״̬
    u16 Power : 2;//ܴ <00=<01>ܴͣ<10>=״̬
    u16 Emergency : 2;//ͣ <00>=<01>=ͣ<10>=״̬
    u16 Other : 2;// <00>=<01>=ϣ<10>=״̬
    u16 Reserve : 4;
  }Value;
}UnionChgStopTruble;
typedef union
{
  u8 Mult;
  struct
  {
    u8 Currt : 2;//ƥ <00>=ƥ䣻<01>=ƥ䣻<10>=״̬
    u8 Volt  : 2;//ѹ쳣 <00>=<01>=ѹ쳣<10>=״̬
    u8 Reserve : 4;
  }Value;
}UnionChgStopFault;
typedef struct
{
  u8 Valid;
  UnionChgStopReason StopReason;//ֹԭ
  UnionChgStopTruble StopTruble;//ֹԭ
  UnionChgStopFault  StopFault;//ֹԭ
}StructCST;

typedef struct
{
//  u8  Valid;
  u16 ChgMin;//ۼƳʱ ݷֱʣ1 min/λ0 minƫݷΧ0~600 min
  u16 ChgEnergy;// ݷֱʣ0.1 kWh/λ0 kWhƫݷΧ0~1000 kWh
  u8  ChgNum[4];//ţ1/λ1ƫݷΧ00xFFFFFFFF 
}StructCSD;

typedef union
{
  u32 Mult;
  struct
  {
    u32 Brm     : 2;//BMSͳıʶĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve1  : 6;
    u32 Bcp     : 2;//յسĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Bro     : 2;//BMSɳ׼ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve2  : 4;
    u32 Bcs     : 2;//յس״̬ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Bcl     : 2;//յسҪĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Bst     : 2;//BMSֹ籨ĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Reserve3  : 2;
    u32 Bsd     : 2;//BMSͳƱĳʱ<00>=<01>=ʱ <10>=״̬
    u32 Other   : 6;
  }Value;
}UnionCEM;
typedef struct
{
//  u8  Valid;
  UnionCEM Cem;//BMSģBEM
}StructCEM;

typedef enum
{
  eChgVer_2011,
  eChgVer_2015,
}EnumChgVersion;

extern StructBHM BhmMsg;
extern StructBRM BrmMsg;
extern StructBCP BcpMsg;
extern StructBRO BroMsg;
extern StructBCL BclMsg;
extern StructBCS BcsMsg;
extern StructBSM BsmMsg;
extern StructBMV BmvMsg;
extern StructBMT BmtMsg;
extern StructBSP BspMsg;
extern StructBST BstMsg;
extern StructBSD BsdMsg;
extern StructBEM BemMsg;

extern StructCST CstMsg;
extern StructCSD CsdMsg;
extern StructCEM CemMsg;

extern void BhmMsgMake(u8 *pBuff);
extern void BrmMsgMake(u8 *pBuff, u16 Len);
extern void BcpMsgMake(u8 *pBuff);
extern void BroMsgMake(u8 *pBuff);
extern void BclMsgMake(u8 *pBuff);
extern void BcsMsgMake(u8 *pBuff);
extern void BsmMsgMake(u8 *pBuff);
extern void BmvMsgMake(u8 *pBuff, u16 Len);
extern void BmtMsgMake(u8 *pBuff, u16 Len);
extern void BspMsgMake(u8 *pBuff, u16 Len);
extern void BstMsgMake(u8 *pBuff);
extern void BsdMsgMake(u8 *pBuff);
extern void BemMsgMake(u8 *pBuff);

extern osMessageQId BmsMsg;
extern StructTransProt TransProt;

extern void BmsCanInit(void);
extern u8 BmsCommInit(void);
extern u8 BmsCommSendMsg(StructChargeSend *pMsg);

extern void NACK_Send(StructPgnRecv *pFrameRecv);

extern void TPCM_AbortSendBegin(StructPgnRecv *pFrameRecv);
extern void TPCM_Cts(StructPgnRecv *pFrameRecv);
extern void TPCM_AbortSending(StructTransProt *pTransProt);
extern void TPCM_EndOfMsgAck(StructTransProt *pTransProt);

extern void CHM_Send(void);
extern void CRM_Send(u8 Recog);
extern void CTS_Send(void);
extern void CML_Send(u16 MaxVolt, u16 MinVolt, u16 MaxCurrt, u16 MinCurrt);
extern void CRO_Send(u8 Status);
extern void CCS_Send(u16 Volt, u16 Currt, u16 Min, u16 ChgEnable);
extern void CST_Send(StructCST *pCst);
extern void CSD_Send(StructCSD *pCsd);
extern void CEM_Send(StructCEM *pCem);

extern void DM1_Send(u32 Dtc);
extern void DM3_Send(u16 Num);

extern EnumChgVersion ChgVer;
extern s32 ChgPgnRecv(StructPgnRecv *pPgnRecv);


extern StructBHM BhmMsg_B;
extern StructBRM BrmMsg_B;
extern StructBCP BcpMsg_B;
extern StructBRO BroMsg_B;
extern StructBCL BclMsg_B;
extern StructBCS BcsMsg_B;
extern StructBSM BsmMsg_B;
extern StructBMV BmvMsg_B;
extern StructBMT BmtMsg_B;
extern StructBSP BspMsg_B;
extern StructBST BstMsg_B;
extern StructBSD BsdMsg_B;
extern StructBEM BemMsg_B;

extern StructCST CstMsg_B;
extern StructCSD CsdMsg_B;
extern StructCEM CemMsg_B;

extern void BhmMsgMake_B(u8 *pBuff);
extern void BrmMsgMake_B(u8 *pBuff, u16 Len);
extern void BcpMsgMake_B(u8 *pBuff);
extern void BroMsgMake_B(u8 *pBuff);
extern void BclMsgMake_B(u8 *pBuff);
extern void BcsMsgMake_B(u8 *pBuff);
extern void BsmMsgMake_B(u8 *pBuff);
extern void BmvMsgMake_B(u8 *pBuff, u16 Len);
extern void BmtMsgMake_B(u8 *pBuff, u16 Len);
extern void BspMsgMake_B(u8 *pBuff, u16 Len);
extern void BstMsgMake_B(u8 *pBuff);
extern void BsdMsgMake_B(u8 *pBuff);
extern void BemMsgMake_B(u8 *pBuff);

extern osMessageQId BmsMsg_B;
extern StructTransProt TransProt_B;

extern void BmsCanInit_B(void);
extern u8 BmsCommInit_B(void);
extern u8 BmsCommSendMsg_B(StructChargeSend *pMsg);

extern void NACK_Send_B(StructPgnRecv *pFrameRecv);

extern void TPCM_AbortSendBegin_B(StructPgnRecv *pFrameRecv);
extern void TPCM_Cts_B(StructPgnRecv *pFrameRecv);
extern void TPCM_AbortSending_B(StructTransProt *pTransProt);
extern void TPCM_EndOfMsgAck_B(StructTransProt *pTransProt);

extern void CHM_Send_B(void);
extern void CRM_Send_B(u8 Recog);
extern void CTS_Send_B(void);
extern void CML_Send_B(u16 MaxVolt, u16 MinVolt, u16 MaxCurrt, u16 MinCurrt);
extern void CRO_Send_B(u8 Status);
extern void CCS_Send_B(u16 Volt, u16 Currt, u16 Min, u16 ChgEnable);
extern void CST_Send_B(StructCST *pCst);
extern void CSD_Send_B(StructCSD *pCsd);
extern void CEM_Send_B(StructCEM *pCem);

extern void DM1_Send_B(u32 Dtc);
extern void DM3_Send_B(u16 Num);

extern EnumChgVersion ChgVer_B;
extern s32 ChgPgnRecv_B(StructPgnRecv *pPgnRecv);

#endif


