
#include "Drv_BoardIo.h"
#include "Drv_ImdJyc.h"
#include "memory.h"

osTimerId FanDelayTimer;
osTimerId FanDelayTimer_Top;

osTimerId DCOutDelayTimer;
osTimerId DCOutDelayTimer_B;
osTimerId DCOutDelayTimer_Uni;

static EnumSwitchStatus FanStatus = eSwSta_Off;
static EnumSwitchStatus FanStatus_Top = eSwSta_Off;
static EnumSwitchStatus FanStatus_A = eSwSta_Off;
static EnumSwitchStatus FanStatus_B = eSwSta_Off;
EnumSwitchStatus ACContactorSta = eSwSta_Off;


EnumSwitchStatus EleLockSta = eSwSta_Off;
EnumSwitchStatus EleLockSta_B = eSwSta_Off;

EnumSwitchStatus DcOutPosSta = eSwSta_Off;
EnumSwitchStatus DcOutNegSta = eSwSta_Off;
EnumSwitchStatus DcOutPosSta_B = eSwSta_Off;
EnumSwitchStatus DcOutNegSta_B = eSwSta_Off;
EnumSwitchStatus DcOutPosSta_Uni = eSwSta_Off;
EnumSwitchStatus DcOutNegSta_Uni = eSwSta_Off;

void BmsPowerInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsPower_Pin;
  RCC_AHB1PeriphClockCmd(BmsPower_RCC, ENABLE);
  GPIO_Init(BmsPower_Port, &GPIO_InitStructure);
  GPIO_ResetBits(BmsPower_Port, BmsPower_Pin);
}

void BmsPowerSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    BmsPower_Port->BSRRH = BmsPower_Pin;
  else
    BmsPower_Port->BSRRL = BmsPower_Pin;
}


static void DCOutDelayHandle(void const *Param)
{
  DcOutPos_Port->BSRRL = DcOutPos_Pin;
  DcOutPosSta = eSwSta_On;
}

void DcOutInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutPos_Pin;
  RCC_AHB1PeriphClockCmd(DcOutPos_RCC, ENABLE);
  GPIO_Init(DcOutPos_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutPos_Port, DcOutPos_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkPos_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkPos_RCC, ENABLE);
  GPIO_Init(DcOutChkPos_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkPos_Port, DcOutChkPos_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutNeg_Pin;
  RCC_AHB1PeriphClockCmd(DcOutNeg_RCC, ENABLE);
  GPIO_Init(DcOutNeg_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutNeg_Port, DcOutNeg_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkNeg_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkNeg_RCC, ENABLE);
  GPIO_Init(DcOutChkNeg_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkNeg_Port, DcOutChkNeg_Pin);

      /* Create a Timer */
  osTimerDef(DCOutDelayTimer, DCOutDelayHandle);
  DCOutDelayTimer = osTimerCreate(osTimer(DCOutDelayTimer), osTimerOnce, (void *)0);
}

void DcOutPosSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutPos_Port->BSRRH = DcOutPos_Pin;
  else
    DcOutPos_Port->BSRRL = DcOutPos_Pin;
  DcOutPosSta = Set;
}
void DcOutNegSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutNeg_Port->BSRRH = DcOutNeg_Pin;
  else
    DcOutNeg_Port->BSRRL = DcOutNeg_Pin;
  DcOutNegSta = Set;
}
#if 1
void DcOutSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
  {
    DcOutPosSet(Set);
    DcOutNegSet(Set);
    osTimerStop(DCOutDelayTimer);
  }
  else
  {
    //DcOutPosSet(Set);
    DcOutNegSet(Set);
    osTimerStart(DCOutDelayTimer, 200);
  }
}
#else
void DcOutSet(EnumSwitchStatus Set)
{
  DcOutPosSet(Set);
  DcOutNegSet(Set);
}
#endif
EnumSwitchStatus DcOutPosGet(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkPos_Port, DcOutChkPos_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutNegGet(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkNeg_Port, DcOutChkNeg_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutPosGetSet(void)
{
  return DcOutPosSta;
}
EnumSwitchStatus DcOutNegGetSet(void)
{
  return DcOutNegSta;
}
EnumSwitchStatus DcOutGet(void)
{
  if(eSwSta_On == DcOutPosGet())// && eSwSta_On == DcOutNegGet()
    return eSwSta_On;
  return eSwSta_Off;
}

void DrainResistInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DrainResist_Pin;
  RCC_AHB1PeriphClockCmd(DrainResist_RCC, ENABLE);
  GPIO_Init(DrainResist_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DrainResist_Port, DrainResist_Pin);
}

void DrainResistSet(EnumSwitchStatus Set)
{
  //if(eSwSta_Off == Set)
 //   DrainResist_Port->BSRRH = DrainResist_Pin;
//  else
//    DrainResist_Port->BSRRL = DrainResist_Pin;
}
void ACContactorSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
   ACContactor_Port->BSRRH = ACContactor_Pin;
 else
  ACContactor_Port->BSRRL = ACContactor_Pin;
}

void ImdWorkSet(EnumSwitchStatus Set)
{
  static EnumSwitchStatus laststa = eSwSta_Off;
  //if(laststa != Set)
  {
    if(eSwSta_On == Set) // Ե
    {
      ImdWrite(0x0017, 0x0002);
      ImdWrite(0x01FE, 0x0001);
    }
    else // رվԵ
    {
      ImdWrite(0x0017, 0x0003);
      ImdWrite(0x01FE, 0x0001);
    }
    laststa = Set;
  }
}

void LockInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Lock_Pin;
  RCC_AHB1PeriphClockCmd(Lock_RCC, ENABLE);
  GPIO_Init(Lock_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Lock_Port, Lock_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = LockChk_Pin;
  RCC_AHB1PeriphClockCmd(LockChk_RCC, ENABLE);
  GPIO_Init(LockChk_Port, &GPIO_InitStructure);
  GPIO_ResetBits(LockChk_Port, LockChk_Pin);
}

void LockSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    Lock_Port->BSRRH = Lock_Pin;
  else
    Lock_Port->BSRRL = Lock_Pin;
  EleLockSta = Set;
}

EnumSwitchStatus LockGet(void)
{
  if(Bit_SET == GPIO_ReadInputDataBit(LockChk_Port, LockChk_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}


void ChgLedInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = ChgLed_Pin;
  RCC_AHB1PeriphClockCmd(ChgLed_RCC, ENABLE);
  GPIO_Init(ChgLed_Port, &GPIO_InitStructure);
  GPIO_ResetBits(ChgLed_Port, ChgLed_Pin);
}

void ChgLedSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    ChgLed_Port->BSRRH = ChgLed_Pin;
  else
    ChgLed_Port->BSRRL = ChgLed_Pin;
}

void FaultLedInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = FaultLed_Pin;
  RCC_AHB1PeriphClockCmd(FaultLed_RCC, ENABLE);
  GPIO_Init(FaultLed_Port, &GPIO_InitStructure);
  GPIO_ResetBits(FaultLed_Port, FaultLed_Pin);
}

void FaultLedSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    FaultLed_Port->BSRRH = FaultLed_Pin;
  else
    FaultLed_Port->BSRRL = FaultLed_Pin;
}

void IdleLedInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = IdleLed_Pin;
  RCC_AHB1PeriphClockCmd(IdleLed_RCC, ENABLE);
  GPIO_Init(IdleLed_Port, &GPIO_InitStructure);
  GPIO_ResetBits(IdleLed_Port, IdleLed_Pin);
}

void IdleLedSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    IdleLed_Port->BSRRH = IdleLed_Pin;
  else
    IdleLed_Port->BSRRL = IdleLed_Pin;
}

/*osTimerId RunLedDelayTimer;
static void RunLedDelayHandle(void const *Param)
{
  RunLed_Port->BSRRH = RunLed_Pin;
}*/

void BmsPowerInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = BmsPower_B_Pin;
  RCC_AHB1PeriphClockCmd(BmsPower_B_RCC, ENABLE);
  GPIO_Init(BmsPower_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(BmsPower_B_Port, BmsPower_B_Pin);
}

void BmsPowerSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    BmsPower_B_Port->BSRRH = BmsPower_B_Pin;
  else
    BmsPower_B_Port->BSRRL = BmsPower_B_Pin;
}

void ShortCirCheck(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = ShortCirCheck_Pin;
  RCC_AHB1PeriphClockCmd(ShortCirCheck_RCC, ENABLE);
  GPIO_Init(ShortCirCheck_Port, &GPIO_InitStructure);
  GPIO_ResetBits(ShortCirCheck_Port, ShortCirCheck_Pin);
}

void ShortCirCheckSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    ShortCirCheck_Port->BSRRH = ShortCirCheck_Pin;
  else
    BmsPower_B_Port->BSRRL = ShortCirCheck_Pin;
}

static void DCOutDelayHandle_B(void const *Param)
{
  DcOutPos_B_Port->BSRRL = DcOutPos_B_Pin;
  DcOutPosSta_B = eSwSta_On;
}

void DcOutInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutPos_B_Pin;
  RCC_AHB1PeriphClockCmd(DcOutPos_B_RCC, ENABLE);
  GPIO_Init(DcOutPos_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutPos_B_Port, DcOutPos_B_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkPos_B_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkPos_B_RCC, ENABLE);
  GPIO_Init(DcOutChkPos_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkPos_B_Port, DcOutChkPos_B_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutNeg_B_Pin;
  RCC_AHB1PeriphClockCmd(DcOutNeg_B_RCC, ENABLE);
  GPIO_Init(DcOutNeg_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutNeg_B_Port, DcOutNeg_B_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkNeg_B_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkNeg_B_RCC, ENABLE);
  GPIO_Init(DcOutChkNeg_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkNeg_B_Port, DcOutChkNeg_B_Pin);
        /* Create a Timer */
  osTimerDef(DCOutDelayTimer_B, DCOutDelayHandle_B);
  DCOutDelayTimer_B = osTimerCreate(osTimer(DCOutDelayTimer_B), osTimerOnce, (void *)0);
}

void DcOutPosSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutPos_B_Port->BSRRH = DcOutPos_B_Pin;
  else
    DcOutPos_B_Port->BSRRL = DcOutPos_B_Pin;
  DcOutPosSta_B = Set;
}
void DcOutNegSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutNeg_B_Port->BSRRH = DcOutNeg_B_Pin;
  else
    DcOutNeg_B_Port->BSRRL = DcOutNeg_B_Pin;
  DcOutNegSta_B = Set;
}
#if 1
void DcOutSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
  {
    DcOutPosSet_B(Set);
    DcOutNegSet_B(Set);
    osTimerStop(DCOutDelayTimer_B);
  }
  else
  {
    //DcOutPosSet_B(Set);
    DcOutNegSet_B(Set);
    osTimerStart(DCOutDelayTimer_B, 200);
  }
}
#else
void DcOutSet_B(EnumSwitchStatus Set)
{
  DcOutPosSet_B(Set);
  DcOutNegSet_B(Set);
}
#endif

EnumSwitchStatus ACContactorGet(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkNeg_B_Port, DcOutChkNeg_B_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}

EnumSwitchStatus DcOutPosGet_B(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkPos_B_Port, DcOutChkPos_B_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutNegGet_B(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkNeg_B_Port, DcOutChkNeg_B_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutPosGetSet_B(void)
{
  return DcOutPosSta_B;
}
EnumSwitchStatus DcOutNegGetSet_B(void)
{
  return DcOutNegSta_B;
}
EnumSwitchStatus DcOutGet_B(void)
{
  if(eSwSta_On == DcOutPosGet_B())// && eSwSta_On == DcOutNegGet()
    return eSwSta_On;
  return eSwSta_Off;
}

void DrainResistInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DrainResist_B_Pin;
  RCC_AHB1PeriphClockCmd(DrainResist_B_RCC, ENABLE);
  GPIO_Init(DrainResist_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DrainResist_B_Port, DrainResist_B_Pin);
}

void DrainResistSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DrainResist_B_Port->BSRRH = DrainResist_B_Pin;
  else
    DrainResist_B_Port->BSRRL = DrainResist_B_Pin;
}

void ImdWorkSet_B(EnumSwitchStatus Set)
{
  static EnumSwitchStatus laststa = eSwSta_Off;
  //if(laststa != Set)
  {
    if(eSwSta_On == Set) // Ե
    {
      ImdWrite_B(0x0017, 0x0002);
      ImdWrite_B(0x01FE, 0x0001);
    }
    else // رվԵ
    {
      ImdWrite_B(0x0017, 0x0003);
      ImdWrite_B(0x01FE, 0x0001);
    }
    laststa = Set;
  }
}

void LockInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Lock_B_Pin;
  RCC_AHB1PeriphClockCmd(Lock_B_RCC, ENABLE);
  GPIO_Init(Lock_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Lock_B_Port, Lock_B_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = LockChk_B_Pin;
  RCC_AHB1PeriphClockCmd(LockChk_B_RCC, ENABLE);
  GPIO_Init(LockChk_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(LockChk_B_Port, LockChk_B_Pin);
}

void LockSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    Lock_B_Port->BSRRH = Lock_B_Pin;
  else
    Lock_B_Port->BSRRL = Lock_B_Pin;
  EleLockSta_B = Set;
}

EnumSwitchStatus LockGet_B(void)
{
  if(Bit_SET == GPIO_ReadInputDataBit(LockChk_B_Port, LockChk_B_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}

void ChgLedInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = ChgLed_B_Pin;
  RCC_AHB1PeriphClockCmd(ChgLed_B_RCC, ENABLE);
  GPIO_Init(ChgLed_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(ChgLed_B_Port, ChgLed_B_Pin);
}

void ChgLedSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    ChgLed_B_Port->BSRRH = ChgLed_B_Pin;
  else
    ChgLed_B_Port->BSRRL = ChgLed_B_Pin;
}

void FaultLedInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = FaultLed_B_Pin;
  RCC_AHB1PeriphClockCmd(FaultLed_B_RCC, ENABLE);
  GPIO_Init(FaultLed_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(FaultLed_B_Port, FaultLed_B_Pin);
}

void FaultLedSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    FaultLed_B_Port->BSRRH = FaultLed_B_Pin;
  else
    FaultLed_B_Port->BSRRL = FaultLed_B_Pin;
}

void IdleLedInit_B(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = IdleLed_B_Pin;
  RCC_AHB1PeriphClockCmd(IdleLed_B_RCC, ENABLE);
  GPIO_Init(IdleLed_B_Port, &GPIO_InitStructure);
  GPIO_ResetBits(IdleLed_B_Port, IdleLed_B_Pin);
}

void IdleLedSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    IdleLed_B_Port->BSRRH = IdleLed_B_Pin;
  else
    IdleLed_B_Port->BSRRL = IdleLed_B_Pin;
}

/**************************************************************/

static void DCOutDelayHandle_Uni(void const *Param)
{
  DcOutPos_Uni_Port->BSRRL = DcOutPos_Uni_Pin;
  DcOutPosSta_Uni = eSwSta_On;
}

void DcOutInit_Uni(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutPos_Uni_Pin;
  RCC_AHB1PeriphClockCmd(DcOutPos_Uni_RCC, ENABLE);
  GPIO_Init(DcOutPos_Uni_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutPos_Uni_Port, DcOutPos_Uni_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkPos_Uni_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkPos_Uni_RCC, ENABLE);
  GPIO_Init(DcOutChkPos_Uni_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkPos_Uni_Port, DcOutChkPos_Uni_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DcOutNeg_Uni_Pin;
  RCC_AHB1PeriphClockCmd(DcOutNeg_Uni_RCC, ENABLE);
  GPIO_Init(DcOutNeg_Uni_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutNeg_Uni_Port, DcOutNeg_Uni_Pin);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = DcOutChkNeg_Uni_Pin;
  RCC_AHB1PeriphClockCmd(DcOutChkNeg_Uni_RCC, ENABLE);
  GPIO_Init(DcOutChkNeg_Uni_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DcOutChkNeg_Uni_Port, DcOutChkNeg_Uni_Pin);
        /* Create a Timer */
  osTimerDef(DCOutDelayTimer_Uni, DCOutDelayHandle_Uni);
  DCOutDelayTimer_Uni = osTimerCreate(osTimer(DCOutDelayTimer_Uni), osTimerOnce, (void *)0);
}

void DcOutPosSet_Uni(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutPos_Uni_Port->BSRRH = DcOutPos_Uni_Pin;
  else
    DcOutPos_Uni_Port->BSRRL = DcOutPos_Uni_Pin;
  DcOutPosSta_Uni = Set;
}
void DcOutNegSet_Uni(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    DcOutNeg_Uni_Port->BSRRH = DcOutNeg_Uni_Pin;
  else
    DcOutNeg_Uni_Port->BSRRL = DcOutNeg_Uni_Pin;
  DcOutNegSta_Uni = Set;
}
#if 1
void DcOutSet_Uni(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
  {
    DcOutPosSet_Uni(Set);
    DcOutNegSet_Uni(Set);
    osTimerStop(DCOutDelayTimer_Uni);
  }
  else if(((eSwSta_Off == DcOutGet()) || (eSwSta_Off == DcOutGet_B()))
       && ((eSwSta_Off == DcOutPosGetSet()) || (eSwSta_Off == DcOutPosGetSet_B()))
         )
  {
    //DcOutPosSet_Uni(Set);
    DcOutNegSet_Uni(Set);
    osTimerStart(DCOutDelayTimer_Uni, 200);
  }
}
#else
void DcOutSet_Uni(EnumSwitchStatus Set)
{
  DcOutPosSet_Uni(Set);
  DcOutNegSet_Uni(Set);
}
#endif
EnumSwitchStatus DcOutPosGet_Uni(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkPos_Uni_Port, DcOutChkPos_Uni_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutNegGet_Uni(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(DcOutChkNeg_Uni_Port, DcOutChkNeg_Uni_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}
EnumSwitchStatus DcOutPosGetSet_Uni(void)
{
  return DcOutPosSta_Uni;
}
EnumSwitchStatus DcOutNegGetSet_Uni(void)
{
  return DcOutNegSta_Uni;
}
EnumSwitchStatus DcOutGet_Uni(void)
{
  if(eSwSta_On == DcOutPosGet_Uni() && eSwSta_On == DcOutNegGet_Uni())//
    return eSwSta_On;
  return eSwSta_Off;
}

void DehumidifierInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Dehumidifier_Pin;
  RCC_AHB1PeriphClockCmd(Dehumidifier_RCC, ENABLE);
  GPIO_Init(Dehumidifier_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Dehumidifier_Port, Dehumidifier_Pin);
}
void DehumidifierSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
    Dehumidifier_Port->BSRRH = Dehumidifier_Pin;
  else
    Dehumidifier_Port->BSRRL = Dehumidifier_Pin;
}

void RunLedInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = RunLed_Pin;
  RCC_AHB1PeriphClockCmd(RunLed_RCC, ENABLE);
  GPIO_Init(RunLed_Port, &GPIO_InitStructure);
  GPIO_ResetBits(RunLed_Port, RunLed_Pin);

      /* Create a Timer */
  //osTimerDef(RunLedDelayTimer, RunLedDelayHandle);
  //RunLedDelayTimer = osTimerCreate(osTimer(RunLedDelayTimer), osTimerOnce, (void *)0);
}

void RunLedSet(EnumSwitchStatus Set)
{
  if(eSwSta_On == Set)
  {
    //osTimerStart(RunLedDelayTimer, 990);
    RunLed_Port->BSRRH = RunLed_Pin;
  }
  else
  {
    //osTimerStop(RunLedDelayTimer);
    RunLed_Port->BSRRL = RunLed_Pin;
  }
}


void EmergenceInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Emergence_Pin;
  RCC_AHB1PeriphClockCmd(Emergence_RCC, ENABLE);
  GPIO_Init(Emergence_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Emergence_Port, Emergence_Pin);
}

EnumSwitchStatus EmergenceGet(void)
{
  if(Bit_RESET == GPIO_ReadInputDataBit(Emergence_Port, Emergence_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}

void DoorChkInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = DoorChk_Pin;
  RCC_AHB1PeriphClockCmd(DoorChk_RCC, ENABLE);
  GPIO_Init(DoorChk_Port, &GPIO_InitStructure);
  GPIO_ResetBits(DoorChk_Port, DoorChk_Pin);
}

EnumSwitchStatus DoorChkGet(void)
{
  if(Bit_SET == GPIO_ReadInputDataBit(DoorChk_Port, DoorChk_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}

void SPDInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = SPD_Pin;
  RCC_AHB1PeriphClockCmd(SPD_RCC, ENABLE);
  GPIO_Init(SPD_Port, &GPIO_InitStructure);
  GPIO_ResetBits(SPD_Port, SPD_Pin);
}

EnumSwitchStatus SPDGet(void)
{
  if(Bit_RESET== GPIO_ReadInputDataBit(SPD_Port, SPD_Pin))
    return eSwSta_On;
  return eSwSta_Off;
}

static void FanDelayHandle(void const *Param)
{
  Fan_Port->BSRRH = Fan_Pin;
  ACContactorSet(eSwSta_Off);
}
void FanInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Fan_Pin;
  RCC_AHB1PeriphClockCmd(Fan_RCC, ENABLE);
  GPIO_Init(Fan_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Fan_Port, Fan_Pin);

    /* Create a Timer */
  osTimerDef(FanDelayTimer, FanDelayHandle);
  FanDelayTimer = osTimerCreate(osTimer(FanDelayTimer), osTimerOnce, (void *)0);
}
void FanSet_Side(EnumSwitchStatus Set)
{
  if(FanStatus == Set)
    return;

  if(eSwSta_Off == Set)
    osTimerStart(FanDelayTimer, 120000);
  else
  {
    osTimerStop(FanDelayTimer);
    Fan_Port->BSRRL = Fan_Pin;
    ACContactorSet(eSwSta_On);
  }
  FanStatus = Set;
}
void FanSetExt(EnumSwitchStatus Set)
{
  osTimerStop(FanDelayTimer);
  if(eSwSta_Off == Set)
    Fan_Port->BSRRH = Fan_Pin;
  else
    Fan_Port->BSRRL = Fan_Pin;
  FanStatus = Set;
}

static void FanDelayHandle_Top(void const *Param)
{
  Fan_Top_Port->BSRRH = Fan_Top_Pin;
}
void FanInit_Top(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Fan_Top_Pin;
  RCC_AHB1PeriphClockCmd(Fan_Top_RCC, ENABLE);
  GPIO_Init(Fan_Top_Port, &GPIO_InitStructure);
  GPIO_ResetBits(Fan_Top_Port, Fan_Top_Pin);

    /* Create a Timer */
  osTimerDef(FanDelayTimer_Top, FanDelayHandle_Top);
  FanDelayTimer_Top = osTimerCreate(osTimer(FanDelayTimer_Top), osTimerOnce, (void *)0);
}
void FanSet_Top(EnumSwitchStatus Set)
{
  if(FanStatus_Top == Set)
    return;

  if(eSwSta_Off == Set)
    osTimerStart(FanDelayTimer_Top, 120000);
  else
  {
    osTimerStop(FanDelayTimer_Top);
    Fan_Top_Port->BSRRL = Fan_Top_Pin;
  }
  FanStatus_Top = Set;
}
void FanSetExt_Top(EnumSwitchStatus Set)
{
  osTimerStop(FanDelayTimer_Top);
  if(eSwSta_Off == Set)
    Fan_Top_Port->BSRRH = Fan_Top_Pin;
  else
    Fan_Top_Port->BSRRL = Fan_Top_Pin;
  FanStatus_Top = Set;
}

void FanControl(EnumSwitchStatus Set)
{
  FanSet_Side(Set);
  if(0 != UserParam.ChgFun.Value.TopFan)
  {
    //FanSet_Top(eSwSta_Off);
    //FanSet_Top(Set);
  }
  else
  {
  //  FanSet_Top(eSwSta_Off);
  }
}

void FanSet(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
  {
    if(eSwSta_Off == FanStatus_B)
      FanControl(Set);
  }
  else
    FanControl(Set);
  FanStatus_A = Set;
}

void FanSet_B(EnumSwitchStatus Set)
{
  if(eSwSta_Off == Set)
  {
    if(eSwSta_Off == FanStatus_A)
      FanControl(Set);
  }
  else
    FanControl(Set);
  FanStatus_B = Set;
}

void BmsPowerSet_AB(EnumSwitchStatus Set)
{
  BmsPowerSet(Set);
  //BmsPowerSet_B(Set);
}
void DcOutSet_AB(EnumSwitchStatus Set)
{
  DcOutSet(Set);
  DcOutSet_B(Set);
}
void DrainResistSet_AB(EnumSwitchStatus Set)
{
  DrainResistSet(Set);
  DrainResistSet_B(Set);
}

void FanSet_AB(EnumSwitchStatus Set)
{
  FanSet(Set);
  FanSet_B(Set);
}
void ImdWorkSet_AB(EnumSwitchStatus Set)
{
  ImdWorkSet(Set);
  //ImdWorkSet_B(Set);
}
void LockSet_AB(EnumSwitchStatus Set)
{

  LockSet(Set);
  LockSet_B(Set);
}
EnumSwitchStatus LockGet_AB(void)
{

  if((eSwSta_Off == LockGet()) || (eSwSta_Off == LockGet_B()))
    return eSwSta_Off;
  else
    return eSwSta_On;
}



/**********************************************************/

void SystemReboot(void)
{
  NVIC_SystemReset();
}

void ACContactorInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = ACContactor_Pin;
  RCC_AHB1PeriphClockCmd(ACContactor_RCC, ENABLE);
  GPIO_Init(ACContactor_Port, &GPIO_InitStructure);
  GPIO_ResetBits(ACContactor_Port, ACContactor_Pin);
}




