
#ifndef __DRV_COMMUSPI2_H__
#define __DRV_COMMUSPI2_H__

/* Includes ------------------------------------------------------------------*/
#include "Global.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/

/* FLASH SPI Interface pins  */
#define CommuSPI2                           SPI2
#define CommuSPI2_CLK                       RCC_APB1Periph_SPI2
#define CommuSPI2_CLK_INIT                  RCC_APB1PeriphClockCmd

#define CommuSPI2_SCK_PIN                   GPIO_Pin_10
#define CommuSPI2_SCK_GPIO_PORT             GPIOB
#define CommuSPI2_SCK_GPIO_CLK              RCC_AHB1Periph_GPIOB
#define CommuSPI2_SCK_SOURCE                GPIO_PinSource10
#define CommuSPI2_SCK_AF                    GPIO_AF_SPI2

#define CommuSPI2_MISO_PIN                  GPIO_Pin_14
#define CommuSPI2_MISO_GPIO_PORT            GPIOB
#define CommuSPI2_MISO_GPIO_CLK             RCC_AHB1Periph_GPIOB
#define CommuSPI2_MISO_SOURCE               GPIO_PinSource14
#define CommuSPI2_MISO_AF                   GPIO_AF_SPI2

#define CommuSPI2_MOSI_PIN                  GPIO_Pin_15
#define CommuSPI2_MOSI_GPIO_PORT            GPIOB
#define CommuSPI2_MOSI_GPIO_CLK             RCC_AHB1Periph_GPIOB
#define CommuSPI2_MOSI_SOURCE               GPIO_PinSource15
#define CommuSPI2_MOSI_AF                   GPIO_AF_SPI2

#define sFLASH_CS_PIN                        GPIO_Pin_10
#define sFLASH_CS_GPIO_PORT                  GPIOD
#define sFLASH_CS_GPIO_CLK                   RCC_AHB1Periph_GPIOD

#define W5500_CS_PIN                        GPIO_Pin_11
#define W5500_CS_GPIO_PORT                  GPIOD
#define W5500_CS_GPIO_CLK                   RCC_AHB1Periph_GPIOD


/* Exported macro ------------------------------------------------------------*/
/* Select sFLASH: Chip Select pin low */
#define sFLASH_CS_LOW()       GPIO_ResetBits(sFLASH_CS_GPIO_PORT, sFLASH_CS_PIN)
/* Deselect sFLASH: Chip Select pin high */
#define sFLASH_CS_HIGH()      GPIO_SetBits(sFLASH_CS_GPIO_PORT, sFLASH_CS_PIN)

/* Exported macro ------------------------------------------------------------*/
/* Select W5500: Chip Select pin low */
#define W5500_CS_LOW()       GPIO_ResetBits(W5500_CS_GPIO_PORT, W5500_CS_PIN)
/* Deselect W5500: Chip Select pin high */
#define W5500_CS_HIGH()      GPIO_SetBits(W5500_CS_GPIO_PORT, W5500_CS_PIN)



extern osMutexId GetCommuMutex();

extern u8 CommuSPI2_SendByte(u8 byte);
extern u8 CommuSPI2_ReadByte(u8 DUMMY_BYTE);
extern u16 CommuSPI2_SendHalfWord(u16 HalfWord);


extern void CommuSPI2_LowLevel_Init(void);

#endif /* #ifndef __DRV_SPIFLASH_H__ */


