
/******************************************************************************
ļ  : Drv_ReaderActR1.c
  : гۿ޹˾ACT-R1
  :
޸  : 2014-08-26      

******************************************************************************/
#include "Memory.h"

#include "Drv_CommuUSART3.h"
#include "Drv_ReaderActR1.h"
#include "Drv_ReaderPcd200.h"
#include "Drv_ReaderZLG600A.h"

osMessageQId ReaderDataRecvMsg = NULL;
osMessageQId ReaderDataSendMsg = NULL;

//static EnumReaderType ReaderType = eReaderType_No;
u8 ReaderErrorCount = 0;

u8 ReaderSendByte(u8 Data);

const StructReaderDrv ReaderDrvHandle[] =
{
  {
    ReaderActR1_Init,
    ReaderActR1_CardFind,
    ReaderActR1_IdCheck,
    ReaderActR1_BlockRead,
    ReaderActR1_BlockWrite
  },
  {
    ReaderActR1_Init,
    ReaderActR1_CardFind,
    ReaderActR1_IdCheck,
    ReaderActR1_BlockRead,
    ReaderActR1_BlockWrite
  },
  {
    ReaderPcb200_Init,
    ReaderPcb200_CardFind,
    ReaderPcb200_IdCheck,
    ReaderPcb200_BlockRead,
    ReaderPcb200_BlockWrite
  },
  {
    ReaderZLG600A_Init,
    ReaderZLG600A_CardFind,
    ReaderZLG600A_IdCheck,
    ReaderZLG600A_BlockRead,
    ReaderZLG600A_BlockWrite
  }
};
StructReaderDrv *pReaderDrv = (StructReaderDrv*)&ReaderDrvHandle[0];

/******************************************************************************
  : ReaderInit
  : ͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 ReaderInit(void)
{

  //USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable GPIO clock */
  /* Configure USART Tx and Rx as alternate function push-pull */
  RCC_AHB1PeriphClockCmd(Reader_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Reader_USARTx_TX_PIN;
  GPIO_Init(Reader_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);

  RCC_AHB1PeriphClockCmd(Reader_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Reader_USARTx_RX_PIN;
  GPIO_Init(Reader_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  Reader_USARTx_CLK_INIT(Reader_USARTx_CLK, ENABLE);

  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(Reader_USARTx_TX_GPIO_PORT, Reader_USARTx_TX_SOURCE, Reader_USARTx_TX_AF);
  GPIO_PinAFConfig(Reader_USARTx_RX_GPIO_PORT, Reader_USARTx_RX_SOURCE, Reader_USARTx_RX_AF);

  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(Reader_USARTx, ENABLE);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = Reader_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue*/
  ReaderDataRecvMsg = NULL;
  osMessageQDef(ReaderDataRecvMsg, 32, u8);
  ReaderDataRecvMsg = osMessageCreate(osMessageQ(ReaderDataRecvMsg), NULL);

  ReaderDataSendMsg = NULL;
  osMessageQDef(ReaderDataSendMsg, 32, u8);
  ReaderDataSendMsg = osMessageCreate(osMessageQ(ReaderDataSendMsg), NULL);

  ReaderDiscern();

  return TRUE;
}
/******************************************************************************
  : ReaderDiscern
  : ʶ
  : 
  : 
******************************************************************************/
void ReaderDiscern(void)
{
  if(1 == UserParam.Reader.Auto_ID)
  {
    ReaderActR1_Init(ReaderDataRecvMsg, ReaderSendByte);

    if(TRUE == ReaderActR1_Test())
    {
      UserParam.Reader.ReaderType = eReaderType_ActR1;
    }
    else// if(UserParam.Reader.ReaderType == eReaderType_No)
    {
      ReaderZLG600A_Init(ReaderDataRecvMsg,ReaderSendByte);
      ReaderPcb200_Init(ReaderDataRecvMsg, ReaderSendByte);

      if(TRUE == ReaderPcb200_Test())
      {
        if(TRUE == ReaderZLG600A_Test())
          UserParam.Reader.ReaderType = eReaderType_ZLG600A;
        else
          UserParam.Reader.ReaderType = eReaderType_Pcd200;
      }
      else
      {
        UserParam.Reader.ReaderType = eReaderType_No;
      }
    }
  }
  if(eReaderType_Max < UserParam.Reader.ReaderType)
    UserParam.Reader.ReaderType = eReaderType_No;

  pReaderDrv = (StructReaderDrv*)&ReaderDrvHandle[UserParam.Reader.ReaderType];
  pReaderDrv->pReaderInit(ReaderDataRecvMsg, ReaderSendByte);
}
/******************************************************************************
  : Reader_USARTx_IRQHandler
  : ڽж
  : 
  : 
******************************************************************************/
void Reader_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;
  osEvent SendDataMsg;

  SR = Reader_USARTx->SR;
  CR1 = Reader_USARTx->CR1;
  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {

    Data = (u8)Reader_USARTx->DR;
    osMessagePut(ReaderDataRecvMsg, Data, 0);
  }

  if((CR1 & USART_CR1_TXEIE) && (SR & USART_SR_TXE))
  {
    SendDataMsg = osMessageGet(ReaderDataSendMsg, 0);
    if(osEventMessage == SendDataMsg.status)
      Reader_USARTx->DR = SendDataMsg.value.v;
    else
      Reader_USARTx->CR1 &= ~USART_CR1_TXEIE;
  }
}

/******************************************************************************
  : ReaderSendData
  : ֽ
  : Data - յֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 ReaderSendByte(u8 Data)
{
  osStatus EvenStatus;

  EvenStatus = osMessagePut(ReaderDataSendMsg, Data, portMAX_DELAY);
  if(osOK == EvenStatus)
  {
    Reader_USARTx->CR1 |= USART_CR1_TXEIE;
    return TRUE;
  }

  return FALSE;
}

/******************************************************************************
  : Cmd_CardFind
  : Ѱ
  : pUID - ѰUID
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int Cmd_CardFind(u8 *pUID)
{
  int temp;
  static u32 Time = 0;

  temp = pReaderDrv->Cmd_CardFind(pUID);

  if(0 != temp)
  {
    if(0 == Time)
      Time = GetSystemTick();
    if((eReaderType_No == UserParam.Reader.ReaderType)
      ||((GetSystemTick() - Time) > 5000))
    {
      ReaderDiscern();
      Time = GetSystemTick();
    }
  }
  else
    Time = GetSystemTick();
  return temp;
}

/******************************************************************************
  : ReaderActR1_IdCheck
  : ֤
  : pID - 뻺ָ
        Section - Ҫ֤ Χ0-15
        Key - 'A''a'A, 'B''b'B
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int Cmd_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid)
{
   return pReaderDrv->pCmd_IdCheck(pID, Section, Key, pUid);
}

/******************************************************************************
  : Cmd_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int Cmd_BlockRead(u8 *pData, u8 Block)
{
    return pReaderDrv->pCmd_BlockRead(pData, Block);
}

/******************************************************************************
  : Cmd_ReadBlock
  : д
  : pData - дݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int Cmd_BlockWrite(u8 *pData, u8 Block)
{
    return pReaderDrv->Cmd_BlockWrite(pData, Block);
}

