
#ifndef __DRV_COMMUUSART3_H__
#define __DRV_COMMUUSART3_H__

#include "Global.h"

#define Reader_USARTx_BaudRate      (9600)

#define Reader_USARTx                           USART3
#define Reader_USARTx_CLK                       RCC_APB1Periph_USART3
#define Reader_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define Reader_USARTx_IRQn                      USART3_IRQn
#define Reader_USARTx_IRQHandler                USART3_IRQHandler

#define Reader_USARTx_TX_PIN                    GPIO_Pin_8
#define Reader_USARTx_TX_GPIO_PORT              GPIOD
#define Reader_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Reader_USARTx_TX_SOURCE                 GPIO_PinSource8
#define Reader_USARTx_TX_AF                     GPIO_AF_USART3

#define Reader_USARTx_RX_PIN                    GPIO_Pin_9
#define Reader_USARTx_RX_GPIO_PORT              GPIOD
#define Reader_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Reader_USARTx_RX_SOURCE                 GPIO_PinSource9
#define Reader_USARTx_RX_AF                     GPIO_AF_USART3

typedef u8 (*pReaderSendByte)(u8 Data);

typedef enum
{
  eReaderType_No         = 0x00,
  eReaderType_ActR1      = 0x01,
  eReaderType_Pcd200     = 0x02,
  eReaderType_ZLG600A    = 0x03,
  eReaderType_Max        = eReaderType_ZLG600A,
}EnumReaderType;

typedef struct
{
  u8 (*pReaderInit)(osMessageQId RecvOsMsgQId, pReaderSendByte pSendByte);
  int (*Cmd_CardFind)(u8 *pUID);
  int (*pCmd_IdCheck)(u8* pID, u8 Section, u8 Key, u8 *pUid);
  int (*pCmd_BlockRead)(u8 *pData, u8 Block);
  int (*Cmd_BlockWrite)(u8 *pData, u8 Block);
}StructReaderDrv;

extern u8 ReaderInit(void);
extern void ReaderDiscern(void);

extern int Cmd_CardFind(u8 *pUID);
extern int Cmd_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid);
extern int Cmd_BlockRead(u8 *pData, u8 Block);
extern int Cmd_BlockWrite(u8 *pData, u8 Block);

#endif

