
#ifndef __DRV_CONNECT_H__
#define __DRV_CONNECT_H__

#include "Global.h"

#define Dc_ADC                          ADC1
#define Dc_ADC_CLK                      RCC_APB2Periph_ADC1
#define Dc_ADC_CLK_INIT                 RCC_APB2PeriphClockCmd
/**************************DMA for ADC********************************/
#define Dc_ADC_DMA                      DMA1
#define Dc_ADC_DMA_CLK                  RCC_AHBPeriph_DMA1
#define Dc_ADC_DMA_CLK_INIT             RCC_AHBPeriphClockCmd
#define Dc_ADC_DMA_CHANNEL              DMA1_Channel1
/**************************ADC Pin ***********************************/
#define Cp_A_ADC_CHANNEL                ADC_Channel_8
#define Cp_A_ADC_PIN                    GPIO_Pin_1
#define Cp_A_ADC_GPIO_PORT              GPIOB
#define Cp_A_ADC_GPIO_CLK               RCC_APB2Periph_GPIOB

#define Cp_B_ADC_CHANNEL                ADC_Channel_9
#define Cp_B_ADC_PIN                    GPIO_Pin_0
#define Cp_B_ADC_GPIO_PORT              GPIOB
#define Cp_B_ADC_GPIO_CLK               RCC_APB2Periph_GPIOB

#define TempA_ADC_CHANNEL                ADC_Channel_10
#define TempA_ADC_PIN                    GPIO_Pin_0
#define TempA_ADC_GPIO_PORT              GPIOC
#define TempA_ADC_GPIO_CLK               RCC_APB2Periph_GPIOC

#define TempB_ADC_CHANNEL                ADC_Channel_11
#define TempB_ADC_PIN                    GPIO_Pin_1
#define TempB_ADC_GPIO_PORT              GPIOC
#define TempB_ADC_GPIO_CLK               RCC_APB2Periph_GPIOC


/**************************PWM and timer******************************/
#define CP_TIM                          TIM4
#define CP_TIM_CLK                      RCC_APB1Periph_TIM4
#define CP_TIM_CLK_INIT                 RCC_APB1PeriphClockCmd

/**************************ӿ  A  ******************************/
#define CP_A_OUT_PIN                      GPIO_Pin_12
#define CP_A_OUT_GPIO_PORT                GPIOD
#define CP_A_OUT_GPIO_CLK                 RCC_APB2Periph_GPIOD
#define CP_A_OCxInit                      TIM_OC1Init
#define CP_A_OCxPreloadConfig             TIM_OC1PreloadConfig
/**************************Cc       ******************************/
#define Cc_A_Check_PIN        GPIO_Pin_14
#define Cc_A_Check_GPIO_PORT  GPIOE
#define Cc_A_Check_GPIO_CLK   RCC_APB2Periph_GPIOE
#define GetCcStarus_A() (((Cc_A_Check_GPIO_PORT->IDR & Cc_A_Check_PIN) != Bit_RESET) ? Bit_SET : Bit_RESET)

/**************************ӿ  B  ******************************/
#define CP_B_OUT_PIN                      GPIO_Pin_13
#define CP_B_OUT_GPIO_PORT                GPIOD
#define CP_B_OUT_GPIO_CLK                 RCC_APB2Periph_GPIOD
#define CP_B_OCxInit                      TIM_OC2Init
#define CP_B_OCxPreloadConfig             TIM_OC2PreloadConfig
/**************************Cc       ******************************/
#define Cc_B_Check_PIN        GPIO_Pin_15
#define Cc_B_Check_GPIO_PORT  GPIOE
#define Cc_B_Check_GPIO_CLK   RCC_APB2Periph_GPIOE
#define GetCcStarus_B() (((Cc_B_Check_GPIO_PORT->IDR & Cc_B_Check_PIN) != Bit_RESET) ? Bit_SET : Bit_RESET)

/**************************Stop     ******************************/
#define Stop_Check_PIN        GPIO_Pin_0
#define Stop_Check_GPIO_PORT  GPIOE
#define Stop_Check_GPIO_CLK   RCC_APB2Periph_GPIOE
#define GetStopStarus() (((Stop_Check_GPIO_PORT->IDR & Stop_Check_PIN) != Bit_RESET) ? Bit_SET : Bit_RESET)
/**************************׮     ******************************/
#define Door_Check_PIN        GPIO_Pin_3
#define Door_Check_GPIO_PORT  GPIOE
#define Door_Check_GPIO_CLK   RCC_APB2Periph_GPIOE
#define GetDoorStarus() (((Door_Check_GPIO_PORT->IDR & Door_Check_PIN) != Bit_RESET) ? Bit_SET : Bit_RESET)


typedef enum
{
  eDcChn_Cp_A = 0,
  eDcChn_Cp_B = 1,
  eDcChn_TempA = 2,
  eDcChn_TempB = 3,
}EnumDcChannel;

#define Dc_AverageSize (32)
extern u16 DcAdcValueAlign[Dc_AverageSize][4];

extern void DcAdcInit(void);

extern void CpPwmInit(void);
extern void CpDutySet_A(u16 Duty);
extern void CpDutySet_B(u16 Duty);
extern void CcCheckInit(void);
extern void StopCheckInit(void);
extern void DoorCheckInit(void);

#endif

