
#ifndef __DRV_DCMODULE_H__
#define __DRV_DCMODULE_H__

#include "Global.h"

#define DcModule_BaudRate        (250)

#define DcModule_Can            eCan_1
#define DcModule_CanPower       ePeriphPower_CAN1
#define DcModule_CanClk         ePeriphClk_CAN1
#define DcModule_CanInt         CAN_INT

#define DcModuleTx_Pin           ePin_1
#define DcModuleTx_Port          ePort_0
#define DcModuleTx_PinFunc       ePinFunc_1

#define DcModuleRx_Pin           ePin_0
#define DcModuleRx_Port          ePort_0
#define DcModuleRx_PinFunc       ePinFunc_1

typedef struct
{
  u16 MaxVolt;//0.1V/Bit;
  u16 MinVolt;//0.1V/Bit;
  u16 MaxCurrt;//0.1A/Bit;
  u16 MinCurrt;//0.1A/Bit;
  u16 SingleMaxCurrt;//0.1A/Bit
}StructDcModuleAbility;
typedef union
{
  u32 Mult;
  struct
  {
    u32 SeNunLo : 9;
    u32 ProduDay: 5;
    u32 ModAd   : 7;//module adress
    u32 MonAd   : 4;//monitor adress
    u32 Protocol: 4;
    u32 Reserve : 3;
  }Disp;
}UnionYouExtId;

typedef struct
{
  u8 Data[8];
  u8 Len; //֡ݳ
  u32 Id;//֡ID
}StructDcModuleSend;

typedef struct
{
  u8  Cmd;
  u8  ValidNum;
  u32 SetVolt;//0.001V/Bit
  u32 SetCurrt;//0.001A/Bit
  long long OnlineFlag;
  long long ValidFlag;
}StructDcModuleManage;

typedef struct
{
  u8 CtrlFlag;
  u16 NeedVolt;//0.1V/Bit;
  u16 NeedCurrt;//0.1A/Bit;
  u16 ActualVolt;//0.1V/Bit;
  u16 ActualCurrt;//0.1A/Bit;
}StructDcModuleCtrl;

#define TemCtrlSwith 0//¿ؿ 1:򿪣0:ر

#if 1
#define DcModuleMaxVolt   (7500)//750V
#define DcModuleMinVolt   (2000)//200V
#define DcModuleMaxCurrt  (100) //10A
#define DcModuleMinCurrt  (5)  //1A
#define DcModuleSinMaxCurrt    (2000)


#else

#define DcModuleMaxVolt   (5000)//750V
#define DcModuleMinVolt   (2000)//250V
#define DcModuleMaxCurrt  (150) //15A
#define DcModuleMinCurrt  (10)  //1A
#endif
typedef enum
{
  eSwSta_Low= 0,
  eSwSta_High,
}EnumModuStatus;

typedef struct
{
  u8  Id;
  u8  Temp;
  u16 Volt;//0.1V/Bit;
  u16 Currt;//0.1A/Bit;
  u16 State;
  u32 RecvTime;
  EnumModuStatus ModStatus;
}StructDcModuleStatus;

extern StructDcModuleAbility DcModuleAbility;
extern void DcModuleCanInit_B(void);

extern StructDcModuleManage DcModuleManage;
extern StructDcModuleManage DcModuleManage_B;

extern StructDcModuleCtrl DcModuleCtrl;
extern StructDcModuleCtrl DcModuleCtrl_B;

extern u8 DcModuleInit(void);
extern u8 DcModuleSendMsg(StructDcModuleSend *pMsg);

extern void DcModuleSet(EnumSwitchStatus Set, u16 Volt, u16 Currt);
extern u16 GetDcModuleVolt(void);
extern u16 GetDcModuleCurrt(void);
extern u16 GetDcModuleVoltSet(void);
extern u16 GetDcModuleCurrtSet(void);

extern u8 DcModuleInit_B(void);
extern u8 DcModuleSendMsg_B(StructDcModuleSend *pMsg);

extern void DcModuleSet_B(EnumSwitchStatus Set, u16 Volt, u16 Currt);
extern u16 GetDcModuleVolt_B(void);
extern u16 GetDcModuleCurrt_B(void);
extern u16 GetDcModuleVoltSet_B(void);
extern u16 GetDcModuleCurrtSet_B(void);

extern void DcModuleSet_AB(EnumSwitchStatus Set, u16 Volt, u16 Currt);
extern u16 GetDcModuleVolt_AB(void);
extern u16 GetDcModuleCurrt_AB(void);
extern u16 GetDcModuleVoltSet_AB(void);
extern u16 GetDcModuleCurrtSet_AB(void);
extern u32 TemDecreaseCurrentValue(void);
extern u32 TemDecreaseCurrentValueB(void);
extern u8 ChargeEnable_AB;
extern u32 TemDecreaseCurrentValue(void);
#endif

