
#ifndef __DRV_DTUUSR_H__
#define __DRV_DTUUSR_H__

#include "Global.h"

#include "Global.h"

#define Dtu_BaudRate      (115200)

#define Dtu_Uart          eUart_0
#define Dtu_UartPower     ePeriphPower_UART0
#define Dtu_UartClk       ePeriphClk_UART0
#define Dtu_UartInt       UART0_INT

#define DtuTx_Pin         ePin_2
#define DtuTx_Port        ePort_0
#define DtuTx_PinFunc     ePinFunc_1

#define DtuRx_Pin         ePin_3
#define DtuRx_Port        ePort_0
#define DtuRx_PinFunc     ePinFunc_1

typedef enum
{
  eDtuSelfCtrl_None = 0,
  eDtuSelfCtrl_CloseSckt,
  eDtuSelfCtrl_Error,
}EnumDtuSelfCtrl;

typedef union
{
  u32 Mux;
  struct
  {
    u32 NoMod : 1;
    u32 NoAp  : 1;
    u32 NoCon : 1;
  }Bit;
}StructDtuError;

typedef struct
{
  osMessageQId RecvQ;
  osMessageQId SendQ;
}StructDtuCommu;

typedef struct
{
  u8 ErrCnt;
  u8 Status;
  u32 StatusTick;
}StructDtuProc;

typedef struct
{
  EnumDtuSelfCtrl SelCtrl;
#if 0
  u8 Csq;
  char Resp[64];
#endif
  u32 LastRecvTime;
  StructDtuError Err;
  StructDtuCommu Uart;
  StructDtuProc Proc;
  osMessageQId AppRecvQ;
  osMutexId SendMutex;
}StructDtuSta;

typedef void(*pDtuProcHandle)(void);

extern StructDtuSta Dtu;

extern u8 DtuInit(osMessageQId AppRecvQ);
extern u8 DtuNetAvail(void);
extern int DtuTcpSend(u8 *pData, u16 Len);
extern void DtuTcpClose(void);

#endif




