
/******************************************************************************
ļ  : Drv_E2rom.c
  : AT24C512BN
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_E2rom.h"

#define I2cDelay()  DelayUs(5)

#define SclHi()     GPIO_SetBits(E2rom_SCL_GPIO_PORT, E2rom_SCL_PIN)
#define SclLo()     GPIO_ResetBits(E2rom_SCL_GPIO_PORT, E2rom_SCL_PIN)
#define SclRead()   GPIO_ReadInputDataBit(E2rom_SCL_GPIO_PORT, E2rom_SCL_PIN)

#define SdaHi()     GPIO_SetBits(E2rom_SDA_GPIO_PORT, E2rom_SDA_PIN)
#define SdaLo()     GPIO_ResetBits(E2rom_SDA_GPIO_PORT, E2rom_SDA_PIN)
#define SdaRead()   GPIO_ReadInputDataBit(E2rom_SDA_GPIO_PORT, E2rom_SDA_PIN)

u8 E2romError = 0;

/******************************************************************************
  : DelayUs
  : ΢뼰ʱ
  : Us - Ҫʱ΢
  : 
******************************************************************************/
static void DelayUs(u32 Us)
{
  u32 i;

  while(Us)
  {
    for(i=0;i<31;i++)
    {
    }
    Us--;
  }
}

/******************************************************************************
  : SetSclOut
  : SCLźΪ©
  : 
  : 
******************************************************************************/
static void SetSclOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SCL_PIN;
  GPIO_Init(E2rom_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclIn
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SCL_PIN;
  GPIO_Init(E2rom_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclOutExt
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SCL_PIN;
  GPIO_Init(E2rom_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOut
  : SDAźΪ©
  : 
  : 
******************************************************************************/
static void SetSdaOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SDA_PIN;
  GPIO_Init(E2rom_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaIn
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SDA_PIN;
  GPIO_Init(E2rom_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOutExt
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = E2rom_SDA_PIN;
  GPIO_Init(E2rom_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : I2cStart
  : I2C߿ʼź
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
static u8 I2cStart(void)
{
  u8 i;

  SclHi();
  SdaHi();
  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }
  /*Ϊ*/
  SetSclOutExt();
  SetSdaOutExt();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
  return TRUE;
}

/******************************************************************************
  : I2cReStart
  : I2C¿ʼ
  : 
  : 
******************************************************************************/
static void I2cReStart(void)
{
  SdaHi();
  SclHi();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
}

/******************************************************************************
  : I2cStart
  : I2C߽ź
  : 
  : 
******************************************************************************/
static void I2cStop(void)
{
  SdaLo();   //PA2(SDA)=00v
  I2cDelay();
  SclHi();    //PA1(SCL)=13.3V
  I2cDelay();
  SdaHi();    //PA2(SDA)=13.3V
  I2cDelay();
  /*Ϊ©*/
  SetSclOut();
  SetSdaOut();
}

/******************************************************************************
  : I2cSendByte
  : I2C߷һֽ
  : Data - ͵ֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 I2cSendByte(u8 Data)
{
  u8 i;
  u8 Bit;
  u8 Rtn;

  Bit = 0x80;
  for(i=0; i<8; i++)
  {
    if(Data & Bit)
      SdaHi();//SDAŷ1
    else
      SdaLo();//SDAŷ0
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    Bit = Bit >> 1;
    I2cDelay();
  }

  SdaHi();
  SetSdaIn();
  I2cDelay();
  SclHi();
  I2cDelay();
  if(SdaRead())
    Rtn = FALSE;
  else
    Rtn = TRUE;
  I2cDelay();
  SclLo();
  I2cDelay();
  SetSdaOutExt();
  return Rtn;
}

/******************************************************************************
  : I2cReadByte
  : I2C߶һֽ
  : Ack - 0 Ӧ 1 Ӧ
  : ض
******************************************************************************/
static u8 I2cReadByte(u8 Ack)
{
  u8 i;
  u8 Data;

  Data = 0;
  SetSdaIn();
  for(i=0; i<8; i++)
  {
    Data = Data << 1;
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    if(SdaRead())
      Data |= 0x01;
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    I2cDelay();
  }
  SetSdaOutExt();

  if(Ack)
    SdaHi();
  else
    SdaLo();
  I2cDelay();
  SclHi();
  I2cDelay();
  I2cDelay();
  SclLo();
  I2cDelay();
  return Data;
}

osMutexId E2RomMutex = NULL;

/******************************************************************************
  : E2romInit
  : E2romӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 E2romInit(void)
{
  u8 i;

  E2RomMutex = NULL;

  RCC_AHB1PeriphClockCmd(E2rom_SCL_GPIO_CLK, ENABLE);
  RCC_AHB1PeriphClockCmd(E2rom_SDA_GPIO_CLK, ENABLE);
  SclHi();
  SdaHi();
  SetSdaOut();
  SetSclOut();

  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
//      SclHi();
//      SdaHi();
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }

//  SclHi();
//  SdaHi();
  SetSclOut();
  SetSdaOut();

  osMutexDef(E2RomMutex);
  E2RomMutex = osMutexCreate(osMutex(E2RomMutex));

  return TRUE;
}

/******************************************************************************
  : E2romWritePage
  : 24C512ҳд
  : Addr - ʼַ
        pData - Ҫдݵָ
        Len - Ҫдݳ
  : ο EnumE2romError
******************************************************************************/
EnumE2romError E2romWritePage(u8 *pData, u16 Addr, u16 Len)
{
  EnumE2romError Err;
  u16 i;

  if(NULL == pData)
    return eE2romErr_DataPiont;
  if(Len > (0xFFFF - Addr))
    return eE2romErr_WriteOver;

  if(0 == Len)
    return eE2romErr_Sucess;

  if(FALSE == I2cStart())
  {
    E2romError = 1;
    Err = eE2romErr_BusErr;
    goto __E2romWritReturn__;
  }

  Err = eE2romErr_Sucess;
  if(FALSE == I2cSendByte(E2rom_SlaveAddr))
  {
    E2romError = 2;
    Err = eE2romErr_WriteCmd;
    goto __E2romWritReturn__;
  }
  if(FALSE == I2cSendByte((u8)(Addr>>8)))
  {
    Err = eE2romErr_RegAddrHi;
    goto __E2romWritReturn__;
  }
  if(FALSE == I2cSendByte((u8)(Addr&0xFF)))
  {
    Err = eE2romErr_RegAddrLo;
    goto __E2romWritReturn__;
  }

  for(i=0; i<Len; i++)
  {
    if(FALSE == I2cSendByte(pData[i]))
    {
      Err = eE2romErr_WriteData;
      goto __E2romWritReturn__;
    }
  }

__E2romWritReturn__:
  I2cStop();

  if(eE2romErr_Sucess == Err)
    E2romError = 0;

  return Err;
}
#if 0

/******************************************************************************
  : E2romWriteData
  : 24C512д
  : Addr - ʼַ
        pData - Ҫдݵָ
        Len - Ҫдݳ
  : ο EnumE2romError
******************************************************************************/
EnumE2romError E2romWriteData(u16 WriteAddr, u8 *pBuffer, u16 NumByteToWrite)
{
  u16 Addr = 0;
  u16 NumOfPage = 0;
  u16 NumOfSingle = 0;
  u16 count = 0;
  EnumE2romError Err = eE2romErr_Sucess;

  Addr = WriteAddr % E2rom_PageSize;

  /*!< If WriteAddr is E2rom_PageSize aligned  */
  if(Addr == 0)
  {
    NumOfPage =  NumByteToWrite / E2rom_PageSize;
    NumOfSingle = NumByteToWrite % E2rom_PageSize;
    while(NumOfPage)
    {
      Err = E2romWritePage(pBuffer, WriteAddr, E2rom_PageSize);
      if(eE2romErr_Sucess != Err)
        return Err;

      WriteAddr +=  E2rom_PageSize;
      pBuffer += E2rom_PageSize;
      NumOfPage--
    }

    if(0 != NumOfSingle)
      Err = E2romWritePage(pBuffer, WriteAddr, NumOfSingle);
    return Err;
  }
  /*!< If WriteAddr is not E2rom_PageSize aligned  */
  else
  {
    count = E2rom_PageSize - Addr;

    if(NumByteToWrite <= count)
      return E2romWritePage(pBuffer, WriteAddr, NumByteToWrite);
    else
    {
      Err = E2romWritePage(pBuffer, WriteAddr, count);
      if(eE2romErr_Sucess != Err)
        return Err;
      WriteAddr += count;
      pBuffer += count;

      NumByteToWrite -= count;
      NumOfPage =  NumByteToWrite / E2rom_PageSize;
      NumOfSingle = NumByteToWrite % E2rom_PageSize;

      while(NumOfPage)
      {
        Err = E2romWritePage(pBuffer, WriteAddr, E2rom_PageSize);
        if(eE2romErr_Sucess != Err)
          return Err;
        WriteAddr +=  E2rom_PageSize;
        pBuffer += E2rom_PageSize;
        NumOfPage--;
      }
      if(NumOfSingle != 0)
        Err = E2romWritePage(pBuffer, WriteAddr, NumOfSingle);
    }
    return Err;
  }
}
#endif

/******************************************************************************
  : E2romWriteData
  : 24C512д
  : Addr - ʼַ
        pData - Ҫдݵָ
        Len - Ҫдݳ
  : ο EnumE2romError
******************************************************************************/
EnumE2romError E2romWriteData(u16 WriteAddr, u8 *pBuffer, u16 NumByteToWrite)
{
  u16 Addr = 0;
  u16 NumOfPage = 0;
  u16 NumOfSingle = 0;
  u16 count = 0;
  EnumE2romError Err = eE2romErr_Sucess;

  if(NULL == E2RomMutex)
    return eE2romErr_Error;

  if(osOK != osMutexWait(E2RomMutex, 5000))//5
    return eE2romErr_Error;

  Addr = WriteAddr % E2rom_PageSize;

  if(0 != Addr)
  {/*ݳȷҳ*/
    count = E2rom_PageSize - Addr;
    if(NumByteToWrite <= count)//ȫһҳ
    {
      Err = E2romWritePage(pBuffer, WriteAddr, NumByteToWrite);
      goto __E2RomWrReturn__;
    }

    DelayUs(25000);
    Err = E2romWritePage(pBuffer, WriteAddr, count);
    if(eE2romErr_Sucess != Err)
      goto __E2RomWrReturn__;

    WriteAddr += count;
    pBuffer += count;
    NumByteToWrite -= count;
  }

  NumOfPage =  NumByteToWrite / E2rom_PageSize;
  NumOfSingle = NumByteToWrite % E2rom_PageSize;

  while(NumOfPage)
  {
    DelayUs(25000);
    Err = E2romWritePage(pBuffer, WriteAddr, E2rom_PageSize);
    if(eE2romErr_Sucess != Err)
      goto __E2RomWrReturn__;
    WriteAddr +=  E2rom_PageSize;
    pBuffer += E2rom_PageSize;
    NumOfPage--;
  }
  if(NumOfSingle != 0)
  {
    DelayUs(25000);
    Err = E2romWritePage(pBuffer, WriteAddr, NumOfSingle);
  }

__E2RomWrReturn__:
  osMutexRelease(E2RomMutex);
  return Err;
}

/******************************************************************************
  : I2cSendByte
  : 24C512
  : Addr - ʼַ
        pData - ݵָ
        Len - Ҫݳ
  : ο EnumE2romError
******************************************************************************/
EnumE2romError E2romReadData(u16 Addr, u8 *pData, u16 Len)
{
  EnumE2romError Err;
  u16 i;

  if(NULL == E2RomMutex)
    return eE2romErr_Error;

  if(NULL == pData)
    return eE2romErr_DataPiont;
  if(Len > (0xFFFF - Addr))
    return eE2romErr_WriteOver;

  if(0 == Len)
    return eE2romErr_Sucess;

  if(osOK != osMutexWait(E2RomMutex, 5000))//5
    return eE2romErr_Error;

  if(FALSE == I2cStart())
  {
    E2romError = 1;
    Err = eE2romErr_BusErr;
    goto __E2romReadReturn__;
  }

  Err = eE2romErr_Sucess;
  if(FALSE == I2cSendByte(E2rom_SlaveAddr))
  {
    E2romError = 2;
    Err = eE2romErr_WriteCmd;
    goto __E2romReadReturn__;
  }
  if(FALSE == I2cSendByte((u8)(Addr>>8)))
  {
    Err = eE2romErr_RegAddrHi;
    goto __E2romReadReturn__;
  }
  if(FALSE == I2cSendByte((u8)(Addr&0xFF)))
  {
    Err = eE2romErr_RegAddrLo;
    goto __E2romReadReturn__;
  }

  I2cReStart();
  if(FALSE == I2cSendByte(E2rom_SlaveAddr|0x01))
  {
    Err = eE2romErr_ReadCmd;
    goto __E2romReadReturn__;
  }

  for(i=0; i<(Len-1); i++)
  {
    pData[i] = I2cReadByte(0);
  }

  pData[i] = I2cReadByte(1);

__E2romReadReturn__:
  I2cStop();
  osMutexRelease(E2RomMutex);
  if(eE2romErr_Sucess == Err)
    E2romError = 0;
  return Err;
}

