
#include "Drv_ImdJyc.h"

#define ImdAckTimeOut  (350)

StructImdValue ImdValue;
StructImdValue ImdValue_B;

osMessageQId ImdRecvQueue = NULL;

osMutexId ImdMutex = NULL;

#define ImdSendEnable()  Imd_RxTxEn_GPIO_PORT->BSRRL = Imd_RxTxEn_PIN//ģʽ
#define ImdSendDisable() Imd_RxTxEn_GPIO_PORT->BSRRH = Imd_RxTxEn_PIN//ģʽ

/******************************************************************************
  : Imd_USARTx_IRQHandler
  : ܱڽж
  : 
  : 
******************************************************************************/
void Imd_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;

  SR = Imd_USARTx->SR;
  CR1 = Imd_USARTx->CR1;

  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {
    Data = (u8)Imd_USARTx->DR;
    osMessagePut(ImdRecvQueue, Data, 0);
  }

  if((CR1 & USART_CR1_TCIE) && (SR & USART_SR_TC))
  {
    Imd_USARTx->CR1 &= ~USART_CR1_TCIE;
    ImdSendDisable();
  }
}

/******************************************************************************
  : ImdSendByte
  : ֽ
  : Data - յֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 ImdSendByte(u8 Data)
{
  while(USART_FLAG_TC != (Imd_USARTx->SR & USART_FLAG_TC))
  {
  }

  Imd_USARTx->DR = Data;

  while(USART_FLAG_TC != (Imd_USARTx->SR & USART_FLAG_TC))
  {
  }

  return TRUE;
}

int ImdRecvByte(u8 *pData, u32 TimeOut)
{
  osEvent RecvEvent;

  if(NULL == ImdRecvQueue)
    return -1;
  RecvEvent = osMessageGet(ImdRecvQueue, TimeOut);
  if(osEventMessage == RecvEvent.status)
  {
    *pData = RecvEvent.value.v;
    return 0;
  }
  else
    return -2;
}

// CRC λֵֽ
const u8 RtuCrcTablHi[] =
{
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
  0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
  0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
  0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
  0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
  0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
  0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
  0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
  0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40, 0x00, 0xC1, 0x81, 0x40,
  0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0, 0x80, 0x41, 0x00, 0xC1,
  0x81, 0x40, 0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41,
  0x00, 0xC1, 0x81, 0x40, 0x01, 0xC0, 0x80, 0x41, 0x01, 0xC0,
  0x80, 0x41, 0x00, 0xC1, 0x81, 0x40
};

// CRC λֵֽ
const u8 RtuCrcTabLo[] =
{
  0x00, 0xC0, 0xC1, 0x01, 0xC3, 0x03, 0x02, 0xC2, 0xC6, 0x06,
  0x07, 0xC7, 0x05, 0xC5, 0xC4, 0x04, 0xCC, 0x0C, 0x0D, 0xCD,
  0x0F, 0xCF, 0xCE, 0x0E, 0x0A, 0xCA, 0xCB, 0x0B, 0xC9, 0x09,
  0x08, 0xC8, 0xD8, 0x18, 0x19, 0xD9, 0x1B, 0xDB, 0xDA, 0x1A,
  0x1E, 0xDE, 0xDF, 0x1F, 0xDD, 0x1D, 0x1C, 0xDC, 0x14, 0xD4,
  0xD5, 0x15, 0xD7, 0x17, 0x16, 0xD6, 0xD2, 0x12, 0x13, 0xD3,
  0x11, 0xD1, 0xD0, 0x10, 0xF0, 0x30, 0x31, 0xF1, 0x33, 0xF3,
  0xF2, 0x32, 0x36, 0xF6, 0xF7, 0x37, 0xF5, 0x35, 0x34, 0xF4,
  0x3C, 0xFC, 0xFD, 0x3D, 0xFF, 0x3F, 0x3E, 0xFE, 0xFA, 0x3A,
  0x3B, 0xFB, 0x39, 0xF9, 0xF8, 0x38, 0x28, 0xE8, 0xE9, 0x29,
  0xEB, 0x2B, 0x2A, 0xEA, 0xEE, 0x2E, 0x2F, 0xEF, 0x2D, 0xED,
  0xEC, 0x2C, 0xE4, 0x24, 0x25, 0xE5, 0x27, 0xE7, 0xE6, 0x26,
  0x22, 0xE2, 0xE3, 0x23, 0xE1, 0x21, 0x20, 0xE0, 0xA0, 0x60,
  0x61, 0xA1, 0x63, 0xA3, 0xA2, 0x62, 0x66, 0xA6, 0xA7, 0x67,
  0xA5, 0x65, 0x64, 0xA4, 0x6C, 0xAC, 0xAD, 0x6D, 0xAF, 0x6F,
  0x6E, 0xAE, 0xAA, 0x6A, 0x6B, 0xAB, 0x69, 0xA9, 0xA8, 0x68,
  0x78, 0xB8, 0xB9, 0x79, 0xBB, 0x7B, 0x7A, 0xBA, 0xBE, 0x7E,
  0x7F, 0xBF, 0x7D, 0xBD, 0xBC, 0x7C, 0xB4, 0x74, 0x75, 0xB5,
  0x77, 0xB7, 0xB6, 0x76, 0x72, 0xB2, 0xB3, 0x73, 0xB1, 0x71,
  0x70, 0xB0, 0x50, 0x90, 0x91, 0x51, 0x93, 0x53, 0x52, 0x92,
  0x96, 0x56, 0x57, 0x97, 0x55, 0x95, 0x94, 0x54, 0x9C, 0x5C,
  0x5D, 0x9D, 0x5F, 0x9F, 0x9E, 0x5E, 0x5A, 0x9A, 0x9B, 0x5B,
  0x99, 0x59, 0x58, 0x98, 0x88, 0x48, 0x49, 0x89, 0x4B, 0x8B,
  0x8A, 0x4A, 0x4E, 0x8E, 0x8F, 0x4F, 0x8D, 0x4D, 0x4C, 0x8C,
  0x44, 0x84, 0x85, 0x45, 0x87, 0x47, 0x46, 0x86, 0x82, 0x42,
  0x43, 0x83, 0x41, 0x81, 0x80, 0x40
};

/*
˵
ִCRCɵCԵĺпܵCRCֵԤװ鵱У㱨ʱԼ򵥵ɣ
һ16λCRC256ܵĸλֽڣһ麬еλֽڵֵ
CRCķʽṩ˱ȶԱĻȥÿһַµCRCķ
ע⣺˳ڲִи/CRCֽڵĽ˺صѾCRCֵҲ˵úķֱֵӷڱ*ڷͣ
*/
//CRCУĺ
u16 ImdCrc16(u8 *pData, u16 Len)
{
  u8 CrcHi = 0xFF; /* CRCֽڳʼ */
  u8 CrcLo = 0xFF; /* CRC ֽڳʼ */
  u8 Index; /* CRCѭе */

  while(Len--) /* Ϣ */
  {
    Index = CrcHi ^ *pData++; /* CRC */
    CrcHi = CrcLo ^ RtuCrcTablHi[Index];
    CrcLo = RtuCrcTabLo[Index];
  }
  return (CrcHi << 8 | CrcLo);
}

void ImdCleanRecvQueue(void)
{
  int RecvMsg;
  u8 Data;

  do
  {/*սջ*/
    RecvMsg = ImdRecvByte(&Data, 1);
  }while(0 == RecvMsg);
}


/******************************************************************************
  : ReaderRespRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ImdReadRecv(u8 *pRespBuff, u16 MaxRespLen, u32 TimeOut)
{
  int RecvAck;
  u32 Time;
  u16 RecvCnt;
  u16 CheckSum;

  if(NULL == pRespBuff)
    return -1;
  if(0 == (MaxRespLen & 0x0001))
    return -2;
  if(MaxRespLen < 7)
    return -3;

  Time = GetSystemTick();
  RecvAck = ImdRecvByte(pRespBuff, TimeOut);
  if(0 == RecvAck)
  {
    RecvCnt = 1;
    while((GetSystemTick() - Time) < TimeOut)
    {
      RecvAck = ImdRecvByte(&pRespBuff[RecvCnt], 5);
      if(0 == RecvAck)
      {
        RecvCnt++;
        if(RecvCnt >= MaxRespLen)
        {
          if((ImdRtuAddr == pRespBuff[0]) && (0x03 == pRespBuff[1])
                && ((MaxRespLen - 5) == pRespBuff[2]) && (0 == (pRespBuff[2] & 0x01)))
          {
            CheckSum = ImdCrc16(pRespBuff, MaxRespLen-2);
            if(((u8)(CheckSum>>8) == pRespBuff[MaxRespLen-2])
                  && ((u8)(CheckSum>>0) == pRespBuff[MaxRespLen-1]))
              return 0;
          }
          memmove(pRespBuff, &pRespBuff[1], MaxRespLen-1);
        }
      }
      else
        RecvCnt = 0;
    }
  }

  return -4;
}

void ImdSendCmd(u8 *pData, u16 Len)
{
  ImdSendEnable();

  osDelay(2);

  ImdCleanRecvQueue();
  while(Len)
  {
    ImdSendByte(*pData);
    pData++;
    Len--;
  }
  ImdSendDisable();
}

/******************************************************************************
  : Cmd_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ImdRead(StructImdValue *pImdValue)
{
  u8 Buff[32] = {ImdRtuAddr, 0x03, 0x00, 0x00, 0x00, 0x08};
  u16 Temp;

  if(NULL == ImdMutex)
    return -1;

  if(osOK != osMutexWait(ImdMutex, 200))//5
    return -1;

  Temp = ImdCrc16(Buff, 6);
  Buff[6] = (u8)(Temp >> 8);
  Buff[7] = (u8)(Temp >> 0);

  ImdSendCmd(Buff, 8);
  if(0 == ImdReadRecv(Buff, 21, ImdAckTimeOut))
  {
    pImdValue->PositVolt = (Buff[5]<<8) | Buff[6];
    pImdValue->NegatVolt = (Buff[7]<<8) | Buff[8];
    pImdValue->PnVolt = (Buff[9]<<8) | Buff[10];
    pImdValue->PositResist = (Buff[11]<<8) | Buff[12];
    pImdValue->NegatResist = (Buff[13]<<8) | Buff[14];
    pImdValue->PositWarn = Buff[16];
    pImdValue->NegatWarn = Buff[18];
    osMutexRelease(ImdMutex);
    return 0;
  }

  osMutexRelease(ImdMutex);
  return -1;
}

/******************************************************************************
  : ReaderRespRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ImdWriteRecv(u8 *pRespBuff, u16 MaxRespLen, u32 TimeOut)
{
  int RecvAck;
  u32 Time;
  u16 RecvCnt;
  u16 CheckSum;

  if(NULL == pRespBuff)
    return -1;

  if(MaxRespLen < 7)
    return -3;

  Time = GetSystemTick();
  RecvAck = ImdRecvByte(pRespBuff, TimeOut);
  if(0 == RecvAck)
  {
    RecvCnt = 1;
    while((GetSystemTick() - Time) < TimeOut)
    {
      RecvAck = ImdRecvByte(&pRespBuff[RecvCnt], 5);
      if(0 == RecvAck)
      {
        RecvCnt++;
        if(RecvCnt >= MaxRespLen)
        {
          if((ImdRtuAddr == pRespBuff[0]) && (0x06 == pRespBuff[1]))
          {
            CheckSum = ImdCrc16(pRespBuff, MaxRespLen-2);
            if(((u8)(CheckSum>>8) == pRespBuff[MaxRespLen-2])
                  && ((u8)(CheckSum>>0) == pRespBuff[MaxRespLen-1]))
              return 0;
          }
          memmove(pRespBuff, &pRespBuff[1], MaxRespLen-1);
        }
      }
      else
        RecvCnt = 0;
    }
  }

  return -4;
}

/******************************************************************************
  : Cmd_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ImdWrite(u16 Addr, u16 Value)
{
  u8 SendBuff[16] = {ImdRtuAddr, 0x06, 0x00, 0x00, 0x00, 0x00};
  u8 RecvBuff[16] = {0};
  u16 Temp;

  if(NULL == ImdMutex)
    return -1;

  if(osOK != osMutexWait(ImdMutex, 200))//5
    return -1;

  SendBuff[2] = (u8)(Addr >> 8);
  SendBuff[3] = (u8)(Addr >> 0);
  SendBuff[4] = (u8)(Value >> 8);
  SendBuff[5] = (u8)(Value >> 0);

  Temp = ImdCrc16(SendBuff, 6);
  SendBuff[6] = (u8)(Temp >> 8);
  SendBuff[7] = (u8)(Temp >> 0);

  ImdSendCmd(SendBuff, 8);
  if(0 == ImdWriteRecv(RecvBuff, 8, ImdAckTimeOut))
  {
    if(0 == memcmp(SendBuff, RecvBuff, 8))
    {
      osMutexRelease(ImdMutex);
      return 0;
    }
  }

  osMutexRelease(ImdMutex);
  return -1;
}

/******************************************************************************
  : ReaderRespRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ImdReadRecv_B(u8 *pRespBuff, u16 MaxRespLen, u32 TimeOut)
{
  int RecvAck;
  u32 Time;
  u16 RecvCnt;
  u16 CheckSum;

  if(NULL == pRespBuff)
    return -1;
  if(0 == (MaxRespLen & 0x0001))
    return -2;
  if(MaxRespLen < 7)
    return -3;

  Time = GetSystemTick();
  RecvAck = ImdRecvByte(pRespBuff, TimeOut);
  if(0 == RecvAck)
  {
    RecvCnt = 1;
    while((GetSystemTick() - Time) < TimeOut)
    {
      RecvAck = ImdRecvByte(&pRespBuff[RecvCnt], 5);
      if(0 == RecvAck)
      {
        RecvCnt++;
        if(RecvCnt >= MaxRespLen)
        {
          if((ImdRtuAddr_B == pRespBuff[0]) && (0x03 == pRespBuff[1])
                && ((MaxRespLen - 5) == pRespBuff[2]) && (0 == (pRespBuff[2] & 0x01)))
          {
            CheckSum = ImdCrc16(pRespBuff, MaxRespLen-2);
            if(((u8)(CheckSum>>8) == pRespBuff[MaxRespLen-2])
                  && ((u8)(CheckSum>>0) == pRespBuff[MaxRespLen-1]))
              return 0;
          }
          memmove(pRespBuff, &pRespBuff[1], MaxRespLen-1);
        }
      }
      else
        RecvCnt = 0;
    }
  }

  return -4;
}
/******************************************************************************
  : Cmd_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ImdRead_B(StructImdValue *pImdValue)
{
  u8 Buff[32] = {ImdRtuAddr_B, 0x03, 0x00, 0x00, 0x00, 0x08};
  u16 Temp;

  if(NULL == ImdMutex)
    return -1;

  if(osOK != osMutexWait(ImdMutex, 200))//5
    return -1;

  Temp = ImdCrc16(Buff, 6);
  Buff[6] = (u8)(Temp >> 8);
  Buff[7] = (u8)(Temp >> 0);

  ImdSendCmd(Buff, 8);
  if(0 == ImdReadRecv_B(Buff, 21, ImdAckTimeOut))
  {
    pImdValue->PositVolt = (Buff[5]<<8) | Buff[6];
    pImdValue->NegatVolt = (Buff[7]<<8) | Buff[8];
    pImdValue->PnVolt = (Buff[9]<<8) | Buff[10];
    pImdValue->PositResist = (Buff[11]<<8) | Buff[12];
    pImdValue->NegatResist = (Buff[13]<<8) | Buff[14];
    pImdValue->PositWarn = Buff[16];
    pImdValue->NegatWarn = Buff[18];
    osMutexRelease(ImdMutex);
    return 0;
  }

  osMutexRelease(ImdMutex);
  return -1;
}

/******************************************************************************
  : ReaderRespRecv
  : Ӧ֡
  : pData - ָ
        Len - ȡݳ
        TimeOut - ȴظʱ
  : 0 - ʧ
        other - ճɹؽյֽ
******************************************************************************/
int ImdWriteRecv_B(u8 *pRespBuff, u16 MaxRespLen, u32 TimeOut)
{
  int RecvAck;
  u32 Time;
  u16 RecvCnt;
  u16 CheckSum;

  if(NULL == pRespBuff)
    return -1;

  if(MaxRespLen < 7)
    return -3;

  Time = GetSystemTick();
  RecvAck = ImdRecvByte(pRespBuff, TimeOut);
  if(0 == RecvAck)
  {
    RecvCnt = 1;
    while((GetSystemTick() - Time) < TimeOut)
    {
      RecvAck = ImdRecvByte(&pRespBuff[RecvCnt], 5);
      if(0 == RecvAck)
      {
        RecvCnt++;
        if(RecvCnt >= MaxRespLen)
        {
          if((ImdRtuAddr_B == pRespBuff[0]) && (0x06 == pRespBuff[1]))
          {
            CheckSum = ImdCrc16(pRespBuff, MaxRespLen-2);
            if(((u8)(CheckSum>>8) == pRespBuff[MaxRespLen-2])
                  && ((u8)(CheckSum>>0) == pRespBuff[MaxRespLen-1]))
              return 0;
          }
          memmove(pRespBuff, &pRespBuff[1], MaxRespLen-1);
        }
      }
      else
        RecvCnt = 0;
    }
  }

  return -4;
}

/******************************************************************************
  : Cmd_BlockRead
  : 
  : pData - ݴָ
        Block -  Χ0-31
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
int ImdWrite_B(u16 Addr, u16 Value)
{
  u8 SendBuff[16] = {ImdRtuAddr_B, 0x06, 0x00, 0x00, 0x00, 0x00};
  u8 RecvBuff[16] = {0};
  u16 Temp;

  if(NULL == ImdMutex)
    return -1;

  if(osOK != osMutexWait(ImdMutex, 200))//5
    return -1;

  SendBuff[2] = (u8)(Addr >> 8);
  SendBuff[3] = (u8)(Addr >> 0);
  SendBuff[4] = (u8)(Value >> 8);
  SendBuff[5] = (u8)(Value >> 0);

  Temp = ImdCrc16(SendBuff, 6);
  SendBuff[6] = (u8)(Temp >> 8);
  SendBuff[7] = (u8)(Temp >> 0);

  ImdSendCmd(SendBuff, 8);
  if(0 == ImdWriteRecv_B(RecvBuff, 8, ImdAckTimeOut))
  {
    if(0 == memcmp(SendBuff, RecvBuff, 8))
    {
      osMutexRelease(ImdMutex);
      return 0;
    }
  }

  osMutexRelease(ImdMutex);
  return -1;
}


/******************************************************************************
  : ImdAddrSet
  : д
  : addr - ԭַ
        changeaddr - ޸ĵַ
  :
******************************************************************************/
int ImdAddrSet(u8 addr, u8 changeaddr)
{
  u8 SendBuff[16] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
  u8 RecvBuff[16] = {0};
  u16 Temp;

  if(NULL == ImdMutex)
    return -1;

  if(osOK != osMutexWait(ImdMutex, 200))//5
    return -1;

  SendBuff[0] = addr;
  SendBuff[1] = 0x06;
  SendBuff[2] = 0x00;
  SendBuff[3] = 0x1A;
  SendBuff[4] = 0x00;
  SendBuff[5] = changeaddr;

  Temp = ImdCrc16(SendBuff, 6);
  SendBuff[6] = (u8)(Temp >> 8);
  SendBuff[7] = (u8)(Temp >> 0);

  ImdSendCmd(SendBuff, 8);
  ImdWriteRecv(RecvBuff, 8, ImdAckTimeOut);
  osDelay(300);

  SendBuff[0] = changeaddr;
  SendBuff[1] = 0x03;
  SendBuff[2] = 0x00;
  SendBuff[3] = 0x18;
  SendBuff[4] = 0x00;
  SendBuff[5] = 0x08;

  Temp = ImdCrc16(SendBuff, 6);
  SendBuff[6] = (u8)(Temp >> 8);
  SendBuff[7] = (u8)(Temp >> 0);

  ImdSendCmd(SendBuff, 8);
  if(((0x01 == changeaddr) && (0 == ImdWriteRecv(RecvBuff, 8, ImdAckTimeOut))) \
    ||((0x02 == changeaddr) && (0 == ImdWriteRecv_B(RecvBuff, 8, ImdAckTimeOut))))
    {
      if(0 == memcmp(SendBuff, RecvBuff, 8))
      {
        osMutexRelease(ImdMutex);
        return 0;
      }
    }
  osMutexRelease(ImdMutex);
  return -1;
}

/******************************************************************************
  : MeterInit
  : ܱͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 ImdInit(void)
{
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Enable GPIO clock */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Imd_RxTxEn_PIN;
  RCC_APB2PeriphClockCmd(Imd_RxTxEn_GPIO_CLK, ENABLE);
  GPIO_Init(Imd_RxTxEn_GPIO_PORT, &GPIO_InitStructure);
  //GPIO_ResetBits(Imd_RxTxEn_GPIO_PORT, Imd_RxTxEn_PIN);//ģʽ
  //GPIO_SetBits(Imd_RxTxEn_GPIO_PORT, Imd_RxTxEn_PIN);//ģʽ
  ImdSendEnable();

  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Imd_USARTx_TX_PIN;
  RCC_AHB1PeriphClockCmd(Imd_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_Init(Imd_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Imd_USARTx_RX_PIN;
  RCC_AHB1PeriphClockCmd(Imd_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_Init(Imd_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  Imd_USARTx_CLK_INIT(Imd_USARTx_CLK, ENABLE);

  GPIO_PinAFConfig(Imd_USARTx_TX_GPIO_PORT, Imd_USARTx_TX_SOURCE, Imd_USARTx_TX_AF);
  GPIO_PinAFConfig(Imd_USARTx_RX_GPIO_PORT, Imd_USARTx_RX_SOURCE, Imd_USARTx_RX_AF);

  /* Enable the USART OverSampling by 8 */
//  USART_OverSampling8Cmd(Imd_USARTx, ENABLE);

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = Imd_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(Imd_USARTx, &USART_InitStructure);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = Imd_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue */
  ImdRecvQueue = NULL;
  osMessageQDef(ImdRecvQueue, 32, u8);
  ImdRecvQueue = osMessageCreate(osMessageQ(ImdRecvQueue), NULL);

//  if(NULL == ImdRecvQueue)
//    return FALSE;

  ImdMutex = NULL;
  osMutexDef(ImdMutex);
  ImdMutex = osMutexCreate(osMutex(ImdMutex));

  /* Enable USART */
  USART_Cmd(Imd_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(Imd_USARTx, USART_IT_RXNE, ENABLE);

  return TRUE;
}


