
/******************************************************************************
ļ  : Drv_Meter.c
  : ܱ
  :
޸  : 2015-05-08      

******************************************************************************/

#include "Drv_Meter.h"
#include "Memory.h"

#define MeterAckTimeOut 500
typedef enum
{
  eMeterFrame_Head = 0x00,
  eMeterFrame_Addr,
  eMeterFrame_ReHead,
  eMeterFrame_Ctrl,
  eMeterFrame_DataLen,
  eMeterFrame_Data,
  eMeterFrame_CS,
  eMeterFrame_End
}EnumMeterFrameStatus;

StructMeterComm MeterComm;

StructMeterValue MeterValue =
{
  0,
  0,
  0,
  0,
  0,
  2200,
  0,
  2200,
  2200,
  2200,
  0,
  1000,
  5000
};
StructMeterValue MeterValue_B =
{
  0,
  0,
  0,
  0,
  0,
  2200,
  0,
  2200,
  2200,
  2200,
  0,
  1000,
  5000
};
StructMeterValue MeterValue_AC =
{
  0,
  0,
  0,
  0,
  0,
  2200,
  0,
  2200,
  2200,
  2200,
  0,
  1000,
  5000
};

/******************************************************************************
  : BcdToEnergy
  : BCDת
  : pBcd - BCDָ
        pEnergy - ָ
  : 
******************************************************************************/
static u8 BcdToEnergy(u8 *pBcd, s32 *pEnergy)
{
  u8 Temp;
  u32 Enery;

  if((NULL == pBcd) || (NULL == pEnergy))
    return FALSE;

  Temp = (pBcd[3] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = Temp;
  Temp = pBcd[3] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[2] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[2] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  if(Enery >= 80000000)
    *pEnergy = -(Enery - 80000000);
  else
    *pEnergy = Enery;

  return TRUE;
}

/******************************************************************************
  : BcdToEnergy
  : BCDת
  : pBcd - BCDָ
        pEnergy - ָ
  : 
******************************************************************************/
static u8 BcdToPositiveEnergy(u8 *pBcd, u32 *pEnergy)
{
  u8 Temp;
  u32 Enery;

  if((NULL == pBcd) || (NULL == pEnergy))
    return FALSE;

  Temp = (pBcd[3] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = Temp;
  Temp = pBcd[3] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[2] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[2] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Enery = (Enery * 10) + Temp;

  //if(Enery >= 80000000)
    //*pEnergy = -(Enery - 80000000);
  //else
    *pEnergy = Enery;

  return TRUE;
}

/******************************************************************************
  : BcdToVoltage
  : BCDת
  : pBcd - BCDָ
        pVoltage - ѹָ
  : 
******************************************************************************/
static u8 BcdToVoltage(u8 *pBcd, u32 *pVoltage)
{
  u8 Temp;
  u32 Voltage;

  if((NULL == pBcd) || (NULL == pVoltage))
    return FALSE;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Voltage = Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Voltage = (Voltage * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Voltage = (Voltage * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Voltage = (Voltage * 10) + Temp;

  *pVoltage = Voltage;

  return TRUE;
}

/******************************************************************************
  : BcdToCurrent
  : BCDת
  : pBcd - BCDָ
        pCurrent - ָ
  : 
******************************************************************************/
static u8 BcdToCurrent(u8 *pBcd, s32 *pCurrent)
{
  u8 Temp;
  s32 Current;

  if((NULL == pBcd) || (NULL == pCurrent))
    return FALSE;

  Temp = (pBcd[2] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = Temp;
  Temp = pBcd[2] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = (Current * 10) + Temp;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = (Current * 10) + Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = (Current * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = (Current * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Current = (Current * 10) + Temp;

  if(Current > 800000)
    *pCurrent = -(Current - 800000);
  else
    *pCurrent = Current;

  return TRUE;
}

/******************************************************************************
  : BcdToPower
  : BCDת
  : pBcd - BCDָ
        pValue - ָ
  : 
******************************************************************************/
static u8 BcdToPower(u8 *pBcd, u32 *pValue)
{
  u8 Temp;
  s32 Power;

  if((NULL == pBcd) || (NULL == pValue))
    return FALSE;

  Temp = (pBcd[2] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = Temp;
  Temp = pBcd[2] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = (Power * 10) + Temp;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = (Power * 10) + Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = (Power * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = (Power * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  Power = (Power * 10) + Temp;

 if(Power >= 800000)
    *pValue = -(Power - 800000);
  else
    *pValue = Power;

  return TRUE;
}

/******************************************************************************
  : BcdToPowerFac
  : BCDת
  : pBcd - BCDָ
        pVoltage - ָ
  : 
******************************************************************************/
static u8 BcdToPowerFac(u8 *pBcd, s32 *pValue)
{
  u8 Temp;
  u32 PowerFac;

  if((NULL == pBcd) || (NULL == pValue))
    return FALSE;

  Temp = (pBcd[1] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  PowerFac = Temp;
  Temp = pBcd[1] & 0x0F;
  if(Temp > 9)
    return FALSE;
  PowerFac = (PowerFac * 10) + Temp;

  Temp = (pBcd[0] >> 4) & 0x0F;
  if(Temp > 9)
    return FALSE;
  PowerFac = (PowerFac * 10) + Temp;
  Temp = pBcd[0] & 0x0F;
  if(Temp > 9)
    return FALSE;
  PowerFac = (PowerFac * 10) + Temp;

  if(PowerFac >= 8000)
    *pValue = -(PowerFac - 8000);
  else
    *pValue = PowerFac;

  return TRUE;
}

#define SendEnable()  Meter_A_RxTxEn_GPIO_PORT->BSRRL = Meter_A_RxTxEn_PIN//
#define SendDisable() Meter_A_RxTxEn_GPIO_PORT->BSRRH = Meter_A_RxTxEn_PIN//

/******************************************************************************
  : Meter_A_USARTx_IRQHandler
  : ܱڽж
  : 
  : 
******************************************************************************/
void Meter_A_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;

  SR = Meter_A_USARTx->SR;
  CR1 = Meter_A_USARTx->CR1;

  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {
    Data = (u8)Meter_A_USARTx->DR;
    osMessagePut(MeterComm.RecvMsg, Data, 0);
  }

  if((CR1 & USART_CR1_TCIE) && (SR & USART_SR_TC))
  {
    MeterComm.SendPost++;
    if(MeterComm.SendPost < MeterComm.SendLen)
      Meter_A_USARTx->DR = MeterComm.SendData[MeterComm.SendPost];
    else
    {
      Meter_A_USARTx->CR1 &= ~USART_CR1_TCIE;
      //Meter_A_RxTxEn_GPIO_PORT->BSRRH = Meter_A_RxTxEn_PIN;//ģʽ
      SendDisable();
    }
  }
}

/******************************************************************************
  : MeterSendFrame
  : ݵܱ
  : Ctrl - 
        pData - ָ
        Len - ݳ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
static u8 MeterSendFrame(u8 Ctrl, u8 *pData, u8 Len, u8 *pAddr)
{
  u8 i;
  u8 CS;
  u8 Data;
  osEvent RecvMsg;

  //if(eMeterSta_Unavail == MeterComm.Status)
  //  return FALSE;
  if((NULL == pData) && (0 != Len))
    return FALSE;
  if(0x80 == (Ctrl & 0x80))
    return FALSE;

  MeterComm.SendLen = 0;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  CS = 0x00;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += *pAddr;
  MeterComm.SendData[MeterComm.SendLen++] = *pAddr++;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += Ctrl;
  MeterComm.SendData[MeterComm.SendLen++] = Ctrl;
  CS += Len;
  MeterComm.SendData[MeterComm.SendLen++] = Len;
  for(i=0; i<Len; i++)
  {
    Data = pData[i] + 0x33;
    CS += Data;
    MeterComm.SendData[MeterComm.SendLen++] = Data;
  }
  MeterComm.SendData[MeterComm.SendLen++] = CS;
  MeterComm.SendData[MeterComm.SendLen++] = 0x16;

  MeterComm.SendPost = 0;//λ

  //Meter_A_RxTxEn_GPIO_PORT->BSRRL = Meter_A_RxTxEn_PIN;//ģʽ
  SendEnable();

  /*սջ*/
  do
  {
    RecvMsg = osMessageGet(MeterComm.RecvMsg, 1);
  }while(osEventMessage == RecvMsg.status);

  /*ʼ*/
  Meter_A_USARTx->DR = MeterComm.SendData[0];
  Meter_A_USARTx->CR1 |= USART_CR1_TCIE;
  osDelay(100);
  return TRUE;
}

/******************************************************************************
  : MeterRecvFrame
  : ݵܱ
  : Ctrl - 
        pData - ָ
        Len - ݳ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
static u8 MeterRecvFrame(StructMeterFrame *pFrame)
{
  osEvent RecvDataMsg;
  u8 *pBuffer;
  u8 BufferPos;
  u8 Data;
  u8 CheckSum;
  u32 i;
  u32 StartTick = GetSystemTick();

  EnumMeterFrameStatus FrameStatus = eMeterFrame_Head;

  if(NULL == pFrame)
    return FALSE;

  pBuffer = (u8*)pFrame;
  BufferPos = 0;
  StartTick = GetSystemTick();
  do
  {
    RecvDataMsg = osMessageGet(MeterComm.RecvMsg, MeterRecvTimeOut);//
    if(osEventMessage == RecvDataMsg.status)
    {
      Data = RecvDataMsg.value.v;
      switch(FrameStatus)
      {
        case eMeterFrame_Head:
          if(0x68 == Data)//֡ͷ
          {
            BufferPos = 0;
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Addr;
          }
          break;

        case eMeterFrame_Addr:
          pBuffer[BufferPos] = Data;
          BufferPos++;
          if(7 == BufferPos)
            FrameStatus = eMeterFrame_ReHead;
          break;

        case eMeterFrame_ReHead:
          if(0x68 == Data)//֡־
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Ctrl;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_Ctrl:
          if(Data & 0x80)//ӻ
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_DataLen;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_DataLen:
          if(0x00 == Data)//
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_CS;
          }
          else if(Data > MaxMeterFrameLen)//ݳ쳣
            FrameStatus = eMeterFrame_Head;
          else
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Data;
          }
          break;

        case eMeterFrame_Data:
          pBuffer[BufferPos] = Data;
          BufferPos++;
          if((pFrame->Len + 10) == BufferPos)
            FrameStatus = eMeterFrame_CS;
          break;

        case eMeterFrame_CS:
          CheckSum = 0;
          for(i=0; i < BufferPos; i++)
            CheckSum += pBuffer[i];
          if(CheckSum == Data)//УCS
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            pFrame->CS= Data;
            FrameStatus = eMeterFrame_End;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_End:
          if(0x16 == Data)//λ
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            pFrame->End = Data;
            for(i=0; i<pFrame->Len; i++)
            {//
              pFrame->Data[i] -= 0x33;
            }
            FrameStatus = eMeterFrame_Head;
            return TRUE;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        default:
          FrameStatus = eMeterFrame_Head;
          break;
      }
    }
  }while(osEventMessage == RecvDataMsg.status && (GetSystemTick() - StartTick) < MeterAckTimeOut);

  return FALSE;
}

/******************************************************************************
  : MeterGetAddr
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetAddr(void)
{
  u8 CS;
  osEvent RecvMsg;
  StructMeterFrame Frame;

  MeterComm.SendLen = 0;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  CS = 0x00;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += 0x13;
  MeterComm.SendData[MeterComm.SendLen++] = 0x13;
  CS += 0x00;
  MeterComm.SendData[MeterComm.SendLen++] = 0x00;
  MeterComm.SendData[MeterComm.SendLen++] = CS;
  MeterComm.SendData[MeterComm.SendLen++] = 0x16;

  MeterComm.SendPost = 0;//λ

  //Meter_A_RxTxEn_GPIO_PORT->BSRRL = Meter_A_RxTxEn_PIN;//ģʽ
  SendEnable();

  /*սջ*/
  do
  {
    RecvMsg = osMessageGet(MeterComm.RecvMsg, 1);
  }while(osEventMessage == RecvMsg.status);

  /*ʼ*/
  Meter_A_USARTx->DR = MeterComm.SendData[0];
  Meter_A_USARTx->CR1 |= USART_CR1_TCIE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;
  if(0x93 != Frame.Ctrl)
    return FALSE;

  if(memcmp(Frame.Addr, Frame.Data, 6))
    return FALSE;

  memcpy(MeterComm.Addr, Frame.Addr, 6);
  MeterComm.Status = eMeterSta_Avail;

  return TRUE;
}

/******************************************************************************
  : MeterGetEnergy
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergy(u32 Type, s32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetPositiveEnergy
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPositiveEnergy(u32 Type, u32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPositiveEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetEnergyBlock
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergyBlock(u32 Type, StructEnergy *pEnergy)
{
//  const u32 Type = eMeter_P_Block_Energy;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;


  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], &Temp))
    return FALSE;
  pEnergy->All = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[8], &Temp))
    return FALSE;
  pEnergy->Sharp = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[12], &Temp))
    return FALSE;
  pEnergy->Peak = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[16], &Temp))
    return FALSE;
  pEnergy->Flat = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[20], &Temp))
    return FALSE;
  pEnergy->Valley= Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltage(u32 Type, u32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltageBlock
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltageBlock(StructVoltage *pVoltage)
{
  const u32 Type = eMeter_Voltage;
  u32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], &Temp))
    return FALSE;
  pVoltage->PhaseA = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[6], &Temp))
    return FALSE;
  pVoltage->PhaseB = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[8], &Temp))
    return FALSE;
  pVoltage->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrent
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrent(u32 Type, s32 *pCurrent)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], pCurrent))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrentBlock
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrentBlock(StructCurrent *pCurrent)
{
  const u32 Type = eMeter_Current;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], &Temp))
    return FALSE;
  pCurrent->PhaseA = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[7], &Temp))
    return FALSE;
  pCurrent->PhaseB = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[10], &Temp))
    return FALSE;
  pCurrent->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetPower
  : ȡܹ
  : Type - ȡĵ
        pValue - 0.1Kw(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPower(u32 Type, s32 *pValue)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pValue)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPower(&Frame.Data[4], (u32*)pValue))
    return FALSE;

  *pValue /= 1000;//0.1Kw/Bit

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPowerFac(u32 Type, s32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPowerFac(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetEnergy_B
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergy_B(u32 Type, s32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetPositiveEnergy
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPositiveEnergy_B(u32 Type, u32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPositiveEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetEnergyBlock
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergyBlock_B(u32 Type, StructEnergy *pEnergy)
{
//  const u32 Type = eMeter_Power_Energy;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;


  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], &Temp))
    return FALSE;
  pEnergy->All = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[8], &Temp))
    return FALSE;
  pEnergy->Sharp = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[12], &Temp))
    return FALSE;
  pEnergy->Peak = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[16], &Temp))
    return FALSE;
  pEnergy->Flat = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[20], &Temp))
    return FALSE;
  pEnergy->Valley= Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltage_B(u32 Type, u32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status_B)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltageBlock_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltageBlock_B(StructVoltage *pVoltage)
{
  const u32 Type = eMeter_Voltage;
  u32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status_B)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], &Temp))
    return FALSE;
  pVoltage->PhaseA = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[6], &Temp))
    return FALSE;
  pVoltage->PhaseB = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[8], &Temp))
    return FALSE;
  pVoltage->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrent_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrent_B(u32 Type, s32 *pCurrent)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], pCurrent))
    return FALSE;
  return TRUE;
}

/******************************************************************************
  : MeterGetCurrentBlock_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrentBlock_B(StructCurrent *pCurrent)
{
  const u32 Type = eMeter_Current;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], &Temp))
    return FALSE;
  pCurrent->PhaseA = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[7], &Temp))
    return FALSE;
  pCurrent->PhaseB = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[10], &Temp))
    return FALSE;
  pCurrent->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrent_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPower_B(u32 Type, s32 *pValue)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pValue)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPower(&Frame.Data[4], (u32*)pValue))
    return FALSE;

  *pValue /= 1000;//0.1Kw/Bit

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPowerFac_B(u32 Type, s32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status_B)
    return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_B[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_B, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPowerFac(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage_AC
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltage_AC(u32 Type, u32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status_AC)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_AC[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_AC, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltageBlock_AC
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltageBlock_AC(StructVoltage *pVoltage)
{
  const u32 Type = eMeter_Voltage;
  u32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  //if(eMeterSta_Unavail == MeterComm.Status_AC)
  //  return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame(0x11, DataType, 4, &(MeterComm.Addr_AC[0])))
    return FALSE;

  if(FALSE == MeterRecvFrame(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr_AC, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], &Temp))
    return FALSE;
  pVoltage->PhaseA = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[6], &Temp))
    return FALSE;
  pVoltage->PhaseB = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[8], &Temp))
    return FALSE;
  pVoltage->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : Thd_Meter_B
  : ܱȡ߳
  : argument - ̴߳
  : 
******************************************************************************/
void Meter(void const *argument)
{
  u32 MeterErrCnt = 0;
  s32 sValue = 0;
  u32 uValue = 0;
  s32 PositivCmdFlag = 0;
  s32 SummationCmdFlag = 0;

  u32 MeterErrCnt_B = 0;
  s32 sValue_B = 0;
  u32 uValue_B = 0;
  s32 PositivCmdFlag_B = 0;
  s32 SummationCmdFlag_B = 0;

  u32 MeterErrCnt_AC = 0;
  //StructCurrent sValue_AC = 0;
  StructVoltage uValue_AC =
  {
    220000,
    220000,
    220000
  };
  //s32 PositivCmdFlag_AC = 0;
  //s32 SummationCmdFlag_AC = 0;

  MeterErrCnt = 0;
  sValue = 0;
  uValue = 0;
  PositivCmdFlag = 0;
  SummationCmdFlag = 0;

  MeterErrCnt_B = 0;
  sValue_B = 0;
  uValue_B = 0;
  PositivCmdFlag_B = 0;
  SummationCmdFlag_B = 0;

  MeterErrCnt_AC = 0;
  //sValue_AC = 0;
  //uValue_AC = 0;
  //PositivCmdFlag_AC = 0;
  //SummationCmdFlag_AC = 0;

  osDelay(5000);

  for(;;)
  {
    //if(eMeterSta_Unavail == MeterComm.Status)
    //{
    //  osDelay(50);
    //  PositivCmdFlag = 0;
    //  SummationCmdFlag = 0;
    //  MeterGetAddr();
    //}
    if( (eMeterSta_Unavail == MeterComm.Status)  \
     && (eMeterSta_Unavail == MeterComm.Status_AC) //&& 0 != UserParam.ChgFun.Value.ACMeter)
     && (eMeterSta_Unavail == MeterComm.Status_B) //&& 0 != UserParam.ChgFun.Value.Num_B)
      )
    {
      SendEnable();
      osDelay(200);
      SendDisable();
      osDelay(200);
      PositivCmdFlag = 0;
      SummationCmdFlag = 0;
      PositivCmdFlag_B = 0;
      SummationCmdFlag_B = 0;
      if(0 != UserParam.ChgFun.Value.ACMeter)
      {
        if(TRUE == MeterGetVoltage_AC(eMeter_Voltage_A, &uValue_B))
          MeterComm.Status_AC = eMeterSta_Avail;
        else
          MeterComm.Status_AC = eMeterSta_Unavail;

      }
      osDelay(50);

      if(TRUE == MeterGetVoltage(eMeter_Voltage_A, &uValue))
      {
        MeterComm.Status = eMeterSta_Avail;
      }
      else
      {
        MeterComm.Status = eMeterSta_Unavail;
      }
      osDelay(50);

      if((0 == UserParam.ChgFun.Value.Num_B) && (eMeterSta_Unavail == MeterComm.Status))
      {
        MeterGetAddr();
        continue;
      }
      if(TRUE == MeterGetVoltage_B(eMeter_Voltage_A, &uValue_B))
      {
        MeterComm.Status_B= eMeterSta_Avail;
      }
      else
      {
        MeterComm.Status_B= eMeterSta_Unavail;
      }
      continue;
    }
/********************************ACMeter***********************************/
    if(0 != UserParam.ChgFun.Value.ACMeter)
    {
      if(TRUE  == MeterGetVoltageBlock_AC(&uValue_AC))
      {
        if(MeterErrCnt_AC > 0)
          MeterErrCnt_AC--;
        MeterValue_AC.VoltageA = uValue_AC.PhaseA;
        MeterValue_AC.VoltageB = uValue_AC.PhaseB;
        MeterValue_AC.VoltageC = uValue_AC.PhaseC;
        MeterValue_AC.Voltage = (MeterValue_AC.VoltageA + MeterValue_AC.VoltageB + MeterValue_AC.VoltageC)/3;
        MeterComm.Status_AC= eMeterSta_Avail;
      }
      else
      {
        if(MeterErrCnt_AC < 10)
          MeterErrCnt_AC += 5;
      }
      osDelay(20);

      if(MeterErrCnt_AC >= 10)
      {
        MeterErrCnt_AC = 0;
        MeterComm.Status_AC= eMeterSta_Unavail;
      }
    }
    else
    {
      MeterComm.Status_AC= eMeterSta_Unavail;
    }
/**************************************************************************/
    if(0 == PositivCmdFlag)
    {
      if(TRUE  == MeterGetPositiveEnergy(eMeter_P_A_Energy, &uValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        if(0 != uValue)
        {
          PositivCmdFlag = 1;
          SummationCmdFlag = -1;
          MeterValue.Energy = uValue;
          //MeterComm.Status = eMeterSta_Avail;
        }
      }
      else
        PositivCmdFlag = -1;

      osDelay(50);
    }

    if(0 == SummationCmdFlag)
    {
      if(TRUE  == MeterGetEnergy(eMeter_Sum_A_Energy, &sValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        if(0 != sValue)
        {
          SummationCmdFlag = 1;
          PositivCmdFlag = -1;
          MeterValue.Energy = sValue;
          //MeterComm.Status = eMeterSta_Avail;
        }
      }
      else
        SummationCmdFlag = -1;

      osDelay(50);
    }
    if(eMeterSta_Unavail == MeterComm.Status)
    {
      PositivCmdFlag = 0;
      SummationCmdFlag = 0;
    }

    if((1 == PositivCmdFlag) && (1 == SummationCmdFlag))
    {
      PositivCmdFlag = 0;
      SummationCmdFlag = 0;
    }

    if((-1 == PositivCmdFlag) && (-1 == SummationCmdFlag))
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }

    if(1 == PositivCmdFlag)
    {
      if(TRUE  == MeterGetPositiveEnergy(eMeter_P_A_Energy, &uValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        MeterValue.Energy = uValue;
        //MeterComm.Status = eMeterSta_Avail;
      }
      else
      {
        if(MeterErrCnt < 10)
          MeterErrCnt += 5;
      }
      osDelay(50);
    }

    if(1 == SummationCmdFlag)
    {
      if(TRUE  == MeterGetEnergy(eMeter_Sum_A_Energy, &sValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        MeterValue.Energy = sValue;
        //MeterComm.Status = eMeterSta_Avail;
      }
      else
      {
        if(MeterErrCnt < 10)
          MeterErrCnt += 5;
      }
      osDelay(50);
    }

    if(TRUE  == MeterGetCurrent(eMeter_Current_A, &sValue))
    {
      if(MeterErrCnt > 0)
        MeterErrCnt--;
      MeterValue.Current = sValue * MeterRate;
      //MeterComm.Status = eMeterSta_Avail;
    }
    else
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }
    osDelay(20);

    if(TRUE  == MeterGetVoltage(eMeter_Voltage_A, &uValue))
    {
      if(MeterErrCnt > 0)
        MeterErrCnt--;
      MeterValue.Voltage = uValue;
      MeterComm.Status = eMeterSta_Avail;
    }
    else
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }
    osDelay(20);

    if(MeterErrCnt >= 10)
    {
      MeterErrCnt = 0;
      MeterComm.Status = eMeterSta_Unavail;
    }
/****************************BMeter**************************************/
    //if(eMeterSta_Unavail == MeterComm.Status)
    //{
    //  osDelay(50);
    //  PositivCmdFlag = 0;
    //  SummationCmdFlag = 0;
    //  MeterGetAddr();
    //}
    //if(eMeterSta_Unavail == MeterComm.Status)
    //{
    //  SendEnable();
    //  osDelay(200);
    //  SendDisable();
    //  osDelay(200);
    //  continue;
    //}
    if(0 == UserParam.ChgFun.Value.Num_B)
    {
      MeterComm.Status_B= eMeterSta_Unavail;
      continue;
    }
    if(0 == PositivCmdFlag_B)
    {
      if(TRUE  == MeterGetPositiveEnergy_B(eMeter_P_A_Energy, &uValue_B))
      {
        if(MeterErrCnt_B> 0)
          MeterErrCnt_B--;
        if(0 != uValue_B)
        {
          PositivCmdFlag_B = 1;
          SummationCmdFlag_B = -1;
          MeterValue_B.Energy = uValue_B;
          //MeterComm.Status_B= eMeterSta_Avail;
        }
      }
      else
        PositivCmdFlag_B = -1;

      osDelay(50);
    }

    if(0 == SummationCmdFlag_B)
    {
      if(TRUE  == MeterGetEnergy_B(eMeter_Sum_A_Energy, &sValue_B))
      {
        if(MeterErrCnt_B > 0)
          MeterErrCnt_B--;
        if(0 != sValue_B)
        {
          SummationCmdFlag_B = 1;
          PositivCmdFlag_B = -1;
          MeterValue_B.Energy = sValue_B;
          //MeterComm.Status_B= eMeterSta_Avail;
        }
      }
      else
        SummationCmdFlag_B = -1;

      osDelay(50);
    }
    if(eMeterSta_Unavail == MeterComm.Status_B)
    {
      PositivCmdFlag_B = 0;
      SummationCmdFlag_B = 0;
    }

    if((1 == PositivCmdFlag_B) && (1 == SummationCmdFlag_B))
    {
      PositivCmdFlag_B = 0;
      SummationCmdFlag_B = 0;
    }

    if((-1 == PositivCmdFlag_B) && (-1 == SummationCmdFlag_B))
    {
      if(MeterErrCnt_B < 10)
        MeterErrCnt_B += 5;
    }

    if(1 == PositivCmdFlag_B)
    {
      if(TRUE  == MeterGetPositiveEnergy_B(eMeter_P_A_Energy, &uValue_B))
      {
        if(MeterErrCnt_B > 0)
          MeterErrCnt_B--;
        MeterValue_B.Energy = uValue_B;
        //MeterComm.Status_B= eMeterSta_Avail;
      }
      else
      {
        if(MeterErrCnt_B < 10)
          MeterErrCnt_B += 5;
      }
      osDelay(50);
    }

    if(1 == SummationCmdFlag_B)
    {
      if(TRUE  == MeterGetEnergy_B(eMeter_Sum_A_Energy, &sValue_B))
      {
        if(MeterErrCnt_B > 0)
          MeterErrCnt_B--;
        MeterValue_B.Energy = sValue_B;
        //MeterComm.Status_B= eMeterSta_Avail;
      }
      else
      {
        if(MeterErrCnt_B < 10)
          MeterErrCnt_B += 5;
      }
      osDelay(50);
    }

    if(TRUE  == MeterGetCurrent_B(eMeter_Current_A, &sValue_B))
    {
      if(MeterErrCnt_B > 0)
        MeterErrCnt_B--;
      MeterValue_B.Current = sValue_B * MeterRate;
      //MeterComm.Status_B= eMeterSta_Avail;
    }
    else
    {
      if(MeterErrCnt_B < 10)
        MeterErrCnt_B += 5;
    }
    osDelay(20);

    if(TRUE  == MeterGetVoltage_B(eMeter_Voltage_A, &uValue_B))
    {
      if(MeterErrCnt_B > 0)
        MeterErrCnt_B--;
      MeterValue_B.Voltage = uValue_B;
      MeterComm.Status_B= eMeterSta_Avail;
    }
    else
    {
      if(MeterErrCnt_B < 10)
        MeterErrCnt_B += 5;
    }
    osDelay(20);

    if(MeterErrCnt_B >= 10)
    {
      MeterErrCnt_B = 0;
      MeterComm.Status_B= eMeterSta_Unavail;
    }
  }
}

/******************************************************************************
  : MeterInit
  : ܱͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 MeterInit(void)
{
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  MeterComm.Status = eMeterSta_Unavail;

  /* Enable GPIO clock */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Meter_A_RxTxEn_PIN;
  RCC_AHB1PeriphClockCmd(Meter_A_RxTxEn_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_A_RxTxEn_GPIO_PORT, &GPIO_InitStructure);
//  GPIO_ResetBits(Meter_A_RxTxEn_GPIO_PORT, Meter_A_RxTxEn_PIN);//ģʽ
  GPIO_SetBits(Meter_A_RxTxEn_GPIO_PORT, Meter_A_RxTxEn_PIN);//ģʽС

  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Meter_A_USARTx_TX_PIN;
  RCC_AHB1PeriphClockCmd(Meter_A_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_A_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Meter_A_USARTx_RX_PIN;
  RCC_AHB1PeriphClockCmd(Meter_A_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_A_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  Meter_A_USARTx_CLK_INIT(Meter_A_USARTx_CLK, ENABLE);

  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(Meter_A_USARTx_TX_GPIO_PORT, Meter_A_USARTx_TX_SOURCE, Meter_A_USARTx_TX_AF);
  GPIO_PinAFConfig(Meter_A_USARTx_RX_GPIO_PORT, Meter_A_USARTx_RX_SOURCE, Meter_A_USARTx_RX_AF);


  /* Enable the USART OverSampling by 8 */
//  USART_OverSampling8Cmd(Meter_A_USARTx, ENABLE);

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = Meter_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_9b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_Even;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(Meter_A_USARTx, &USART_InitStructure);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = Meter_A_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue */
  MeterComm.RecvMsg = NULL;
  osMessageQDef(MeterComm, MaxMeterFrameLen, u8);
  MeterComm.RecvMsg = osMessageCreate(osMessageQ(MeterComm), NULL);
  memcpy(MeterComm.Addr, UserParam.MeterAddr, 6);
  memcpy(MeterComm.Addr_B, UserParam.MeterAddr_B, 6);
  memcpy(MeterComm.Addr_AC, UserParam.MeterAddr_AC, 6);

//  if(NULL == MeterComm.RecvMsg)
//    return FALSE;

  /* Enable USART */
  USART_Cmd(Meter_A_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(Meter_A_USARTx, USART_IT_RXNE, ENABLE);

  osThreadDef(Meter, Meter, osPriorityAboveNormal, 0, configMINIMAL_STACK_SIZE);
  if(NULL == osThreadCreate(osThread(Meter), NULL))
    return FALSE;

  return TRUE;
}
#if 0
#define SendEnable_B()  Meter_B_RxTxEn_GPIO_PORT->BSRRL = Meter_A_RxTxEn_PIN//
#define SendDisable_B() Meter_B_RxTxEn_GPIO_PORT->BSRRH = Meter_A_RxTxEn_PIN//
/******************************************************************************
  : Meter_B_USARTx_IRQHandler
  : ܱڽж
  : 
  : 
******************************************************************************/
void Meter_B_USARTx_IRQHandler(void)
{
  u16 CR1,SR;
  u8 Data;

  SR = Meter_B_USARTx->SR;
  CR1 = Meter_B_USARTx->CR1;

  if((CR1 & USART_CR1_RXNEIE) && (SR & USART_SR_RXNE))
  {
    Data = (u8)Meter_B_USARTx->DR;
    osMessagePut(MeterComm.RecvMsg, Data, 0);
  }

  if((CR1 & USART_CR1_TCIE) && (SR & USART_SR_TC))
  {
    MeterComm.SendPost++;
    if(MeterComm.SendPost < MeterComm.SendLen)
      Meter_B_USARTx->DR = MeterComm.SendData[MeterComm.SendPost];
    else
    {
      Meter_B_USARTx->CR1 &= ~USART_CR1_TCIE;
      //Meter_B_RxTxEn_GPIO_PORT->BSRRH = Meter_B_RxTxEn_PIN;//ģʽ
      SendDisable_B();
    }
  }
}

/******************************************************************************
  : MeterSendFrame_B
  : ݵܱ
  : Ctrl - 
        pData - ָ
        Len - ݳ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
static u8 MeterSendFrame_B(u8 Ctrl, u8 *pData, u8 Len)
{
  u8 i;
  u8 CS;
  u8 Data;
  osEvent RecvMsg;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if((NULL == pData) && (0 != Len))
    return FALSE;
  if(0x80 == (Ctrl & 0x80))
    return FALSE;

  MeterComm.SendLen = 0;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  CS = 0x00;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += MeterComm.Addr[0];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[0];
  CS += MeterComm.Addr[1];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[1];
  CS += MeterComm.Addr[2];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[2];
  CS += MeterComm.Addr[3];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[3];
  CS += MeterComm.Addr[4];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[4];
  CS += MeterComm.Addr[5];
  MeterComm.SendData[MeterComm.SendLen++] = MeterComm.Addr[5];
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += Ctrl;
  MeterComm.SendData[MeterComm.SendLen++] = Ctrl;
  CS += Len;
  MeterComm.SendData[MeterComm.SendLen++] = Len;
  for(i=0; i<Len; i++)
  {
    Data = pData[i] + 0x33;
    CS += Data;
    MeterComm.SendData[MeterComm.SendLen++] = Data;
  }
  MeterComm.SendData[MeterComm.SendLen++] = CS;
  MeterComm.SendData[MeterComm.SendLen++] = 0x16;

  MeterComm.SendPost = 0;//λ

  //Meter_B_RxTxEn_GPIO_PORT->BSRRL = Meter_B_RxTxEn_PIN;//ģʽ
  SendEnable_B();

  /*սջ*/
  do
  {
    RecvMsg = osMessageGet(MeterComm.RecvMsg, 1);
  }while(osEventMessage == RecvMsg.status);

  /*ʼ*/
  Meter_B_USARTx->DR = MeterComm.SendData[0];
  Meter_B_USARTx->CR1 |= USART_CR1_TCIE;

  return TRUE;
}

/******************************************************************************
  : MeterRecvFrame_B
  : ݵܱ
  : Ctrl - 
        pData - ָ
        Len - ݳ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
static u8 MeterRecvFrame_B(StructMeterFrame *pFrame)
{
  osEvent RecvDataMsg;
  u8 *pBuffer;
  u8 BufferPos;
  u8 Data;
  u8 CheckSum;
  u32 i;
  EnumMeterFrameStatus FrameStatus = eMeterFrame_Head;

  if(NULL == pFrame)
    return FALSE;

  pBuffer = (u8*)pFrame;
  BufferPos = 0;

  do
  {
    RecvDataMsg = osMessageGet(MeterComm.RecvMsg, MeterRecvTimeOut);
    if(osEventMessage == RecvDataMsg.status)
    {
      Data = RecvDataMsg.value.v;
      switch(FrameStatus)
      {
        case eMeterFrame_Head:
          if(0x68 == Data)//֡ͷ
          {
            BufferPos = 0;
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Addr;
          }
          break;

        case eMeterFrame_Addr:
          pBuffer[BufferPos] = Data;
          BufferPos++;
          if(7 == BufferPos)
            FrameStatus = eMeterFrame_ReHead;
          break;

        case eMeterFrame_ReHead:
          if(0x68 == Data)//֡־
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Ctrl;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_Ctrl:
          if(Data & 0x80)//ӻ
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_DataLen;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_DataLen:
          if(0x00 == Data)//
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_CS;
          }
          else if(Data > MaxMeterFrameLen)//ݳ쳣
            FrameStatus = eMeterFrame_Head;
          else
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            FrameStatus = eMeterFrame_Data;
          }
          break;

        case eMeterFrame_Data:
          pBuffer[BufferPos] = Data;
          BufferPos++;
          if((pFrame->Len + 10) == BufferPos)
            FrameStatus = eMeterFrame_CS;
          break;

        case eMeterFrame_CS:
          CheckSum = 0;
          for(i=0; i < BufferPos; i++)
            CheckSum += pBuffer[i];
          if(CheckSum == Data)//УCS
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            pFrame->CS= Data;
            FrameStatus = eMeterFrame_End;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        case eMeterFrame_End:
          if(0x16 == Data)//λ
          {
            pBuffer[BufferPos] = Data;
            BufferPos++;
            pFrame->End = Data;
            for(i=0; i<pFrame->Len; i++)
            {//
              pFrame->Data[i] -= 0x33;
            }
            FrameStatus = eMeterFrame_Head;
            return TRUE;
          }
          else
            FrameStatus = eMeterFrame_Head;
          break;

        default:
          FrameStatus = eMeterFrame_Head;
          break;
      }
    }
  }while(osEventMessage == RecvDataMsg.status);

  return FALSE;
}

/******************************************************************************
  : MeterGetAddr_B
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
//u8 MeterGetAddr_B(u8 *pAddr)
u8 MeterGetAddr_B(void)
{
  u8 CS;
  osEvent RecvMsg;
  StructMeterFrame Frame;

//  if(NULL == pAddr)
//    return FALSE;

  MeterComm.SendLen = 0;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  MeterComm.SendData[MeterComm.SendLen++] = 0xFE;
  CS = 0x00;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0xAA;
  MeterComm.SendData[MeterComm.SendLen++] = 0xAA;
  CS += 0x68;
  MeterComm.SendData[MeterComm.SendLen++] = 0x68;
  CS += 0x13;
  MeterComm.SendData[MeterComm.SendLen++] = 0x13;
  CS += 0x00;
  MeterComm.SendData[MeterComm.SendLen++] = 0x00;
  MeterComm.SendData[MeterComm.SendLen++] = CS;
  MeterComm.SendData[MeterComm.SendLen++] = 0x16;

  MeterComm.SendPost = 0;//λ

  //Meter_B_RxTxEn_GPIO_PORT->BSRRL = Meter_B_RxTxEn_PIN;//ģʽ
  SendEnable_B();

  /*սջ*/
  do
  {
    RecvMsg = osMessageGet(MeterComm.RecvMsg, 1);
  }while(osEventMessage == RecvMsg.status);

  /*ʼ*/
  Meter_B_USARTx->DR = MeterComm.SendData[0];
  Meter_B_USARTx->CR1 |= USART_CR1_TCIE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;
  if(0x93 != Frame.Ctrl)
    return FALSE;

  if(memcmp(Frame.Addr, Frame.Data, 6))
    return FALSE;

//  memcpy(pAddr, Frame.Addr, 6);
  memcpy(MeterComm.Addr, Frame.Addr, 6);
  MeterComm.Status = eMeterSta_Avail;
  return TRUE;
}

/******************************************************************************
  : MeterGetEnergy_B
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergy_B(u32 Type, s32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetPositiveEnergy
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPositiveEnergy_B(u32 Type, u32 *pEnergy)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPositiveEnergy(&Frame.Data[4], pEnergy))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetEnergyBlock
  : ȡܱ
  : Type - ȡĵ
        pEnergy - ŵָ뵥λ()
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetEnergyBlock_B(u32 Type, StructEnergy *pEnergy)
{
//  const u32 Type = eMeter_Power_Energy;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pEnergy)
    return FALSE;


  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToEnergy(&Frame.Data[4], &Temp))
    return FALSE;
  pEnergy->All = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[8], &Temp))
    return FALSE;
  pEnergy->Sharp = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[12], &Temp))
    return FALSE;
  pEnergy->Peak = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[16], &Temp))
    return FALSE;
  pEnergy->Flat = Temp;

  if(FALSE  == BcdToEnergy(&Frame.Data[20], &Temp))
    return FALSE;
  pEnergy->Valley= Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltage_B(u32 Type, u32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltageBlock_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetVoltageBlock_B(StructVoltage *pVoltage)
{
  const u32 Type = eMeter_Voltage;
  u32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToVoltage(&Frame.Data[4], &Temp))
    return FALSE;
  pVoltage->PhaseA = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[6], &Temp))
    return FALSE;
  pVoltage->PhaseB = Temp;

  if(FALSE  == BcdToVoltage(&Frame.Data[8], &Temp))
    return FALSE;
  pVoltage->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrent_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrent_B(u32 Type, s32 *pCurrent)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], pCurrent))
    return FALSE;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrentBlock_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetCurrentBlock_B(StructCurrent *pCurrent)
{
  const u32 Type = eMeter_Current;
  s32 Temp;
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pCurrent)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToCurrent(&Frame.Data[4], &Temp))
    return FALSE;
  pCurrent->PhaseA = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[7], &Temp))
    return FALSE;
  pCurrent->PhaseB = Temp;

  if(FALSE  == BcdToCurrent(&Frame.Data[10], &Temp))
    return FALSE;
  pCurrent->PhaseC = Temp;

  return TRUE;
}

/******************************************************************************
  : MeterGetCurrent_B
  : ȡܱ
  : Type - ȡĵ
        pVoltage - ŵָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPower_B(u32 Type, s32 *pValue)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pValue)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPower(&Frame.Data[4], (u32*)pValue))
    return FALSE;

  *pValue /= 1000;//0.1Kw/Bit

  return TRUE;
}

/******************************************************************************
  : MeterGetVoltage_B
  : ȡܱѹ
  : Type - ȡĵѹ
        pVoltage - ŵѹָ(λ)
  : TRUE - ɹ
        FASLE - ʧ
******************************************************************************/
u8 MeterGetPowerFac_B(u32 Type, s32 *pVoltage)
{
  u8 DataType[4];
  StructMeterFrame Frame;

  if(eMeterSta_Unavail == MeterComm.Status)
    return FALSE;
  if(NULL == pVoltage)
    return FALSE;

  DataType[0] = (u8)Type;
  DataType[1] = (u8)(Type >> 8);
  DataType[2] = (u8)(Type >> 16);
  DataType[3] = (u8)(Type >> 24);

  if(FALSE == MeterSendFrame_B(0x11, DataType, 4))
    return FALSE;

  if(FALSE == MeterRecvFrame_B(&Frame))
    return FALSE;

  if(memcmp(MeterComm.Addr, Frame.Addr, 6))
    return FALSE;

  if(0x91 != Frame.Ctrl)
    return FALSE;

  if(memcmp(DataType, Frame.Data, 4))
    return FALSE;

  if(FALSE  == BcdToPowerFac(&Frame.Data[4], pVoltage))
    return FALSE;

  return TRUE;
}


StructMeterValue MeterValue_B =
{
  0,
  0,
  0,
  0,
  0,
  2200,
  0,
  0,
  1000,
  5000
};

/******************************************************************************
  : Thd_Meter_A
  : ܱȡ߳
  : argument - ̴߳
  : 
******************************************************************************/
void Meter_B(void const *argument)
{
  u32 MeterErrCnt = 0;
  s32 sValue = 0;
  u32 uValue = 0;
  s32 PositivCmdFlag = 0;
  s32 SummationCmdFlag = 0;

  MeterErrCnt = 0;
  sValue = 0;
  uValue = 0;
  PositivCmdFlag = 0;
  SummationCmdFlag = 0;

  osDelay(5000);

  for(;;)
  {
    if(eMeterSta_Unavail == MeterComm.Status)
    {
      osDelay(50);
      PositivCmdFlag = 0;
      SummationCmdFlag = 0;
      MeterGetAddr_B();
    }
    if(eMeterSta_Unavail == MeterComm.Status)
    {
      SendEnable_B();
      osDelay(200);
      SendDisable_B();
      osDelay(200);
      continue;
    }

    if(0 == PositivCmdFlag)
    {
      if(TRUE  == MeterGetPositiveEnergy_B(eMeter_P_A_Energy, &uValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        if(0 != uValue)
        {
          PositivCmdFlag = 1;
          SummationCmdFlag = -1;
          MeterValue_B.Energy = uValue;
        }
      }
      else
        PositivCmdFlag = -1;

      osDelay(50);
    }

    if(0 == SummationCmdFlag)
    {
      if(TRUE  == MeterGetEnergy_B(eMeter_Sum_A_Energy, &sValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        if(0 != sValue)
        {
          SummationCmdFlag = 1;
          PositivCmdFlag = -1;
          MeterValue_B.Energy = sValue;
        }
      }
      else
        SummationCmdFlag = -1;

      osDelay(50);
    }

    if((1 == PositivCmdFlag) && (1 == SummationCmdFlag))
    {
      PositivCmdFlag = 0;
      SummationCmdFlag = 0;
    }

    if((-1 == PositivCmdFlag) && (-1 == SummationCmdFlag))
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }

    if(1 == PositivCmdFlag)
    {
      if(TRUE  == MeterGetPositiveEnergy_B(eMeter_P_A_Energy, &uValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        MeterValue_B.Energy = uValue;
      }
      else
      {
        if(MeterErrCnt < 10)
          MeterErrCnt += 5;
      }
      osDelay(50);
    }

    if(1 == SummationCmdFlag)
    {
      if(TRUE  == MeterGetEnergy_B(eMeter_Sum_A_Energy, &sValue))
      {
        if(MeterErrCnt > 0)
          MeterErrCnt--;
        MeterValue_B.Energy = sValue;
      }
      else
      {
        if(MeterErrCnt < 10)
          MeterErrCnt += 5;
      }
      osDelay(50);
    }

    if(TRUE  == MeterGetCurrent_B(eMeter_Current_A, &sValue))
    {
      if(MeterErrCnt > 0)
        MeterErrCnt--;
      MeterValue_B.Current = sValue * MeterRate;
    }
    else
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }
    osDelay(20);

    if(TRUE  == MeterGetVoltage_B(eMeter_Voltage_A, &uValue))
    {
      if(MeterErrCnt > 0)
        MeterErrCnt--;
      MeterValue_B.Voltage = uValue;
    }
    else
    {
      if(MeterErrCnt < 10)
        MeterErrCnt += 5;
    }
    osDelay(20);

    if(MeterErrCnt >= 10)
    {
      MeterErrCnt = 0;
      MeterComm.Status = eMeterSta_Unavail;
    }
  }
}

/******************************************************************************
  : MeterInit
  : ܱͨŽӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 MeterInit_B(void)
{
  USART_InitTypeDef USART_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  MeterComm.Status = eMeterSta_Unavail;

  /* Enable GPIO clock */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Meter_B_RxTxEn_PIN;
  RCC_APB2PeriphClockCmd(Meter_B_RxTxEn_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_B_RxTxEn_GPIO_PORT, &GPIO_InitStructure);
  //GPIO_ResetBits(Meter_B_RxTxEn_GPIO_PORT, Meter_B_RxTxEn_PIN);//ģʽ
  GPIO_SetBits(Meter_B_RxTxEn_GPIO_PORT, Meter_B_RxTxEn_PIN);//ģʽ

  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = Meter_B_USARTx_TX_PIN;
  RCC_AHB1PeriphClockCmd(Meter_B_USARTx_TX_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_B_USARTx_TX_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = Meter_B_USARTx_RX_PIN;
  RCC_AHB1PeriphClockCmd(Meter_B_USARTx_RX_GPIO_CLK, ENABLE);
  GPIO_Init(Meter_B_USARTx_RX_GPIO_PORT, &GPIO_InitStructure);

  /* Enable USART clock */
  Meter_B_USARTx_CLK_INIT(Meter_B_USARTx_CLK, ENABLE);

  GPIO_PinAFConfig(Meter_B_USARTx_TX_GPIO_PORT, Meter_B_USARTx_TX_SOURCE, Meter_B_USARTx_TX_AF);
  GPIO_PinAFConfig(Meter_B_USARTx_RX_GPIO_PORT, Meter_B_USARTx_RX_SOURCE, Meter_B_USARTx_RX_AF);

  /* Enable the USART OverSampling by 8 */
//  USART_OverSampling8Cmd(Meter_B_USARTx, ENABLE);

  /* USARTx configuration ----------------------------------------------------*/
  USART_InitStructure.USART_BaudRate = Meter_USARTx_BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_9b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_Even;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(Meter_B_USARTx, &USART_InitStructure);

  /* Enable the USARTx Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = Meter_B_USARTx_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = configLIBRARY_MAX_SYSCALL_INTERRUPT_PRIORITY + 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  /* Create Storage Message Queue */
  MeterComm.RecvMsg = NULL;
  osMessageQDef(MeterComm, MaxMeterFrameLen, u8);
  MeterComm.RecvMsg = osMessageCreate(osMessageQ(MeterComm), NULL);

//  if(NULL == MeterComm.RecvMsg)
//    return FALSE;

  /* Enable USART */
  USART_Cmd(Meter_B_USARTx, ENABLE);

  /* Enable the Tx buffer empty interrupt */
  USART_ITConfig(Meter_B_USARTx, USART_IT_RXNE, ENABLE);

  osThreadDef(Meter_B, Meter_B, osPriorityAboveNormal, 0, configMINIMAL_STACK_SIZE);
  if(NULL == osThreadCreate(osThread(Meter_B), NULL))
    return FALSE;
  return TRUE;
}
#endif
