
#ifndef __DRV_METER_H__
#define __DRV_METER_H__

#include "Global.h"
//#include "Drv_RctF1xx.h"

#define Meter_USARTx_BaudRate                  (2400)
#define MeterRecvTimeOut                       (500)

#define MeterRate           (1)//(1)//(2)//(20)

#if 0
#define Meter_A_USARTx                           UART4
#define Meter_A_USARTx_CLK                       RCC_APB1Periph_UART4
#define Meter_A_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define Meter_A_USARTx_IRQn                      UART4_IRQn
#define Meter_A_USARTx_IRQHandler                UART4_IRQHandler

#define Meter_A_USARTx_TX_PIN                    GPIO_Pin_10
#define Meter_A_USARTx_TX_GPIO_PORT              GPIOC
#define Meter_A_USARTx_TX_GPIO_CLK               RCC_APB2Periph_GPIOC

#define Meter_A_USARTx_RX_PIN                    GPIO_Pin_11
#define Meter_A_USARTx_RX_GPIO_PORT              GPIOC
#define Meter_A_USARTx_RX_GPIO_CLK               RCC_APB2Periph_GPIOC

#define Meter_A_RxTxEn_PIN                       GPIO_Pin_4
#define Meter_A_RxTxEn_GPIO_PORT                 GPIOD
#define Meter_A_RxTxEn_GPIO_CLK                  RCC_APB2Periph_GPIOD



#define Meter_B_USARTx                           UART5
#define Meter_B_USARTx_CLK                       RCC_APB1Periph_UART5
#define Meter_B_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define Meter_B_USARTx_IRQn                      UART5_IRQn
#define Meter_B_USARTx_IRQHandler                UART5_IRQHandler

#define Meter_B_USARTx_TX_PIN                    GPIO_Pin_12
#define Meter_B_USARTx_TX_GPIO_PORT              GPIOC
#define Meter_B_USARTx_TX_GPIO_CLK               RCC_APB2Periph_GPIOC

#define Meter_B_USARTx_RX_PIN                    GPIO_Pin_2
#define Meter_B_USARTx_RX_GPIO_PORT              GPIOD
#define Meter_B_USARTx_RX_GPIO_CLK               RCC_APB2Periph_GPIOD

#define Meter_B_RxTxEn_PIN                       GPIO_Pin_3
#define Meter_B_RxTxEn_GPIO_PORT                 GPIOD
#define Meter_B_RxTxEn_GPIO_CLK                  RCC_APB2Periph_GPIOD
#else

#define Meter_A_USARTx                           USART1
#define Meter_A_USARTx_CLK                       RCC_APB2Periph_USART1
#define Meter_A_USARTx_CLK_INIT                  RCC_APB2PeriphClockCmd
#define Meter_A_USARTx_IRQn                      USART1_IRQn
#define Meter_A_USARTx_IRQHandler                USART1_IRQHandler

#define Meter_A_USARTx_TX_PIN                    GPIO_Pin_9
#define Meter_A_USARTx_TX_GPIO_PORT              GPIOA
#define Meter_A_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOA
#define Meter_A_USARTx_TX_SOURCE                 GPIO_PinSource9
#define Meter_A_USARTx_TX_AF                     GPIO_AF_USART1

#define Meter_A_USARTx_RX_PIN                    GPIO_Pin_10
#define Meter_A_USARTx_RX_GPIO_PORT              GPIOA
#define Meter_A_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOA
#define Meter_A_USARTx_RX_SOURCE                 GPIO_PinSource10
#define Meter_A_USARTx_RX_AF                     GPIO_AF_USART1

#define Meter_A_RxTxEn_PIN                       GPIO_Pin_8
#define Meter_A_RxTxEn_GPIO_PORT                 GPIOA
#define Meter_A_RxTxEn_GPIO_CLK                  RCC_AHB1Periph_GPIOA


#define Meter_B_USARTx                           USART2
#define Meter_B_USARTx_CLK                       RCC_APB1Periph_USART2
#define Meter_B_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define Meter_B_USARTx_IRQn                      USART2_IRQn
//#define Meter_B_USARTx_IRQHandler                USART2_IRQHandler

#define Meter_B_USARTx_TX_PIN                    GPIO_Pin_5
#define Meter_B_USARTx_TX_GPIO_PORT              GPIOD
#define Meter_B_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Meter_B_USARTx_TX_SOURCE                 GPIO_PinSource5
#define Meter_B_USARTx_TX_AF                     GPIO_AF_USART2

#define Meter_B_USARTx_RX_PIN                    GPIO_Pin_6
#define Meter_B_USARTx_RX_GPIO_PORT              GPIOD
#define Meter_B_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define Meter_B_USARTx_RX_SOURCE                 GPIO_PinSource6
#define Meter_B_USARTx_RX_AF                     GPIO_AF_USART2

#define Meter_B_RxTxEn_PIN                       GPIO_Pin_7
#define Meter_B_RxTxEn_GPIO_PORT                 GPIOD
#define Meter_B_RxTxEn_GPIO_CLK                  RCC_AHB1Periph_GPIOD

#endif

typedef enum
{
  eMeterSta_Unavail = 0,
  eMeterSta_Avail
}EnumMeterStatus;

#define MaxMeterFrameLen (64)
typedef struct
{
  EnumMeterStatus Status;
  EnumMeterStatus Status_B;
  EnumMeterStatus Status_AC;
  u8 Addr[6];
  u8 Addr_B[6];
  u8 Addr_AC[6];
  u8 SendLen;
  u8 SendPost;
  u8 SendData[MaxMeterFrameLen];
  osMessageQId RecvMsg;
}StructMeterComm;

typedef struct
{
  u8 Head;
  u8 Addr[6];
  u8 ReHead;
  u8 Ctrl;
  u8 Len;
  u8 Data[MaxMeterFrameLen];
  u8 CS;
  u8 End;
}StructMeterFrame;

typedef struct
{
  s32 All;
  s32 Sharp;
  s32 Peak;
  s32 Flat;
  s32 Valley;
}StructEnergy;

typedef struct
{
  u32 PhaseA;
  u32 PhaseB;
  u32 PhaseC;
}StructVoltage;

typedef struct
{
  s32 PhaseA;
  s32 PhaseB;
  s32 PhaseC;
}StructCurrent;


typedef enum
{
  eMeter_Sum_A_Energy   = 0x00000000,//йܵ
  eMeter_Sum_R1_Energy  = 0x00000100,//й1
  eMeter_Sum_R2_Energy  = 0x00000200,//й2
  eMeter_Sum_R3_Energy  = 0x00000300,//й3
  eMeter_Sum_R4_Energy  = 0x00000400,//й4
  eMeter_Sum_Block_Energy = 0x0000FF00,//йʵܿ

  eMeter_P_A_Energy  = 0x00010000,//йܵ
  eMeter_P_R1_Energy = 0x00010100,//й1
  eMeter_P_R2_Energy = 0x00010200,//й2
  eMeter_P_R3_Energy = 0x00010300,//й3
  eMeter_P_R4_Energy = 0x00010400,//й4
  eMeter_P_Block_Energy = 0x0010FF00,//йʵܿ


  eMeter_Voltage_A = 0x02010100,//Aѹ
  eMeter_Voltage_B = 0x02010200,//Bѹ
  eMeter_Voltage_C = 0x02010300,//Cѹ
  eMeter_Voltage   = 0x0201FF00,//ѹݿ

  eMeter_Current_A = 0x02020100,//A
  eMeter_Current_B = 0x02020200,//B
  eMeter_Current_C = 0x02020300,//C
  eMeter_Current   = 0x0202FF00,//ݿ

  eMeter_Power        = 0x02030000,//˲ʱй
  eMeter_Power_A      = 0x02030100,//˲ʱAй
  eMeter_NegPower_A   = 0x02040100,//˲ʱA޹
  eMeter_PowerFac     = 0x02060000,//ܹ
  eMeter_PowerFac_A   = 0x02060100,//A๦
  eMeter_PowerHz_A    = 0x02800002,//A๦

}EnumMeterCmd;

typedef struct
{
  s32 Energy;//0.01Kwh/bit
  s32 Sharp;//0.01Kwh/bit
  s32 Peak;//0.01Kwh/bit
  s32 Flat;//0.01Kwh/bit
  s32 Valley;//0.01Kwh/bit
  u32 Voltage;//0.1V/bit
  s32 Current;//0.001A/bit
  u32 VoltageA;// A ѹ
  u32 VoltageB;
  u32 VoltageC;
  //s32 CurrentA;// A 
  //s32 CurrentB;
  //s32 CurrentC;
  s32 Power;//0.0001Kw/bit
  s32 PowerFac;//0.001/bit
  s32 Freq;//0.01Hz/bit
}StructMeterValue;

extern StructMeterComm MeterComm;
extern StructMeterValue MeterValue;
extern StructMeterValue MeterValue_B;
extern StructMeterValue MeterValue_AC;

extern u8 MeterInit(void);
extern u8 MeterGetAddr(void);
extern u8 MeterGetEnergy(u32 Type, s32 *pEnergy);
extern u8 MeterGetVoltage(u32 Type, u32 *pVoltage);
extern u8 MeterGetCurrent(u32 Type, s32 *pCurrent);
extern u8 MeterGetEnergyBlock(u32 Type, StructEnergy *pEnergy);
extern u8 MeterGetVoltageBlock(StructVoltage *pVoltage);
extern u8 MeterGetCurrentBlock(StructCurrent *pCurrent);
extern u8 MeterGetPower(u32 Type, s32 *pValue);
extern u8 MeterGetPowerFac(u32 Type, s32 *pValue);
extern u8 MeterGetPositiveEnergy(u32 Type, u32 *pEnergy);

extern u8 MeterGetEnergy_B(u32 Type, s32 *pEnergy);
extern u8 MeterGetVoltage_B(u32 Type, u32 *pVoltage);
extern u8 MeterGetCurrent_B(u32 Type, s32 *pCurrent);
extern u8 MeterGetEnergyBlock_B(u32 Type, StructEnergy *pEnergy);
extern u8 MeterGetVoltageBlock_B(StructVoltage *pVoltage);
extern u8 MeterGetCurrentBlock_B(StructCurrent *pCurrent);
extern u8 MeterGetPower_B(u32 Type, s32 *pValue);
extern u8 MeterGetPowerFac_B(u32 Type, s32 *pValue);
extern u8 MeterGetPositiveEnergy_B(u32 Type, u32 *pEnergy);

#if 0
extern u8 MeterInit_B(void);
extern u8 MeterGetAddr_B(void);
extern u8 MeterGetEnergy_B(u32 Type, s32 *pEnergy);
extern u8 MeterGetVoltage_B(u32 Type, u32 *pVoltage);
extern u8 MeterGetCurrent_B(u32 Type, s32 *pCurrent);
extern u8 MeterGetEnergyBlock_B(u32 Type, StructEnergy *pEnergy);
extern u8 MeterGetVoltageBlock_B(StructVoltage *pVoltage);
extern u8 MeterGetCurrentBlock_B(StructCurrent *pCurrent);
extern u8 MeterGetPower_B(u32 Type, s32 *pValue);
extern u8 MeterGetPowerFac_B(u32 Type, s32 *pValue);
#endif

#endif


