
#ifndef __DRV_READER_H__
#define __DRV_READER_H__

#include "Global.h"

#define ReaderPcb200_USARTx_BaudRate                  (57600)

#define ReaderPcb200_USARTx                           USART3
#define ReaderPcb200_USARTx_CLK                       RCC_APB1Periph_USART3
#define ReaderPcb200_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define ReaderPcb200_USARTx_IRQn                      USART3_IRQn
#define ReaderPcb200_USARTx_IRQHandler                USART3_IRQHandler

#define ReaderPcb200_USARTx_TX_PIN                    GPIO_Pin_8
#define ReaderPcb200_USARTx_TX_GPIO_PORT              GPIOD
#define ReaderPcb200_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderPcb200_USARTx_TX_SOURCE                 GPIO_PinSource8
#define ReaderPcb200_USARTx_TX_AF                     GPIO_AF_USART3

#define ReaderPcb200_USARTx_RX_PIN                    GPIO_Pin_9
#define ReaderPcb200_USARTx_RX_GPIO_PORT              GPIOD
#define ReaderPcb200_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderPcb200_USARTx_RX_SOURCE                 GPIO_PinSource9
#define ReaderPcb200_USARTx_RX_AF                     GPIO_AF_USART3

typedef u8 (*pReaderPcb200SendByte)(u8 Data);

extern u8 ReaderPcb200_Init(osMessageQId RecvOsMsgQId, pReaderPcb200SendByte pSendByte);

extern u8 ReaderPcb200_Test(void);

extern int ReaderPcb200_CardFind(u8 *pUID);
extern int ReaderPcb200_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid);
extern int ReaderPcb200_BlockRead(u8 *pData, u8 Block);
extern int ReaderPcb200_BlockWrite(u8 *pData, u8 Block);

#endif

