
#ifndef __DRV_READERZLG600A_H__
#define __DRV_READERZLG600A_H__

#include "Global.h"

#define ReaderZLG600A_USARTx_BaudRate                  (57600)

#define ReaderZLG600A_USARTx                           USART3
#define ReaderZLG600A_USARTx_CLK                       RCC_APB1Periph_USART3
#define ReaderZLG600A_USARTx_CLK_INIT                  RCC_APB1PeriphClockCmd
#define ReaderZLG600A_USARTx_IRQn                      USART3_IRQn
#define ReaderZLG600A_USARTx_IRQHandler                USART3_IRQHandler

#define ReaderZLG600A_USARTx_TX_PIN                    GPIO_Pin_8
#define ReaderZLG600A_USARTx_TX_GPIO_PORT              GPIOD
#define ReaderZLG600A_USARTx_TX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderZLG600A_USARTx_TX_SOURCE                 GPIO_PinSource8
#define ReaderZLG600A_USARTx_TX_AF                     GPIO_AF_USART3

#define ReaderZLG600A_USARTx_RX_PIN                    GPIO_Pin_9
#define ReaderZLG600A_USARTx_RX_GPIO_PORT              GPIOD
#define ReaderZLG600A_USARTx_RX_GPIO_CLK               RCC_AHB1Periph_GPIOD
#define ReaderZLG600A_USARTx_RX_SOURCE                 GPIO_PinSource9
#define ReaderZLG600A_USARTx_RX_AF                     GPIO_AF_USART3

typedef u8 (*pReaderZLG600ASendByte)(u8 Data);

extern u8 ReaderZLG600A_Init(osMessageQId RecvOsMsgQId, pReaderZLG600ASendByte pSendByte);

//extern u8 ReaderZLG600A_Test(void);
extern u8 ReaderZLG600A_Test(void);

extern int ReaderZLG600A_CardFind(u8 *pUID);
extern int ReaderZLG600A_IdCheck(u8* pID, u8 Section, u8 Key, u8 *pUid);
extern int ReaderZLG600A_BlockRead(u8 *pData, u8 Block);
extern int ReaderZLG600A_BlockWrite(u8 *pData, u8 Block);

#endif


