
/******************************************************************************
ļ  : Drv_RtcExt.c
  : AT24C512BN
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_RtcExt.h"

#define I2cDelay()  DelayUs(5)

#define SclHi()     GPIO_SetBits(Rtc_SCL_GPIO_PORT, Rtc_SCL_PIN)
#define SclLo()     GPIO_ResetBits(Rtc_SCL_GPIO_PORT, Rtc_SCL_PIN)
#define SclRead()   GPIO_ReadInputDataBit(Rtc_SCL_GPIO_PORT, Rtc_SCL_PIN)

#define SdaHi()     GPIO_SetBits(Rtc_SDA_GPIO_PORT, Rtc_SDA_PIN)
#define SdaLo()     GPIO_ResetBits(Rtc_SDA_GPIO_PORT, Rtc_SDA_PIN)
#define SdaRead()   GPIO_ReadInputDataBit(Rtc_SDA_GPIO_PORT, Rtc_SDA_PIN)

u8 ExtRtcError = 0;

/******************************************************************************
  : DelayUs
  : ΢뼰ʱ
  : Us - Ҫʱ΢
  : 
******************************************************************************/
static void DelayUs(u32 Us)
{
  u32 i;

  while(Us)
  {
    for(i=0;i<31;i++)
    {
    }
    Us--;
  }
}

/******************************************************************************
  : SetSclOut
  : SCLźΪ©
  : 
  : 
******************************************************************************/
static void SetSclOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SCL_PIN;
  GPIO_Init(Rtc_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclIn
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SCL_PIN;
  GPIO_Init(Rtc_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSclOutExt
  : SCLźΪ
  : 
  : 
******************************************************************************/
static void SetSclOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SCL_PIN;
  GPIO_Init(Rtc_SCL_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOut
  : SDAźΪ©
  : 
  : 
******************************************************************************/
static void SetSdaOut(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SDA_PIN;
  GPIO_Init(Rtc_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaIn
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaIn(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SDA_PIN;
  GPIO_Init(Rtc_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : SetSdaOutExt
  : SDAźΪ
  : 
  : 
******************************************************************************/
static void SetSdaOutExt(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_Pin = Rtc_SDA_PIN;
  GPIO_Init(Rtc_SDA_GPIO_PORT, &GPIO_InitStructure);
}

/******************************************************************************
  : I2cStart
  : I2C߿ʼź
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
static u8 I2cStart(void)
{
  u8 i;

  SclHi();
  SdaHi();
  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }
  /*Ϊ*/
  SetSclOutExt();
  SetSdaOutExt();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
  return TRUE;
}

/******************************************************************************
  : I2cReStart
  : I2C¿ʼ
  : 
  : 
******************************************************************************/
static void I2cReStart(void)
{
  SdaHi();
  SclHi();
  I2cDelay();
  SdaLo();
  I2cDelay();
  SclLo();
  I2cDelay();
}

/******************************************************************************
  : I2cStart
  : I2C߽ź
  : 
  : 
******************************************************************************/
static void I2cStop(void)
{
  SdaLo();   //PA2(SDA)=00v
  I2cDelay();
  SclHi();    //PA1(SCL)=13.3V
  I2cDelay();
  SdaHi();    //PA2(SDA)=13.3V
  I2cDelay();
  /*Ϊ©*/
  SetSclOut();
  SetSdaOut();
}

/******************************************************************************
  : I2cSendByte
  : I2C߷һֽ
  : Data - ͵ֽ
  : TRUE - ɹ
        FALSE - ʧ
******************************************************************************/
static u8 I2cSendByte(u8 Data)
{
  u8 i;
  u8 Bit;
  u8 Rtn;

  Bit = 0x80;
  for(i=0; i<8; i++)
  {
    if(Data & Bit)
      SdaHi();//SDAŷ1
    else
      SdaLo();//SDAŷ0
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    Bit = Bit >> 1;
    I2cDelay();
  }

  SdaHi();
  SetSdaIn();
  I2cDelay();
  SclHi();
  I2cDelay();
  if(SdaRead())
    Rtn = FALSE;
  else
    Rtn = TRUE;
  I2cDelay();
  SclLo();
  I2cDelay();
  SetSdaOutExt();
  return Rtn;
}

/******************************************************************************
  : I2cReadByte
  : I2C߶һֽ
  : Ack - 0 Ӧ 1 Ӧ
  : ض
******************************************************************************/
static u8 I2cReadByte(u8 Ack)
{
  u8 i;
  u8 Data;

  Data = 0;
  SetSdaIn();
  for(i=0; i<8; i++)
  {
    Data = Data << 1;
    I2cDelay();
    SclHi();    //PA1(SCL)=13.3V
    I2cDelay();
    if(SdaRead())
      Data |= 0x01;
    I2cDelay();
    SclLo();   //PA1(SCL)=00v
    I2cDelay();
  }
  SetSdaOutExt();

  if(Ack)
    SdaHi();
  else
    SdaLo();
  I2cDelay();
  SclHi();
  I2cDelay();
  I2cDelay();
  SclLo();
  I2cDelay();
  return Data;
}

/******************************************************************************
  : RtcExtIicInit
  : Iicӿڳʼ
  : 
  : TRUE - ʼ
        FALSE - ʼ
******************************************************************************/
u8 RtcExtIicInit(void)
{
  u8 i;

  RCC_AHB1PeriphClockCmd(Rtc_SCL_GPIO_CLK, ENABLE);
  RCC_AHB1PeriphClockCmd(Rtc_SDA_GPIO_CLK, ENABLE);
  SclHi();
  SdaHi();
  SetSdaOut();
  SetSclOut();

  I2cDelay();
  SetSclIn();
  SetSdaIn();
  if(0 == SdaRead() || (0 == SclRead()))
  {//
    SetSclOutExt();
    for(i=0; i<10; i++)//9clk
    {
      SclHi();
      I2cDelay();
      I2cDelay();
      SclLo();
      I2cDelay();
      I2cDelay();
    }
    SetSdaOutExt();//
    SdaLo();
    I2cDelay();
    SclHi();
    I2cDelay();
    SdaHi();

    SetSclIn();
    SetSdaIn();
    I2cDelay();
    if(0 == SdaRead() || (0 == SclRead()))
    {
//      SclHi();
//      SdaHi();
      SetSclOut();
      SetSdaOut();
      return FALSE;
    }
  }

//  SclHi();
//  SdaHi();
  SetSclOut();
  SetSdaOut();
  return TRUE;
}

/******************************************************************************
  : RtcExtWriteData
  : 24C512ҳд
  : Addr - ʼַ
        pData - Ҫдݵָ
        Len - Ҫдݳ
  : ο EnumRtcExtError
******************************************************************************/
EnumRtcExtError RtcExtWriteData(u8 Addr, u8 *pData, u8 Len)
{
  EnumRtcExtError Err;
  u16 i;

  if(NULL == pData)
    return eRtcErr_DataPiont;
  if(Len > (0x0F - Addr))
    return eRtcErr_WriteOver;

  if(0 == Len)
    return eRtcErr_Sucess;

  if(FALSE == I2cStart())
  {
    Err = eRtcErr_BusErr;
    goto __RtcWritReturn__;
  }

  Err = eRtcErr_Sucess;
  if(FALSE == I2cSendByte(Rtc_SlaveAddr))
  {
    Err = eRtcErr_WriteCmd;
    goto __RtcWritReturn__;
  }

  if(FALSE == I2cSendByte(Addr))
  {
    Err = eRtcErr_RegAddr;
    goto __RtcWritReturn__;
  }

  for(i=0; i<Len; i++)
  {
    if(FALSE == I2cSendByte(pData[i]))
    {
      Err = eRtcErr_WriteData;
      goto __RtcWritReturn__;
    }
  }

__RtcWritReturn__:
  I2cStop();
  return Err;
}

/******************************************************************************
  : RtcExtReadData
  : 24C512
  : Addr - ʼַ
        pData - ݵָ
        Len - Ҫݳ
  : ο EnumRtcExtError
******************************************************************************/
EnumRtcExtError RtcExtReadData(u16 Addr, u8 *pData, u16 Len)
{
  EnumRtcExtError Err;
  u16 i;

  if(NULL == pData)
    return eRtcErr_DataPiont;
  if(Len > (0xFFFF - Addr))
    return eRtcErr_WriteOver;

  if(0 == Len)
    return eRtcErr_Sucess;

  if(FALSE == I2cStart())
  {
    Err = eRtcErr_BusErr;
    goto __RtcReadReturn__;
  }

  Err = eRtcErr_Sucess;
  if(FALSE == I2cSendByte(Rtc_SlaveAddr))
  {
    Err = eRtcErr_WriteCmd;
    goto __RtcReadReturn__;
  }

  if(FALSE == I2cSendByte(Addr))
  {
    Err = eRtcErr_RegAddr;
    goto __RtcReadReturn__;
  }

  I2cReStart();
  if(FALSE == I2cSendByte(Rtc_SlaveAddr|0x01))
  {
    Err = eRtcErr_ReadCmd;
    goto __RtcReadReturn__;
  }

  for(i=0; i<(Len-1); i++)
  {
    pData[i] = I2cReadByte(0);
  }

  pData[i] = I2cReadByte(1);

__RtcReadReturn__:
  I2cStop();
  return Err;
}

//*:BcDToHex
//*: BCDת16
//*: bcd_data  ҪתBCD(0-100)
//*: ת16
static u8 BcDToHex(u8 Bcd)
{
  return ((Bcd>>4)*10 + (Bcd&0x0F));
}

//*ƣ HexToBcd
//*ܣ  16תBCD
//*  hex_data  Ҫת16(0-100)
//*أ  תBCD
static u8 HexToBcd(u8 Hex)
{
  u8 Temp;
  u8 Bcd;

  Temp = Hex%100;
  Bcd = (Temp/10<<4) | (Temp%10);

  return Bcd;
}

//*: void RtcExtStart(void)
//*: PCF8563оƬ
EnumRtcExtError RtcExtStart(void)
{
  u8 Temp = 0;

  return RtcExtWriteData(eRtcReg_CrtlSta_1, &Temp, 1);
}

//*: void RtcExtStart(void)
//*: PCF8563оƬ
EnumRtcExtError RtcExtStop(void)
{
  u8 Temp = 0x20;

  return RtcExtWriteData(eRtcReg_CrtlSta_1, &Temp, 1);
}


//*: void RtcExtGetTime(unsigned char *ptr)
//*: RTCоƬȡʱ ŵָ
u8 RtcExtGetTime(StructTime *pTime)
{
  u8 Bcd[7];

  if(NULL == pTime)
    return FALSE;

  if(eRtcErr_Sucess != RtcExtReadData(eRtcReg_Sec, Bcd, 7))
    return FALSE;

  pTime->Sec = BcDToHex(Bcd[0]&0x7F);      //  
  pTime->Min = BcDToHex(Bcd[1]&0x7F);      //  
  pTime->Hour = BcDToHex(Bcd[2]&0x3F);      //  Сʱ
  pTime->Day = BcDToHex(Bcd[3]&0x3F);      //  
//  Bcd[4]=Bcd[4];                        //
  pTime->Mon = BcDToHex(Bcd[5]&0x1F);      //  
  if(Bcd[5]&0x80)
    pTime->Year = 1900 + BcDToHex(Bcd[6]);          //  
  else
    pTime->Year = 2000 + BcDToHex(Bcd[6]);          //  

  return TRUE;
}

//**:  RtcExtSetTime
//*:  ʱдPCF8563Ƭ
//*:  *pTime  ʱ
u8 RtcExtSetTime(StructTime *pTime)
{
  u8 Bcd[7];

  if(NULL == pTime)
    return FALSE;

  Bcd[0] = HexToBcd(pTime->Sec);
  Bcd[1] = HexToBcd(pTime->Min);
  Bcd[2] = HexToBcd(pTime->Hour);
  Bcd[3] = HexToBcd(pTime->Day);
  Bcd[4] = 0;
  Bcd[5] = HexToBcd(pTime->Mon);
  if(pTime->Year >= 2000)
    Bcd[6] = HexToBcd((u8)(pTime->Year - 2000));
  else if(pTime->Year >= 1900)
  {
    Bcd[6] = HexToBcd((u8)(pTime->Year - 1900));
    Bcd[5] |= 0x80;
  }
  else
    Bcd[6] = 0;

  if(eRtcErr_Sucess != RtcExtStop())      //  PCF8563ʱоֹͣ
    return FALSE;

  if(eRtcErr_Sucess != RtcExtWriteData(eRtcReg_Sec, Bcd, 7))//  ʱдPCF8563
    return FALSE;

  if(eRtcErr_Sucess != RtcExtStart())    //  PCF8563ʱоʼ
    return FALSE;

  return TRUE;
}

u8 RtcExtInit(void)
{
  u8 Bcd;
  StructTime Time = {2017, 1, 1, 0, 0, 0};

  if(FALSE == RtcExtIicInit())
  {
    ExtRtcError = 1;
    return FALSE;
  }

  if(eRtcErr_Sucess != RtcExtReadData(eRtcReg_Sec, &Bcd, 1))
  {
    ExtRtcError = 2;
    return FALSE;
  }
  if(Bcd >= 0x60)
  {
    if(FALSE == RtcExtSetTime(&Time))
    {
      ExtRtcError = 3;
      return FALSE;
    }
  }

  ExtRtcError = 0;
  return TRUE;
}


