
#ifndef __DRV_RTCEXT_H__
#define __DRV_RTCEXT_H__

#include "Global.h"

#define Rtc_SCL_GPIO_CLK               RCC_AHB1Periph_GPIOB
#define Rtc_SCL_GPIO_PORT              GPIOB
#define Rtc_SCL_PIN                    GPIO_Pin_6

#define Rtc_SDA_GPIO_CLK               RCC_AHB1Periph_GPIOB
#define Rtc_SDA_GPIO_PORT              GPIOB
#define Rtc_SDA_PIN                    GPIO_Pin_7

#define Rtc_SlaveAddr                  (0xA2)

typedef enum
{
  eRtcErr_Sucess = 0, //ɹ
  eRtcErr_DataPiont,  //ָΪ
  eRtcErr_WriteOver,  //дݳΧ
  eRtcErr_ReadOver,   //ݳΧ
  eRtcErr_BusErr,     //ߴ
  eRtcErr_WriteCmd,   //豸ӵַдӦ
  eRtcErr_ReadCmd,    //豸ӵַӦ
  eRtcErr_RegAddr,  //Ĵ͵ַӦ
  eRtcErr_WriteData,  //дӦ
}EnumRtcExtError;

typedef enum
{
  eRtcReg_CrtlSta_1 = 0x00,  //CONTROL_STATUS_1
  eRtcReg_CrtlSta_2 = 0x01,  //CONTROL_STATUS_2
  eRtcReg_Sec       = 0x02,  //VL_SECONDS
  eRtcReg_Min       = 0x03,  //MINUTES
  eRtcReg_Hour      = 0x04,  //HOURS
  eRtcReg_Day       = 0x05,  //DAYS
  eRtcReg_Week      = 0x06,  //WEEKDAYS
  eRtcReg_Mon       = 0x07,  //CENTURY_MONTHS
  eRtcReg_Year      = 0x08,  //YEARS
  eRtcReg_MinAlarm  = 0x09,  //MINUTE_ALARM
  eRtcReg_HourAlarm = 0x0A,  //HOUR_ALARM
  eRtcReg_DayAlarm  = 0x0B,  //DAY_ALARM
  eRtcReg_WeekAlarm = 0x0C,  //WEEKDAY_ALARM
  eRtcReg_ClkOut    = 0x0D,  //CLKOUT_CONTROL
  eRtcReg_TimerCtrl = 0x0E,  //TIMER_CONTROL
  eRtcReg_Timer     = 0x0F,  //TIMER
}EnumRtcExtReg;



extern u8 RtcExtInit(void);
extern u8 RtcExtGetTime(StructTime *pTime);
extern u8 RtcExtSetTime(StructTime *pTime);

//*:BcDToHex
//*: BCDת16
//*: bcd_data  ҪתBCD(0-100)
//*: ת16
extern u8 BcDToHex(u8 Bcd);


//*ƣ HexToBcd
//*ܣ  16תBCD
//*  hex_data  Ҫת16(0-100)
//*أ  תBCD
extern u8 HexToBcd(u8 Hex);


#endif


