
#include "Drv_TCUComm.h"

#include "Drv_Meter.h"

#include "Thd_Lcd.h"

#include "Drv_Adc.h"

osMessageQId	TCUMsg = 0;


u8 TCUSendMsg(StructChargeSend * pMsg)
{
	CanTxMsg		TxMsg;

	TxMsg.ExtId 		= pMsg->Id.Mult;
	TxMsg.IDE			= CAN_ID_EXT;
	TxMsg.RTR			= CAN_RTR_DATA;
	TxMsg.DLC			= pMsg->Len;
	TxMsg.Data[0]		= pMsg->Data[0];
	TxMsg.Data[1]		= pMsg->Data[1];
	TxMsg.Data[2]		= pMsg->Data[2];
	TxMsg.Data[3]		= pMsg->Data[3];
	TxMsg.Data[4]		= pMsg->Data[4];
	TxMsg.Data[5]		= pMsg->Data[5];
	TxMsg.Data[6]		= pMsg->Data[6];
	TxMsg.Data[7]		= pMsg->Data[7];

	if (CAN_TxStatus_NoMailBox != MCP2515_B_Transmit(&TxMsg))
		return TRUE;

	return FALSE; //δͳɹFALSE
}


void TCURxIrqHandle(void)
{
	CanRxMsg		RxMsg;
	u8				IrSta = 0;

	//u8 RecvFlag;
	StructTCUSend	Frame;
	Union1939Id 	Id1939 =
	{
		.Mult				= 0, 
	};
	IrSta				= MCP2515_B_ReadStatus();
	portBASE_TYPE	taskWoken = pdFALSE;

	if (IrSta & 0x01)
	{
		MCP2515_B_Receive(0, &RxMsg);
		MCP2515_B_BitModify(CANINTF, 0x01, 0x00);

		if ((CAN_ID_STD == RxMsg.IDE) || (CAN_RTR_REMOTE == RxMsg.RTR))
			return;

		Id1939.Mult 		= RxMsg.ExtId;

		if (1 == Id1939.Disp.R)
			return;

		if (1 == Id1939.Disp.DP)
			return;

		if ((Id1939.Disp.DA_PS != ChargerCont1939Addr) || (Id1939.Disp.SA != TCU1939Addr))
			return;

		if (Id1939.Disp.PF < 240)
		{
			Frame.DA			= Id1939.Disp.DA_PS;

			Frame.Pgn			= Id1939.Disp.PF << 8;

			if (Id1939.Disp.DP)
				Frame.Pgn += 0x010000;
		}
		else 
		{
			Frame.DA			= 0xFF;
			Frame.Pgn			= (Id1939.Disp.PF << 8) +Id1939.Disp.DA_PS;

			if (Id1939.Disp.DP)
				Frame.Pgn += 0x010000;
		}

		switch (Frame.Pgn)
		{
			case eCmd_start: // ֡		
			case eCmd_stop: // ֹͣ֡	
			case eCmd_time: // ʱ֡		
			case eCmd_versi: // 汾У֡	
			case eCmd_param: // ·Ϣ֡		
			case eCmd_SerCon: // ͣ֡	
			case eCmd_Gun: // ɿ֡ 
			case eCmd_power: //  ʵڿ֡ 
			case eCmd_Query: //  ׮Ϣѯ֡  
			case eCmd_verificationAck: //֤Ӧ֡	
				////////////״̬֡///////////////// 
			case eCmd_startCompAck: //	Ӧ֡	
			case eCmd_stopCompAck: // ֹͣӦ֡ 
				///////////֡/ֱ////////////
			case eCmd_DCTCUMeasu: // ƷѵԪң֡
				///////////֡///////////
			case eCmd_TcuHeart: //	ƷѵԪ	
			case eCmd_TCUErroComm: // ƷѵԪ֡
				Frame.Prio = Id1939.Disp.Prio;
				Frame.DP = Id1939.Disp.DP;
				Frame.PF = Id1939.Disp.PF;
				Frame.SA = Id1939.Disp.SA;
				Frame.Len = RxMsg.DLC;

				if (Frame.Len > 8)
					Frame.Len = 8;

				Frame.Data[0] = RxMsg.Data[0];
				Frame.Data[1] = RxMsg.Data[1];
				Frame.Data[2] = RxMsg.Data[2];
				Frame.Data[3] = RxMsg.Data[3];
				Frame.Data[4] = RxMsg.Data[4];
				Frame.Data[5] = RxMsg.Data[5];
				Frame.Data[6] = RxMsg.Data[6];
				Frame.Data[7] = RxMsg.Data[7];

				if (pdTRUE == xQueueSendFromISR(TCUMsg, &Frame, &taskWoken))
					portEND_SWITCHING_ISR(taskWoken);

				break;

			default:
				break;
		}

	}

	if (IrSta & 0x02)
	{
		MCP2515_B_Receive(1, &RxMsg);
		MCP2515_B_BitModify(CANINTF, 0x02, 0x00);

		if ((CAN_ID_STD == RxMsg.IDE) || (CAN_RTR_REMOTE == RxMsg.RTR))
			return;

		Id1939.Mult 		= RxMsg.ExtId;

		if (1 == Id1939.Disp.R)
			return;

		if (1 == Id1939.Disp.DP)
			return;

		if ((Id1939.Disp.DA_PS != ChargerCont1939Addr) || (Id1939.Disp.SA != TCU1939Addr))
			return;

		if (Id1939.Disp.PF < 240)
		{
			Frame.DA			= Id1939.Disp.DA_PS;

			Frame.Pgn			= Id1939.Disp.PF << 8;

			if (Id1939.Disp.DP)
				Frame.Pgn += 0x010000;
		}
		else 
		{
			Frame.DA			= 0xFF;
			Frame.Pgn			= (Id1939.Disp.PF << 8) +Id1939.Disp.DA_PS;

			if (Id1939.Disp.DP)
				Frame.Pgn += 0x010000;
		}

		switch (Frame.Pgn)
		{
			case eCmd_start: //  ֡		
			case eCmd_stop: //	ֹͣ֡	
			case eCmd_time: //		ʱ֡		
			case eCmd_versi: //汾У֡	
			case eCmd_param: //  ·Ϣ֡		
			case eCmd_SerCon: //	 ͣ֡	
			case eCmd_Gun: //	ɿ֡ 
			case eCmd_power: //  ʵڿ֡ 
			case eCmd_Query: //  ׮Ϣѯ֡  
			case eCmd_verificationAck: //֤Ӧ֡	
				////////////״̬֡///////////////// 
			case eCmd_startCompAck: //	Ӧ֡	
			case eCmd_stopCompAck: // ֹͣӦ֡ 
				///////////֡/ֱ////////////
				///////////֡///////////
			case eCmd_TcuHeart: //	ƷѵԪ	
			case eCmd_TCUErroComm: // ƷѵԪ֡	
				Frame.Prio = Id1939.Disp.Prio;
				Frame.DP = Id1939.Disp.DP;
				Frame.PF = Id1939.Disp.PF;
				Frame.SA = Id1939.Disp.SA;
				Frame.Len = RxMsg.DLC;

				if (Frame.Len > 8)
					Frame.Len = 8;

				Frame.Data[0] = RxMsg.Data[0];
				Frame.Data[1] = RxMsg.Data[1];
				Frame.Data[2] = RxMsg.Data[2];
				Frame.Data[3] = RxMsg.Data[3];
				Frame.Data[4] = RxMsg.Data[4];
				Frame.Data[5] = RxMsg.Data[5];
				Frame.Data[6] = RxMsg.Data[6];
				Frame.Data[7] = RxMsg.Data[7];

				if (pdTRUE == xQueueSendFromISR(TCUMsg, &Frame, &taskWoken))
					portEND_SWITCHING_ISR(taskWoken);

				break;

			default:
				break;
		}




	}

}


void TCUCanInit(void)
{
	MCP2515_B_EnterCritical();

	MCP2515_B_SetInt(TCURxIrqHandle, DISABLE);

	MCP2515_B_SpiInit();							//ʼMCUSPI

	MCP2515_B_Reset();								// MCP2515 ǰλ

	//ʹλ޸ָMCP2515Ϊģʽ
	//ҲǽCANCTRLĴREQOP[2:0]Ϊ100
	MCP2515_B_BitModify(CANCTRL, 0xE0, (1 << REQOP2));

	/*
	//㲢MCP2515λʱ

	// ʱƵʣFosc	= 16MHz
	// Ƶ CNF1.BRP[5:0] = 7
	// Сʱݶ TQ = 2 * ( BRP + 1 ) / Fosc	= 2*(7+1)/16M = 1uS
	// ͬ Sync Seg	= 1TQ
	//  Prop Seg	= ( PRSEG + 1 ) * TQ	= 1 TQ
	// λ Phase Seg1 = ( PHSEG1 + 1 ) * TQ = 1 TQ
	// λ Phase Seg2 = ( PHSEG2 + 1 ) * TQ = 1 TQ
	// ͬתΪ CNF1.SJW[1:0] = 00,  1TQ
	// ߲ NBR = Fbit =	1/(sync seg + Prop seg + PS1 + PS2 )
	//						 = 1/(4TQ) = 1/4uS = 250kHz

	//÷ƵCNF1.BRP[5:0] = 7ͬתΪ CNF1.SJW[1:0] = 00
	MCP2515_WriteReg( CNF1, (1<<BRP0)|(1<<BRP1)|(1<<BRP2) );
	// ô Prop Seg Ϊ001TQλ Phase Seg1ĳ1TQ
	MCP2515_WriteReg( CNF2, (1<<BTLMODE)|(0<<PHSEG10) );
	//  λ Phase Seg2Ϊ 1TQ  û˲
	MCP2515_WriteReg( CNF3, (0<<PHSEG20) );

	*/
	MCP2515_B_WriteReg(CNF1, (1 << BRP0) | (1 << BRP1) | (1 << BRP2));

	// ô Prop Seg Ϊ001TQλ Phase Seg1ĳ1TQ
	MCP2515_B_WriteReg(CNF2, (1 << BTLMODE) | (0 << PHSEG11));

	//  λ Phase Seg2Ϊ 1TQ  û˲
	MCP2515_B_WriteReg(CNF3, (0 << PHSEG21));

	// MCP2515жʹܼĴ,ʹܽջж
	MCP2515_B_WriteReg(CANINTE, (1 << RX1IE) | (1 << RX0IE));

	//ݽؼĴ
	// RXM[1:0]=11,رսջ0/˲ܣбģֹ湦
	//MCP2515_WriteReg(RXB0CTRL, (1<<RXM1)|(1<<RXM0));
	MCP2515_B_WriteReg(RXB0CTRL, (1 << RXM1) | (1 << RXM0) | (1 << BUKT));

	// RXM[1:0]=11,رսջ1/˲ܣбģ
	MCP2515_B_WriteReg(RXB1CTRL, (1 << RXM1) | (1 << RXM0));
	u8				Temp[4] =
	{
		0, 0, 0, 0
	};

	//6˲ĴΪ0
	MCP2515_B_WriteBuffer(RXF0SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXF1SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXF2SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXF3SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXF4SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXF5SIDH, Temp, 4);

	//2˲ĴΪ0
	MCP2515_B_WriteBuffer(RXM0SIDH, Temp, 4);
	MCP2515_B_WriteBuffer(RXM1SIDH, Temp, 4);

	//
	//ýſƼĴǽõڶ
	MCP2515_B_WriteReg(BFPCTRL, 0);

	//ʹãBFPCTRLʹRX0BF,RX1BFΪ
	//MCP2515_BitModify( BFPCTRL, (1<<B1BFE)|(1<<B0BFE)|(1<<B1BFM)|(1<<B0BFM), (1<<B1BFE)|(1<<B0BFE) );
	//÷ſƼĴǽõڶ
	MCP2515_B_WriteReg(TXRTSCTRL, 0);

	//MCP2515뻷ģʽйܲ
	//MCP2515_BitModify(CANCTRL, 0XE0, (1<<REQOP1));
	//MCP2515ģʽ
	MCP2515_B_BitModify(CANCTRL, 0xE0, 0);

	MCP2515_B_SetInt(TCURxIrqHandle, ENABLE);

	MCP2515_B_ExitCritical();

	MCP2515_B_SpiHightSpeedInit();
}


u8 TCUCommInit(void)
{
	/* Create Storage Message Queue */
	TCUMsg				= NULL;
	osMessageQDef(TCUMsg, 64, StructPgnRecv);
	TCUMsg				= osMessageCreate(osMessageQ(TCUMsg), NULL);

	TCUCanInit();
	
	return TRUE;
}


StructStartMeg	StartMeg_A =
{
	0
};


StructStartMeg	StartMeg_B =
{
	0
};


StructStartCompMeg AckStartCompMeg_A =
{
	0
};


StructStartCompMeg AckStartCompMeg_B =
{
	0
};


StructStopCompMeg AckStopCompMeg_A =
{
	0
};


StructStopCompMeg AckStopCompMeg_B =
{
	0
};


UnionInformainReport1 InformainReport_A =
{
	0
};


UnionInformainReport1 InformainReport_B =
{
	0
};


UnionInformainReport2 InformainReport2_A =
{
	0
};


UnionInformainReport2 InformainReport2_B =
{
	0
};


StructVerificationInformain VerificaInfo =
{
	0
};


StructVerificationInformain VerificaInfo_B =
{
	0
};


StructTCUEM 	TCUChgContralTCUEM_A;
StructTCUEM 	TCUChgContralTCUEM_B;




StructTCUCControl TCUControlInfo =
{
	.ChargingServiceFlag = 1, 
	.version			= 0x0100, 
	.ChargeNum			=
	{
		0, 0, 0, 0
	},
	.ManufacturerCode	=
	{
		0xFF, 0xff, 0xff, 0xff
	},
	.DeviceModel		=
	{
		0xFF, 0xff, 
	},

	//豸ͺ
	.HardwareVersion	=
	{
		0xFF, 0xff, 
	},

	//Ӳ汾
	.SoftwareVersion	=
	{
		0xFF, 0xff, 
	},

	//汾
	.SoftwareData		=
	{
		0xFF, 0xff, 0xFF, 0xFF
	},

	//
	.BmsVersion 		= 0x01, 					//BMSЭ汾01H GB/27930-2011 02HGB/27930-2011
	.DcMaxVolt			= 7500, 					//ģѹ XXX.xV
	.DcMinVolt			= 3000, 					//ģСѹ XXX.xV
	.DcMaxCurrt 		= 2400, 					//ģ XX.xA
	.DcMinCurrt 		= 0,						//ģС XX.xA 
	.PowerControl_A 	=
	{
		2, 0, 100
	},
	.PowerControl_B 	=
	{
		2, 0, 100
	},
};


void TCUSinglePackSendMsg(u8 * pframe, u16 len, EnumTCUCommPgn cmd, u8 Prio)
{
	StructChargeSend FrameSend;

	//u8 Reason = 0x00;
	FrameSend.Id.Mult	= 0;
	FrameSend.Id.Disp.Prio = Prio;
	FrameSend.Id.Disp.PF = cmd >> 8;
	FrameSend.Id.Disp.DA_PS = TCU1939Addr;
	FrameSend.Id.Disp.SA = ChargerCont1939Addr;
	FrameSend.Len		= len;
	FrameSend.Data[0]	= pframe[0];
	FrameSend.Data[1]	= pframe[1];
	FrameSend.Data[2]	= pframe[2];
	FrameSend.Data[3]	= pframe[3];
	FrameSend.Data[4]	= pframe[4];
	FrameSend.Data[5]	= pframe[5];
	FrameSend.Data[6]	= pframe[6];
	FrameSend.Data[7]	= pframe[7];

	TCUSendMsg(&FrameSend);
}


void TCUMultiPackSendMsg(u8 * pfram, u16 len, EnumTCUCommPgn cmd, u8 Prio)
{
	u8				i;
	StructChargeSend FrameSend;
	u8				lenFlag = 0;

	FrameSend.Id.Mult	= 0;
	FrameSend.Id.Disp.Prio = Prio;
	FrameSend.Id.Disp.PF = cmd >> 8;
	FrameSend.Id.Disp.DA_PS = TCU1939Addr;
	FrameSend.Id.Disp.SA = ChargerCont1939Addr;
	u16 			checkSum = 0;

	for (i = 0; i < len; i++)
	{
		checkSum			+= pfram[i];
	}

	checkSum			= checkSum + ((len + 3 + 2) / 7 + 1);
	checkSum			= checkSum + (u8)len + (u8) (len >> 8);

	for (i = 1; i <= ((len + 3 + 2) / 7 + 1); i++) //һ
	{
		if (i == 1)
		{
			FrameSend.Data[0]	= i;
			FrameSend.Data[1]	= (len + 3 + 2) / 7 + 1;
			FrameSend.Data[2]	= (u8)len;
			FrameSend.Data[3]	= (u8) (len >> 8);
			//FrameSend.Data[4]	= *pfram++;
			memcpy(&FrameSend.Data[4], pfram, 4);
			lenFlag 			+= 4;
		}
		else if (i == ((len + 3 + 2) / 7 + 1)) //һ
		{
			FrameSend.Data[0]	= i;
			memcpy(&FrameSend.Data[1], &pfram[lenFlag], len - lenFlag);
			FrameSend.Data[len - lenFlag] = (u8)checkSum;
			FrameSend.Data[len - lenFlag + 1] = (u8) (checkSum >> 8);
			memset(&FrameSend.Data[len - lenFlag + 1 + 1], 0x00, 6 - len + lenFlag);
		}
		else 
		{
			FrameSend.Data[0]	= i;
			memcpy(&FrameSend.Data[1], &pfram[lenFlag], 7);
			lenFlag 			+= 7;
		}

		FrameSend.Len		= 8;
		TCUSendMsg(&FrameSend);
		osDelay(1);
	}
}



void StartMeg(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 0x01)
	{
		if ((TCUCurChgRecd.TCUChgStartNotetrl == 0) && (TCUCurChgRecd.TCUChargeEnable == 0) &&
			 ((eLcdPro_TCUMainMenu == TCUCtrl.CurScreen) || (eLcdPro_TCUChargeSummary_B == TCUCtrl.CurScreen)))
		{

			StartMeg_A.GunNum	= pPgnRecv->Data[0];
			StartMeg_A.LoadSswitch = pPgnRecv->Data[1];
			StartMeg_A.PlugToChgFlag = pPgnRecv->Data[2];

			if ((StartMeg_A.LoadSswitch == 1) || (StartMeg_A.LoadSswitch == 2) && (StartMeg_A.PlugToChgFlag == 0) ||
				 (StartMeg_A.PlugToChgFlag == 1))
			{
				TCUCurChgRecd.StarValid = 1;
				TCUCurChgRecd.StarChgType = pPgnRecv->Data[2];
				TCUCtrl.CurScreen	= eLcdPro_TCUPrstart;
				TCUCtrl.Param		= 0;
				TCUCurChgRecd.TCUChgStartNotetrl = 1; //ظ翪ʼͱ־λ
			}
			else 
			{
				TCUCurChgRecd.StarValid = 0;		//·ʧ
				TCUCurChgRecd.TCUChgStartNotetrl = 1; //ظ翪ʼͱ־λ
			}
		}
		else if ((TCUCurChgRecd.TCUChgStartNotetrl != 0) && (TCUCurChgRecd.TCUChargeEnable == 0))
		{
			;										//߼׶β
		}
		else //if((TCUCurChgRecd.TCUChgStartNotetrl ==0)

		//	&&(TCUCurChgRecd.TCUChargeEnable !=0)
		//	)
		{
			TCUCurChgRecd.TCUChgStartNotetrl = 1;	//ظ翪ʼͱ־λ
		}

	}
	else if (pPgnRecv->Data[0] == 0x02)
	{
		if ((TCUCurChgRecd_B.TCUChgStartNotetrl == 0) && (TCUCurChgRecd_B.TCUChargeEnable == 0) &&
			 ((eLcdPro_TCUMainMenu == TCUCtrl.CurScreen) || (eLcdPro_TCUChargeSummary == TCUCtrl.CurScreen)))
		{
			StartMeg_B.GunNum	= pPgnRecv->Data[0];
			StartMeg_B.LoadSswitch = pPgnRecv->Data[1];
			StartMeg_B.PlugToChgFlag = pPgnRecv->Data[2];

			if ((StartMeg_B.LoadSswitch == 1) || (StartMeg_B.LoadSswitch == 2) && (StartMeg_B.PlugToChgFlag == 0) ||
				 (StartMeg_B.PlugToChgFlag == 1))
			{
				TCUCurChgRecd_B.StarValid = 1;
				TCUCurChgRecd_B.StarChgType = pPgnRecv->Data[2];
				TCUCtrl.CurScreen	= eLcdPro_TCUPrstart_B;
				TCUCtrl.Param		= 0;
				TCUCurChgRecd.TCUChgStartNotetrl = 1; //ظ翪ʼͱ־λ
			}
			else 
			{
				TCUCurChgRecd_B.StarValid = 0;		//·ʧ
				TCUCurChgRecd_B.TCUChgStartNotetrl = 1; //ظ翪ʼͱ־λ

			}
		}
		else if ((TCUCurChgRecd_B.TCUChgStartNotetrl != 0) && (TCUCurChgRecd_B.TCUChargeEnable == 0))
		{
			;										//߼׶β
		}
		else //if((TCUCurChgRecd_B.TCUChgStartNotetrl ==0)

		//	&&(TCUCurChgRecd_B.TCUChargeEnable !=0)
		//	)
		{
			TCUCurChgRecd_B.TCUChgStartNotetrl = 1; //׶
		}

	}

}


u8 AllowDTUStartCharge(u8 * Reason)
{
	if (TCUCurChgRecd.StarValid == 0)
		*Reason = 0x01;
	else if (TCUCommuStatus.ConnectFlag == 0)
		*Reason = 0x02;
	else if (TCUCommuStatus.VerChkVaild == 0)
		*Reason = 0x03;
	else if (TCUCommuStatus.ParamVaild == 0)
		*Reason = 0x04;
	else if (TCUControlInfo.ChargingServiceFlag == 0x01) //ͣ
		*Reason = 0x05;
	else if (ChargeCtrl.CurProcess != eChgPro_ChgIdle)
		*Reason = 0x06;
	else if (ChargePauseFlag == 1) //ͣ
		*Reason = 0x07;
	else if (eSwSta_On != CcStatusRead())
		*Reason = 0x08;
	else if (PillarError.Value.Emergency == 1)
		*Reason = 0x09;
	else if (PillarError.Value.Door == 1)
		*Reason = 0x0A;
	else if (PillarError.Value.SPD == 1)
		*Reason = 0x0B;
	else if (PillarError.Value.EleLock == 1)
		*Reason = 0x0F;
	else if ((PillarError.Value.Insulation == 1) || (PillarError.Value.ImdDev == 1))
		*Reason = 0x010;
	else if (ChargeStopType == eChgStop_PillarReady_BatVoltError)
		*Reason = 0x11;
	else if ((ChargeStopType == eChgStop_Imd_BhmTimeOut) || (ChargeStopType == eChgStop_ComBreak_CommError))
		*Reason = 0x12;
	else if (PillarError.Value.ACContactor == 1)
		*Reason = 0x13;
	else if (PillarError.Value.Contactor)
		*Reason = 0x17;
	else if (PillarError.Value.UniContactor)
		*Reason = 0x1A;
	else if (PillarError.Value.DCmodError)
		*Reason = 0x1D;
	else if (PillarError.Value.OutVolt)
		*Reason = 0x1F;
	else if (PillarError.Value.OutCurrt)
		*Reason = 0x21;
	else 
	{
		*Reason 			= 0x00;
		TCUCurChgRecd.StarChgResult = 1;			//ɹ
		return TRUE;

	}

	TCUCurChgRecd.StarChgResult = 2;				//ʧ
	return FALSE;
}


u8 AllowDTUStartCharge_B(u8 * Reason)
{
	if (TCUCurChgRecd_B.StarValid == 0)
		*Reason = 0x01;
	else if (TCUCommuStatus.ConnectFlag == 0)
		*Reason = 0x02;
	else if (TCUCommuStatus.VerChkVaild == 0)
		*Reason = 0x03;
	else if (TCUCommuStatus.ParamVaild == 0)
		*Reason = 0x05;
	else if (ChargeCtrl_B.CurProcess != eChgPro_B_ChgIdle)
		*Reason = 0x06;
	else if (ChargePauseFlag_B == 1)
		*Reason = 0x07;
	else if (eSwSta_On != CcStatusRead())
		*Reason = 0x08;
	else if (PillarError_B.Value.Emergency == 1)
		*Reason = 0x09;
	else if (PillarError_B.Value.Door == 1)
		*Reason = 0x0A;
	else if (PillarError_B.Value.SPD == 1)
		*Reason = 0x0B;
	else if (PillarError_B.Value.EleLock == 1)
		*Reason = 0x0F;
	else if ((PillarError.Value.Insulation == 1) || (PillarError.Value.ImdDev == 1))
		*Reason = 0x010;
	else if (ChargeStopType_B == eChgStop_PillarReady_BatVoltError)
		*Reason = 0x11;
	else if ((ChargeStopType_B == eChgStop_Imd_BhmTimeOut) || (ChargeStopType == eChgStop_ComBreak_CommError))
		*Reason = 0x12;
	else if (PillarError_B.Value.ACContactor == 1)
		*Reason = 0x13;
	else if (PillarError_B.Value.Contactor)
		*Reason = 0x17;
	else if (PillarError_B.Value.UniContactor)
		*Reason = 0x1A;
	else if (PillarError_B.Value.DCmodError)
		*Reason = 0x1D;
	else if (PillarError_B.Value.OutVolt)
		*Reason = 0x1F;
	else if (PillarError_B.Value.OutCurrt)
		*Reason = 0x21;
	else 
	{
		*Reason 			= 0x00;
		TCUCurChgRecd_B.StarChgResult = 1;			//ɹ
		return TRUE;

	}

	TCUCurChgRecd_B.StarChgResult = 2;				//ʧ
	return FALSE;
}


void StartMegAck_A(void)
{
	u8				Data[8] =
	{
		0
	};
	u8				Reason = 0x00;

	Data[0] 			= 0x01;
	Data[1] 			= StartMeg_A.LoadSswitch;

	if (FALSE == AllowDTUStartCharge(&Reason))
		Data[2] = 0x01;
	else 
		Data[2] = 0x00;

	Data[3] 			= Reason;
	Data[4] 			= StartMeg_A.LoadSswitch;
	Data[5] 			= 0x00;
	Data[6] 			= 0x00;
	Data[7] 			= 0x00;
	TCUSinglePackSendMsg(Data, 8, eCmd_startAck, 6);
}


void StartMegAck_B(void)
{
	u8				Data[8] =
	{
		0
	};
	u8				Reason = 0x00;

	Data[0] 			= 0x02;
	Data[1] 			= StartMeg_B.LoadSswitch;

	if (FALSE == AllowDTUStartCharge_B(&Reason))
		Data[2] = 0x01;
	else 
		Data[2] = 0x00;

	Data[3] 			= Reason;
	Data[4] 			= StartMeg_B.LoadSswitch;
	TCUSinglePackSendMsg(Data, 8, eCmd_startAck, 6);
}


u8 AllowDTUStartCompCharge(u8 * Reason)
{
	if (TCUCurChgRecd.TCUStartCompresult == 1)
	{
		*Reason 			= 0x0;					//ɹ
		return TRUE;
	}
	else if (TCUCommuStatus.ConnectFlag == 0)
		*Reason = 0x02; //ͨѶʱ
	else if (PillarError.Value.Emergency == 1)
		*Reason = 0x03;
	else if (PillarError.Value.Door == 1)
		*Reason = 0x04;
	else if (PillarError.Value.SPD == 1)
		*Reason = 0x05;
	else if (PillarError.Value.ACContactor == 1)
		*Reason = 0x07;
	else if (PillarError.Value.InVolt == 1)
		*Reason = 0x0A;
	else if (PillarError.Value.EleLock == 1)
		*Reason = 0x0D;
	else if ((PillarError.Value.Insulation == 1) || (PillarError.Value.ImdDev == 1))
		*Reason = 0x0E;
	else if (ChargeStopType == eChgStop_PillarReady_BatVoltError)
		*Reason = 0x0F;
	else if (PillarError.Value.Contactor)
		*Reason = 0x11;
	else if (PillarError.Value.UniContactor)
		*Reason = 0x14;
	else if (PillarError.Value.DCmodError)
		*Reason = 0x17;
	else if (PillarError.Value.OutVolt)
		*Reason = 0x18;
	else if (PillarError.Value.OutCurrt)
		*Reason = 0x1A;
	else if (PillarError.Value.OutCurrt)
		*Reason = 0x1A;
	else if (PillarError.Value.OutShort)
		*Reason = 0x1B;
	else if (ChargeStopType == eChgStop_Conf_ChgMaxVoltLessPillarMinVolt)
		*Reason = 0x1C;
	else if (TCUCurChgRecd.TCUChgStopType == 0x1c)
		*Reason = 0x1D;
	else if (ChargeStopType == eChgStop_PillarReady_BatVoltMismatchBcpVolt)
		*Reason = 0x1E;
	else if (CemMsg.Cem.Value.Brm == 1)
		*Reason = 0x22;
	else if (CemMsg.Cem.Value.Bcp == 1)
		*Reason = 0x24;
	else if (CemMsg.Cem.Value.Bro == 1)
		*Reason = 0x27;
	else if ((CemMsg.Cem.Value.Bro != 0) || (ChargeStopType != 0))
		*Reason = 0x28;
	else if ((VerificaInfo.result == 1) && (StartMeg_A.PlugToChgFlag == 1))
		*Reason = 0x29;
	else if (TCUCommuStatus.ErrData.Value.verificationAck == 1)
		*Reason = 0x30;
	else if (TCUCurChgRecd.TCUStartCompresult == 2)
		*Reason = 0x01; //Ƶ
	else 
		* Reason = 0x28; //

	return FALSE;
}


u8 AllowDTUStartCompCharge_B(u8 * Reason)
{
	if (TCUCurChgRecd_B.TCUStartCompresult == 1)
	{
		*Reason 			= 0x0;					//ɹ
		return TRUE;
	}
	else if (TCUCommuStatus.ConnectFlag == 0)
		*Reason = 0x02; //ͨѶʱ
	else if (PillarError_B.Value.Emergency == 1)
		*Reason = 0x03;
	else if (PillarError_B.Value.Door == 1)
		*Reason = 0x04;
	else if (PillarError_B.Value.SPD == 1)
		*Reason = 0x05;
	else if (PillarError_B.Value.ACContactor == 1)
		*Reason = 0x07;
	else if (PillarError_B.Value.InVolt == 1)
		*Reason = 0x0A;
	else if (PillarError_B.Value.EleLock == 1)
		*Reason = 0x0D;
	else if ((PillarError_B.Value.Insulation == 1) || (PillarError_B.Value.ImdDev == 1))
		*Reason = 0x0E;
	else if (ChargeStopType_B == eChgStop_PillarReady_BatVoltError)
		*Reason = 0x0F;
	else if (PillarError_B.Value.Contactor)
		*Reason = 0x11;
	else if (PillarError_B.Value.UniContactor)
		*Reason = 0x14;
	else if (PillarError_B.Value.DCmodError)
		*Reason = 0x17;
	else if (PillarError_B.Value.OutVolt)
		*Reason = 0x18;
	else if (PillarError_B.Value.OutCurrt)
		*Reason = 0x1A;
	else if (PillarError_B.Value.OutCurrt)
		*Reason = 0x1A;
	else if (PillarError_B.Value.OutShort)
		*Reason = 0x1B;
	else if (ChargeStopType_B == eChgStop_Conf_ChgMaxVoltLessPillarMinVolt)
		*Reason = 0x1C;
	else if (CurChgRecd_B.ChgStopType == 0x1c)
		*Reason = 0x1D;
	else if (ChargeStopType_B == eChgStop_PillarReady_BatVoltMismatchBcpVolt)
		*Reason = 0x1E;
	else if (CemMsg_B.Cem.Value.Brm == 1)
		*Reason = 0x22;
	else if (CemMsg_B.Cem.Value.Bcp == 1)
		*Reason = 0x24;
	else if (CemMsg_B.Cem.Value.Bro == 1)
		*Reason = 0x27;
	else if ((CemMsg_B.Cem.Value.Bro != 0) || (ChargeStopType != 0))
		*Reason = 0x28;
	else if ((VerificaInfo_B.result == 1) && (StartMeg_B.PlugToChgFlag == 1))
		*Reason = 0x29;
	else if (TCUCommuStatus.ErrData_B.Value.verificationAck == 1)
		*Reason = 0x30;
	else if (TCUCurChgRecd.TCUStartCompresult == 2)
		*Reason = 0x01; //Ƶ
	else 
		* Reason = 0x28; //

	return FALSE;
}


void startCompSend_A(void)
{
	u8				Data[64];
	u8				len = 0;
	u8				reason;

	Data[len++] 		= StartMeg_A.GunNum;
	Data[len++] 		= StartMeg_A.LoadSswitch;

	if (FALSE == AllowDTUStartCompCharge(&reason))
		Data[len++] = 0x01;
	else 
		Data[len++] = 0x00;

	Data[len++] 		= reason;

	Data[len++] 		= 0x01;
	Data[len++] 		= 0x01;
	Data[len++] 		= 0x00; 					//2015

	if (ChgVer == eChgVer_2011)
	{
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x00;
		Data[len++] 		= 0x00;
	}
	else 
	{
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x00;
	}

	if (ChgVer == eChgVer_2011)
		Data[len++] = 0x01;
	else 
		Data[len++] = 0x00;

	Data[len++] 		= BrmMsg.BatType;
	Data[len++] 		= BcpMsg.MaxTemp;
	Data[len++] 		= (u8) (BcpMsg.ChgMaxVolt >> 0); //ѹ	BIN	2
	Data[len++] 		= (u8) (BcpMsg.ChgMaxVolt >> 8);

	Data[len++] 		= (u8) (BcpMsg.ChgMaxCurrt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg.ChgMaxCurrt >> 8);

	Data[len++] 		= (u8) (BrmMsg.BatRateVolt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BrmMsg.BatRateVolt >> 8); //ضܵѹ

	Data[len++] 		= (u8) (BcpMsg.StartVolt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg.StartVolt >> 8); //صǰѹ

	Data[len++] 		= (u8) (BrmMsg.BatRateCap >> 0); //	BIN	2
	Data[len++] 		= (u8) (BrmMsg.BatRateCap >> 8); //ض

	Data[len++] 		= (u8) (BcpMsg.BatEnergy >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg.BatEnergy >> 8); //ر
	Data[len++] 		= (u8) (BcpMsg.StartSoc >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg.StartSoc >> 8); //ǰɵ״̬

	Data[len++] 		= 0x4C; 					//	BIN	2
	Data[len++] 		= 0x1D; 					//ѹ 750

	Data[len++] 		= 0xB8; 					//	BIN	2
	Data[len++] 		= 0x0B; 					//ѹ300

	Data[len++] 		= 0xDC; 					//	BIN	2
	Data[len++] 		= 0x05; 					// 
	Data[len++] 		= 0xa0; 					//	BIN	2
	Data[len++] 		= 0x0F; 					//С0A 
	memcpy(&Data[len], BrmMsg.Vin, 17); 			//ʶ	BIN  17
	len 				+= 17;

	TCUMultiPackSendMsg(Data, len, eCmd_startComp, 4);

}


void startCompSend_B(void)
{
	u8				Data[64];
	u8				len = 0;
	u8				reason;

	Data[len++] 		= StartMeg_B.GunNum;
	Data[len++] 		= StartMeg_B.LoadSswitch;

	if (FALSE == AllowDTUStartCompCharge_B(&reason))
		Data[len++] = 0x01;
	else 
		Data[len++] = 0x00;

	Data[len++] 		= reason;

	Data[len++] 		= 0x01;
	Data[len++] 		= 0x01;
	Data[len++] 		= 0x00; 					//2015

	if (ChgVer_B == eChgVer_2011)
	{
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x00;
		Data[len++] 		= 0x00;
	}
	else 
	{
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x01;
		Data[len++] 		= 0x00;
	}

	if (ChgVer_B == eChgVer_2011)
		Data[len++] = 0x01;
	else 
		Data[len++] = 0x00;

	Data[len++] 		= BrmMsg_B.BatType;
	Data[len++] 		= BcpMsg_B.MaxTemp;
	Data[len++] 		= (u8) (BcpMsg.ChgMaxVolt >> 0); //ѹ	BIN	2
	Data[len++] 		= (u8) (BcpMsg.ChgMaxVolt >> 8);

	Data[len++] 		= (u8) (BcpMsg_B.ChgMaxCurrt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg_B.ChgMaxCurrt >> 8);

	Data[len++] 		= (u8) (BrmMsg_B.BatRateVolt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BrmMsg_B.BatRateVolt >> 8); //ضܵѹ

	Data[len++] 		= (u8) (BcpMsg_B.StartVolt >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg_B.StartVolt >> 8); //صǰѹ

	Data[len++] 		= (u8) (BrmMsg_B.BatRateCap >> 0); //	BIN	2
	Data[len++] 		= (u8) (BrmMsg_B.BatRateCap >> 8); //ض

	Data[len++] 		= (u8) (BcpMsg_B.BatEnergy >> 0); //	BIN	2
	Data[len++] 		= (u8) (BcpMsg_B.BatEnergy >> 8); //ر
	Data[len++] 		= (u8) (BcpMsg_B.StartSoc >> 0); // BIN	2
	Data[len++] 		= (u8) (BcpMsg_B.StartSoc >> 8); //ǰɵ״̬

	Data[len++] 		= 0x4C; 					//	BIN	2
	Data[len++] 		= 0x1D; 					//ѹ 750

	Data[len++] 		= 0xB8; 					//	BIN	2
	Data[len++] 		= 0x0B; 					//ѹ300

	Data[len++] 		= 0xDC; 					//	BIN	2
	Data[len++] 		= 0x05; 					// 
	Data[len++] 		= 0xa0; 					//	BIN	2
	Data[len++] 		= 0x0F; 					//С0A 
	memcpy(&Data[len], BrmMsg_B.Vin, 17);			//ʶ	BIN  17
	len 				+= 17;
	TCUMultiPackSendMsg(Data, len, eCmd_startComp, 4); //
}


void ACkStartCompMeg(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 0x01)
	{
		AckStartCompMeg_A.GunNum = pPgnRecv->Data[0];
		AckStartCompMeg_A.LoadSswitch = pPgnRecv->Data[1];
		AckStartCompMeg_A.AckFlag = pPgnRecv->Data[2];

		if (AckStartCompMeg_A.AckFlag == 01)
		{
			TCUCurChgRecd.TCUChargeEnable = 0;
		}

		TCUCurChgRecd.TCUChgStarCompNotetrl = 3;
	}
	else if (pPgnRecv->Data[0] == 0x02)
	{
		AckStartCompMeg_B.GunNum = pPgnRecv->Data[0];
		AckStartCompMeg_B.LoadSswitch = pPgnRecv->Data[1];
		AckStartCompMeg_B.AckFlag = pPgnRecv->Data[2];

		if (AckStartCompMeg_A.AckFlag == 01)
		{
			TCUCurChgRecd_B.TCUChargeEnable = 0;
		}

		TCUCurChgRecd_B.TCUChgStarCompNotetrl = 3;
	}

}


void StopMeg(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 0x01)
	{
		TCUCurChgRecd.TCUChgStopType = pPgnRecv->Data[1];
		TCUCurChgRecd.TCUChgStopNotetrl = 1;
		TCUCurChgRecd.TCUChargeEnable = 0;
	}
	else if (pPgnRecv->Data[0] == 0x02)
	{
		TCUCurChgRecd_B.TCUChgStopType = pPgnRecv->Data[1];
		TCUCurChgRecd_B.TCUChgStopNotetrl = 1;
		TCUCurChgRecd_B.TCUChargeEnable = 0;
	}

}


void StopMegAck_A(void)
{
	u8				Data[8] =
	{
		0
	};

	Data[0] 			= 0x01;

	if (TCUCurChgRecd.TCUChargeEnable == 1)
	{
		TCUCurChgRecd.TCUChargeEnable = 0;			//Bmsֹͣ־
		Data[1] 			= 00;
	}
	else 
		Data[1] = 01;

	TCUSinglePackSendMsg(Data, 8, eCmd_stopAck, 4);
}


void StopMegAck_B(void)
{
	u8				Data[8] =
	{
		0
	};

	Data[0] 			= 0x01;

	if (TCUCurChgRecd_B.TCUChargeEnable == 1)
	{
		Data[1] 			= 00;
		TCUCurChgRecd_B.TCUChargeEnable = 0;		//bǹBmsֹͣ־
	}
	else 
		Data[1] = 01;

	TCUSinglePackSendMsg(Data, 8, eCmd_stopAck, 4);
}


void GetStopReason_A(u8 * stopReason)
{
	if (TCUCurChgRecd.TCUChgStopType == 1)
		*stopReason = 01;
	else if (TCUCurChgRecd.TCUChgStopType == 2)
		*stopReason = 02;
	else if (TCUCurChgRecd.TCUChgStopType == 3)
		*stopReason = 03;
	else if (TCUCommuStatus.ErrData.Value.startCompAck == 1)
		*stopReason = 0x04;
	else if (ChargeStopType == eChgStop_Run_CcOpen)
		*stopReason = 0x05; //Ƶʱ//г絼ǹ
	else if (TCUCommuStatus.ConnectFlag == 0)
		*stopReason = 0x06; //ƷѵԪͨѶʱֹͣ
	else if (PillarError.Value.Emergency)
		*stopReason = 0x08; //ͣť
	else if (PillarError.Value.Door)
		*stopReason = 0x09; //Ž
	else if (PillarError.Value.SPD)
		*stopReason = 0x0A; //
	else if (PillarError.Value.ACContactor)
		*stopReason = 0x0E; //Ӵճ
	else if (PillarError.Value.InVolt)
		*stopReason = 0x0F; ////Ƿѹȱ
	else if (PillarError.Value.EleLock)
		*stopReason = 0x0F; ////Ƿѹȱ
	else if (PillarError.Value.Contactor)
		*stopReason = 0x14; //̵ֱճ
	else if (PillarError.Value.UniContactor)
		*stopReason = 0x16; //Ӵճ
	else if (PillarError.Value.DCmodError)
		*stopReason = 0x1A; //ģ
	else if (ChargeStopType == eChgStop_Run_VoltOutHighErr)
		*stopReason = 0x1B; //ֱѹ
	else if (ChargeStopType == eChgStop_Run_CurrtOutHighErr)
		*stopReason = 0x1D; //ֱ
	else if (PillarError.Value.OutShort)
		*stopReason = 0x1E; //ֱ·
	else if (CemMsg.Cem.Value.Bcl == 1)
		*stopReason = 0x1F;
	else if (CemMsg.Cem.Value.Bcs == 1)
		*stopReason = 0x20;

	//else if(CemMsg.Cem.Value.Bsm==1)
	// *stopReason = 0x21;
	else if (BsmMsg.BatSta.Value.Volt == 0x01)
		*stopReason = 0x22;
	else if (BsmMsg.BatSta.Value.Volt == 0x02)
		*stopReason = 0x23;

	else if (BsmMsg.BatSta.Value.Soc == 0x01)
		*stopReason = 0x24;
	else if (BsmMsg.BatSta.Value.Soc == 0x02)
		*stopReason = 0x25;

	else if (BsmMsg.BatSta.Value.Currt == 0x01)
		*stopReason = 0x26;
	else if (BsmMsg.BatSta.Value.Temp == 0x01)
		*stopReason = 0x27;
	else if (BsmMsg.ChgSta.Value.Imd == 0x01)
		*stopReason = 0x28;
	else if (BsmMsg.ChgSta.Value.Connect == 0x01)
		*stopReason = 0x29;
	else if ((BstMsg.StopReason.Value.NeedSoc == 0x01) || (BstMsg.StopReason.Value.SetVolt == 0x01) ||
		 (BstMsg.StopReason.Value.PerSetVolt == 0x01))
		*stopReason = 0x2A;
	else if ((BstMsg.StopTruble.Mult != 0) || ((BstMsg.StopFault.Mult & 0x0F) != 0))
		*stopReason = 0x2B;
	else if (ChargeCtrl.CurProcess == eChgPro_ChgBreak)
		*stopReason = 0x2D;
	else 
		* stopReason = 0x2c;

	return;

}


void GetStopReason_B(u8 * stopReason)
{
	if (TCUCurChgRecd_B.TCUChgStopType == 1)
		*stopReason = 01;
	else if (TCUCurChgRecd_B.TCUChgStopType == 2)
		*stopReason = 02;
	else if (TCUCurChgRecd_B.TCUChgStopType == 3)
		*stopReason = 03;
	else if (TCUCommuStatus.ErrData_B.Value.startCompAck == 1)
		*stopReason = 0x04;
	else if (ChargeStopType_B == eChgStop_Run_CcOpen)
		*stopReason = 0x05; //Ƶʱ//г絼ǹ
	else if (TCUCommuStatus.ConnectFlag == 0)
		*stopReason = 0x06; //ƷѵԪͨѶʱֹͣ
	else if (PillarError_B.Value.Emergency)
		*stopReason = 0x08; //ͣť
	else if (PillarError_B.Value.Door)
		*stopReason = 0x09; //Ž
	else if (PillarError_B.Value.SPD)
		*stopReason = 0x0A; //
	else if (PillarError_B.Value.ACContactor)
		*stopReason = 0x0E; //Ӵճ
	else if (PillarError_B.Value.InVolt)
		*stopReason = 0x0F; ////Ƿѹȱ
	else if (PillarError_B.Value.EleLock)
		*stopReason = 0x0F; ////Ƿѹȱ
	else if (PillarError_B.Value.Contactor)
		*stopReason = 0x14; //̵ֱճ
	else if (PillarError_B.Value.UniContactor)
		*stopReason = 0x16; //Ӵճ
	else if (PillarError_B.Value.DCmodError)
		*stopReason = 0x1A; //ģ
	else if (ChargeStopType_B == eChgStop_Run_VoltOutHighErr)
		*stopReason = 0x1B; //ֱѹ
	else if (ChargeStopType_B == eChgStop_Run_CurrtOutHighErr)
		*stopReason = 0x1D; //ֱ
	else if (PillarError_B.Value.OutShort)
		*stopReason = 0x1E; //ֱ·
	else if (CemMsg_B.Cem.Value.Bcl == 1)
		*stopReason = 0x1F;
	else if (CemMsg_B.Cem.Value.Bcs == 1)
		*stopReason = 0x20;

	//else if(CemMsg_B.Cem.Value.Bsm==1)
	// *stopReason = 0x21;
	else if (BsmMsg_B.BatSta.Value.Volt == 0x01)
		*stopReason = 0x22;
	else if (BsmMsg_B.BatSta.Value.Volt == 0x02)
		*stopReason = 0x23;
	else if (BsmMsg_B.BatSta.Value.Soc == 0x01)
		*stopReason = 0x24;
	else if (BsmMsg_B.BatSta.Value.Soc == 0x02)
		*stopReason = 0x25;
	else if (BsmMsg_B.BatSta.Value.Currt == 0x01)
		*stopReason = 0x26;
	else if (BsmMsg_B.BatSta.Value.Temp == 0x01)
		*stopReason = 0x27;
	else if (BsmMsg_B.ChgSta.Value.Imd == 0x01)
		*stopReason = 0x28;
	else if (BsmMsg_B.ChgSta.Value.Connect == 0x01)
		*stopReason = 0x29;
	else if ((BstMsg_B.StopReason.Value.NeedSoc == 0x01) || (BstMsg_B.StopReason.Value.SetVolt == 0x01) ||
		 (BstMsg_B.StopReason.Value.PerSetVolt == 0x01))
		*stopReason = 0x2A;
	else if ((BstMsg_B.StopTruble.Mult != 0) || ((BstMsg_B.StopFault.Mult & 0x0F) != 0))
		*stopReason = 0x2B;
	else if (ChargeCtrl_B.CurProcess == eChgPro_B_ChgBreak)
		*stopReason = 0x2D;
	else 
		* stopReason = 0x2c;

	return;


}


void stopCompSend_A(void)
{
	u8				Data[64];
	u8				len = 0;
	u8				reason;

	Data[len++] 		= 0x01;
	GetStopReason_A(&reason);
	Data[len++] 		= reason;					//ɹʶ
	Data[len++] 		= 00;
	Data[len++] 		= BstMsg.StopReason.Mult;
	Data[len++] 		= BstMsg.StopTruble.Mult;
	Data[len++] 		= BstMsg.StopTruble.Mult >> 8;
	Data[len++] 		= BstMsg.StopFault.Mult;
	Data[len++] 		= BsdMsg.StopSOC;
	Data[len++] 		= BsdMsg.PerMinVolt;
	Data[len++] 		= BsdMsg.PerMinVolt >> 8;
	Data[len++] 		= BsdMsg.PerMaxVolt;
	Data[len++] 		= BsdMsg.PerMaxVolt >> 8;
	Data[len++] 		= BsdMsg.MinTemp;
	Data[len++] 		= BsdMsg.MaxTemp;
	Data[len++] 		= CemMsg.Cem.Mult;
	Data[len++] 		= BsdMsg.MaxTemp;
	Data[len++] 		=
		 BemMsg.Bem.Value.Crm_00 + (BemMsg.Bem.Value.Crm_AA << 2) + (BemMsg.Bem.Value.Cml_Cts << 4) + (BemMsg.Bem.Value.Cro << 6);
	Data[len++] 		=
		 BemMsg.Bem.Value.Ccs + (BemMsg.Bem.Value.Cst << 2) + (BemMsg.Bem.Value.Csd << 4) + ((0x03 & BemMsg.Bem.Value.Other) << 6);

	Data[len++] 		=
		 ((0x0c & BemMsg.Bem.Value.Other) >> 2) + ((0x30 & BemMsg.Bem.Value.Other) >> 2) + (CemMsg.Cem.Value.Brm << 4) + ((CemMsg.Cem.Value.Bcp) << 6);
	Data[len++] 		=
		 ((CemMsg.Cem.Value.Bro) << 0) + ((CemMsg.Cem.Value.Bcs) << 2) + ((CemMsg.Cem.Value.Bcl) << 4) + ((CemMsg.Cem.Value.Bst) << 6);
	Data[len++] 		= CemMsg.Cem.Value.Bsd + ((0x3F & CemMsg.Cem.Value.Other) << 2);
	TCUMultiPackSendMsg(Data, len, eCmd_stopComp, 4); //
}


void stopCompSend_B(void)
{
	u8				Data[64];
	u8				len = 0;
	u8				reason;

	Data[len++] 		= 0x01;
	GetStopReason_B(&reason);
	Data[len++] 		= reason;
	Data[len++] 		= 00;						//ɹʶ
	Data[len++] 		= BstMsg_B.StopReason.Mult;
	Data[len++] 		= BstMsg_B.StopTruble.Mult;
	Data[len++] 		= BstMsg_B.StopTruble.Mult >> 8;
	Data[len++] 		= BstMsg_B.StopFault.Mult;
	Data[len++] 		= BsdMsg_B.StopSOC;
	Data[len++] 		= BsdMsg_B.PerMinVolt;
	Data[len++] 		= BsdMsg_B.PerMinVolt >> 8;
	Data[len++] 		= BsdMsg_B.PerMaxVolt;
	Data[len++] 		= BsdMsg_B.PerMaxVolt >> 8;
	Data[len++] 		= BsdMsg_B.MinTemp;
	Data[len++] 		= BsdMsg_B.MaxTemp;
	Data[len++] 		= CemMsg_B.Cem.Mult;
	Data[len++] 		= BsdMsg_B.MaxTemp;

	Data[len++] 		=
		 BemMsg_B.Bem.Value.Crm_00 + (BemMsg_B.Bem.Value.Crm_AA << 2) + (BemMsg_B.Bem.Value.Cml_Cts << 4) + (BemMsg_B.Bem.Value.Cro << 6);
	Data[len++] 		=
		 BemMsg_B.Bem.Value.Ccs + (BemMsg_B.Bem.Value.Cst << 2) + (BemMsg_B.Bem.Value.Csd << 4) + ((0x03 & BemMsg_B.Bem.Value.Other) << 6);

	Data[len++] 		=
		 ((0x0c & BemMsg_B.Bem.Value.Other) >> 2) + ((0x30 & BemMsg_B.Bem.Value.Other) >> 2) + (CemMsg_B.Cem.Value.Brm << 4) + ((CemMsg_B.Cem.Value.Bcp) << 6);
	Data[len++] 		=
		 ((CemMsg_B.Cem.Value.Bro) << 0) + ((CemMsg_B.Cem.Value.Bcs) << 2) + ((CemMsg_B.Cem.Value.Bcl) << 4) + ((CemMsg_B.Cem.Value.Bst) << 6);
	Data[len++] 		= CemMsg_B.Cem.Value.Bsd + ((0x3F & CemMsg_B.Cem.Value.Other) << 2);

	TCUMultiPackSendMsg(Data, len, eCmd_stopComp, 4); //
}


void stopCompAck(StructTCUSend * pPgnRecv)
{

	if (pPgnRecv->Data[0] == 0x01)
	{
		AckStopCompMeg_A.GunNum = pPgnRecv->Data[0];
		AckStopCompMeg_A.StopReason = pPgnRecv->Data[1];
		AckStopCompMeg_A.AckFlag = pPgnRecv->Data[2];
		TCUCurChgRecd.TCUChgStopCompNotetrl = 3;	//ֹͣ֡
	}
	else if (pPgnRecv->Data[0] == 0x02)
	{
		AckStopCompMeg_B.GunNum = pPgnRecv->Data[0];
		AckStopCompMeg_B.StopReason = pPgnRecv->Data[1];
		AckStopCompMeg_B.AckFlag = pPgnRecv->Data[2];
		TCUCurChgRecd_B.TCUChgStopCompNotetrl = 3;	//ֹͣ֡
	}
}


void TCUHeartBeat_A(void)
{
	u8				Data[8] =
	{
		0
	};
	static u8		CountNum;						//255

	Data[0] 			= 0x00;
	Data[1] 			= CountNum++;
	Data[2] 			= TCUCommuStatus.ConnectFlag;
	Data[3] 			= TCUControlInfo.ChargingServiceFlag;
	TCUSinglePackSendMsg(Data, 8, eCmd_ContHeart, 6);
}


void TCUHeartBeat_B(void)
{
	u8				Data[8] =
	{
		0
	};
	static u8		CountNum;						//255

	Data[0] 			= 0x02;
	Data[1] 			= CountNum++;
	Data[2] 			= TCUCommuStatus.ConnectFlag;
	Data[3] 			= TCUControlInfo.ChargingServiceFlag;
	TCUSinglePackSendMsg(Data, 8, eCmd_ContHeart, 6);
}


void AckTCUHeartBeat(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 0)
	{
		TCUCommuStatus.HeartBeatErrCnt = 0;
		TCUCommuStatus.HeartBeatRecvTime = GetSystemTick();
	}



		TCUCommuStatus.ConnectFlag = CONNECT_NORMAL; 			//tcu״̬
		TCUCommuStatus.HeartBeatVaild = CONNECT_NORMAL;			//tcu״̬

}


void TCUtimeSet(StructTCUSend * pPgnRecv)
{
	StructTime		TimeBlock;

	cp56time2a *	time = NULL;

	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	TCUCommuStatus.TimeRecvTime = GetSystemTick();
	TCUCommuStatus.CommStage = TimeStage;

	memcpy(time, &pPgnRecv->Data[1], 7);
	TimeBlock.Year		= time->year + 2000;
	TimeBlock.Mon		= time->month;
	TimeBlock.Day		= time->mday;
	TimeBlock.Hour		= time->hour;
	TimeBlock.Min		= time->min;
	TimeBlock.Sec		= time->msec / 1000;

	//RtcExtSetTime(&TimeBlock);
	RtcSetTime(TimeToStamp(&TimeBlock));			//DateTimeSet(TimeToStamp(&TimeBlock));
	RtcExtSetTime(&TimeBlock);

	//LcdSetRtc(&TimeBlock);
}


void TCUtimeSetAck(void)
{
	u8				Data[8] =
	{
		0
	};
	StructTime		Time;
	cp56time2a *	time = NULL;

	Data[0] 			= TCUCommuStatus.ChgNum;
	StampToTime(RtcGetTime(), &Time);
	time->year			= Time.Year - 2000;
	time->month 		= Time.Mon;
	time->mday			= Time.Day;
	time->hour			= Time.Hour;
	time->min			= Time.Min;
	time->msec			= (((u16) Time.Sec) * 1000);
	memcpy(&Data[1], time, 7);
	TCUSinglePackSendMsg(Data, 8, eCmd_timeAck, 6);
}


void TCUVersionCheck(StructTCUSend * pPgnRecv)
{
	u16 			version;

	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	version 			= (((u16) pPgnRecv->Data[2]) << 8) +pPgnRecv->Data[1];

	if (TCUControlInfo.version == version)
	{
		TCUCommuStatus.VerChkVaild = 1; 			//汾Уɹ
		TCUCommuStatus.CommStage = VersionStage;
		TCUCommuStatus.VersionRecvTime = GetSystemTick();
		TCUCommuStatus.VersionSentTime = 0; 		//汾ͳʼ
	}
	else 
		TCUCommuStatus.VerChkVaild = 0; //汾Уʧ

	return;

}


void TCUVersionCheckSent(void)
{
	u8				Data[8] =
	{
		0
	};

	Data[0] 			= TCUCommuStatus.ChgNum;
	Data[1] 			= TCUControlInfo.version;
	Data[2] 			= (u8) (TCUControlInfo.version >> 8);
	TCUSinglePackSendMsg(Data, 8, eCmd_versiAck, 6);
}


void TCUParam(StructTCUSend * pPgnRecv)
{
	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	TCUCommuStatus.CommStage = ChageParamStage;
	memcpy(TCUControlInfo.ChargeNum, &pPgnRecv->Data[0], 8);
	TCUCommuStatus.ParamRecvTime = GetSystemTick();
	TCUCommuStatus.ParamSentTime = 0;				//ͳʼ
}


void TCUParamAck(void)
{
	u8				Data[8];
	memset(Data,0,8);
	Data[0] 			= TCUCommuStatus.ChgNum;

	if ((TCUCommuStatus.VerChkVaild == 0) || (TCUCommuStatus.ConnectFlag == CONNECT_TIMEOUT))
	{
		TCUCommuStatus.ParamVaild = 0;
		Data[1] 			= 01;					//ʧ

		if (TCUCommuStatus.VerChkVaild == 0)
			Data[2] = 1; //汾Уʧ
		else 
			Data[2] = 2; //ʱ
	}
	else 
	{
		Data[1] 			= 0;
		Data[2] 			= 0;
		TCUCommuStatus.ParamVaild = 1;
	}

	TCUSinglePackSendMsg(Data, 8, eCmd_paramAck, 6);
}


void SerConAckAnalysis(StructTCUSend * pPgnRecv)
{
	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	TCUCommuStatus.CommStage = ServiceContralStage;
	TCUCommuStatus.ServiceContralRecvTime = GetSystemTick();
	TCUCommuStatus.ServiceContralSentTime = 0;

	if ((pPgnRecv->Data[1] != 0x01) && (pPgnRecv->Data[1] != 0x02))
		TCUCommuStatus.ServiceContralVaildValue = 1; //ݺϷУʧ
	else if ((TCUCommuStatus.ConnectFlag == 0) || (TCUCommuStatus.HeartBeatVaild))
		TCUCommuStatus.ServiceContralVaildValue = 2; //ͨѶʱ
	else if (TCUCommuStatus.VerChkVaild == 0)
		TCUCommuStatus.ServiceContralVaildValue = 3; //汾Уδ 
	else if (TCUCommuStatus.ParamVaild == 0)
		TCUCommuStatus.ServiceContralVaildValue = 4; //·Ϊδ
	else if ((TCUCurChgRecd.TCUChargeEnable == 1) || (TCUCurChgRecd_B.TCUChargeEnable == 1))
		TCUCommuStatus.ServiceContralVaildValue = 05;
	else 
		TCUCommuStatus.ServiceContralVaildValue = 0;

	TCUCommuStatus.ChargingServiceSetValue = pPgnRecv->Data[1];

	if (TCUCommuStatus.ServiceContralVaildValue == 0)
		TCUControlInfo.ChargingServiceFlag = pPgnRecv->Data[1];
}


void SerConAck(void)
{
	u8				Data[8] =
	{
		0
	};

	Data[0] 			= TCUCommuStatus.ChgNum;
	Data[1] 			= TCUCommuStatus.ChargingServiceSetValue;

	if (TCUCommuStatus.ServiceContralVaildValue == 0)
	{
		Data[2] 			= 00;					//ɹ
		Data[3] 			= 00;					//ɹ
	}
	else 
	{
		Data[2] 			= 01;					//ʧ
		Data[3] 			= TCUCommuStatus.ServiceContralVaildValue; //ʧ
	}

	TCUSinglePackSendMsg(Data, 8, eCmd_SerConAck, 4);
}


void ElectControlAnalysis(StructTCUSend * pPgnRecv)
{
	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	TCUCommuStatus.ElectLockRecvTime = GetSystemTick();
	TCUCommuStatus.CommStage = ElectLockStage;
	TCUCommuStatus.ElectLockSentTime = 0;
	TCUCommuStatus.ElectLockSetValue = pPgnRecv->Data[2];

	if (((pPgnRecv->Data[1] != 0x01) && (pPgnRecv->Data[1] != 0x02)) || ((pPgnRecv->Data[2] != 0x01) &&
		 (pPgnRecv->Data[2] != 0x02)))
		TCUCommuStatus.ElectLockVaildValue = 1; //ݺϷУʧ
	else if ((TCUCommuStatus.ConnectFlag == 0) || (TCUCommuStatus.HeartBeatVaild))
		TCUCommuStatus.ElectLockVaildValue = 2; //ͨѶʱ
	else if (TCUCommuStatus.VerChkVaild == 0)
		TCUCommuStatus.ElectLockVaildValue = 3; //汾Уδ 
	else if (TCUCommuStatus.ParamVaild == 0)
		TCUCommuStatus.ElectLockVaildValue = 4; //·Ϊδ
	else if ((TCUCurChgRecd.TCUChargeEnable == 1) || (TCUCurChgRecd_B.TCUChargeEnable == 1))
		TCUCommuStatus.ElectLockVaildValue = 05;
	else if (PillarError.Value.EleLock == 1)
		TCUCommuStatus.ElectLockVaildValue = 07; //
	else 
		TCUCommuStatus.ServiceContralVaildValue = 0;

	if ((TCUCommuStatus.ServiceContralVaildValue == 0) || (TCUCommuStatus.ServiceContralVaildValue == 0x07))
	{
		if (TCUCommuStatus.ChgNum == 1)
		{
			if (TCUCommuStatus.ElectLockSetValue == 01)
				LockSet(eSwSta_On);
			else 
				LockSet(eSwSta_Off);
		}
		else if (TCUCommuStatus.ChgNum == 2)
		{

			if (TCUCommuStatus.ElectLockSetValue == 01)
				LockSet(eSwSta_On);
			else 
				LockSet(eSwSta_Off);
		}

	}
}


void ElectControlAck(void)
{
	u8				Data[8] =
	{
		0
	};

	Data[0] 			= TCUCommuStatus.ChgNum;
	Data[1] 			= TCUCommuStatus.ElectLockSetValue;

	if (PillarError.Value.EleLock == 1)
		TCUCommuStatus.ServiceContralVaildValue = 0x07;

	if (TCUCommuStatus.ElectLockVaildValue == 0)
	{
		Data[2] 			= 00;					//ɹ

		Data[3] 			= 00;					//ɹ
	}
	else 
	{
		Data[2] 			= 01;					//ʧ
		Data[3] 			= TCUCommuStatus.ServiceContralVaildValue; //ʧ
	}

	TCUSinglePackSendMsg(Data, 8, eCmd_GunAck, 4);

}


void PowerControlAnalysis(StructTCUSend * pPgnRecv)
{
	TCUCommuStatus.ChgNum = pPgnRecv->Data[0];
	TCUCommuStatus.CommStage = PowerControlStage;
	TCUCommuStatus.PowerControlRecvTime = GetSystemTick();
	TCUCommuStatus.PowerControlSentTime = 0;
	TCUCommuStatus.PowerControltype = pPgnRecv->Data[1];
	TCUCommuStatus.PowerControlParam = pPgnRecv->Data[2] + (u16)
	pPgnRecv->Data[3] << 8;

	if (((pPgnRecv->Data[1] != 0x01) && (pPgnRecv->Data[1] != 0x02)) || ((pPgnRecv->Data[2] != 0x01) &&
		 (pPgnRecv->Data[2] != 0x02)))
		TCUCommuStatus.PowerControlVaildValue = 1; //ݺϷУʧ
	else 
	{
		TCUCommuStatus.PowerControlVaildValue = 0;	//ݺϷУɹ

		if (pPgnRecv->Data[0] == 01) //aǹ
		{
			TCUControlInfo.PowerControl_A.ControlType = pPgnRecv->Data[1];

			if (pPgnRecv->Data[1] == 01)
			{
				TCUControlInfo.PowerControl_A.Kwh = ((u16) pPgnRecv->Data[3] << 8) +pPgnRecv->Data[2] -1000;
			}
			else if (pPgnRecv->Data[1] == 02)
			{
				TCUControlInfo.PowerControl_A.Percentage = pPgnRecv->Data[3];
			}
		}
		else if (pPgnRecv->Data[0] == 02) //bǹ
		{
			TCUControlInfo.PowerControl_B.ControlType = pPgnRecv->Data[1];

			if (pPgnRecv->Data[1] == 01)
			{
				TCUControlInfo.PowerControl_B.Kwh = ((u16) pPgnRecv->Data[3] << 8) +pPgnRecv->Data[2] -1000;
			}
			else if (pPgnRecv->Data[1] == 02)
			{
				TCUControlInfo.PowerControl_B.Percentage = pPgnRecv->Data[3];
			}
		}

	}
}


void PowerControlAck(void)
{
	u8				Data[8] =
	{
		0
	};
	Data[0] 			= TCUCommuStatus.ChgNum;
	Data[1] 			= TCUCommuStatus.PowerControltype;
	Data[2] 			= (u8)
	TCUCommuStatus.PowerControlParam;
	Data[3] 			= (u8) (TCUCommuStatus.PowerControlParam >> 8);

	if (TCUCommuStatus.PowerControlVaildValue == 0)
	{
		Data[4] 			= 0;
		Data[5] 			= 0;
	}
	else 
	{
		Data[4] 			= 01;
		Data[5] 			= TCUCommuStatus.PowerControlVaildValue; //ʧ
	}

	TCUSinglePackSendMsg(Data, 8, eCmd_powerAck, 4);
}


u8 InsertGunStatu_A(void)
{
	u8				status;

	return status;
}


u8 InsertGunStatu_B(void)
{
	u8				status;

	return status;
}


void InformationReporting_22_A(void)
{
	u8				Data[128] =
	{
		0
	};

	Data[0] 			= 0x01;

	if ((ChargeCtrl.CurProcess == eChgPro_ChgIdle) && (TCUCurChgRecd.TCUChargeEnable == 0))
	{
		InformainReport_A.InfRe.workStau = 0x00;
	}
	else if ((ChargeCtrl.CurProcess != eChgPro_ChgIdle) && (ChargePauseFlag != 1))
	{
		InformainReport_A.InfRe.workStau = 0x01;
	}
	else if ((ChargeCtrl.CurProcess == eChgPro_ChgIdle) && (TCUCurChgRecd.TCUChargeEnable == 1))
	{
		InformainReport_A.InfRe.workStau = 0x02;
	}
	else if ((ChargeCtrl.CurProcess != eChgPro_ChgIdle) && (ChargePauseFlag == 1))
	{
		InformainReport_A.InfRe.workStau = 0x03;
	}

	InformainReport_A.InfRe.Emergency = PillarError.Value.Emergency == 1;
	InformainReport_A.InfRe.smoke = 0x00;
	InformainReport_A.InfRe.AccContac = 0x00;
	InformainReport_A.InfRe.DCOutConOff = PillarError.Value.Contactor;

	InformainReport_A.InfRe.DCFuse = 00;
	InformainReport_A.InfRe.EleLock = PillarError.Value.EleLock;
	InformainReport_A.InfRe.Fan = 00;
	InformainReport_A.InfRe.SPD = PillarError.Value.SPD;
	InformainReport_A.InfRe.ImdDev = PillarError.Value.ImdDev;

	if ((ChargeStopType == eChgStop_PillarReady_BatVoltError) && (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport_A.InfRe.BattPola = 01;
	else 
		InformainReport_A.InfRe.BattPola = 0;

	InformainReport_A.InfRe.ContGuid = 0;			//Ƶ

	InformainReport_A.InfRe.tempOver = 0;

	if ((BstMsg.StopTruble.Value.ComponentTemp == 0x01) && (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport_A.InfRe.ConnTemp = 0x01;
	else 
		InformainReport_A.InfRe.ConnTemp = 0x00;

	InformainReport_A.InfRe.PutBack = PillarError.Value.PutBack;

	if (((0 != BemMsg.Bem.Value.Crm_00) || (0 != BemMsg.Bem.Value.Crm_AA) || (0 != BemMsg.Bem.Value.Cml_Cts) ||
		 (0 != BemMsg.Bem.Value.Cro) || (0 != BemMsg.Bem.Value.Ccs) || (0 != BemMsg.Bem.Value.Csd) ||
		 (0 != CemMsg.Cem.Value.Brm) || (0 != CemMsg.Cem.Value.Bcp) || (0 != CemMsg.Cem.Value.Bro) ||
		 (0 != CemMsg.Cem.Value.Bcs) || (0 != CemMsg.Cem.Value.Bcl) || (0 != CemMsg.Cem.Value.Bst) ||
		 (0 != CemMsg.Cem.Value.Bsd)) && (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport_A.InfRe.BMSComm = 01;
	else 
		InformainReport_A.InfRe.BMSComm = 01;

	InformainReport_A.InfRe.InVoltHi = 00;
	InformainReport_A.InfRe.InVoltlo = 00;

	if ((ChargeStopType == eChgStop_Run_VoltOutHighErr) && (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport_A.InfRe.DcVolHi = 01;
	else 
		InformainReport_A.InfRe.DcVolHi = 0;

	if ((ChargeStopType == eChgStop_Run_CurrtOutHighErr) && (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport_A.InfRe.DCCurrHi = 01;
	else 
		InformainReport_A.InfRe.DCCurrHi = 0;


	InformainReport_A.InfRe.DcModErr = PillarError.Value.NoDcmod;
	InformainReport_A.InfRe.DCModIn = 0;
	InformainReport_A.InfRe.DCModInHi = 0;
	InformainReport_A.InfRe.DCModInLo = 0;
	InformainReport_A.InfRe.DCModPhas = 0;
	InformainReport_A.InfRe.DcOutShor = PillarError.Value.OutShort;
	InformainReport_A.InfRe.DCModOutCuHi = 0;
	InformainReport_A.InfRe.DCModOutVoHi = 0;

	InformainReport_A.InfRe.DCModOutVoLo = 0;
	InformainReport_A.InfRe.DCModTempHi = 0;
	InformainReport_A.InfRe.DCModComm = PillarError.Value.NoDcmod;
	InformainReport_A.InfRe.DCModFan = 0;
	InformainReport_A.InfRe.CCConnect = !CcStatusRead();
	InformainReport_A.InfRe.InsertGunSta = InsertGunStatu_A();
	InformainReport_A.InfRe.DcOutContSta = DcOutPosGet();
	InformainReport_A.InfRe.ElectLock = LockGet();

	if (((InformainReport_A.data[0] &0xf0) != 0) || ((InformainReport_A.data[1] &0xff) != 0) ||
		 ((InformainReport_A.data[2] &0xfD) != 0) || ((InformainReport_A.data[3] &0x00) != 0) ||
		 ((InformainReport_A.data[4] &0x00) != 0) || ((InformainReport2_B.data & 0x07CB) != 0))
		InformainReport_A.InfRe.sumFalt = 01;
	else 
		InformainReport_A.InfRe.sumFalt = 00;

	if (((InformainReport_A.data[0] &0x00) != 0) || ((InformainReport_A.data[1] &0x00) != 0) ||
		 ((InformainReport_A.data[2] &0x10) != 0) || ((InformainReport_A.data[3] &0xFF) != 0) ||
		 ((InformainReport_A.data[4] &0x0f) != 0) || ((InformainReport2_B.data & 0x52) != 0))
		InformainReport_A.InfRe.sumWarm = 01;
	else 
		InformainReport_A.InfRe.sumWarm = 00;

	memcpy(&Data[1], InformainReport_A.data, 5);
	Data[6] 			= 0;
	Data[7] 			= 0;
	TCUSinglePackSendMsg(Data, 8, eCmd_DCConInfor1, 4);

}


void InformationReporting_22_B(void)
{
	u8				Data[128] =
	{
		0
	};

	Data[0] 			= 0x02;

	if ((ChargeCtrl_B.CurProcess == eChgPro_B_ChgIdle) && (TCUCurChgRecd_B.TCUChargeEnable == 0))
	{
		InformainReport_B.InfRe.workStau = 0x00;
	}
	else if ((ChargeCtrl_B.CurProcess != eChgPro_B_ChgIdle) && (ChargePauseFlag_B != 1))
	{
		InformainReport_B.InfRe.workStau = 0x01;
	}
	else if ((ChargeCtrl_B.CurProcess == eChgPro_B_ChgIdle) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
	{
		InformainReport_B.InfRe.workStau = 0x02;
	}
	else if ((ChargeCtrl_B.CurProcess != eChgPro_B_ChgIdle) && (ChargePauseFlag_B == 1))
	{
		InformainReport_B.InfRe.workStau = 0x03;
	}

	InformainReport_B.InfRe.Emergency = PillarError_B.Value.Emergency == 1;
	InformainReport_B.InfRe.smoke = 0x00;
	InformainReport_B.InfRe.AccContac = 0x00;
	InformainReport_B.InfRe.DCOutConOff = PillarError_B.Value.Contactor;

	InformainReport_B.InfRe.DCFuse = 00;
	InformainReport_B.InfRe.EleLock = PillarError_B.Value.EleLock;
	InformainReport_B.InfRe.Fan = 00;
	InformainReport_B.InfRe.SPD = PillarError_B.Value.SPD;
	InformainReport_B.InfRe.ImdDev = PillarError_B.Value.ImdDev;

	if ((ChargeStopType_B == eChgStop_PillarReady_BatVoltError) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport_B.InfRe.BattPola = 01;
	else 
		InformainReport_B.InfRe.BattPola = 0;

	InformainReport_B.InfRe.ContGuid = 0;			//Ƶ

	InformainReport_B.InfRe.tempOver = 0;

	if ((BstMsg_B.StopTruble.Value.ComponentTemp == 0x01) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport_B.InfRe.ConnTemp = 0x01;
	else 
		InformainReport_B.InfRe.ConnTemp = 0x00;

	InformainReport_B.InfRe.PutBack = PillarError_B.Value.PutBack;

	if (((0 != BemMsg_B.Bem.Value.Crm_00) || (0 != BemMsg_B.Bem.Value.Crm_AA) || (0 != BemMsg_B.Bem.Value.Cml_Cts) ||
		 (0 != BemMsg_B.Bem.Value.Cro) || (0 != BemMsg_B.Bem.Value.Ccs) || (0 != BemMsg_B.Bem.Value.Csd) ||
		 (0 != CemMsg_B.Cem.Value.Brm) || (0 != CemMsg_B.Cem.Value.Bcp) || (0 != CemMsg_B.Cem.Value.Bro) ||
		 (0 != CemMsg_B.Cem.Value.Bcs) || (0 != CemMsg_B.Cem.Value.Bcl) || (0 != CemMsg_B.Cem.Value.Bst) ||
		 (0 != CemMsg_B.Cem.Value.Bsd)) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport_B.InfRe.BMSComm = 01;
	else 
		InformainReport_B.InfRe.BMSComm = 01;

	InformainReport_B.InfRe.InVoltHi = 00;
	InformainReport_B.InfRe.InVoltlo = 00;

	if ((ChargeStopType_B == eChgStop_Run_VoltOutHighErr) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport_B.InfRe.DcVolHi = 01;
	else 
		InformainReport_B.InfRe.DcVolHi = 0;

	if ((ChargeStopType_B == eChgStop_Run_CurrtOutHighErr) && (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport_B.InfRe.DCCurrHi = 01;
	else 
		InformainReport_B.InfRe.DCCurrHi = 0;


	InformainReport_B.InfRe.DcModErr = PillarError_B.Value.NoDcmod;
	InformainReport_B.InfRe.DCModIn = 0;
	InformainReport_B.InfRe.DCModInHi = 0;
	InformainReport_B.InfRe.DCModInLo = 0;
	InformainReport_B.InfRe.DCModPhas = 0;
	InformainReport_B.InfRe.DcOutShor = PillarError_B.Value.OutShort;
	InformainReport_B.InfRe.DCModOutCuHi = 0;
	InformainReport_B.InfRe.DCModOutVoHi = 0;

	InformainReport_B.InfRe.DCModOutVoLo = 0;
	InformainReport_B.InfRe.DCModTempHi = 0;
	InformainReport_B.InfRe.DCModComm = PillarError_B.Value.NoDcmod;
	InformainReport_B.InfRe.DCModFan = 0;
	InformainReport_B.InfRe.CCConnect = !CcStatusRead_B();
	InformainReport_B.InfRe.InsertGunSta = InsertGunStatu_B();
	InformainReport_B.InfRe.DcOutContSta = DcOutPosGet_B();
	InformainReport_B.InfRe.ElectLock = LockGet_B();

	if (((InformainReport_B.data[0] &0xf0) != 0) || ((InformainReport_B.data[1] &0xff) != 0) ||
		 ((InformainReport_B.data[2] &0xfD) != 0) || ((InformainReport_B.data[3] &0x00) != 0) ||
		 ((InformainReport_B.data[4] &0x00) != 0) || ((InformainReport2_B.data & 0x07CB) != 0))
		InformainReport_B.InfRe.sumFalt = 01;
	else 
		InformainReport_B.InfRe.sumFalt = 00;

	if (((InformainReport_B.data[0] &0x00) != 0) || ((InformainReport_B.data[1] &0x00) != 0) ||
		 ((InformainReport_B.data[2] &0x10) != 0) || ((InformainReport_B.data[3] &0xFF) != 0) ||
		 ((InformainReport_B.data[4] &0x0f) != 0) || ((InformainReport2_B.data & 0x52) != 0))
		InformainReport_B.InfRe.sumWarm = 0x01;
	else 
		InformainReport_B.InfRe.sumWarm = 0x00;

	memcpy(&Data[1], InformainReport_B.data, 5);
	Data[6] 			= 0;
	Data[7] 			= 0;
	TCUSinglePackSendMsg(Data, 8, eCmd_DCConInfor1, 4);
}


void InformationReporting_23_A(void)
{
	u8				Data[64];

	Data[0] 			= 0x01;
	InformainReport2_A.InfRe.Door = PillarError.Value.Door;
	InformainReport2_A.InfRe.DCOutConOn = 0x01;

	if (((ChargeError.Value.IsolateWarn == 1) || (ChargeError.Value.IsolateError == 1)) &&
		 (TCUCurChgRecd.TCUChargeEnable == 1))
		InformainReport2_A.InfRe.ImdWarm = 0x01;
	else 
		InformainReport2_A.InfRe.ImdWarm = 0x00;

	InformainReport2_A.InfRe.DrainResist = 0x00;
	InformainReport2_A.InfRe.tempOver = 0;
	InformainReport2_A.InfRe.gunTemp = 0;
	InformainReport2_A.InfRe.AccContacON = PillarError.Value.ACContactor;
	InformainReport2_A.InfRe.AccContacOff = 00;
	InformainReport2_A.InfRe.Power = 00;
	InformainReport2_A.InfRe.UniContactorOff = PillarError.Value.UniContactor;
	InformainReport2_A.InfRe.UniContactorOn = 0x00;

	TCUSinglePackSendMsg(Data, 8, eCmd_DCConInfor2, 6);
}


void InformationReporting_23_B(void)
{
	u8				Data[64];

	Data[0] 			= 0x02;
	Data[0] 			= 0x01;
	InformainReport2_A.InfRe.Door = PillarError.Value.Door;
	InformainReport2_A.InfRe.DCOutConOn = 0x01;

	if (((ChargeError.Value.IsolateWarn == 1) || (ChargeError.Value.IsolateError == 1)) &&
		 (TCUCurChgRecd_B.TCUChargeEnable == 1))
		InformainReport2_A.InfRe.ImdWarm = 0x01;
	else 
		InformainReport2_A.InfRe.ImdWarm = 0x00;

	InformainReport2_A.InfRe.DrainResist = 0x00;
	InformainReport2_A.InfRe.tempOver = 0;
	InformainReport2_A.InfRe.gunTemp = 0;
	InformainReport2_A.InfRe.AccContacON = PillarError.Value.ACContactor;
	InformainReport2_A.InfRe.AccContacOff = 00;
	InformainReport2_A.InfRe.Power = 00;
	InformainReport2_A.InfRe.UniContactorOff = PillarError.Value.UniContactor;
	InformainReport2_A.InfRe.UniContactorOn = 0x00;

	TCUSinglePackSendMsg(Data, 8, eCmd_DCConInfor2, 6);
}


void measuringReporting20_A(void)
{
	u8				Data[64];
	u8				len = 0;

	Data[len++] 		= 0x01;
	Data[len++] 		= GetDcModuleVolt();
	Data[len++] 		= GetDcModuleVolt() >> 8;
	Data[len++] 		= GetDcModuleCurrt();
	Data[len++] 		= GetDcModuleCurrt() >> 8;
	Data[len++] 		= BcsMsg.CurSoc;
	Data[len++] 		= BsmMsg.HighTemp;
	Data[len++] 		= BsmMsg.LowTemp;
	Data[len++] 		= BcsMsg.BatVoltAndGroup.Value.Volt;
	Data[len++] 		= BcsMsg.BatVoltAndGroup.Value.Volt >> 8;
	Data[len++] 		= BcsMsg.BatVoltAndGroup.Value.Volt;
	Data[len++] 		= BcsMsg.BatVoltAndGroup.Value.Volt >> 8;
	Data[len++] 		= Dht12_GetTemp() + 50;
	Data[len++] 		= BclMsg.NeedVolt;
	Data[len++] 		= BclMsg.NeedVolt >> 8; 	//12V
	Data[len++] 		= BclMsg.NeedCurrt;
	Data[len++] 		= BclMsg.NeedCurrt >> 8;
	Data[len++] 		= BclMsg.ChgType;
	Data[len++] 		= BcsMsg.ChgVolt;
	Data[len++] 		= BcsMsg.ChgVolt >> 8;		//12V
	Data[len++] 		= BcsMsg.ChgCurrt;
	Data[len++] 		= BcsMsg.ChgCurrt >> 8;
	Data[len++] 		= BcsMsg.RemainMin;

	Data[len++] 		= Adc_Get_a_PTemp() + 50;
	Data[len++] 		= Adc_Get_a_NTemp() + 50;
	Data[len++] 		= Adc_Get_B_PTemp() + 50;
	Data[len++] 		= Adc_Get_B_NTemp() + 50;
	TCUMultiPackSendMsg(Data, len, eCmd_DCConMeasu, 6);
}


void measuringReporting20_B(void)
{
	u8				Data[64];
	u8				len = 0;

	Data[len++] 		= 0x01;
	Data[len++] 		= GetDcModuleVolt();
	Data[len++] 		= GetDcModuleVolt() >> 8;
	Data[len++] 		= GetDcModuleCurrt();
	Data[len++] 		= GetDcModuleCurrt() >> 8;
	Data[len++] 		= BcsMsg_B.CurSoc;
	Data[len++] 		= BsmMsg_B.HighTemp;
	Data[len++] 		= BsmMsg_B.LowTemp;
	Data[len++] 		= BcsMsg_B.BatVoltAndGroup.Value.Volt;
	Data[len++] 		= BcsMsg_B.BatVoltAndGroup.Value.Volt >> 8;
	Data[len++] 		= BcsMsg_B.BatVoltAndGroup.Value.Volt;
	Data[len++] 		= BcsMsg_B.BatVoltAndGroup.Value.Volt >> 8;
	Data[len++] 		= Dht12_GetTemp() + 50;
	Data[len++] 		= BclMsg_B.NeedVolt;
	Data[len++] 		= BclMsg_B.NeedVolt >> 8;	//12V
	Data[len++] 		= BclMsg_B.NeedCurrt;
	Data[len++] 		= BclMsg_B.NeedCurrt >> 8;
	Data[len++] 		= BclMsg_B.ChgType;
	Data[len++] 		= BcsMsg_B.ChgVolt;
	Data[len++] 		= BcsMsg_B.ChgVolt >> 8;	//12V
	Data[len++] 		= BcsMsg_B.ChgCurrt;
	Data[len++] 		= BcsMsg_B.ChgCurrt >> 8;
	Data[len++] 		= BcsMsg_B.RemainMin;

	Data[len++] 		= Adc_Get_a_PTemp() + 50;
	Data[len++] 		= Adc_Get_a_NTemp() + 50;
	Data[len++] 		= Adc_Get_B_PTemp() + 50;
	Data[len++] 		= Adc_Get_B_NTemp() + 50;
	TCUMultiPackSendMsg(Data, len, eCmd_DCConMeasu, 6);
}


void ChgInfornQueryAck(void)
{
	u8				data[128];
	u8				len = 0;

	data[len++] 		= TCUCommuStatus.ChgNum;
	memcpy(&data[len], TCUControlInfo.ManufacturerCode, 4);
	len 				+= 4;
	memcpy(&data[len], TCUControlInfo.DeviceModel, 2);
	len 				+= 2;
	memcpy(&data[len], TCUControlInfo.HardwareVersion, 2);
	len 				+= 2;
	memcpy(&data[len], TCUControlInfo.SoftwareVersion, 2);
	len 				+= 2;
	memcpy(&data[len], TCUControlInfo.SoftwareData, 4);
	len 				+= 4;

	data[len++] 		= TCUControlInfo.BmsVersion;
	data[len++] 		= (u8)
	TCUControlInfo.DcMaxVolt;
	data[len++] 		= (u8) (TCUControlInfo.DcMaxVolt >> 8);
	data[len++] 		= (u8)
	TCUControlInfo.DcMinVolt;
	data[len++] 		= (u8) (TCUControlInfo.DcMinVolt >> 8);

	data[len++] 		= (u8) (4000 - TCUControlInfo.DcMaxCurrt);
	data[len++] 		= (u8) ((4000 - TCUControlInfo.DcMaxCurrt) >> 8);
	data[len++] 		= (u8) (4000 - TCUControlInfo.DcMinCurrt);
	data[len++] 		= (u8) ((4000 - TCUControlInfo.DcMinCurrt) >> 8);
	TCUMultiPackSendMsg(data, len, eCmd_QueryAck, 6);
}


void verification(void)
{
	u8				data[128];
	u8				len = 0;

	data[len++] 		= 0x01;
	memcpy(&data[len], BrmMsg.Vin, 17);
	len 				+= 17;
	memcpy(&data[len], &BrmMsg.ChgCount, 3);
	len 				+= 3;
	memcpy(&data[len], &BcpMsg.StartSoc, 2);
	len 				+= 3;
	memcpy(&data[len], &BcpMsg.StartVolt, 2);
	len 				+= 2;
	TCUMultiPackSendMsg(data, len, eCmd_verification, 6);
}


void verification_B(void)
{
	u8				data[128];
	u8				len = 0;

	data[len++] 		= 0x02;
	memcpy(&data[len], BrmMsg_B.Vin, 17);
	len 				+= 17;
	memcpy(&data[len], &BrmMsg_B.ChgCount, 3);
	len 				+= 3;
	memcpy(&data[len], &BcpMsg_B.StartSoc, 2);
	len 				+= 3;
	memcpy(&data[len], &BcpMsg_B.StartVolt, 2);
	len 				+= 2;
	TCUMultiPackSendMsg(data, len, eCmd_verification, 6);

}


void verificationAck(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 0x01)
	{
		VerificaInfo.result = pPgnRecv->Data[1];
		VerificaInfo.FailReason = pPgnRecv->Data[2];
	}
	else if (pPgnRecv->Data[0] == 0x02)
	{
		VerificaInfo_B.result = pPgnRecv->Data[1];
		VerificaInfo_B.FailReason = pPgnRecv->Data[2];
	}
}


void TcuEMMsg(u8 data)
{
	u8				Data[8];

	Data[0] 			= 0x01;
	Data[1] 			= data;
	TCUSinglePackSendMsg(Data, 8, eCmd_ConErroComm, 4);
}


void TcuEMMsg_B(u8 data)
{
	u8				Data[8];

	Data[0] 			= 0x02;
	Data[1] 			= data;
	TCUSinglePackSendMsg(Data, 8, eCmd_ConErroComm, 4);
}


void TCUErroCommAnalysis(StructTCUSend * pPgnRecv)
{
	if (pPgnRecv->Data[0] == 1)
		memcpy(&TCUChgContralTCUEM_A.tcuem, &pPgnRecv->Data[1], 2);
	else if (pPgnRecv->Data[0] == 2)
		memcpy(&TCUChgContralTCUEM_B.tcuem, &pPgnRecv->Data[1], 2);

}

void TCUMeasuRecv(StructTCUSend * pPgnRecv)
{
	if(pPgnRecv->Data[0] == 0)
	{
		TCUCommuStatus.DCMeasuRecvTime = GetSystemTick();
		TCUCommuStatus.DCMeasuRecvTime_B = GetSystemTick();
	}
	else if(pPgnRecv->Data[0] == 1)
	{
		TCUCommuStatus.DCMeasuRecvTime = GetSystemTick();
	}
	else if(pPgnRecv->Data[0] == 2)
	{
		TCUCommuStatus.DCMeasuRecvTime_B = GetSystemTick();
	}
}
