
#ifndef __DRV_TCUCOMM_H__
#define __DRV_TCUCOMM_H__

#include "Global.h"
#include "Thd_Charge.h"
#include "Memory.h"
#include "Thd_TCU.h"
#include "Drv_MCP2515.h"
#include "Thd_TcuControl.h"


extern u8 TCUSendMsg(StructChargeSend *pMsg);

extern void TCUCanInit_B(void);
extern osMessageQId TCUMsg;

typedef struct
{
  u8 ControlType;
  s16 Kwh;
  u8 Percentage;
}StructPowerControl;

typedef struct cp56time2a {
    u16 msec;
    u16 min :6;
    u8 res1 :1;
    u8 iv :1;       // invalid, iv = 0 Ч iv = 1 Ч
    u8 hour :5;
    u8 res2 :2;
    u8 su :1;       //summer time, su = 0 ׼ʱ䣻 su = 1 ļʱ
    u8 mday :5;
    u8 wday :3;
    u8 month :4;
    u8 res3 :4;
    u8 year :7;
    u8 res4 :1;
} cp56time2a;

typedef struct
{
  //u8 Len;
 // u8 Data[8];
 // Union1939Id Id;
  u8 Prio;
  u8 DP;
  u8 PF;
  u8 DA;
  u8 SA;
  u8 Len;
  u8 Data[8];
  u32 Pgn;
}StructTCUSend;

typedef struct
{
  u8  GunNum; // ǹ 0 һ  1-255 
  u8  LoadSswitch;//ɿƿ    Ƿûͺṩͬ 0102رЧ
  u8  PlugToChgFlag;//弴ʶ  00 01 弴other:invalid
}StructStartMeg;
typedef struct
{
  u8  GunNum; // ǹ 0 һ  1-255 
  u8  LoadSswitch;//ɿƿ    Ƿûͺṩͬ 0102رЧ
  u8  AckFlag;
  u32 RecvTick;
 }StructStartCompMeg;
typedef struct
{
  u8  GunNum; // ǹ 0 һ  1-255 
  u8  StopReason;
  u8  AckFlag;
}StructStopCompMeg;

typedef  enum
{
 stopIdle    =0,
 commStop    =1,
 TcuFultStop =2,
 ChgFultStop =3,
}stopReason; 
typedef struct
{
  u8          GunNum; // ǹ 0 һ  1-255 
  stopReason  StopReason;//
}StructStopMeg;

typedef struct
{
  u8  ChargingServiceFlag;//01ֹͣ02
  u16 version;
  u8  ChargeNum[8];
  u8  ManufacturerCode[4];//ұ
  u8  DeviceModel[2];//豸ͺ
  u8  HardwareVersion[2];//Ӳ汾
  u8  SoftwareVersion[2];//汾
  u8  SoftwareData[4];//
  u8  BmsVersion;//BMSЭ汾01H GB/27930-2011 02HGB/27930-2011
  u16 DcMaxVolt;//ģѹ XXX.xV
  u16 DcMinVolt;//ģСѹ XXX.xV
  u16 DcMaxCurrt;//ģ XX.xA
  u16 DcMinCurrt;//ģС XX.xA 
  StructPowerControl PowerControl_A;
  StructPowerControl PowerControl_B;
  
}StructTCUCControl;


typedef union
{
 u8 data[5];
 struct 
 {
  u8 workStau : 2;
  u8 sumFalt  : 1;
  u8 sumWarm  : 1;
  u8 Emergency: 1;
  u8 smoke    : 1;
  u8 AccContac: 1;
  u8 DCOutConOff: 1;//ĸ߽Ӵݶ/󶯹
  
  u8 DCFuse   : 1;//۶
  u8 EleLock  : 1;
  u8 Fan      : 1;
  u8 SPD      : 1;
  u8 ImdDev   : 1;
  u8 BattPola : 1;
  u8 ContGuid : 1;
  u8 tempOver : 1;
  
  u8 ConnTemp  : 1;
  u8 PutBack  : 1;
  u8 BMSComm  : 1;
  u8 InVoltHi : 1;
  u8 InVoltlo : 1;
  u8 DcVolHi  : 1;
  u8 DcVolLo  : 1;
  u8 DCCurrHi : 1;
  
  u8 DcModErr : 1;
  u8 DCModIn  : 1;
  u8 DCModInHi: 1;
  u8 DCModInLo: 1;
  u8 DCModPhas: 1;
  u8 DcOutShor: 1;
  u8 DCModOutCuHi: 1;
  u8 DCModOutVoHi: 1;
  
  u8 DCModOutVoLo: 1;
  u8 DCModTempHi : 1;
  u8 DCModComm   : 1;
  u8 DCModFan    : 1;
  u8 CCConnect   : 1;
  u8 InsertGunSta: 1;
  u8 DcOutContSta: 1;
  u8 ElectLock  : 1;
 }InfRe;
}UnionInformainReport1;

typedef union
{
 u16 data;
 struct 
 { 
  u16 Door        : 1;//۶
  u16 DCOutConOn  : 1;//ĸ߽Ӵճ
  u16 ImdWarm     : 1;
  u16 DrainResist : 1;
  u16 tempOver    : 1;
  u16 gunTemp     : 1;
  u16 AccContacON : 1;//սӴݶ/󶯹
  
  u16 AccContacOff: 1;//ճ
  u16 Power : 1;//Դ 
  u16 UniContactorOff : 1;//ĸ߽Ӵݶ/󶯹
  u16 UniContactorOn : 1;//ĸ߽Ӵݶ/󶯹
 }InfRe;
}UnionInformainReport2;


typedef union
{
  u32 Mult;
  struct
  {
   u32 Idle       : 1;//
   u32 paramAck   : 1;//
   u32 startAck   : 1;//
   u32 startComp  : 1;//
   u32 stopAck    : 1;//
   u32 stopComp   : 1;//
   u32 timeAck    : 1;//
   u32 SerConAck  : 1;//
   
   u32 GunAck     : 1;//
   u32 powerAck   : 1;//
   u32 QueryAck : 1;//
   u32 DCConInfor : 1;//
   u32 DCConMeasu : 1;//
   u32 verification : 1;//       
         
    
  }Value;
}UnionTCUEM;
typedef struct
{
//  u8  Valid;
  UnionTCUEM tcuem;//ʱ
}StructTCUEM;


typedef struct
{
  u8  result;
  u8  FailReason;
 
}StructVerificationInformain;

#define TCU1939Addr    (0x8A)
#define ChargerCont1939Addr (0xE0)
typedef enum
{
  eCmd_start      =   0x000100,//  ֡	
  eCmd_startAck   =   0x000200,//  ֡	

  eCmd_stop       =   0x000300,//  ֹͣ֡	
  eCmd_stopAck    =   0x000400,//  ֹͣ֡	

  eCmd_time       =   0x000500,//   	ʱ֡  	
  eCmd_timeAck    =   0x000600,//     ʱ֡	

  eCmd_versi      =   0x000700,//汾У֡	
  eCmd_versiAck   =   0x000800,//汾У֡ 

  eCmd_param	  =	  0x000900,//  ·Ϣ֡     
  eCmd_paramAck   =	  0x000A00,// ·ϢӦ֡  

  eCmd_SerCon     =	  0x000B00,//   ͣ֡  
  eCmd_SerConAck  =	  0x000C00,//  ͣ֡Ӧ 

  eCmd_Gun	      =	  0x000D00,//   ɿ֡  
  eCmd_GunAck     =	  0x000E00,//  ɿӦ֡

  eCmd_power	  =	  0x000F00,//  ʵڿ֡ 
  eCmd_powerAck   =	  0x001000,// ʵڿӦ֡  

  eCmd_Query	  =	  0x006000,//  ׮Ϣѯ֡  
  eCmd_QueryAck =	   0x006100,// ׮ϢѯӦ֡ 

  eCmd_verification	   =0x002D00,//   ֤֡ 
  eCmd_verificationAck =0x002E00,//֤Ӧ֡  

 ////////////״̬֡/////////////////
  eCmd_startComp	   =0x001100,//   ֡  
  eCmd_startCompAck    =0x001200,//  Ӧ֡  

  eCmd_stopComp  	   =0x001300,//   ֹͣ֡ 
  eCmd_stopCompAck     =0x001400,// ֹͣӦ֡ 
  ///////////֡/ֱ////////////
  eCmd_DCConMeasu	   =0x002000,// ң֡
  eCmd_DCTCUMeasu      =0x002100,// ƷѵԪң ֡
  eCmd_DCConInfor1	   =0x002200,// ң֡
  eCmd_DCConInfor2     =0x002300,//  ң֡
  ///////////֡/////////////
  eCmd_ACConMeasu      =0x003000,//  ң֡ 
  eCmd_ACTCUMeasu      =0x003100,//  ƷѵԪң ֡ 
  eCmd_ACConInfor      =0x003200,//  ң֡  
  eCmd_ACTCUInfor      =0x003300,//  ƷѵԪң֡ 
///////////֡///////////
  eCmd_TcuHeart        =0x004000,  //  ƷѵԪ  
  eCmd_ContHeart       =0x004100,  //  ֡ 
  
  eCmd_TCUErroComm	   =0x005100,  // ƷѵԪ֡	
  eCmd_ConErroComm	   =0x005200,  //֡ 
}EnumTCUCommPgn;

extern u8 TCUCommInit(void);
extern void StartMeg ( StructTCUSend* pPgnRecv );
extern void StartMegAck_A(void);
extern void StartMegAck_B(void);
extern void AckTCUHeartBeat(StructTCUSend* pPgnRecv);
extern void TCUParamAck(void);

extern void startCompSend_A(void);
extern void startCompSend_B(void);
extern void ACkStartCompMeg ( StructTCUSend* pPgnRecv );
extern void StopMeg( StructTCUSend* pPgnRecv );
extern void StopMegAck_A(void );
extern void StopMegAck_B(void );

extern void stopCompSend_A(void);
extern void stopCompSend_B(void);
extern void stopCompAck( StructTCUSend* pPgnRecv);
extern void TCUHeartBeat_A(void);
extern void TCUHeartBeat_B(void);
extern void TCUtimeSet(StructTCUSend* pPgnRecv);
extern void TCUtimeSetAck(void);
extern void TCUVersionCheck(StructTCUSend* pPgnRecv);
extern void TCUVersionCheckSent(void);
extern void SerConAckAnalysis(StructTCUSend* pPgnRecv);
extern void SerConAck(void);
extern void ElectControlAnalysis(StructTCUSend* pPgnRecv);
extern void ElectControlAck(void);
extern void PowerControlAnalysis(StructTCUSend* pPgnRecv);
extern void PowerControlAck(void);
extern void InformationReporting_22_A (void);
extern void InformationReporting_22_B (void);
extern void InformationReporting_23_A (void);
extern void InformationReporting_23_B(void);
extern void measuringReporting20_A(void);
extern void measuringReporting20_B(void);
extern void ChgInfornQueryAck(void);
extern void verification(void);
extern void verificationAck(StructTCUSend* pPgnRecv);
extern void TcuEMMsg( u8 data);
extern void TcuEMMsg_B(u8 data);
extern void TCUParam(StructTCUSend* pPgnRecv);
extern void TCUMeasuRecv(StructTCUSend * pPgnRecv);

extern StructStartMeg StartMeg_A ;
extern StructStartMeg StartMeg_B;

extern StructStartCompMeg AckStartCompMeg_A ;
extern StructStartCompMeg AckStartCompMeg_B ;

extern StructStopMeg StopMeg_A ;
extern StructStopMeg StopMeg_B ;

extern StructStopCompMeg AckStopCompMeg_A ;
extern StructStopCompMeg AckStopCompMeg_B ;

extern UnionInformainReport1 InformainReport_A;
extern UnionInformainReport1 InformainReport_B;

extern UnionInformainReport2 InformainReport2_A;
extern UnionInformainReport2 InformainReport2_B;
extern StructVerificationInformain VerificaInfo ;
extern StructVerificationInformain VerificaInfo_B ;
extern StructTCUEM  TCUChgContralTCUEM_A;
extern StructTCUEM  TCUChgContralTCUEM_B;


#endif


