
/******************************************************************************
ļ  : Drv_W5500.c
  : STM32F4RTC
  :
޸  : 2014-08-26      

******************************************************************************/

#include "Drv_W5500.h"
#include "Memory.h"
#include "Drv_CommuSPI2.h"
#include "FTP_Upgrade.h"

osMessageQId CableNetRecvQ;
u8 CableNetStatus;

osMutexId W5500Mutex = NULL;

u32 LastRecvTick = 0;


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define W5500_DUMMY_BYTE         0xFF
#if 0
/**
  * @brief  DeInitializes the peripherals used by the SPI FLASH driver.
  * @param  None
  * @retval None
  */
void W5500_LowLevel_DeInit(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /*!< Disable the W5500_SPI  ************************************************/
  SPI_Cmd(W5500_SPI, DISABLE);

  /*!< DeInitializes the W5500_SPI *******************************************/
  SPI_I2S_DeInit(W5500_SPI);

  /*!< W5500_SPI Periph clock disable ****************************************/
  W5500_SPI_CLK_INIT(W5500_SPI_CLK, DISABLE);

  /*!< Configure all pins used by the SPI as input floating *******************/
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;

  GPIO_InitStructure.GPIO_Pin = W5500_SPI_SCK_PIN;
  GPIO_Init(W5500_SPI_SCK_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = W5500_SPI_MISO_PIN;
  GPIO_Init(W5500_SPI_MISO_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = W5500_SPI_MOSI_PIN;
  GPIO_Init(W5500_SPI_MOSI_GPIO_PORT, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = W5500_CS_PIN;
  GPIO_Init(W5500_CS_GPIO_PORT, &GPIO_InitStructure);
}

/**
  * @brief  DeInitializes the peripherals used by the SPI FLASH driver.
  * @param  None
  * @retval None
  */
void W5500_DeInit(void)
{
  W5500_LowLevel_DeInit();
}
#endif
/**
*@brief  W5500λú
*@param  
*@return  
*/
void W5500_Reset(void)
{
#if 0
  GPIO_ResetBits(GPIOE, WIZ_RESET);
  delay_us(2);
  GPIO_SetBits(GPIOE, WIZ_RESET);
  delay_ms(1600);
#endif
}

/**
  * @brief  Sends a byte through the SPI interface and return the byte received
  *         from the SPI bus.
  * @param  byte: byte to send.
  * @retval The value of the received byte.
  */
u8 W5500_SendByte(u8 byte)
{
  return CommuSPI2_SendByte(byte);
}

/**
*@brief  дһ8λݵW5500
*@param  addrbsb: дݵĵַ
*@param   dataд8λ
*@return  
*/
void W5500_WriteByte(u8 data)
{
  CommuSPI2_SendByte(data);
}

/**
*@brief  W5500һ8λ
*@param  addrbsb: дݵĵַ
*@param   dataдĵַȡ8λ
*@return  
*/
u8 W5500_ReadByte(void)
{
  return CommuSPI2_ReadByte(W5500_DUMMY_BYTE);
}

/* Exported macro ------------------------------------------------------------*/
/* Select sFLASH: Chip Select pin low */
void W5500_Select(void)
{
  W5500_CS_LOW();
}

/* Deselect sFLASH: Chip Select pin high */
void W5500_Deselect()
{
  W5500_CS_HIGH();
}

void CableNetInit(void)
{
  const u8 memsize[2][8] = { {2,2,2,2,2,2,2,2},{2,2,2,2,2,2,2,2}};

//  u8 Temp[10] = {0};
  wiz_NetTimeout Timeout =
  {
    .retry_cnt = 16,
    .time_100us = 4000,
  };

  wiz_NetInfo NetInfo =
  {
    .mac = {0x00, 0x08, 0xdc, 0x00, 0xab, 0xcd},
    .ip = {188, 188, 5, 252},
    .sn = {255, 255, 0, 0},
    .gw = {188, 188, 1, 1},
    .dns = {0, 0, 0, 0},
    .dhcp = NETINFO_STATIC
  };
#if 0
  if(TRUE == GetMemory(eeAddr_MacAddr, Temp, sizeof(MacAddr)))
    memcpy(MacAddr, Temp, sizeof(MacAddr));
  MacAddr[0] &= 0xFE;

  if(TRUE == GetMemory(eeAddr_LocalIp, Temp, sizeof(LocalIp)))
    memcpy(LocalIp, Temp, sizeof(LocalIp));
  if(TRUE == GetMemory(eeAddr_SubIp, Temp, sizeof(SubIp)))
    memcpy(SubIp, Temp, sizeof(SubIp));
  if(TRUE == GetMemory(eeAddr_GwIp, Temp, sizeof(GwIp)))
    memcpy(GwIp, Temp, sizeof(GwIp));
  if(TRUE == GetMemory(eeAddr_DnsIp, Temp, sizeof(DnsIp)))
    memcpy(DnsIp, Temp, sizeof(DnsIp));
#endif

  memcpy(NetInfo.mac, UserParam.MacAddr, sizeof(NetInfo.mac));
  memcpy(NetInfo.ip, UserParam.LocalIp, sizeof(NetInfo.ip));
  memcpy(NetInfo.sn, UserParam.SubIp, sizeof(NetInfo.sn));
  memcpy(NetInfo.gw, UserParam.GwIp, sizeof(NetInfo.gw));
  memcpy(NetInfo.dns, UserParam.DnsIp, sizeof(NetInfo.dns));


  ctlwizchip(CW_RESET_PHY, (void*)0);

  ctlwizchip(CW_INIT_WIZCHIP,(void*)memsize);

  ctlnetwork(CN_SET_NETINFO, (void*)&NetInfo);

  ctlnetwork(CN_GET_NETINFO, (void*)&NetInfo);

  ctlnetwork(CN_SET_TIMEOUT, (void*)&Timeout);

#if 0
  memcpy(MacAddr, NetInfo.mac, sizeof(MacAddr));
  memcpy(LocalIp, NetInfo.ip, sizeof(LocalIp));
  memcpy(SubIp, NetInfo.sn, sizeof(SubIp));
  memcpy(GwIp, NetInfo.gw, sizeof(GwIp));
  memcpy(DnsIp, NetInfo.dns, sizeof(DnsIp));
#endif
}

int W5500_Recv(void)
{
  u16 RecvLen;
  u8 Buff[64];
  u32 i;

  RecvLen = getSn_RX_RSR(SocketCommu);/*lenΪѽݵĳ*/
  if(RecvLen > 0)
  {
    LastRecvTick = GetSystemTick();
    if(RecvLen > sizeof(Buff))
      RecvLen = sizeof(Buff);
    recv(SocketCommu, Buff, RecvLen);/*Server*/
    if(CableNetRecvQ)
    {
      for(i=0; i<RecvLen; i++)
        osMessagePut(CableNetRecvQ, Buff[i], portMAX_DELAY);
    }
  }
  return RecvLen;
}

/*
StructServerAddr ServerAddr =
{
  {218,17,56,50},
  9005
};////׮IP


StructServerAddr ServerAddr =
{
  {188,188,5,240},
  9006
};////׮IP
*/

/******************************************************************************
  : Thd_W5500
  : ܱȡ߳
  : argument - ̴߳
  : 
******************************************************************************/
void Thd_W5500(void const *argument)
{
  u8 SocketIr = 0;
  u8 LinkPin = 0;
  u32 ConnectTick = 0;
  u32 ResetNetTick = 0;
//  GPIO_ResetBits(GPIOB, GPIO_Pin_11);
//  osDelay(1000);
//  GPIO_SetBits(GPIOB, GPIO_Pin_11);
  
  CableNetInit();
  osDelay(2000);
  CableNetInit();
  osDelay(1000);

  

  for(;;)
  {
    osDelay(50);
    LinkPin = wizphy_getphylink();
    if(0 == LinkPin)
    {
      ResetNetTick = 0;
      CableNetStatus = SOCK_CLOSED;
      //continue;
    }
    else
      CableNetStatus = getSn_SR(SocketCommu);
    /*ȡsocket״̬*/

    switch(CableNetStatus)
    {
      case SOCK_CLOSED:/*socketڹر״̬*/
        if(0 == ResetNetTick)
          ResetNetTick = GetSystemTick();
        else if((GetSystemTick() - ResetNetTick) > 300000)
        {
          CableNetInit();
          osDelay(1000);
          ResetNetTick = GetSystemTick();
        }
        socket(SocketCommu, Sn_MR_TCP, 0, Sn_MR_ND);
        break;

      case SOCK_INIT:/*socketڳʼ״̬*/
        //if(0 == HadSigned)
          //break;
        LastRecvTick = 0;
        //connect(SocketCommu,ServerAddr.Ip,ServerAddr.Port); /*socketӷ*/
        connect(SocketCommu,UserParam.ServerAddr.Ip,UserParam.ServerAddr.Port);
        ConnectTick = GetSystemTick();
        while(1)
        {
          SocketIr = getSn_IR(SocketCommu);

          if(SocketIr & Sn_IR_CON)
          {
            setSn_IR(SocketCommu, Sn_IR_CON); /*жϱ־λ*/
            break;
          }
          else if(SocketIr & Sn_IR_DISCON)
          {
            setSn_IR(SocketCommu, Sn_IR_DISCON); /*жϱ־λ*/
            break;
          }
          else if(SocketIr & Sn_IR_TIMEOUT)
          {
            setSn_IR(SocketCommu, Sn_IR_TIMEOUT); /*жϱ־λ*/
            break;
          }
          if((GetSystemTick() - ConnectTick) > 10000)
            break;
          osDelay(50);
        }
        break;

      case SOCK_ESTABLISHED:/*socketӽ״̬*/
        if(0 == LastRecvTick)
          LastRecvTick = GetSystemTick();
        ResetNetTick = 0;
        if(getSn_IR(SocketCommu) & Sn_IR_CON)
          setSn_IR(SocketCommu, Sn_IR_CON); /*жϱ־λ*/
        W5500_Recv();

        if((GetSystemTick() - LastRecvTick) > (2*60*1000))
          close(SocketCommu);
        break;

      case SOCK_CLOSE_WAIT:/*socketڵȴر״̬*/
        close(SocketCommu);
        break;

      default:
        break;
    }
    FtpUpgardeProcess();
    osDelay(15);
  }
}

int W5500_Send(u8 *pData, u16 Len)
{
  if(SOCK_ESTABLISHED != CableNetStatus)
    return -1;

  send(SocketCommu, pData, Len);
  return 0;
}

u8 CableNetAvail(void)
{
  if(SOCK_ESTABLISHED == CableNetStatus)
    return TRUE;

  return FALSE;
}

void CableNetClose(void)
{
  close(SocketCommu);
}


void W5500MutexEnter(void)
{
  osMutexWait(W5500Mutex, 5000);
}

void W5500MutexExit(void)
{
  osMutexRelease(W5500Mutex);
}

/**
  * @brief  Initializes the peripherals used by the SPI FLASH driver.
  * @param  None
  * @retval None
  */
u8 W5500_Init(osMessageQId AppRecvQ)
{
  osDelay(100);

  CableNetRecvQ = AppRecvQ;
  W5500Mutex = GetCommuMutex();

  reg_wizchip_cris_cbfunc(W5500MutexEnter, W5500MutexExit);
  /* Chip selection call back */
  reg_wizchip_cs_cbfunc(W5500_Select, W5500_Deselect);
  /* SPI Read & Write callback function */
  reg_wizchip_spi_cbfunc(W5500_ReadByte, W5500_WriteByte);

  osThreadDef(Thd_W5500, Thd_W5500, osPriorityAboveNormal, 0, 4*configMINIMAL_STACK_SIZE);
  osThreadCreate(osThread(Thd_W5500), NULL);

  return TRUE;
}


