
#include "Drv_WatchDog.h"

void WdgInit(void)
{
  u32 ErrorTime;

  ErrorTime = 0x00800000;
  RCC_LSICmd(ENABLE);
  while((RESET == RCC_GetFlagStatus(RCC_FLAG_LSIRDY)) && ErrorTime)
  {/* Wait till LSI is ready */
    ErrorTime--;
  }

  /* IWDG timeout equal to 250 ms (the timeout may varies due to LSI frequency
     dispersion) */
  /* Enable write access to IWDG_PR and IWDG_RLR registers */
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);

  /* IWDG counter clock: LSI/32 */
  IWDG_SetPrescaler(IWDG_Prescaler_32);
  /* Set counter reload value to obtain 3276.8ms IWDG TimeOut. */
  IWDG_SetReload(0xFFF);

  /* Reload IWDG counter */
  IWDG_ReloadCounter();

  /* Enable IWDG (the LSI oscillator will be enabled by hardware) */
  IWDG_Enable();
}

void FeedDog(void)
{
  /* Reload IWDG counter */
  IWDG_ReloadCounter();
}

