#ifndef __MD5_H
#define __MD5_H

#include "stm32f4xx.h"

/**
 @brief	MD5 context.
 */
typedef struct {
        u32 state[4];    /**< state (ABCD)                            */
        u32 count[2];    /**< number of bits, modulo 2^64 (lsb first) */
        u8  buffer[64];  /**< input buffer                            */
      } md5_ctx;

extern void md5_init(md5_ctx *context);
extern void md5_update(md5_ctx *context, u8 *buffer, u32 length);
extern void md5_final(u8 result[16], md5_ctx *context);

#endif	// __md5_H
