
#include "Drv_DcModule.h"
#include "Drv_MCP2515.h"
#include "Memory.h"
#include "Drv_SmartAllocation.h"
#include "Global.h"
#include "Drv_BoardIo.h"

StructDcModuleGroup DcModuleGroup[] =
{
	{
		2, 0, 
		{
			1, 0, 0, 0, 2, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		1, 0, 
		{
			3, 0, 0, 0, 0, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		2, 0, 
		{
			4, 0, 0, 0, 5, 0, 0, 0
		},
		Invalid, 0, 0
	},
	{
		1, 0, 
		{
			6, 0, 0, 0, 0, 0, 0, 0
		},
		Invalid, 0, 0
	},
};


static u8		DcModuleGroupSize = sizeof(DcModuleGroup) / sizeof(DcModuleGroup[0]);


extern StructDcModuleManage DcModuleManage;
extern StructDcModuleManage DcModuleManage_B;
extern StructDcModuleManage DcModuleManage_All;

extern StructDcModuleCtrl DcModuleCtrl;
extern StructDcModuleCtrl DcModuleCtrl_B;
extern StructDcModuleCtrl DcModuleCtrl_ALL;


extern StructDcModuleStatus DcModuleStatus_ALL[64];

extern void DcModuleCanInit(void);

extern osMessageQId DcModeMsg;


void DcModuleManageProcess_SmartAllocation(void)
{
	static u32		CheckTick = 0;
	u8				addr = 0;

	u8				i, j;
	long long		Flag;
	u8				Count, Count_A, Count_B;
	u32 			Currt, Currt_A, Currt_B;
	u32 			Volt, Volt_A, Volt_B;
	u8				status;


	StructDcModuleSend DataSend;

	static u32		StaticTick = 0;

	if (StaticTick == 0)
		StaticTick = GetSystemTick();

	if ((GetSystemTick() -StaticTick) > 1000)
	{
		StaticTick			= GetSystemTick();

		for (i = 0; i < DcModuleGroupSize; i++)
		{
			for (j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x01;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= 0x00;

				//DcModuleSendMsg(&DataSend);
				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					osDelay(10);
				}
			}

		}
	}


	if ((GetSystemTick() -CheckTick) < 100)
		return;

	CheckTick			= GetSystemTick();

	Flag				= 1;
	Count				= 0;

	for (i = 0; i < 64; i++)
	{
		if (Flag & DcModuleManage_All.OnlineFlag)
		{
			if ((GetSystemTick() -DcModuleStatus_ALL[i].RecvTime) > 8000)
			{
				DcModuleManage_All.OnlineFlag &= ~Flag;
				DcModuleManage_All.ValidFlag &= ~Flag;
			}
			else 
			{
				if (0x0002 != (DcModuleStatus_ALL[i].State & 0x0002))
				{
					DcModuleManage_All.ValidFlag |= Flag;
					Count++;
				}
			}
		}

		Flag				= Flag << 1;
	}

	DcModuleManage_All.ValidNum = Count;

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		Currt				= 0;
		Volt				= 0;
		Count				= 0;

		for (j = 0; j < DcModuleGroup[i].num; j++)
		{
			addr				= DcModuleGroup[i].modules[j].addr;
			Flag				= addr << 1;

			if (Flag & DcModuleManage_All.ValidFlag)
			{
				Currt				+= DcModuleStatus_ALL[addr].Currt;
				Volt				+= DcModuleStatus_ALL[addr].Volt;
				Count++;

				DcModuleGroup[i].modules[j].status = Valid;
				DcModuleGroup[i].modules[j].Voltage = DcModuleStatus_ALL[addr].Volt;
				DcModuleGroup[i].modules[j].Current = DcModuleStatus_ALL[addr].Currt;
			}
			else 
			{
				DcModuleGroup[i].modules[j].status = Invalid;

			}
		}

		DcModuleGroup[i].ValidNum = Count;
		DcModuleGroup[i].Voltage = Volt / Count;
		DcModuleGroup[i].Current = Currt;
	}

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		status				= DcModuleGroup[i].modules[0].status;

		if (DcModuleGroup[i].num != DcModuleGroup[i].ValidNum)
		{

		}

		if (DcModuleGroup[i].num > 1)
		{
			if (status != Valid)
			{
				if (DcModuleGroup[i].modules[1].status != Valid)
				{
					DcModuleGroup[i].status = Invalid;

				}
			}
		}
		else 
		{
			if (status != Valid)
			{
				DcModuleGroup[i].status = Invalid;
			}

		}
	}

	Currt				= 0;
	Currt_A 			= 0;
	Currt_B 			= 0;
	Volt				= 0;
	Volt_A				= 0;
	Volt_B				= 0;
	Count				= 0;
	Count_A 			= 0;
	Count_B 			= 0;

	for (i = 0; i < DcModuleGroupSize; i++)
	{
		if (DcModuleGroup[i].status == Valid)
		{
			Volt				+= DcModuleGroup[i].Voltage;
			Currt				+= DcModuleGroup[i].Current;
			Count				+= DcModuleGroup[i].ValidNum;
		}
		else if (DcModuleGroup[i].status == Hold_A)
		{
			Volt_A				+= DcModuleGroup[i].Voltage;
			Currt_A 			+= DcModuleGroup[i].Current;
			Count_A 			+= DcModuleGroup[i].ValidNum;
		}
		else if (DcModuleGroup[i].status == Hold_B)
		{
			Volt_B				+= DcModuleGroup[i].Voltage;
			Currt_B 			+= DcModuleGroup[i].Current;
			Count_B 			+= DcModuleGroup[i].ValidNum;
		}
	}

	DcModuleCtrl.ActualCurrt = Currt_A;
	DcModuleCtrl.ActualVolt = Volt_A;
	DcModuleCtrl_ALL.ActualCurrt = Currt_A;
	DcModuleCtrl_ALL.ActualVolt = Volt_A;
	DcModuleCtrl_B.ActualCurrt = Currt_B;
	DcModuleCtrl_B.ActualVolt = Volt_B;

	DcModuleManage.ValidNum = Count_A;
	DcModuleManage_All.ValidNum = Count;
	DcModuleManage_B.ValidNum = Count_B;

	if (0 == DcModuleManage_All.OnlineFlag)
		DcModuleCanInit();
}



void DcModuleCtrlProcess_SmartAllocation(void)
{
	static u32		CtrlTick = 0;
	static u8		LastFlag_A = 0;
	static u8		LastFlag_B = 0;

	static StructDcModuleUsedStatus status[4] =
	{
		Invalid, Invalid, Invalid, Invalid
	};
	static StructDcModuleUsedStatus status1[4] =
	{
		Invalid, Invalid, Invalid, Invalid
	};

	StructDcModuleSend DataSend;
	u32 			Temp;
	u8				addr;
	u32 	Volt = 0;
	u8 		Cmd = 0;
	Temp				= 0;
	
	for (u8 i = 0; i < DcModuleGroupSize; i++)
	{
		if (status[i] != DcModuleGroup[i].status)
		{
			Temp = 1;
			Volt = DcModuleAbility.MinVolt * 100;
			if (DcModuleGroup[i].status == Valid)
			{
				//关机
				if (status[i] == Hold_A)
				{
					if(i == 0)
					{
						DcModuleManage.SetVolt = DcModuleAbility.MinVolt * 100;
						DcModuleManage.SetCurrt = DcModuleAbility.MinCurrt * 100;
						DcModuleManage.Cmd	= 0xAA; 	//关机
					}
					else if(i == 1)
					{
						GPIO_ResetBits(RELAY_K1K2_Port,RELAY_K1K2_Pin);
					}
					else if(i == 2)
					{
						GPIO_ResetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
					}
					else//  if(i == 3)
					{
						GPIO_ResetBits(RELAY_K3K4_Port,RELAY_K3K4_Pin);
					}
				}
				else if (status[i] == Hold_B)
				{
					if(i==2)
					{
						DcModuleManage_B.SetVolt = DcModuleAbility.MinVolt * 100;
						DcModuleManage_B.SetCurrt = DcModuleAbility.MinCurrt * 100;
						DcModuleManage_B.Cmd = 0xAA;	//关机
					}
					else if(i == 0)
					{
						GPIO_ResetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
					}
					else if(i == 1)
					{
						GPIO_ResetBits(RELAY_K7K8_Port,RELAY_K7K8_Pin);
					}
					else// if(i == 3)
					{
						GPIO_ResetBits(RELAY_K9K10_Port,RELAY_K9K10_Pin);
					}
				}
				//Volt = DcModuleAbility.MinVolt * 100;
				Cmd = 0xAA; //关机
			}
			else if (DcModuleGroup[i].status == Hold_A)
			{
				if(i!=0) //升压
				{
					Volt = DcModuleManage.SetVolt;
				}
				else if(status[i] == Hold_B)
				{
					GPIO_ResetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
				}
				Cmd = 0x55; //开机
			}
			else if (DcModuleGroup[i].status == Hold_B)
			{
				if(i!=2) //升压
				{
					Volt = DcModuleManage.SetVolt;
				}
				else if(status[i] == Hold_A)
				{
					GPIO_ResetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
				}
				Cmd = 0x55; //开机
			}
			else 
			{
				
			}
			
			for (u8 j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x00;
				DataSend.Data[1]	= 0x00;
				Temp				= DcModuleAbility.MinCurrt * 100;
				DataSend.Data[2]	= (u8) (Temp >> 8);
				DataSend.Data[3]	= (u8) (Temp >> 0);
				Temp				= Volt;//DcModuleAbility.MinVolt * 100;
				DataSend.Data[4]	= (u8) (Temp >> 24);
				DataSend.Data[5]	= (u8) (Temp >> 16);
				DataSend.Data[6]	= (u8) (Temp >> 8);
				DataSend.Data[7]	= (u8) (Temp >> 0);

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}
				
				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x02;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= Cmd; 	//关机

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}
			}
			status[i]			= DcModuleGroup[i].status;
		}

	}

	if(Temp) return;

	Temp				= 0;

	for (u8 i = 0; i < DcModuleGroupSize; i++)
	{
		if (status1[i] != DcModuleGroup[i].status)
		{
			Temp = 1;
			if (DcModuleGroup[i].status == Valid)
			{
				//切换继电器
				if (status[i] == Hold_A)
				{

				}
				else if (status[i] == Hold_B)
				{
					
				}
				
				
			}
			else if (DcModuleGroup[i].status == Hold_A)
			{
				//切换继电器
				if(i==0)
				{
					
				}
				else if(i == 1)
				{
					GPIO_SetBits(RELAY_K1K2_Port,RELAY_K1K2_Pin);
				}
				else if(i == 2)
				{
					GPIO_SetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
				}
				else// if(i == 3)
				{
					GPIO_SetBits(RELAY_K3K4_Port,RELAY_K3K4_Pin);
				}
			}
			else if (DcModuleGroup[i].status == Hold_B)
			{
				//切换继电器
				if(i==2)
				{

				}
				else if(i == 0)
				{
					GPIO_SetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
				}
				else if(i == 1)
				{
					GPIO_SetBits(RELAY_K7K8_Port,RELAY_K7K8_Pin);
				}
				else// if(i == 3)
				{
					GPIO_SetBits(RELAY_K9K10_Port,RELAY_K9K10_Pin);
				}
			}
			else 
			{
				//切换继电器
			}
			
			
			status1[i]			= DcModuleGroup[i].status;
		}

	}
	if(Temp) return;
	
	if (LastFlag_A != DcModuleCtrl.CtrlFlag)
	{
		LastFlag_A			= DcModuleCtrl.CtrlFlag;
		Temp++;
	}

	if (LastFlag_B != DcModuleCtrl_B.CtrlFlag)
	{
		LastFlag_B			= DcModuleCtrl_B.CtrlFlag;
		Temp++;
	}

	if ((GetSystemTick() -CtrlTick) > 100)
	{
		CtrlTick			= GetSystemTick();
		Temp++;
	}

	if (0 == Temp)
		return;

	if (DcModuleCtrl.CtrlFlag)
	{
		if (DcModuleCtrl.NeedVolt > DcModuleAbility.MaxVolt)
			DcModuleManage.SetVolt = (DcModuleAbility.MaxVolt * 100);
		else if (DcModuleCtrl.NeedVolt > DcModuleAbility.MinVolt)
			DcModuleManage.SetVolt = (DcModuleCtrl.NeedVolt * 100);
		else 
			DcModuleManage.SetVolt = (DcModuleAbility.MinVolt * 100);

		if (DcModuleManage.ValidNum)
		{
			Temp				= (DcModuleCtrl.NeedCurrt * 100) / DcModuleManage.ValidNum;

			if ((DcModuleCtrl.NeedCurrt * 100) % DcModuleManage.ValidNum)
				Temp++;
		}
		else 
			Temp = DcModuleManage.SetCurrt;

		if (Temp > (DcModuleAbility.MaxCurrt * 100))
			Temp = (DcModuleAbility.MaxCurrt * 100);
		else if (Temp < (DcModuleAbility.MinCurrt * 100))
			Temp = (DcModuleAbility.MinCurrt * 100);

		if (Temp <= DcModuleManage.SetCurrt)
			DcModuleManage.SetCurrt = Temp;
		else 
		{
			DcModuleManage.SetCurrt += 500;

			if (DcModuleManage.SetCurrt >= Temp)
				DcModuleManage.SetCurrt = Temp;
		}

		if (DcModuleManage.SetCurrt > (DcModuleAbility.MaxCurrt * 100))
			DcModuleManage.SetCurrt = (DcModuleAbility.MaxCurrt * 100);
		else if (DcModuleManage.SetCurrt < (DcModuleAbility.MinCurrt * 100))
			DcModuleManage.SetCurrt = (DcModuleAbility.MinCurrt * 100);

		for (u8 i = 0; i < DcModuleGroupSize; i++)
		{
			if (DcModuleGroup[i].status != Hold_A)
				continue;

			for (u8 j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x00;
				DataSend.Data[1]	= 0x00;

				Temp				= DcModuleManage.SetCurrt;
				DataSend.Data[2]	= (u8) (Temp >> 8);
				DataSend.Data[3]	= (u8) (Temp >> 0);
				Temp				= DcModuleManage.SetVolt;
				DataSend.Data[4]	= (u8) (Temp >> 24);
				DataSend.Data[5]	= (u8) (Temp >> 16);
				DataSend.Data[6]	= (u8) (Temp >> 8);
				DataSend.Data[7]	= (u8) (Temp >> 0);

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}

				DcModuleManage.Cmd	= 0x55; 		//开机
				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x02;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= DcModuleManage.Cmd;

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}
			}
		}
	}
	else 
	{

	}

	if (DcModuleCtrl_B.CtrlFlag)
	{
		if (DcModuleCtrl_B.NeedVolt > DcModuleAbility.MaxVolt)
			DcModuleManage_B.SetVolt = (DcModuleAbility.MaxVolt * 100);
		else if (DcModuleCtrl_B.NeedVolt > DcModuleAbility.MinVolt)
			DcModuleManage_B.SetVolt = (DcModuleCtrl_B.NeedVolt * 100);
		else 
			DcModuleManage_B.SetVolt = (DcModuleAbility.MinVolt * 100);

		if (DcModuleManage_B.ValidNum)
		{
			Temp				= (DcModuleCtrl_B.NeedCurrt * 100) / DcModuleManage_B.ValidNum;

			if ((DcModuleCtrl_B.NeedCurrt * 100) % DcModuleManage_B.ValidNum)
				Temp++;
		}
		else 
			Temp = DcModuleManage_B.SetCurrt;

		if (Temp > (DcModuleAbility.MaxCurrt * 100))
			Temp = (DcModuleAbility.MaxCurrt * 100);
		else if (Temp < (DcModuleAbility.MinCurrt * 100))
			Temp = (DcModuleAbility.MinCurrt * 100);

		if (Temp <= DcModuleManage_B.SetCurrt)
			DcModuleManage_B.SetCurrt = Temp;
		else 
		{
			DcModuleManage_B.SetCurrt += 500;

			if (DcModuleManage_B.SetCurrt >= Temp)
				DcModuleManage_B.SetCurrt = Temp;
		}

		if (DcModuleManage_B.SetCurrt > (DcModuleAbility.MaxCurrt * 100))
			DcModuleManage_B.SetCurrt = (DcModuleAbility.MaxCurrt * 100);
		else if (DcModuleManage_B.SetCurrt < (DcModuleAbility.MinCurrt * 100))
			DcModuleManage_B.SetCurrt = (DcModuleAbility.MinCurrt * 100);

		for (u8 i = 0; i < DcModuleGroupSize; i++)
		{
			if (DcModuleGroup[i].status != Hold_B)
				continue;

			for (u8 j = 0; j < DcModuleGroup[i].num; j++)
			{
				addr				= DcModuleGroup[i].modules[j].addr;

				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x00;
				DataSend.Data[1]	= 0x00;

				Temp				= DcModuleManage_B.SetCurrt;
				DataSend.Data[2]	= (u8) (Temp >> 8);
				DataSend.Data[3]	= (u8) (Temp >> 0);
				Temp				= DcModuleManage_B.SetVolt;
				DataSend.Data[4]	= (u8) (Temp >> 24);
				DataSend.Data[5]	= (u8) (Temp >> 16);
				DataSend.Data[6]	= (u8) (Temp >> 8);
				DataSend.Data[7]	= (u8) (Temp >> 0);

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}

				DcModuleManage_B.Cmd = 0x55;		//开机
				DataSend.Id 		= 0x1307C080 + addr;
				DataSend.Len		= 8;
				DataSend.Data[0]	= 0x02;
				DataSend.Data[1]	= 0x00;
				DataSend.Data[2]	= 0x00;
				DataSend.Data[3]	= 0x00;
				DataSend.Data[4]	= 0x00;
				DataSend.Data[5]	= 0x00;
				DataSend.Data[6]	= 0x00;
				DataSend.Data[7]	= DcModuleManage_B.Cmd;

				//放入队列
				if (pdTRUE != xQueueSend(DcModeMsg, &DataSend, 0))
				{
					//osDelay(10);
				}
			}
		}

	}
	else 
	{


	}
}


