

/******************************************************************************
ļ	: Drv_RunLedIncre.c
	: Ӣģ
	:
޸	: 2015-04-02  	

******************************************************************************/
#include "Drv_DcModule.h"
#include "Drv_MCP2515.h"
#include "Memory.h"
#include "Drv_SmartAllocation.h"
#include "Drv_BoardIo.h"


StructDcModuleAbility DcModuleAbility =
{
	.MaxVolt			= DcModuleMaxVolt, 
	.MinVolt			= DcModuleMinVolt, 
	.MaxCurrt			= DcModuleMaxCurrt, 
	.MinCurrt			= DcModuleMinCurrt, 
	.SingleMaxCurrt 	= DcModuleSinMaxCurrt, 
};


StructDcModuleManage DcModuleManage;
StructDcModuleManage DcModuleManage_B;
StructDcModuleManage DcModuleManage_All;

StructDcModuleStatus DcModuleStatus_ALL[64];

StructDcModuleCtrl DcModuleCtrl;
StructDcModuleCtrl DcModuleCtrl_B;
StructDcModuleCtrl DcModuleCtrl_ALL;

void DcModeleRelayInit(void);


void DcModuleRxIrqHandle(void)
{
	CanRxMsg		RxMsg;
	u8				IrSta = 0;
	StructDcModuleStatus Data;
	u8				RecvFlag;
	Union1939Id 	Id1939 =
	{
		.Mult				= 0, 
	};
	UnionYouExtId	CommId =
	{
		.Mult				= 0, 
	};

	IrSta				= MCP2515_ReadStatus();

	if (IrSta & 0x01)
	{
		RecvFlag			= MCP2515_Receive(0, &RxMsg);
		MCP2515_BitModify(CANINTF, 0x01, 0x00);
		Id1939.Mult 		= RxMsg.ExtId;
		CommId.Mult 		= RxMsg.ExtId;

		if (TRUE == RecvFlag)
		{
			if ((CAN_ID_EXT == RxMsg.IDE) && (CAN_RTR_DATA == RxMsg.RTR))
			{

				if ((0x1207C080 == (RxMsg.ExtId & 0xFFFFFFC0)) && (0x01 == RxMsg.Data[0])) //ģ״̬ظ
				{
					Data.Id 			= RxMsg.ExtId & 0x0000003F;
					DcModuleManage_All.OnlineFlag |= ((long long) 1 << Data.Id);
					Data.Currt			= ((u32) RxMsg.Data[2] << 8) +RxMsg.Data[3];
					Data.Volt			= ((u32) RxMsg.Data[4] << 8) +RxMsg.Data[5];
					Data.State			= ((u32) RxMsg.Data[6] << 8) +RxMsg.Data[7];
					Data.RecvTime		= GetSystemTick();
					DcModuleStatus_ALL[Data.Id] = Data;
				}

			}
		}
	}
	else if (IrSta & 0x02)
	{
		RecvFlag			= MCP2515_Receive(1, &RxMsg);
		MCP2515_BitModify(CANINTF, 0x02, 0x00);
		Id1939.Mult 		= RxMsg.ExtId;
		CommId.Mult 		= RxMsg.ExtId;

		if (TRUE == RecvFlag)
		{
			if ((CAN_ID_EXT == RxMsg.IDE) && (CAN_RTR_DATA == RxMsg.RTR))
			{

				if ((0x1207C080 == (RxMsg.ExtId & 0xFFFFFFC0)) && (0x01 == RxMsg.Data[0])) //ģ״̬ظ
				{
					Data.Id 			= RxMsg.ExtId & 0x0000003F;
					DcModuleManage_All.OnlineFlag |= ((long long) 1 << Data.Id);
					Data.Currt			= ((u32) RxMsg.Data[2] << 8) +RxMsg.Data[3];
					Data.Volt			= ((u32) RxMsg.Data[4] << 8) +RxMsg.Data[5];
					Data.State			= ((u32) RxMsg.Data[6] << 8) +RxMsg.Data[7];
					Data.RecvTime		= GetSystemTick();
					DcModuleStatus_ALL[Data.Id] = Data;
				}

			}
		}
	}
}


/*125K*/
void DcModuleCanInit(void)
{
	MCP2515_EnterCritical();

	MCP2515_SetInt(DcModuleRxIrqHandle, DISABLE);

	MCP2515_SpiInit();								//ʼMCUSPI

	MCP2515_Reset();								// MCP2515 ǰλ

	//ʹλ޸ָMCP2515Ϊģʽ
	//ҲǽCANCTRLĴREQOP[2:0]Ϊ100
	MCP2515_BitModify(CANCTRL, 0xE0, (1 << REQOP2));

	/*
	//㲢MCP2515λʱ

	// ʱƵʣFosc	= 16MHz
	// Ƶ CNF1.BRP[5:0] = 7
	// Сʱݶ TQ = 2 * ( BRP + 1 ) / Fosc	= 2*(7+1)/16M = 1uS
	// ͬ Sync Seg	= 1TQ
	//  Prop Seg	= ( PRSEG + 1 ) * TQ  = 1 TQ
	// λ Phase Seg1 = ( PHSEG1 + 1 ) * TQ = 3 TQ
	// λ Phase Seg2 = ( PHSEG2 + 1 ) * TQ = 3 TQ
	// ͬתΪ CNF1.SJW[1:0] = 00,  1TQ
	// ߲ NBR = Fbit =  1/(sync seg + Prop seg + PS1 + PS2 )
	//						 = 1/(8TQ) = 1/8uS = 125kHz

	//÷ƵCNF1.BRP[5:0] = 7ͬתΪ CNF1.SJW[1:0] = 00
	MCP2515_WriteReg( CNF1, (1<<BRP0)|(1<<BRP1)|(1<<BRP2) );
	// ô Prop Seg Ϊ001TQλ Phase Seg1ĳ3TQ
	MCP2515_WriteReg( CNF2, (1<<BTLMODE)|(1<<PHSEG11) );
	//  λ Phase Seg2Ϊ 3TQ  û˲
	MCP2515_WriteReg( CNF3, (1<<PHSEG21) );

	*/
	MCP2515_WriteReg(CNF1, (1 << BRP0) | (1 << BRP1) | (1 << BRP2)); //125K

	// ô Prop Seg Ϊ001TQλ Phase Seg1ĳ3TQ
	MCP2515_WriteReg(CNF2, (1 << BTLMODE) | (1 << PHSEG11));

	//  λ Phase Seg2Ϊ 3TQ  û˲
	MCP2515_WriteReg(CNF3, (1 << PHSEG21));

	// MCP2515жʹܼĴ,ʹܽջж
	MCP2515_WriteReg(CANINTE, (1 << RX1IE) | (1 << RX0IE));

	//ݽؼĴ
	// RXM[1:0]=11,رսջ0/˲ܣбģֹ湦
	//MCP2515_WriteReg(RXB0CTRL, (1<<RXM1)|(1<<RXM0));
	MCP2515_WriteReg(RXB0CTRL, (1 << RXM1) | (1 << RXM0) | (1 << BUKT));

	// RXM[1:0]=11,رսջ1/˲ܣбģ
	MCP2515_WriteReg(RXB1CTRL, (1 << RXM1) | (1 << RXM0));
	u8				Temp[4] =
	{
		0, 0, 0, 0
	};

	//6˲ĴΪ0
	MCP2515_WriteBuffer(RXF0SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXF1SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXF2SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXF3SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXF4SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXF5SIDH, Temp, 4);

	//2˲ĴΪ0
	MCP2515_WriteBuffer(RXM0SIDH, Temp, 4);
	MCP2515_WriteBuffer(RXM1SIDH, Temp, 4);

	//
	//ýſƼĴǽõڶ
	MCP2515_WriteReg(BFPCTRL, 0);

	//ʹãBFPCTRLʹRX0BF,RX1BFΪ
	//MCP2515_BitModify( BFPCTRL, (1<<B1BFE)|(1<<B0BFE)|(1<<B1BFM)|(1<<B0BFM), (1<<B1BFE)|(1<<B0BFE) );
	//÷ſƼĴǽõڶ
	MCP2515_WriteReg(TXRTSCTRL, 0);

	//MCP2515뻷ģʽйܲ
	//MCP2515_BitModify(CANCTRL, 0XE0, (1<<REQOP1));
	//MCP2515ģʽ
	MCP2515_BitModify(CANCTRL, 0xE0, 0);

	MCP2515_SetInt(DcModuleRxIrqHandle, ENABLE);

	MCP2515_ExitCritical();

	MCP2515_SpiHightSpeedInit();
}


/**************************************************************************************************
** : CAN1_SendMessage
** 䡡: ulCanId----ID ulCanDataA----ݵĵ4ֽڣ  ulCanDataB----ݵĸ4ք17
	1717
** 䡡: ȡ״̬
** 	: ͨCANͨ
** ա: 2010/08/19
**************************************************************************************************/
u8 DcModuleSendMsg(StructDcModuleSend * pMsg)
{
	CanTxMsg		TxMsg;

	TxMsg.ExtId 		= pMsg->Id;
	TxMsg.IDE			= CAN_ID_EXT;
	TxMsg.RTR			= CAN_RTR_DATA;
	TxMsg.DLC			= pMsg->Len;
	TxMsg.Data[0]		= pMsg->Data[0];
	TxMsg.Data[1]		= pMsg->Data[1];
	TxMsg.Data[2]		= pMsg->Data[2];
	TxMsg.Data[3]		= pMsg->Data[3];
	TxMsg.Data[4]		= pMsg->Data[4];
	TxMsg.Data[5]		= pMsg->Data[5];
	TxMsg.Data[6]		= pMsg->Data[6];
	TxMsg.Data[7]		= pMsg->Data[7];

	if (CAN_TxStatus_NoMailBox != MCP2515_Transmit(&TxMsg))
		return TRUE;

	return FALSE; //δͳɹFALSE
}



void DcModuleSet(EnumSwitchStatus Set, u16 Volt, u16 Currt)
{
	if (Currt > DcModuleAbility.SingleMaxCurrt)
		Currt = DcModuleAbility.SingleMaxCurrt;

	if (eSwSta_Off == Set)
	{
		DcModuleCtrl.CtrlFlag = 0;
		DcModuleCtrl.NeedVolt = Volt;
		DcModuleCtrl.NeedCurrt = Currt;

		if(DcModuleGroup[0].status == Hold_A)
		{
			DcModuleGroup[0].status = Valid;
			DcModuleManage.ValidNum -= DcModuleGroup[0].ValidNum;
		}
	}
	else 
	{
		DcModuleCtrl.CtrlFlag = 1;
		DcModuleCtrl.NeedVolt = Volt;
		DcModuleCtrl.NeedCurrt = Currt;

		if(DcModuleGroup[0].status == Hold_B)
		{
			DcModuleGroup[0].status = Hold_A;
			DcModuleManage_B.ValidNum -= DcModuleGroup[0].ValidNum;
		}
		else if(DcModuleGroup[0].status == Valid)
		{
			DcModuleGroup[0].status = Hold_A;
			DcModuleManage.ValidNum += DcModuleGroup[0].ValidNum;
		}
	}
}


u16 GetDcModuleVolt(void)
{
	return (u16) ((u32) DcModuleCtrl.ActualVolt * UserParam.VoltRatio / 1000);
}


u16 GetDcModuleCurrt(void)
{
	return (u16) ((u32) DcModuleCtrl.ActualCurrt * UserParam.CurrtRatio / 1000);
}


u16 GetDcModuleVoltSet(void)
{
	return DcModuleCtrl.NeedVolt;
}


u16 GetDcModuleCurrtSet(void)
{
	return DcModuleCtrl.NeedCurrt;
}


osMessageQId	DcModeMsg = 0;
extern void DcModuleManageProcess_SmartAllocation(void);
extern void DcModuleCtrlProcess_SmartAllocation(void);

/* the system main thread */
void DcModule(void const * parameter)
{
	osDelay(6000);
	DcModeleRelayInit();
	DcModuleCanInit();

	DcModuleAbility.MaxVolt = UserParam.DcMaxVolt;
	DcModuleAbility.MinVolt = UserParam.DcMinVolt;
	DcModuleAbility.MaxCurrt = UserParam.DcMaxCurrt;
	DcModuleAbility.MinCurrt = UserParam.DcMinCurrt;
	DcModuleAbility.SingleMaxCurrt = UserParam.SingleMaxCurrt;

	DcModeMsg			= NULL;
	osMessageQDef(DcModeMsg, 64, StructDcModuleSend);
	DcModeMsg			= osMessageCreate(osMessageQ(DcModeMsg), NULL);

	while (1)
	{



		StructDcModuleSend DataSend;

		if (pdTRUE == xQueueReceive(DcModeMsg, &DataSend, 0))
		{
			DcModuleSendMsg(&DataSend);
		}

		DcModuleManageProcess_SmartAllocation();

		osDelay(15);
		DcModuleCtrlProcess_SmartAllocation();
		osDelay(15);
	}
}


u8 DcModuleInit(void)
{

	osThreadDef(DcModule, DcModule, osPriorityAboveNormal, 0, configMINIMAL_STACK_SIZE);

	if (NULL == osThreadCreate(osThread(DcModule), NULL))
		return FALSE;

	return TRUE;
}


void DcModuleSet_B(EnumSwitchStatus Set, u16 Volt, u16 Currt)
{
	if (Currt > DcModuleAbility.SingleMaxCurrt)
		Currt = DcModuleAbility.SingleMaxCurrt;

	if (eSwSta_Off == Set)
	{
		DcModuleCtrl_B.CtrlFlag = 0;
		DcModuleCtrl_B.NeedVolt = Volt;
		DcModuleCtrl_B.NeedCurrt = Currt;

		if(DcModuleGroup[2].status == Hold_B)
		{
			DcModuleGroup[2].status = Valid;
			DcModuleManage_B.ValidNum -= DcModuleGroup[2].ValidNum;
		}
	}
	else 
	{
		DcModuleCtrl_B.CtrlFlag = 1;
		DcModuleCtrl_B.NeedVolt = Volt;
		DcModuleCtrl_B.NeedCurrt = Currt;
		if(DcModuleGroup[2].status == Hold_A)
		{
			DcModuleGroup[2].status = Hold_B;
			DcModuleManage.ValidNum -= DcModuleGroup[2].ValidNum;
		}
		else if(DcModuleGroup[2].status == Valid)
		{
			DcModuleGroup[2].status = Hold_B;
			DcModuleManage_B.ValidNum += DcModuleGroup[2].ValidNum;
		}
	}
}


u16 GetDcModuleVolt_B(void)
{
	//return DcModuleCtrl_B.ActualVolt;
	return (u16) ((u32) DcModuleCtrl_B.ActualVolt * UserParam.VoltRatio / 1000);
}


u16 GetDcModuleCurrt_B(void)
{
	//return DcModuleCtrl_B.ActualCurrt;
	return (u16) ((u32) DcModuleCtrl_B.ActualCurrt * UserParam.CurrtRatio / 1000);
}


u16 GetDcModuleVoltSet_B(void)
{
	//return DcModuleManage_B.SetVolt/100;
	return DcModuleCtrl_B.NeedVolt;
}


u16 GetDcModuleCurrtSet_B(void)
{
	//return DcModuleManage_B.SetVolt*DcModuleManage_B.ValidNum/100;
	return DcModuleCtrl_B.NeedCurrt;
}


void DcModuleSet_AB(EnumSwitchStatus Set, u16 Volt, u16 Currt)
{
	if (eSwSta_Off == Set)
	{
		DcModuleCtrl.NeedVolt = DcModuleAbility.MinVolt;
		DcModuleCtrl.NeedCurrt = DcModuleAbility.MinCurrt * DcModuleManage.ValidNum;
		DcModuleCtrl_B.NeedVolt = DcModuleAbility.MinVolt;
		DcModuleCtrl_B.NeedCurrt = DcModuleAbility.MinCurrt * DcModuleManage_B.ValidNum;

		DcModuleCtrl.CtrlFlag = 0;
		DcModuleCtrl_B.CtrlFlag = 0;

	}
	else 
	{
		if (ChargeEnable_AB == 0) //ǹ
		{
			if (Currt > DcModuleAbility.SingleMaxCurrt)
				Currt = DcModuleAbility.SingleMaxCurrt;
		}

		if (0 == DcModuleManage_B.ValidNum)
		{
			if (0 == DcModuleManage.ValidNum)
			{
				DcModuleCtrl.NeedVolt = DcModuleAbility.MinVolt;
				DcModuleCtrl.NeedCurrt = DcModuleAbility.MinCurrt * DcModuleManage.ValidNum;
				DcModuleCtrl.CtrlFlag = 0;
			}
			else 
			{
				DcModuleCtrl.NeedVolt = Volt;
				DcModuleCtrl.NeedCurrt = Currt; 	//* (DcModuleManage.ValidNum / (DcModuleManage.ValidNum + DcModuleManage_B.ValidNum));
				DcModuleCtrl.CtrlFlag = 1;
			}

			DcModuleCtrl_B.NeedVolt = DcModuleAbility.MinVolt;
			DcModuleCtrl_B.NeedCurrt = DcModuleAbility.MinCurrt * DcModuleManage_B.ValidNum;
			DcModuleCtrl_B.CtrlFlag = 0;
		}
		else if (0 == DcModuleManage.ValidNum)
		{
			DcModuleCtrl_B.NeedVolt = Volt;
			DcModuleCtrl_B.NeedCurrt = Currt;
			DcModuleCtrl_B.CtrlFlag = 1;

			DcModuleCtrl.NeedVolt = DcModuleAbility.MinVolt;
			DcModuleCtrl.NeedCurrt = DcModuleAbility.MinCurrt * DcModuleManage.ValidNum;
			DcModuleCtrl.CtrlFlag = 0;
		}
		else 
		{
			DcModuleCtrl.NeedVolt = Volt;
			DcModuleCtrl_B.NeedVolt = Volt;
			DcModuleCtrl.NeedCurrt =
				 (u16) (Currt * ((float) (DcModuleManage.ValidNum) / (DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)));
			DcModuleCtrl_B.NeedCurrt =
				 (u16) (Currt * ((float) (DcModuleManage_B.ValidNum) / (DcModuleManage.ValidNum + DcModuleManage_B.ValidNum)));
			DcModuleCtrl.CtrlFlag = 1;
			DcModuleCtrl_B.CtrlFlag = 1;
		}
	}

	if (ChargeEnable_AB == 1) //˫ǹ
	{
		if (DcModuleCtrl.NeedCurrt > DcModuleAbility.SingleMaxCurrt)
			DcModuleCtrl.NeedCurrt = DcModuleAbility.SingleMaxCurrt;

		if (DcModuleCtrl_B.NeedCurrt > DcModuleAbility.SingleMaxCurrt)
			DcModuleCtrl_B.NeedCurrt = DcModuleAbility.SingleMaxCurrt;
	}

}


u16 GetDcModuleVolt_AB(void)
{
	if (0 == DcModuleCtrl.CtrlFlag)
		return GetDcModuleVolt_B();

	if (0 == DcModuleCtrl_B.CtrlFlag)
		return GetDcModuleVolt();

	return (GetDcModuleVolt() +GetDcModuleVolt_B()) / 2;
}


u16 GetDcModuleCurrt_AB(void)
{
	return (GetDcModuleCurrt() +GetDcModuleCurrt_B());
}


u16 GetDcModuleVoltSet_AB(void)
{
	//return DcModuleManage.SetVolt/100;
	return (DcModuleCtrl.NeedVolt + DcModuleCtrl_B.NeedVolt) / 2;
}


u16 GetDcModuleCurrtSet_AB(void)
{
	//return DcModuleManage.SetVolt*DcModuleManage.ValidNum/100;
	return (DcModuleCtrl.NeedCurrt + DcModuleCtrl_B.NeedCurrt);
}

void DcModeleRelayInit()
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_AHB1PeriphClockCmd(RELAY_K1K2_RCC, ENABLE);
	RCC_AHB1PeriphClockCmd(RELAY_K3K4_RCC, ENABLE);
	RCC_AHB1PeriphClockCmd(RELAY_K5K6_RCC, ENABLE);
	RCC_AHB1PeriphClockCmd(RELAY_K7K8_RCC, ENABLE);
	RCC_AHB1PeriphClockCmd(RELAY_K9K10_RCC, ENABLE);

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_InitStructure.GPIO_Pin = Fan_Pin;
	GPIO_Init(RELAY_K1K2_Port, &GPIO_InitStructure);
	GPIO_ResetBits(RELAY_K1K2_Port,RELAY_K1K2_Pin);
	GPIO_Init(RELAY_K3K4_Port, &GPIO_InitStructure);
	GPIO_ResetBits(RELAY_K3K4_Port,RELAY_K3K4_Pin);
	GPIO_Init(RELAY_K5K6_Port, &GPIO_InitStructure);
	GPIO_ResetBits(RELAY_K5K6_Port,RELAY_K5K6_Pin);
	GPIO_Init(RELAY_K7K8_Port, &GPIO_InitStructure);
	GPIO_ResetBits(RELAY_K7K8_Port,RELAY_K7K8_Pin);
	GPIO_Init(RELAY_K9K10_Port, &GPIO_InitStructure);
	GPIO_ResetBits(RELAY_K9K10_Port,RELAY_K9K10_Pin);
}

