

#include "Thd_Charge.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"


void ChgProChgConfigure(StructChargeCtrl *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRM_SendTick = 0;
  u8  CrmRecog;
  u32 CcStatusChkTick = 0;

  BemMsg.Valid = 0;
  BcpMsg.Valid = 0;
  BmsCanInit();
  osDelay(20);

  ChargeTimerSet(eSwSta_Off);
  BmsPowerSet(eSwSta_On);
  LockSet(eSwSta_On);
  FanSet(eSwSta_On);
  ImdWorkSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  DcOutSet(eSwSta_Off);
  DcModuleSet(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage.ValidNum);

  CrmRecog = 0xAA;
  CRM_Send(CrmRecog);
  CRM_SendTick = GetSystemTick();
  BcpMsg.RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRM_SendTick) > 250)
    {
      CRM_Send(CrmRecog);
      CRM_SendTick = GetSystemTick();
    }

    ChgPgnRecv(&PgnRecv);

    if((GetSystemTick() - BcpMsg.RecvTick) > MsgTimeout_5S)
    {
      CemMsg.Cem.Value.Bcp = 1;
      pChargeCtrl->CurProcess = eChgPro_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg.Cem.Value.Bcp = 0;

    if(0 != BcpMsg.Valid)
    {//յBrm
///////////////////////////////////////////////////////////////////////////////////////
/*      if(BcpMsg.StartSoc > 980)
      {
        ChargeStopType = eChgStop_Conf_StartSoc98;
        pChargeCtrl->CurProcess = eChgPro_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else */
      if(BcpMsg.StartVolt > BcpMsg.ChgMaxVolt)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_BatVoltOverPermitMax;
        pChargeCtrl->CurProcess = eChgPro_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(BcpMsg.StartVolt > DcModuleAbility.MaxVolt)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_StartVoltOverPillarMax;
        pChargeCtrl->CurProcess = eChgPro_ChgStop;
        pChargeCtrl->Param = 0;
      }
      else if(DcModuleAbility.MinVolt > BcpMsg.ChgMaxVolt)
      {
        CstMsg.StopReason.Value.Truble = 1;
        CstMsg.StopTruble.Value.Other = 1;
        CstMsg.StopFault.Value.Volt = 1;
        ChargeStopType = eChgStop_Conf_ChgMaxVoltLessPillarMinVolt;
        pChargeCtrl->CurProcess = eChgPro_ChgStop;
        pChargeCtrl->Param = 0;
      }
//////////////////////////////////////////////////////////////////////////////////////
      else
      {
        pChargeCtrl->CurProcess = eChgPro_WaitBmsReady;
        pChargeCtrl->Param = 0;
      }
    }

    if(0 != BemMsg.Valid)
    {
      pChargeCtrl->CurProcess = eChgPro_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd.TCUChargeEnable)
    {//ⲿƽ
      ChargeStopType = eChgStop_Conf_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick * 2))
    {
      CcStatusChkTick = 0;
      ChargeStopType = eChgStop_Conf_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Emergency)
    {
      ChargeStopType = eChgStop_Conf_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Door)
    {
      ChargeStopType = eChgStop_Conf_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Contactor)
    {
      ChargeStopType = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.UniContactor)
    {
      ChargeStopType = eChgStop_Conf_Contactor;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.InVolt)
    {
      ChargeStopType = eChgStop_Conf_InVolt;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.NoDcmod)
    {
      ChargeStopType = eChgStop_Conf_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError.Value.Meter)
    {
      ChargeStopType = eChgStop_Conf_Meter;
      pChargeCtrl->CurProcess = eChgPro_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_ChgConfigure != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}

