

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"


void ChgProChgStart_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRO_SendTick = 0;
  u8  CroStarus = 0x00;
  u32 CcStatusChkTick = 0;

  BemMsg_B.Valid = 0;
  BclMsg_B.Valid = 0;
  BcsMsg_B.Valid = 0;
  BstMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
    DcOutSet_B(eSwSta_On);
  else
    DcOutSet_B(eSwSta_Off);

  CroStarus = 0xAA;
  CRO_Send_B(CroStarus);
  CRO_SendTick = GetSystemTick();

  BclMsg_B.RecvTick = GetSystemTick();
  BcsMsg_B.RecvTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRO_SendTick) > 250)
    {
      CRO_Send_B(CroStarus);
      CRO_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
    {
      if((GetSystemTick() - BclMsg_B.RecvTick) > MsgTimeout_B_1S)
      {
        CemMsg_B.Cem.Value.Bcl = 1;
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
        pChargeCtrl->Param = 0;
      }

      if((GetSystemTick() - BcsMsg_B.RecvTick) > MsgTimeout_B_5S)
      {
        CemMsg_B.Cem.Value.Bcs = 1;
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
        pChargeCtrl->Param = 0;
      }
    }
    else
    {
      if((GetSystemTick() - BclMsg_B.RecvTick) > (MsgTimeout_B_5S*4))
      {
        CemMsg_B.Cem.Value.Bcl = 1;
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
        pChargeCtrl->Param = 0;
      }

      if((GetSystemTick() - BcsMsg_B.RecvTick) > (MsgTimeout_B_5S*4))
      {
        CemMsg_B.Cem.Value.Bcs = 1;
        DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
        pChargeCtrl->Param = 0;
      }
    }

    if((0 != BclMsg_B.Valid) && (0 != BcsMsg_B.Valid))
    {//յBrm
      pChargeCtrl->CurProcess = eChgPro_B_ChgRun;
      //pChargeCtrl->CurProcess = eChgPro_B_WaitVoltChgRun;
      pChargeCtrl->Param = 0;
    }

    if(0 != BemMsg_B.Valid)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 != BstMsg_B.Valid)
    {
      CstMsg_B.StopReason.Value.BmsStop = 1;
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_Start_BmsStop;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      CstMsg_B.StopReason.Value.Manual = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_Start_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B))
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.ChgGun = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_Start_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Emergency = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      CstMsg_B.StopReason.Value.Truble = 1;
      CstMsg_B.StopTruble.Value.Other = 1;
      CST_Send_B(&CstMsg_B);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      DcOutSet_B(eSwSta_Off);
      ChargeStopType_B = eChgStop_Start_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_ChgStart != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}



