

#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Drv_ImdJyc.h"
#include "Memory.h"

/**************************************************************************************************
** : GetBatVoltWaitPillarReady
** 䡡: 
** 䡡: ֱڵǰѹ
**   : ȡֱѹ
**************************************************************************************************/
s32 GetBatVoltWaitPillarReady_B(void)
{
  if((ImdValue_B.Vaild))
    return ImdValue_B.PnVolt;

  return BcpMsg_B.StartVolt;
}

s32 IsBatPnCorrect_B(void)
{
  if(0 == ImdValue_B.Vaild)
    return 0;
  if((0 == ImdValue_B.PositVolt) && (0 == ImdValue_B.NegatVolt) && (0 == ImdValue_B.PnVolt))
    return -1;
  return 1;
}

void ChgProWaitPillarReady_B(StructChargeCtrl_B *pChargeCtrl)
{
  StructPgnRecv PgnRecv;
  u32 CRO_SendTick = 0;
  u8  CroStarus = 0x00;
  u32 CcStatusChkTick = 0;
  u32 VoltReadyTick = 0;

  BemMsg_B.Valid = 0;
  BmsCanInit_B();
  osDelay(20);

  ChargeTimerSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_Off);

  CroStarus = 0x00;
  CRO_Send_B(CroStarus);
  CRO_SendTick = GetSystemTick();

  if((BcpMsg_B.StartVolt >= DcModuleAbility.MinVolt) && (BcpMsg_B.StartVolt <= DcModuleAbility.MaxVolt))
    DcModuleSet_B(eSwSta_On, BcpMsg_B.StartVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
  else if(BcpMsg_B.StartVolt < DcModuleAbility.MinVolt)
    DcModuleSet_B(eSwSta_On, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
  else
  {
    CstMsg_B.StopReason.Value.Truble = 1;
    CstMsg_B.StopTruble.Value.Other = 1;
    CstMsg_B.StopFault.Value.Volt = 1;
    DcOutSet_B(eSwSta_Off);
    DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
    ChargeStopType_B = eChgStop_PillarReady_BatVoltOverPillarMax;
    pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
    pChargeCtrl->Param = 0;
    return;
  }
  VoltReadyTick = GetSystemTick();

  while(1)
  {
    if((GetSystemTick() - CRO_SendTick) > 250)
    {
      CRO_Send_B(CroStarus);
      CRO_SendTick = GetSystemTick();
    }

    ChgPgnRecv_B(&PgnRecv);

    if((eChgVer_2011 != UserParam.ChgVer) && (eChgVer_2011 != ChgVer_B))
    {
      if((0 != VoltReadyTick) && ((GetSystemTick() - VoltReadyTick) > (MsgTimeout_B_5S/2)))
      {
        if(-1 == IsBatPnCorrect_B())
        {
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CstMsg_B.StopFault.Value.Volt = 1;
          DcOutSet_B(eSwSta_Off);
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          ChargeStopType_B = eChgStop_PillarReady_BatVoltError;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
        }

        else if((eChgVer_2011 != UserParam.ChgVer)
                && ((abs(GetBatVoltWaitPillarReady_B() - BcpMsg_B.StartVolt)) > (BcpMsg_B.StartVolt*5/100)))
        {
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CstMsg_B.StopFault.Value.Volt = 1;
          DcOutSet_B(eSwSta_Off);
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          ChargeStopType_B = eChgStop_PillarReady_BatVoltMismatchBcpVolt;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
        }

        else if(abs(GetDcModuleVolt_B()- GetBatVoltWaitPillarReady_B()) <= 100)
        {
          VoltReadyTick = 0;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStart;
          pChargeCtrl->Param = 0;
        }
        else
        {
          if((GetBatVoltWaitPillarReady_B() >= DcModuleAbility.MinVolt) && (GetBatVoltWaitPillarReady_B() <= DcModuleAbility.MaxVolt))
            DcModuleSet_B(eSwSta_On, GetBatVoltWaitPillarReady_B(), DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          else if(GetBatVoltWaitPillarReady_B() < DcModuleAbility.MinVolt)
            DcModuleSet_B(eSwSta_On, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        }
      }
      if((0 != VoltReadyTick) && ((GetSystemTick() - VoltReadyTick) > (MsgTimeout_B_60S)))
      {
        /*VoltReadyTick = 0;
        pChargeCtrl->CurProcess = eChgPro_ChgStart;
        pChargeCtrl->Param = 0;*/
          CstMsg_B.StopReason.Value.Truble = 1;
          CstMsg_B.StopTruble.Value.Other = 1;
          CstMsg_B.StopFault.Value.Volt = 1;
          DcOutSet_B(eSwSta_Off);
          DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
          ChargeStopType_B= eChgStop_Conf_ChgMaxVoltLessPillarMinVolt;
          pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
          pChargeCtrl->Param = 0;
      }
    }

   /* else if(eChgVer_2011 != ChgVer_B)
    {
      if((0 != VoltReadyTick) && ((GetSystemTick() - VoltReadyTick) > (MsgTimeout_B_10S)))
      {
        VoltReadyTick = 0;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStart;
        pChargeCtrl->Param = 0;
      }
      else if(abs(GetDcModuleVolt_B()- GetBatVoltWaitPillarReady_B()) <= 100)
      {
        VoltReadyTick = 0;
        pChargeCtrl->CurProcess = eChgPro_B_ChgStart;
        pChargeCtrl->Param = 0;
      }
      else
      {
        if((GetBatVoltWaitPillarReady_B() >= DcModuleAbility.MinVolt) && (GetBatVoltWaitPillarReady_B() <= DcModuleAbility.MaxVolt))
          DcModuleSet_B(eSwSta_On, GetBatVoltWaitPillarReady_B(), DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
        else if(GetBatVoltWaitPillarReady_B() < DcModuleAbility.MinVolt)
          DcModuleSet_B(eSwSta_On, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      }
    }*/

    else
    {
      VoltReadyTick = 0;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStart;
      pChargeCtrl->Param = 0;
    }


    if((GetSystemTick() - BroMsg_B.RecvTick) > MsgTimeout_B_5S)
    {
      CemMsg_B.Cem.Value.Bro = 1;
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }
    else
      CemMsg_B.Cem.Value.Bro = 0;

    if(0 != BemMsg_B.Valid)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      pChargeCtrl->CurProcess = eChgPro_B_CommBreak;
      pChargeCtrl->Param = 0;
    }

    if(0 == TCUCurChgRecd_B.TCUChargeEnable)
    {//ⲿƽ
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_UserCancel;
      pChargeCtrl->CurProcess = eChgPro_B_ChgStop;
      pChargeCtrl->Param = 0;
    }

    if(eSwSta_On != CcStatusRead_B())
    {
      if(0 == CcStatusChkTick)
        CcStatusChkTick = GetSystemTick();
    }
    else
      CcStatusChkTick = 0;
    if((0 != CcStatusChkTick) && ((GetSystemTick() - CcStatusChkTick) > CC_CheckTick_B * 2))
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      CcStatusChkTick = 0;
      ChargeStopType_B = eChgStop_PillarReady_CcOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Emergency)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_EmerClose;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Door)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_DoorOpen;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Contactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.UniContactor)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_Contactor;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.InVolt)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_InVolt;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.NoDcmod)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_NoDcmod;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(0 != PillarError_B.Value.Meter)
    {
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      ChargeStopType_B = eChgStop_PillarReady_Meter;
      pChargeCtrl->CurProcess = eChgPro_B_ChgBreak;
      pChargeCtrl->Param = 0;
    }
    if(eChgPro_B_WaitPillarReady != pChargeCtrl->CurProcess)
      return;
    osDelay(25);
  }
}



