
#include "Thd_Lcd.h"

#define ScrnChargeStop_B  ((u16)15)
#define BtnChargeStop_B_Enter      ((u16)0x0015)
#define BtnChargeStop_B_Cancel        ((u16)0x0016)
#define VarChargeStop_B_Position       ((u16)0x003C)

void ChargeStopPaint_B(void)
{
  LcdShowData16(VarChargeStop_B_Position, 2);
  LcdShowPage(ScrnChargeStop_B);
}

typedef struct
{
  u32 RePainTick;
}StructChargeStopUpdate;

void ChargeStopUpdate_B(void)
{

}

#define TimeOutTime   (30*1000)

void LcdProChargeStop_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  u32 TimeOutTick;

  ChargePauseFlag_B = 1;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  ChargeStopPaint_B();

  TimeOutTick = GetSystemTick();


  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeStop_B != Temp)
              LcdShowPage(ScrnChargeStop_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeStop_B_Enter:
             //   if(CurChgRecd_B.CardValidFlag != 0)
                {
                  ChargeEnable_B = 0;
                  pLcdCtrl->CurScreen = eLcdPro_B_SwipeCard;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnChargeStop_B_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnChargeStop_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_B_ChargeStop != pLcdCtrl->CurScreen)
    {
      ChargePauseFlag_B = 0;
      return;
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    ChargeStopUpdate_B();

    osDelay(100);
  }
}





