
#include "Thd_Lcd.h"

#define ScrnChargeSummary_B  ((u16)109)
#define BtnChargeSummary_B_Cancel      ((u16)0x1114)
#define BtnChargeSummary_B_Infor        ((u16)0x1113)

#define VarChargeSummary_B_TotalMoney     ((u16)0x0039)
#define DataChargeSummary_B_Volt               ((u16)0x0038)
#define DataChargeSummary_B_Currt              ((u16)0x0037)
#define DataChargeSummary_B_Soc                ((u16)0x0036)
#define TextChargeSummary_B_ChgStatus             ((u16)0x41C0)
#define AnimChargeSummary_B_Charge             ((u16)0x001C)

#define BtnChargeSummary_B_Start_A        ((u16)0x0101)

#define BtnElock_A_Off      ((u16)0x1115)
#define Elock_Key_Show      ((u16)0x003D)


void ChargeSummaryPaint_B(void)
{
  char Str[64];
  u16 TempU16;

  LcdShowData16(VarChargeSummary_B_TotalMoney, CurChgRecd_B.TotalMoney);
  TempU16 = BcsMsg_B.CurSoc;
  LcdShowData16(DataChargeSummary_B_Soc, TempU16);
  if(TRUE == UniChgEnable)
  {
    TempU16 = GetDcModuleVolt_AB();
    LcdShowData16(DataChargeSummary_B_Volt, TempU16);
    TempU16 = GetDcModuleCurrt_AB();
    LcdShowData16(DataChargeSummary_B_Currt, TempU16);
  }
  else
  {
    TempU16 = GetDcModuleVolt_B();
    LcdShowData16(DataChargeSummary_B_Volt, TempU16);
    TempU16 = GetDcModuleCurrt_B();
    LcdShowData16(DataChargeSummary_B_Currt, TempU16);
  }

  if((eChgPro_B_ChgIdle == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_ChgStop == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_ChgBreak == ChargeCtrl_B.CurProcess)
      || (eChgPro_B_CommError == ChargeCtrl_B.CurProcess))
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(AnimChargeSummary_B_Charge, TempU16);
  if(eChgPro_B_ChgIdle == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹͣ");
  else if (eChgPro_B_ChgStop == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "");
  else if(eChgPro_B_ChgBreak == ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else if(eChgPro_B_CommError== ChargeCtrl_B.CurProcess)
    snprintf(Str, sizeof(Str), "ֹ");
  else
    snprintf(Str, sizeof(Str), "ڳ");
  LcdShowStr(TextChargeSummary_B_ChgStatus, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnChargeSummary_B);
}

typedef struct
{
  u32 RePainTick;
}StructChargeSummaryUpdate;

void ChargeSummaryUpdate_B(StructChargeSummaryUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    ChargeSummaryPaint_B();
  }
}

static u32 UnconnectTick_B;
#define UnconnectTime   (3500)//20S   //ⲻCC/CP Ͽֹͣ 
extern u32 ChgEnergyCheckValue_B;
extern u32 EnergyCheckTick_B;

extern void EnergyCheckpPer30S_B(void);

void LcdProChargeSummary_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 SummaryChkTick;
  u32 Temp;
  StructChargeSummaryUpdate Update;


  StructTime Time;
  u32 TimeSynTick;
  u32 TempRecdTick;
  u8 Cmd[1],i,j;

  //TempChgRecdSaveToLog(&CurChgRecd_B, 2, 1);
  //TempRecdTick = GetSystemTick();

  SummaryChkTick = GetSystemTick();

  ChargeSummaryPaint_B();
  Update.RePainTick = GetSystemTick();

  TimeSynTick = GetSystemTick();
  ChgEnergyCheckValue_B = CurChgRecd_B.ChgEnergy;
  EnergyCheckTick_B = GetSystemTick();
  LcdGetRtc();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnChargeSummary_B != Temp)
              LcdShowPage(ScrnChargeSummary_B);
          }
          else if(eLcdRegAddr_Rtc == Frame.Ctrl.RdReg.Addr)
          {
            Time.Year = 2000 + BcdToHex(Frame.Ctrl.RdReg.Data[0]);          //  
            Time.Mon = BcdToHex(Frame.Ctrl.RdReg.Data[1] & 0x1F);      //  
            Time.Day = BcdToHex(Frame.Ctrl.RdReg.Data[2] & 0x3F);      //  
                    //Frame.Ctrl.RdReg.Data[3]
            Time.Hour = BcdToHex(Frame.Ctrl.RdReg.Data[4] & 0x3F);      //  Сʱ
            Time.Min = BcdToHex(Frame.Ctrl.RdReg.Data[5] & 0x7F);      //  
            Time.Sec = BcdToHex(Frame.Ctrl.RdReg.Data[6] &0x7F);      //  

            RtcSetTime(GetExtOrLcdStamp(&Time));
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnChargeSummary_B_Cancel:
                pLcdCtrl->CurScreen = eLcdPro_B_SwipeCard;
                //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeSummary_B_Infor:
                pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
                pLcdCtrl->Param = 0;
                break;
              case BtnChargeSummary_B_Start_A:
                if(
                    (0 != PillarError.Value.Emergency)
                    || (0 != PillarError.Value.NoDcmod)
                    || (0 != PillarError.Value.Insulation)
                    || (0 != PillarError.Value.ImdDev)// && (eChgVer_2011 != UserParam.ChgVer))
                    || (0 != PillarError.Value.DrainResist)
                    || (0 != PillarError.Value.Reader)
                    || (0 != PillarError.Value.Meter)
                    || (0 != PillarError.Value.ACMeter)
                    || (0 != PillarError.Value.Memory)
                    || (0 != PillarError.Value.Lcd)
                    || (0 != PillarError.Value.Contactor)
                    || (0 != PillarError.Value.UniContactor)
                    || (0 != PillarError.Value.Door)
                    || (0 != PillarError.Value.SPD)
                    || (0 != PillarError.Value.InVolt)
                    || (0 != PillarError.Value.OutVolt)
                    || (0 != PillarError.Value.OutCurrt)
                    || (0 != PillarError.Value.EleLock)
                    || (0 != PillarError.Value.Humiture)
                    || (UserParam.HadSigned && (0 != PillarError.Value.Net))
                    || (0 == UserParam.ChgFun.Value.Num_A)
                  )
                {
                  pLcdCtrl->CurScreen = eLcdPro_PillarError;
                  pLcdCtrl->Param = 0;
                }
                else
                {
                  pLcdCtrl->CurScreen = eLcdPro_GetCard;
                  //pLcdCtrl->CurScreen = eLcdPro_CnctDetect;
                  pLcdCtrl->Param = 0;
                }
                break;
              case BtnElock_A_Off:
                if(LockGet()!=eSwSta_Off)
                {
                  Cmd[0]=0x06;
                  LcdWriteReg(0x4F, Cmd, sizeof(Cmd));
                  for(i=0;i<8;i++)
                  {
                    LockSet(eSwSta_On);
                    osDelay(500);
                    LockSet(eSwSta_Off);
                    osDelay(500);
                    for(j=0;j<10;j++)
                    {
                      if(LockGet()!=eSwSta_Off) break;
                      osDelay(10);
                    }
                    if(j>=10) break;
                    osDelay(1000);
                  }
                  CloseKeyBoard();
                }
                break;

              default:
                LcdShowPage(ScrnChargeSummary_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

  	if((eSwSta_On != CcStatusRead_B())&&( ChargeStopType_B!= eChgStop_None))
  //  if(0)
    {
      if(0 == UnconnectTick_B)
        UnconnectTick_B = GetSystemTick();
    }
    else
      UnconnectTick_B = 0;
    if((0 != UnconnectTick_B) && (GetSystemTick() - UnconnectTick_B) > UnconnectTime)
    {
      CurChgRecd_B.ChgStopType = 4;//ǹֹͣ  "׮CC/CPźŶϿֱ׮CC1ȷ϶Ͽ"  4

      //pLcdCtrl->CurScreen = eLcdPro_B_PutBack;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_PutBack);
      pLcdCtrl->Param = 0;
    }

    //if((1 == CurChgRecd_B.CardValidFlag) && (CurChgRecd_B.TotalMoney >= CurChgRecd_B.CardRespMoney))
    if(CurChgRecd_B.TotalMoney >= (CurChgRecd_B.CardRespMoney - UserParam.BalanceMoney))
    {
      ChargeEnable_B = 0;
      CurChgRecd_B.ChgStopType = 5;//ֹͣ  ôﵽ˻ֹͣ  5
    }

    if(eLcdPro_B_ChargeSummary != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - SummaryChkTick) >= CheckSreenTime)
    {
      SummaryChkTick = GetSystemTick();
      LcdGetPage();
    }

    if((GetSystemTick() - TimeSynTick) >= RtcSynTime)
    {
      TimeSynTick = GetSystemTick();
      LcdGetRtc();
    }
     if((BcsMsg_B.CurSoc >= UserParam.SOCMAX)&&(BclMsg_B.Valid ==1))
     {
      ChargeEnable_B= 0;
      CurChgRecd_B.ChgStopType = 3;//ﵽsoc趨ֵ
     }
    if((GetSystemTick() - TempRecdTick) > 60*1000)
    {
      TempChgRecdSaveToLog(&CurChgRecd_B, 2, 1);
      TempRecdTick = GetSystemTick();
    }
    EnergyCheckpPer30S_B();
    ChargeSummaryUpdate_B(&Update);

    LcdShowData16(Elock_Key_Show, !LockGet());

    osDelay(100);
  }
}





