
#include "Thd_Lcd.h"

#define ScrnCommuInfor_B  ((u16)20)
#define BtnCommuInfor_B_Cancel      ((u16)0x2001)
#define BtnCommuInfor_B_Next        ((u16)0x000B)
#define BtnCommuInfor_B_Last        ((u16)0x000A)

#define DataCommuInfor_B_BSE_E             ((u16)0x41E0)
#define DataCommuInfor_B_BST               ((u16)0x41F0)
#define DataCommuInfor_B_CST               ((u16)0x4200)
#define DataCommuInfor_B_BEM               ((u16)0x4210)
#define DataCommuInfor_B_CEM               ((u16)0x4220)
#define DataCommuInfor_B_PillError         ((u16)0x4230)

#define VarCommuInfor_B_Position                 ((u16)0x003C)


void CommuInforPaint_B(void)
{
  char Str[64];

  LcdShowData16(VarCommuInfor_B_Position, 2);

  if(BsmMsg_B.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %02X ", BsmMsg_B.BatSta.Mult,BsmMsg_B.ChgSta.Mult);
    LcdShowStr(DataCommuInfor_B_BSE_E, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_B_BSE_E, (u8*)Str, (strlen(Str)+1));
  }

  if(BstMsg_B.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", BstMsg_B.StopReason.Mult,BstMsg_B.StopTruble.Mult,BstMsg_B.StopFault.Mult);
    LcdShowStr(DataCommuInfor_B_BST, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_B_BST, (u8*)Str, (strlen(Str)+1));
  }

  //if(CstMsg_B.Valid)
  {
    snprintf(Str, sizeof(Str), "%02X %04X %02X", CstMsg_B.StopReason.Mult,CstMsg_B.StopTruble.Mult,CstMsg_B.StopFault.Mult);
    LcdShowStr(DataCommuInfor_B_CST, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_B_CST, (u8*)Str, (strlen(Str)+1));
  //}

  if(BemMsg_B.Valid)
  {
    snprintf(Str, sizeof(Str), "%08X ", BemMsg_B.Bem.Mult);
    LcdShowStr(DataCommuInfor_B_BEM, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), " ");
    LcdShowStr(DataCommuInfor_B_BEM, (u8*)Str, (strlen(Str)+1));
  }

  //if(CemMsg_B.Cem.Mult)
  {
    snprintf(Str, sizeof(Str), "%08X ", CemMsg_B.Cem.Mult);
    LcdShowStr(DataCommuInfor_B_CEM, (u8*)Str, (strlen(Str)+1));
  }
  //else
  //{
  //  snprintf(Str, sizeof(Str), " ");
  //  LcdShowStr(DataCommuInfor_B_CEM, (u8*)Str, (strlen(Str)+1));
  //}

  snprintf(Str, sizeof(Str), "%08X ", PillarError_B.Mult);
  LcdShowStr(DataCommuInfor_B_PillError, (u8*)Str, (strlen(Str)+1));

  LcdShowPage(ScrnCommuInfor_B);
}

typedef struct
{
  u32 RePainTick;
}StructCommuInforUpdate_B;

void CommuInforUpdate_B(StructCommuInforUpdate_B *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    CommuInforPaint_B();
  }
}

#define TimeOutTime   (30*1000)

void LcdProCommuInfor_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructCommuInforUpdate_B Update;
  u32 TimeOutTick;
  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  CommuInforPaint_B();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();
  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnCommuInfor_B != Temp)
              LcdShowPage(ScrnCommuInfor_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnCommuInfor_B_Cancel:
                //pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              case BtnCommuInfor_B_Next:
                //pLcdCtrl->CurScreen = eLcdPro_B_BmsInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_BmsInfor);
                pLcdCtrl->Param = 0;
              case BtnCommuInfor_B_Last:
                //pLcdCtrl->CurScreen = eLcdPro_B_BmsInfor;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_BmsInfor);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnCommuInfor_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_B_CommuInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      //pLcdCtrl->CurScreen = eLcdPro_B_ChargeScreen;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_B_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    CommuInforUpdate_B(&Update);

    osDelay(100);
  }
}


