
#include "Thd_Lcd.h"

#define ScrnElectLock_B             ((u16)119)//((u16)18)
#define BtnElectLock_B_Cancel       ((u16)0x1192)//((u16)0x1801)
#define BtnElectLock_B_Enter        ((u16)0x1191)

#define BtnElectLock_B_LockOn       ((u16)0x1802)
#define BtnElectLock_B_LockOff      ((u16)0x1803)

#define VarElectLock_B_Position     ((u16)0x003C)

void ElectLockPaint_B(void)
{
  LcdShowData16(VarElectLock_B_Position, 2);
  LcdShowPage(ScrnElectLock_B);
}

void ElectLockIdle_B(void)
{

}

#define TimeOutTime   (60*1000)

void LcdProElectLock_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  TimeOutTick = GetSystemTick();
  ElectLockPaint_B();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnElectLock_B_Cancel:  //A ǹ"" 
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
                pLcdCtrl->Param = 0;
                break;

              case BtnElectLock_B_Enter:  //A ǹ"" 
                pLcdCtrl->CurScreen = eLcdPro_B_CnctDetect;
                break;
              default:
                LcdShowPage(ScrnElectLock_B);
                break;
            }
          }
          else
            LcdShowPage(ScrnElectLock_B);
          break;

        default:
          break;
      }
    }


    if(eLcdPro_B_ElectLock != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      LockSet_B(eSwSta_Off);
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

   /* if(eSwSta_Off == LockGet_B())
    {
      LockSet_B(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    if(eSwSta_Off == CcStatusRead_B())
    {
      LockSet_B(eSwSta_Off);
      //pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }
*/
    ElectLockIdle_B();

    osDelay(100);
  }
}

