
#include "Thd_Lcd.h"

#define ScrnFactoryChgInfor_B  ((u16)45)
#define BtnFactoryChgInfor_B_Stop      ((u16)0x4501)
#define BtnFactoryChgInfor_B_Next        ((u16)0x000B)
#define BtnFactoryChgInfor_B_Last        ((u16)0x000A)

#define DataFactoryChgInfor_B_ChgVolt               ((u16)0x0021)
#define DataFactoryChgInfor_B_ChgCurrt              ((u16)0x0022)

#define DataFactoryChgInfor_B_PosReg               ((u16)0x0180)
#define DataFactoryChgInfor_B_NegReg              ((u16)0x0181)

#define VarFactoryChgInfor_B_Position           ((u16)0x003C)

void FactoryChgInforPaint_B(void)
{
LcdShowData16(VarFactoryChgInfor_B_Position, 2);

  LcdShowData16(DataFactoryChgInfor_B_ChgVolt, GetDcModuleVolt_B());
  LcdShowData16(DataFactoryChgInfor_B_ChgCurrt, GetDcModuleCurrt_B());

  if(ImdValue_B.Vaild)
  {
    LcdShowData16(DataFactoryChgInfor_B_PosReg, ImdValue_B.PositResist);
    LcdShowData16(DataFactoryChgInfor_B_NegReg, ImdValue_B.NegatResist);
  }

  LcdShowPage(ScrnFactoryChgInfor_B);
}

typedef struct
{
  u32 RePainTick;
}StructFactoryChgInforUpdate;

void FactoryChgInforUpdate_B(StructFactoryChgInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    FactoryChgInforPaint_B();
  }
}

void LcdProFactoryChgInfor_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructFactoryChgInforUpdate Update;

  IdleLedSet_B(eSwSta_Off);
  ChgLedSet_B(eSwSta_On);

  BmsPowerSet_B(eSwSta_On);
  LockSet_B(eSwSta_On);
  FanSet_B(eSwSta_On);
  ImdWorkSet_B(eSwSta_On);
  DrainResistSet_B(eSwSta_Off);
  DcOutSet_B(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  FactoryChgInforPaint_B();
  Update.RePainTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryChgInfor_B != Temp)
              LcdShowPage(ScrnFactoryChgInfor_B);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryChgInfor_B_Stop:
                pLcdCtrl->CurScreen = eLcdPro_B_FactoryChgSet;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnFactoryChgInfor_B);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_B_FactoryChgInfor != pLcdCtrl->CurScreen)
    {
      ChgLedSet_B(eSwSta_Off);

      IdleLedSet_B(eSwSta_On);

      BmsPowerSet_B(eSwSta_Off);
      LockSet_B(eSwSta_Off);
      FanSet_B(eSwSta_Off);
      ImdWorkSet_B(eSwSta_Off);
      DrainResistSet_B(eSwSta_Off);
      DcOutSet_B(eSwSta_Off);
      DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
      return;
    }

    FactoryChgInforUpdate_B(&Update);

    osDelay(100);
  }
}






