
#include "Thd_Lcd.h"

#define ScrnFactoryChgSet_B            ((u16)44)
#define BtnFactoryChgSet_B_Start       ((u16)0x4401)

#define BtnFactoryChgSet_B_Next        ((u16)0x000B)
#define BtnFactoryChgSet_B_Last        ((u16)0x000A)

#define VarFactoryChgSet_B_SetVolt     ((u16)0x0027)
#define VarFactoryChgSet_B_SetCurrt    ((u16)0x002B)
#define VarFactoryChgSet_B_ChgVolt     ((u16)0x0021)
#define VarFactoryChgSet_B_ChgCurrt    ((u16)0x0022)

#define VarFactoryChgSet_B_Position           ((u16)0x003C)


void FactoryChgSetPaint_B(void)
{
  LcdShowData16(VarFactoryChgSet_B_Position, 2);

  LcdShowData16(VarFactoryChgSet_B_SetVolt, DcModuleAbility.MinVolt);
  LcdShowData16(VarFactoryChgSet_B_SetCurrt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);
  LcdShowData16(VarFactoryChgSet_B_ChgVolt, 0);
  LcdShowData16(VarFactoryChgSet_B_ChgCurrt, 0);

  LcdShowPage(ScrnFactoryChgSet_B);
}

void FactoryChgSetIdle_B(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProFactoryChgSet_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 NeedVolt;
  u16 NeedCurrt;

//  ChgLedSet(eSwSta_Off);
//  IdleLedSet(eSwSta_Off);

  BmsPowerSet_B(eSwSta_Off);
  LockSet_B(eSwSta_Off);
  FanSet_B(eSwSta_Off);
  ImdWorkSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_On);
  DcOutSet_B(eSwSta_Off);
  DcModuleSet_B(eSwSta_Off, DcModuleAbility.MinVolt, DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum);

  NeedVolt = DcModuleAbility.MinVolt;
  NeedCurrt = DcModuleAbility.MinCurrt*DcModuleManage_B.ValidNum;

  TimeOutTick = GetSystemTick();

  FactoryChgSetPaint_B();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnFactoryChgSet_B_Start:
                TimeOutTick = GetSystemTick();
                DrainResistSet_B(eSwSta_Off);
                ImdWorkSet_B(eSwSta_On);
                osDelay(200);
                DcModuleSet_B(eSwSta_On, NeedVolt, NeedCurrt);
                LcdShowData16(VarFactoryChgSet_B_SetVolt, NeedVolt);
                LcdShowData16(VarFactoryChgSet_B_SetCurrt, NeedCurrt);
                pLcdCtrl->CurScreen = eLcdPro_B_FactoryChgInfor;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryChgSet_B_Next:
                TimeOutTick = GetSystemTick();
				DrainResistSet_B(eSwSta_Off);
                pLcdCtrl->CurScreen = eLcdPro_FactoryDcModSet;
                pLcdCtrl->Param = 0;
                break;

              case BtnFactoryChgSet_B_Last:
                TimeOutTick = GetSystemTick();
				DrainResistSet_B(eSwSta_Off);
                pLcdCtrl->CurScreen = eLcdPro_B_FactoryTestTwo;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnFactoryChgSet_B);
				DrainResistSet_B(eSwSta_Off);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnFactoryChgSet_B);
            if(VarFactoryChgSet_B_SetVolt == Temp)
              NeedVolt = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarFactoryChgSet_B_SetCurrt == Temp)
              NeedCurrt = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_B_FactoryChgSet != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      DrainResistSet_B(eSwSta_Off);
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    FactoryChgSetIdle_B();

    osDelay(100);
  }
}


