
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryTest_B  ((u16)58)
#define BtnFactoryTest_B_Cancel        ((u16)0x5801)

#define BtnFactoryTest_B_Next        ((u16)0x000B)
#define BtnFactoryTest_B_Last        ((u16)0x000A)

#define BtnFactoryTestAddr_B_ChgLed  ((u16)0x0139)
#define BtnFactoryTestValue_B_ChgLedOff ((u16)0x0000)
#define BtnFactoryTest_B_ChgLedOff      ((u32)BtnFactoryTestAddr_B_ChgLed*65536+BtnFactoryTestValue_B_ChgLedOff)
#define BtnFactoryTestValue_B_ChgLedOn  ((u16)0x0001)
#define BtnFactoryTest_B_ChgLedOn       ((u32)BtnFactoryTestAddr_B_ChgLed*65536+BtnFactoryTestValue_B_ChgLedOn)

#define BtnFactoryTestAddr_B_FaultLed  ((u16)0x013A)
#define BtnFactoryTestValue_B_FaultLedOff ((u16)0x0000)
#define BtnFactoryTest_B_FaultLedOff      ((u32)BtnFactoryTestAddr_B_FaultLed*65536+BtnFactoryTestValue_B_FaultLedOff)
#define BtnFactoryTestValue_B_FaultLedOn  ((u16)0x0001)
#define BtnFactoryTest_B_FaultLedOn       ((u32)BtnFactoryTestAddr_B_FaultLed*65536+BtnFactoryTestValue_B_FaultLedOn)

#define BtnFactoryTestAddr_B_Fan  ((u16)0x013B)
#define BtnFactoryTestValue_B_FanOff ((u16)0x0000)
#define BtnFactoryTest_B_FanOff      ((u32)BtnFactoryTestAddr_B_Fan*65536+BtnFactoryTestValue_B_FanOff)
#define BtnFactoryTestValue_B_FanOn  ((u16)0x0001)
#define BtnFactoryTest_B_FanOn       ((u32)BtnFactoryTestAddr_B_Fan*65536+BtnFactoryTestValue_B_FanOn)

#define BtnFactoryTestAddr_B_DrainResist  ((u16)0x013C)
#define BtnFactoryTestValue_B_DrainResistOff ((u16)0x0000)
#define BtnFactoryTest_B_DrainResistOff      ((u32)BtnFactoryTestAddr_B_DrainResist*65536+BtnFactoryTestValue_B_DrainResistOff)
#define BtnFactoryTestValue_B_DrainResistOn  ((u16)0x0001)
#define BtnFactoryTest_B_DrainResistOn       ((u32)BtnFactoryTestAddr_B_DrainResist*65536+BtnFactoryTestValue_B_DrainResistOn)

#define BtnFactoryTestAddr_B_DcOut  ((u16)0x013D)
#define BtnFactoryTestValue_B_DcOutOff ((u16)0x0000)
#define BtnFactoryTest_B_DcOutOff      ((u32)BtnFactoryTestAddr_B_DcOut*65536+BtnFactoryTestValue_B_DcOutOff)
#define BtnFactoryTestValue_B_DcOutOn  ((u16)0x0001)
#define BtnFactoryTest_B_DcOutOn       ((u32)BtnFactoryTestAddr_B_DcOut*65536+BtnFactoryTestValue_B_DcOutOn)

#define BtnFactoryTestAddr_B_BmsPower  ((u16)0x013E)
#define BtnFactoryTestValue_B_BmsPowerOff ((u16)0x0000)
#define BtnFactoryTest_B_BmsPowerOff      ((u32)BtnFactoryTestAddr_B_BmsPower*65536+BtnFactoryTestValue_B_BmsPowerOff)
#define BtnFactoryTestValue_B_BmsPowerOn  ((u16)0x0001)
#define BtnFactoryTest_B_BmsPowerOn       ((u32)BtnFactoryTestAddr_B_BmsPower*65536+BtnFactoryTestValue_B_BmsPowerOn)

#define BtnFactoryTestAddr_B_eLock  ((u16)0x013F)
#define BtnFactoryTestValue_B_eLockOff ((u16)0x0000)
#define BtnFactoryTest_B_eLockOff      ((u32)BtnFactoryTestAddr_B_eLock*65536+BtnFactoryTestValue_B_eLockOff)
#define BtnFactoryTestValue_B_eLockOn  ((u16)0x0001)
#define BtnFactoryTest_B_eLockOn       ((u32)BtnFactoryTestAddr_B_eLock*65536+BtnFactoryTestValue_B_eLockOn)

#define IconFactoryTestAddr_B_Emergency  ((u16)0x0140)
#define IconFactoryTestAddr_B_DcOutSta   ((u16)0x0141)
#define IconFactoryTestAddr_B_MeterSta   ((u16)0x0142)
#define IconFactoryTestAddr_B_ImdSta     ((u16)0x0143)
#define IconFactoryTestAddr_B_SpdSta     ((u16)0x0144)
#define DataFactoryTestAddr_B_DcModNum   ((u16)0x0145)
#define IconFactoryTestAddr_B_ConnectSta ((u16)0x0146)

void FactoryTestPaint_B(void)
{
  //char Buff[32];
  u16 TempU16;

  LcdShowData16(BtnFactoryTestAddr_B_ChgLed, 0);
  LcdShowData16(BtnFactoryTestAddr_B_FaultLed, 0);
  LcdShowData16(BtnFactoryTestAddr_B_Fan, 0);
  LcdShowData16(BtnFactoryTestAddr_B_DrainResist, 0);
  LcdShowData16(BtnFactoryTestAddr_B_DcOut, 0);
  LcdShowData16(BtnFactoryTestAddr_B_BmsPower, 0);
  LcdShowData16(BtnFactoryTestAddr_B_eLock, 0);

  if(PillarError_B.Value.Emergency)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_B_Emergency, TempU16);

  if(eSwSta_On == DcOutPosGet_B())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_B_DcOutSta, TempU16);

  if(eMeterSta_Unavail == MeterComm.Status_B)
    TempU16 = 0;
  else
    TempU16 = 1;
  LcdShowData16(IconFactoryTestAddr_B_MeterSta, TempU16);

  LcdShowData16(DataFactoryTestAddr_B_DcModNum, DcModuleManage_B.ValidNum);

  if(eSwSta_On == CcStatusRead_B())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_B_ConnectSta, TempU16);

  LcdShowPage(ScrnFactoryTest_B);
}

typedef struct
{
  u32 RePaintTick;
}StructFactoryTestUpdate;

void FactoryTestUpdate_B(StructFactoryTestUpdate *pUpdate)
{
  u16 TempU16;

  if((GetSystemTick() - pUpdate->RePaintTick) >= 1000)
  {
    pUpdate->RePaintTick = GetSystemTick();
    if(PillarError_B.Value.Emergency)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_B_Emergency, TempU16);

    if(eSwSta_On == DcOutPosGet_B())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_B_DcOutSta, TempU16);

    if(PillarError_B.Value.Meter)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_B_MeterSta, TempU16);

    if(PillarError_B.Value.ImdDev)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_B_ImdSta, TempU16);

    if(PillarError_B.Value.SPD)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_B_SpdSta, TempU16);

    LcdShowData16(DataFactoryTestAddr_B_DcModNum, DcModuleManage_B.ValidNum);

    if(eSwSta_On == CcStatusRead_B())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_B_ConnectSta, TempU16);
  }
}

void LcdProFactoryTest_B(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 KeyValue;
  StructFactoryTestUpdate Update;

  FaultLedSet_B(eSwSta_Off);
  //DcOutSet(eSwSta_Off);
  DcOutPosSet_B(eSwSta_Off);
  BmsPowerSet_B(eSwSta_Off);
  FanSetExt_Top(eSwSta_Off);
  ChgLedSet_B(eSwSta_Off);
  IdleLedSet_B(eSwSta_Off);
  DrainResistSet_B(eSwSta_Off);

  ScreenChkTick = GetSystemTick();
  Update.RePaintTick = GetSystemTick();
  FactoryTestPaint_B();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryTest_B != KeyValue)
              LcdShowPage(ScrnFactoryTest_B);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryTest_B_Cancel:
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTest_B_Next:
              pLcdCtrl->CurScreen = eLcdPro_B_FactoryTestTwo;
              pLcdCtrl->Param = 0;
              break;
            case BtnFactoryTest_B_Last:
              pLcdCtrl->CurScreen = eLcdPro_FactoryChgSet;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTest_B_FaultLedOff:
              FaultLedSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_FaultLedOn:
              FaultLedSet_B(eSwSta_On);
              break;
            case BtnFactoryTest_B_DcOutOff:
              DcOutPosSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_DcOutOn:
              DcOutPosSet_B(eSwSta_On);
              break;
            case BtnFactoryTest_B_BmsPowerOff:
              BmsPowerSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_BmsPowerOn:
              BmsPowerSet_B(eSwSta_On);
              break;
            case BtnFactoryTest_B_FanOff:
              FanSetExt_Top(eSwSta_Off);
              break;
            case BtnFactoryTest_B_FanOn:
              FanSetExt_Top(eSwSta_On);
              break;
            case BtnFactoryTest_B_ChgLedOff:
              ChgLedSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_ChgLedOn:
              ChgLedSet_B(eSwSta_On);
              break;
            case BtnFactoryTest_B_DrainResistOff:
              DrainResistSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_DrainResistOn:
              DrainResistSet_B(eSwSta_On);
              break;
            case BtnFactoryTest_B_eLockOff:
              LockSet_B(eSwSta_Off);
              break;
            case BtnFactoryTest_B_eLockOn:
              LockSet_B(eSwSta_On);
              break;

            default:
              LcdShowPage(ScrnFactoryTest_B);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_B_FactoryTest != pLcdCtrl->CurScreen)
    {
      FaultLedSet_B(eSwSta_Off);
      DcOutPosSet_B(eSwSta_Off);
      BmsPowerSet_B(eSwSta_Off);
      FanSetExt_Top(eSwSta_Off);
      ChgLedSet_B(eSwSta_Off);
      IdleLedSet(eSwSta_Off);
      DrainResistSet_B(eSwSta_Off);
      return;
    }

    FactoryTestUpdate_B(&Update);

    osDelay(100);
  }
}


