
#include "Thd_Lcd.h"

#define ScrnBmsInfor  ((u16)16)
#define BtnBmsInfor_Cancel      ((u16)0x1601)
#define BtnBmsInfor_Commu      ((u16)0x1602)
#define BtnBmsInfor_Next        ((u16)0x000B)
#define BtnBmsInfor_Last        ((u16)0x000A)

#define DataBmsInfor_MaxtVolt               ((u16)0x0025)
#define DataBmsInfor_MaxCurrt               ((u16)0x0026)
#define DataBmsInfor_NeedVolt               ((u16)0x0027)
#define DataBmsInfor_CurSoc                 ((u16)0x0028)
#define DataBmsInfor_MaxTemp                ((u16)0x0029)
#define DataBmsInfor_BatEnergy              ((u16)0x002A)
#define DataBmsInfor_NeedCurrt              ((u16)0x002B)
#define DataBmsInfor_BatTemp                ((u16)0x002C)

#define DataBmsInfor_PerBatVoltHi           ((u16)0x0034)
#define DataBmsInfor_PerBatVoltLo           ((u16)0x0035)
#define DataBmsInfor_PerBatPerVoltHi        ((u16)0x0165)
#define DataBmsInfor_BatType                ((u16)0x4000)

#define VarBmsInfor_Position                 ((u16)0x003C)
void BmsInforPaint(void)
{
  char Str[64];
  LcdShowStr((u16)0x00E1, (u8*)"¶ȣ", (strlen("¶ȣ")+1));
  LcdShowData16((u16)0x0053, Dht12_GetTemp()/100);
  LcdShowStr((u16)0x00E9, (u8*)"", (strlen("")+1));
  LcdShowData16((u16)0x0051, Adc_Get_a_PTemp());
  LcdShowStr((u16)0x00F4, (u8*)"", (strlen("")+1));
  LcdShowData16((u16)0x0052, Adc_Get_a_NTemp());
  LcdShowData16(VarBmsInfor_Position, UserParam.ChgFun.Value.Num_B);

  if(BcpMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_MaxtVolt, BcpMsg.ChgMaxVolt);
    LcdShowData16(DataBmsInfor_MaxCurrt, (s16)(4000 - BcpMsg.ChgMaxCurrt));
    LcdShowData16(DataBmsInfor_MaxTemp, (s16)BcpMsg.MaxTemp - 50);
    LcdShowData16(DataBmsInfor_BatEnergy, BcpMsg.BatEnergy);
    LcdShowData16(DataBmsInfor_PerBatPerVoltHi,BcpMsg.PerBatMaxVolt);
  }
  else
  {
    LcdShowData16(DataBmsInfor_MaxtVolt, 0);
    LcdShowData16(DataBmsInfor_MaxCurrt, 0);
    LcdShowData16(DataBmsInfor_MaxTemp, 0);
    LcdShowData16(DataBmsInfor_BatEnergy, 0);
    LcdShowData16(DataBmsInfor_PerBatPerVoltHi,0);
  }

  if(BclMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_NeedVolt, BclMsg.NeedVolt);
    LcdShowData16(DataBmsInfor_NeedCurrt, (s16)(4000 - BclMsg.NeedCurrt));
  }
  else
  {
    LcdShowData16(DataBmsInfor_NeedVolt, 0);
    LcdShowData16(DataBmsInfor_NeedCurrt, 0);
  }

  if(BcsMsg.Valid)
    LcdShowData16(DataBmsInfor_CurSoc, BcsMsg.CurSoc);
  else
    LcdShowData16(DataBmsInfor_CurSoc, 0);

  if(BsmMsg.Valid)
    LcdShowData16(DataBmsInfor_BatTemp, (s16)BsmMsg.HighTemp - 50);
  else
    LcdShowData16(DataBmsInfor_BatTemp, 0);

  if(BsdMsg.Valid)
  {
    LcdShowData16(DataBmsInfor_PerBatVoltLo, BsdMsg.PerMinVolt);
    LcdShowData16(DataBmsInfor_PerBatVoltHi, BsdMsg.PerMaxVolt);
  }
  else
  {
    LcdShowData16(DataBmsInfor_PerBatVoltLo, 0);
    if(BcsMsg.Valid)
      LcdShowData16(DataBmsInfor_PerBatVoltHi, BcsMsg.BatVoltAndGroup.Value.Volt);
  }

  if(eChgPro_CommError== ChargeCtrl.CurProcess)
  {
    snprintf(Str, sizeof(Str), "%08X %06X %08X %06X", CommErrFrame[0], CommErrFrame[1], CommErrFrame[2], CommErrFrame[3]);
    LcdShowStr(DataBmsInfor_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else if(BrmMsg.Valid)
  {
    switch(BrmMsg.BatType)
    {
      case 0x01:
        snprintf(Str, sizeof(Str), "Ǧ");
        break;
      case 0x02:
        snprintf(Str, sizeof(Str), "");
        break;
      case 0x03:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x04:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x05:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0x06:
        snprintf(Str, sizeof(Str), "Ԫϵ");
        break;
      case 0x07:
        snprintf(Str, sizeof(Str), "ۺӵ");
        break;
      case 0x08:
        snprintf(Str, sizeof(Str), "﮵");
        break;
      case 0xFF:
        snprintf(Str, sizeof(Str), "");
        break;
      default:
        snprintf(Str, sizeof(Str), "δ֪");
        break;
    }
    LcdShowStr(DataBmsInfor_BatType, (u8*)Str, (strlen(Str)+1));
  }
  else
  {
    snprintf(Str, sizeof(Str), "ͨѶ");
    LcdShowStr(DataBmsInfor_BatType, (u8*)Str, (strlen(Str)+1));
  }

  LcdShowPage(ScrnBmsInfor);
}

typedef struct
{
  u32 RePainTick;
}StructBmsInforUpdate;

void BmsInforUpdate(StructBmsInforUpdate *pUpdate)
{
  if((GetSystemTick() - pUpdate->RePainTick) >= 1590)
  {
    pUpdate->RePainTick = GetSystemTick();

    BmsInforPaint();
  }
}

#define TimeOutTime   (30*1000)

void LcdProBmsInfor(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 Temp;
  StructBmsInforUpdate Update;
  u32 TimeOutTick;

  //IdleLedSet(eSwSta_Off);
  //ChgLedSet(eSwSta_On);

  ScreenChkTick = GetSystemTick();

  BmsInforPaint();
  Update.RePainTick = GetSystemTick();

  TimeOutTick = GetSystemTick();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            Temp = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnBmsInfor != Temp)
              LcdShowPage(ScrnBmsInfor);
          }
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0] << 8;
            Temp += Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnBmsInfor_Cancel:
                //pLcdCtrl->CurScreen = eLcdPro_ChargeSummary;
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
                pLcdCtrl->Param = 0;
                break;
              case BtnBmsInfor_Next:
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_CommuInfor);
                pLcdCtrl->Param = 0;
              case BtnBmsInfor_Last:
                pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_CommuInfor);
                pLcdCtrl->Param = 0;
                break;
              default:
                LcdShowPage(ScrnBmsInfor);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_BmsInfor != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      TimeOutTick = GetSystemTick();
      //pLcdCtrl->CurScreen = eLcdPro_ChargeSummary;
      pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_ChargeSummary);
      pLcdCtrl->Param = 0;
    }

    BmsInforUpdate(&Update);

    osDelay(100);
  }
}





