
/******************************************************************************
ļ  : Lcd_ChgReserve.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"

#define PageChgReserve            ((u16)17)

#define TxtChgReserve_Tip         ((u16)0x4000)



static void ChgReservePaint(void)
{
  char Str[16]= {0};
  StructTime TimeBlock;

  StampToTime(ReserveParam.StopTime, &TimeBlock);

  snprintf(Str, sizeof(Str), "%d : %02d", TimeBlock.Hour, TimeBlock.Min);
  LcdShowStr(TxtChgReserve_Tip, (u8*)Str, strlen(Str)+1);
  LcdShowPage(PageChgReserve);
}

static void ChgReserveIdle(void)
{

}

extern StructCommuStatus CommuStatus;

#define OffLinefTime      (5*60*1000) //5

void LcdProChgReserve(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 OffLineTick;
  u32 EndTime;

  BuzzerRun(1, 800, 100);
  EndTime = ReserveParam.StopTime;
  ReserveParam.ReserveNoteCtrl = 0;
  OffLineTick = GetSystemTick();
  ChgReservePaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              default:
                LcdShowPage(PageChgReserve);
                break;
            }
          }
          else
            LcdShowPage(PageChgReserve);
          break;

        default:
          break;
      }
    }

    if(eLcdPro_ChgReserve != pLcdCtrl->CurScreen)
    {
      memset(&ReserveParam, 0, sizeof(ReserveParam));
      return;
    }

    if(0 == CommuStatus.ConnectFlag)
    {
      if(0 == OffLineTick)
        OffLineTick = GetSystemTick();
    }
    else
    {
      OffLineTick = 0;
    }
    if((0 != OffLineTick) && ((GetSystemTick() - OffLineTick) >= OffLinefTime))
      ReserveParam.ValidFlag = 0;

    if((RtcGetTime() >= ReserveParam.StopTime) || (0 == ReserveParam.ValidFlag))
    {
      if(ReserveParam.ValidFlag)
        ReserveParam.ReserveNoteCtrl = 1;
      ReserveParam.ValidFlag = 0;
      if(eLcdPro_ChgReserve == pLcdCtrl->CurScreen)
//        pLcdCtrl->CurScreen = eLcdPro_MainMenu;
        pLcdCtrl->CurScreen = GetLcdProcess(eLcdPro_MainMenu);
      pLcdCtrl->Param = 0;
    }

    if(EndTime != ReserveParam.StopTime)
    {
      EndTime = ReserveParam.StopTime;
      ChgReservePaint();
    }

    ChgReserveIdle();

    osDelay(100);
  }
}







