
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryProtSet  ((u16)50)
#define BtnFactoryProtSet_Enter        ((u16)0x5001)
#define BtnFactoryProtSet_Cancel        ((u16)0x5002)
#define BtnFactoryProtSet_Function        ((u16)0x5003)

#define BtnFactoryProtSet_Next        ((u16)0x000B)
#define BtnFactoryProtSet_Last        ((u16)0x000A)

#define BtnFactoryProtSetAddr_ChgVer  ((u16)0x012C)
#define BtnFactoryProtSetValue_ChgVer2011 ((u16)0x0000)
#define BtnFactoryProtSet_ChgVer2011      ((u32)BtnFactoryProtSetAddr_ChgVer*65536+BtnFactoryProtSetValue_ChgVer2011)
#define BtnFactoryProtSetValue_ChgVer2015  ((u16)0x0001)
#define BtnFactoryProtSet_ChgVer2015       ((u32)BtnFactoryProtSetAddr_ChgVer*65536+BtnFactoryProtSetValue_ChgVer2015)

void FactoryProtSetPaint(void)
{
  u16 TempU16;

  if(eChgVer_2011 == UserParam.ChgVer)
    TempU16 = 0;
  else
    TempU16 = 1;
  LcdShowData16(BtnFactoryProtSetAddr_ChgVer, TempU16);

  LcdShowPage(ScrnFactoryProtSet);
}

#define TimeOutTime   (40*1000)

void LcdProFactoryProtSet(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 TimeOutTick;
  u32 KeyValue;
  u8 ProtocolVer;
  u32 BtnFunctionTick;
  u8  BtnFunctionCounter;

  if(eChgVer_2011 == UserParam.ChgVer)
    ProtocolVer = 0;
  else
    ProtocolVer = 1;

  TimeOutTick = GetSystemTick();
  BtnFunctionTick = GetSystemTick();
  BtnFunctionCounter = 0;

  FactoryProtSetPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryProtSet != KeyValue)
              LcdShowPage(ScrnFactoryProtSet);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryProtSet_Cancel:  //A ǹ"" 
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryProtSet_Enter:
              TimeOutTick = GetSystemTick();

              UserParam.ChgVer = ProtocolVer;

              SaveUserParam((u8*)&UserParam, sizeof(UserParam));
              UserParamInit();

              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryProtSet_Next:
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_FactoryTest;
              pLcdCtrl->Param = 0;
              break;
            case BtnFactoryProtSet_Last:
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_FactoryPillarInputSet;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryProtSet_ChgVer2011:
              TimeOutTick = GetSystemTick();
              ProtocolVer = 0;
              break;
            case BtnFactoryProtSet_ChgVer2015:
              TimeOutTick = GetSystemTick();
              ProtocolVer = 1;
              break;

            case BtnFactoryProtSet_Function:
              if((GetSystemTick() - BtnFunctionTick) >= 1000)
                BtnFunctionCounter = 0;
              else
              {
                BtnFunctionCounter++;
                if(BtnFunctionCounter > 2)
                {
                  pLcdCtrl->CurScreen = eLcdPro_FactoryFunctionSet;
                  pLcdCtrl->Param = 0;
                }
              }
              BtnFunctionTick = GetSystemTick();
              break;

            default:
              LcdShowPage(ScrnFactoryProtSet);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    if(eLcdPro_FactoryProtSet != pLcdCtrl->CurScreen)
      return;

    osDelay(100);
  }
}



