
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryTest  ((u16)31)
#define BtnFactoryTest_Cancel        ((u16)0x3101)

#define BtnFactoryTest_Next        ((u16)0x000B)
#define BtnFactoryTest_Last        ((u16)0x000A)

#define BtnFactoryTestAddr_ChgLed  ((u16)0x011E)
#define BtnFactoryTestValue_ChgLedOff ((u16)0x0000)
#define BtnFactoryTest_ChgLedOff      ((u32)BtnFactoryTestAddr_ChgLed*65536+BtnFactoryTestValue_ChgLedOff)
#define BtnFactoryTestValue_ChgLedOn  ((u16)0x0001)
#define BtnFactoryTest_ChgLedOn       ((u32)BtnFactoryTestAddr_ChgLed*65536+BtnFactoryTestValue_ChgLedOn)

#define BtnFactoryTestAddr_FaultLed  ((u16)0x011F)
#define BtnFactoryTestValue_FaultLedOff ((u16)0x0000)
#define BtnFactoryTest_FaultLedOff      ((u32)BtnFactoryTestAddr_FaultLed*65536+BtnFactoryTestValue_FaultLedOff)
#define BtnFactoryTestValue_FaultLedOn  ((u16)0x0001)
#define BtnFactoryTest_FaultLedOn       ((u32)BtnFactoryTestAddr_FaultLed*65536+BtnFactoryTestValue_FaultLedOn)

#define BtnFactoryTestAddr_Fan  ((u16)0x0120)
#define BtnFactoryTestValue_FanOff ((u16)0x0000)
#define BtnFactoryTest_FanOff      ((u32)BtnFactoryTestAddr_Fan*65536+BtnFactoryTestValue_FanOff)
#define BtnFactoryTestValue_FanOn  ((u16)0x0001)
#define BtnFactoryTest_FanOn       ((u32)BtnFactoryTestAddr_Fan*65536+BtnFactoryTestValue_FanOn)

#define BtnFactoryTestAddr_DrainResist  ((u16)0x0121)
#define BtnFactoryTestValue_DrainResistOff ((u16)0x0000)
#define BtnFactoryTest_DrainResistOff      ((u32)BtnFactoryTestAddr_DrainResist*65536+BtnFactoryTestValue_DrainResistOff)
#define BtnFactoryTestValue_DrainResistOn  ((u16)0x0001)
#define BtnFactoryTest_DrainResistOn       ((u32)BtnFactoryTestAddr_DrainResist*65536+BtnFactoryTestValue_DrainResistOn)

#define BtnFactoryTestAddr_DcOut  ((u16)0x0122)
#define BtnFactoryTestValue_DcOutOff ((u16)0x0000)
#define BtnFactoryTest_DcOutOff      ((u32)BtnFactoryTestAddr_DcOut*65536+BtnFactoryTestValue_DcOutOff)
#define BtnFactoryTestValue_DcOutOn  ((u16)0x0001)
#define BtnFactoryTest_DcOutOn       ((u32)BtnFactoryTestAddr_DcOut*65536+BtnFactoryTestValue_DcOutOn)

#define BtnFactoryTestAddr_BmsPower  ((u16)0x0123)
#define BtnFactoryTestValue_BmsPowerOff ((u16)0x0000)
#define BtnFactoryTest_BmsPowerOff      ((u32)BtnFactoryTestAddr_BmsPower*65536+BtnFactoryTestValue_BmsPowerOff)
#define BtnFactoryTestValue_BmsPowerOn  ((u16)0x0001)
#define BtnFactoryTest_BmsPowerOn       ((u32)BtnFactoryTestAddr_BmsPower*65536+BtnFactoryTestValue_BmsPowerOn)

#define BtnFactoryTestAddr_eLock  ((u16)0x0124)
#define BtnFactoryTestValue_eLockOff ((u16)0x0000)
#define BtnFactoryTest_eLockOff      ((u32)BtnFactoryTestAddr_eLock*65536+BtnFactoryTestValue_eLockOff)
#define BtnFactoryTestValue_eLockOn  ((u16)0x0001)
#define BtnFactoryTest_eLockOn       ((u32)BtnFactoryTestAddr_eLock*65536+BtnFactoryTestValue_eLockOn)

#define IconFactoryTestAddr_Emergency  ((u16)0x0125)
#define IconFactoryTestAddr_DcOutSta   ((u16)0x0126)
#define IconFactoryTestAddr_MeterSta   ((u16)0x0127)
#define IconFactoryTestAddr_ImdSta     ((u16)0x0128)
#define IconFactoryTestAddr_SpdSta     ((u16)0x0129)
#define DataFactoryTestAddr_DcModNum   ((u16)0x012A)
#define IconFactoryTestAddr_ConnectSta ((u16)0x012B)

void FactoryTestPaint(void)
{
  //char Buff[32];
  u16 TempU16;

  LcdShowData16(BtnFactoryTestAddr_ChgLed, 0);
  LcdShowData16(BtnFactoryTestAddr_FaultLed, 0);
  LcdShowData16(BtnFactoryTestAddr_Fan, 0);
  LcdShowData16(BtnFactoryTestAddr_DrainResist, 0);
  LcdShowData16(BtnFactoryTestAddr_DcOut, 0);
  LcdShowData16(BtnFactoryTestAddr_BmsPower, 0);
  LcdShowData16(BtnFactoryTestAddr_eLock, 0);

  if(PillarError.Value.Emergency)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_Emergency, TempU16);

  if(eSwSta_On == DcOutPosGet())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_DcOutSta, TempU16);

  if(eMeterSta_Unavail == MeterComm.Status)
    TempU16 = 0;
  else
    TempU16 = 1;
  LcdShowData16(IconFactoryTestAddr_MeterSta, TempU16);

  LcdShowData16(DataFactoryTestAddr_DcModNum, DcModuleManage.ValidNum);

  if(eSwSta_On == CcStatusRead())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestAddr_ConnectSta, TempU16);

  LcdShowPage(ScrnFactoryTest);
}

typedef struct
{
  u32 RePaintTick;
}StructFactoryTestUpdate;

void FactoryTestUpdate(StructFactoryTestUpdate *pUpdate)
{
  u16 TempU16;

  if((GetSystemTick() - pUpdate->RePaintTick) >= 1000)
  {
    pUpdate->RePaintTick = GetSystemTick();
    if(PillarError.Value.Emergency)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_Emergency, TempU16);

    if(eSwSta_On == DcOutPosGet())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_DcOutSta, TempU16);

    if(PillarError.Value.Meter)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_MeterSta, TempU16);

    if(PillarError.Value.ImdDev)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_ImdSta, TempU16);

    if(PillarError.Value.SPD)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestAddr_SpdSta, TempU16);

    LcdShowData16(DataFactoryTestAddr_DcModNum, DcModuleManage.ValidNum);

    if(eSwSta_On == CcStatusRead())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestAddr_ConnectSta, TempU16);
  }
}

void LcdProFactoryTest(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 KeyValue;
  StructFactoryTestUpdate Update;

  FaultLedSet(eSwSta_Off);
  //DcOutSet(eSwSta_Off);
  DcOutPosSet(eSwSta_Off);
  BmsPowerSet(eSwSta_Off);
  FanSetExt(eSwSta_Off);
  ChgLedSet(eSwSta_Off);
  IdleLedSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);

  ScreenChkTick = GetSystemTick();
  Update.RePaintTick = GetSystemTick();
  FactoryTestPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryTest != KeyValue)
              LcdShowPage(ScrnFactoryTest);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryTest_Cancel:
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTest_Next:
              pLcdCtrl->CurScreen = eLcdPro_FactoryTestTwo;
              pLcdCtrl->Param = 0;
              break;
            case BtnFactoryTest_Last:
              pLcdCtrl->CurScreen = eLcdPro_FactoryProtSet;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTest_FaultLedOff:
              FaultLedSet(eSwSta_Off);
              break;
            case BtnFactoryTest_FaultLedOn:
              FaultLedSet(eSwSta_On);
              break;
            case BtnFactoryTest_DcOutOff:
              DcOutPosSet(eSwSta_Off);
              break;
            case BtnFactoryTest_DcOutOn:
              DcOutPosSet(eSwSta_On);
              break;
            case BtnFactoryTest_BmsPowerOff:
              BmsPowerSet(eSwSta_Off);
              break;
            case BtnFactoryTest_BmsPowerOn:
              BmsPowerSet(eSwSta_On);
              break;
            case BtnFactoryTest_FanOff:
              FanSetExt(eSwSta_Off);
              break;
            case BtnFactoryTest_FanOn:
              FanSetExt(eSwSta_On);
              break;
            case BtnFactoryTest_ChgLedOff:
              ChgLedSet(eSwSta_Off);
              break;
            case BtnFactoryTest_ChgLedOn:
              ChgLedSet(eSwSta_On);
              break;
            case BtnFactoryTest_DrainResistOff:
              DrainResistSet(eSwSta_Off);
              break;
            case BtnFactoryTest_DrainResistOn:
              DrainResistSet(eSwSta_On);
              break;
            case BtnFactoryTest_eLockOff:
              LockSet(eSwSta_Off);
              break;
            case BtnFactoryTest_eLockOn:
              LockSet(eSwSta_On);
              break;

            default:
              LcdShowPage(ScrnFactoryTest);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_FactoryTest != pLcdCtrl->CurScreen)
    {
      FaultLedSet(eSwSta_Off);
      DcOutPosSet(eSwSta_Off);
      BmsPowerSet(eSwSta_Off);
      FanSetExt(eSwSta_Off);
      ChgLedSet(eSwSta_Off);
      IdleLedSet(eSwSta_Off);
      DrainResistSet(eSwSta_Off);
      return;
    }

    FactoryTestUpdate(&Update);

    osDelay(100);
  }
}


