
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnFactoryTestTwo  ((u16)56)
#define BtnFactoryTestTwo_Cancel        ((u16)0x5601)

#define BtnFactoryTestTwo_Next        ((u16)0x000B)
#define BtnFactoryTestTwo_Last        ((u16)0x000A)

#define BtnFactoryTestTwoAddr_IdeLed  ((u16)0x0131)
#define BtnFactoryTestTwoValue_IdeLedOff ((u16)0x0000)
#define BtnFactoryTestTwo_IdeLedOff      ((u32)BtnFactoryTestTwoAddr_IdeLed*65536+BtnFactoryTestTwoValue_IdeLedOff)
#define BtnFactoryTestTwoValue_IdeLedOn  ((u16)0x0001)
#define BtnFactoryTestTwo_IdeLedOn       ((u32)BtnFactoryTestTwoAddr_IdeLed*65536+BtnFactoryTestTwoValue_IdeLedOn)

#define BtnFactoryTestTwoAddr_DcOutNeg  ((u16)0x0133)
#define BtnFactoryTestTwoValue_DcOutNegOff ((u16)0x0000)
#define BtnFactoryTestTwo_DcOutNegOff      ((u32)BtnFactoryTestTwoAddr_DcOutNeg*65536+BtnFactoryTestTwoValue_DcOutNegOff)
#define BtnFactoryTestTwoValue_DcOutNegOn  ((u16)0x0001)
#define BtnFactoryTestTwo_DcOutNegOn       ((u32)BtnFactoryTestTwoAddr_DcOutNeg*65536+BtnFactoryTestTwoValue_DcOutNegOn)

#define BtnFactoryTestTwoAddr_Dehumidifier  ((u16)0x0135)
#define BtnFactoryTestTwoValue_DehOff ((u16)0x0000)
#define BtnFactoryTestTwo_DehOff      ((u32)BtnFactoryTestTwoAddr_Dehumidifier*65536+BtnFactoryTestTwoValue_DehOff)
#define BtnFactoryTestTwoValue_DehOn  ((u16)0x0001)
#define BtnFactoryTestTwo_DehOn       ((u32)BtnFactoryTestTwoAddr_Dehumidifier*65536+BtnFactoryTestTwoValue_DehOn)

#define BtnFactoryTestTwoAddr_eLock  ((u16)0x0124)
#define BtnFactoryTestTwoValue_eLockOff ((u16)0x0000)
#define BtnFactoryTestTwo_eLockOff      ((u32)BtnFactoryTestTwoAddr_eLock*65536+BtnFactoryTestTwoValue_eLockOff)
#define BtnFactoryTestTwoValue_eLockOn  ((u16)0x0001)
#define BtnFactoryTestTwo_eLockOn       ((u32)BtnFactoryTestTwoAddr_eLock*65536+BtnFactoryTestTwoValue_eLockOn)

#define IconFactoryTestTwoAddr_DoorSta       ((u16)0x0132)
#define IconFactoryTestTwoAddr_DcOutNegSta   ((u16)0x0134)
#define IconFactoryTestTwoAddr_HumitureSta   ((u16)0x0136)
#define IconFactoryTestTwoAddr_SlaveSysSta   ((u16)0x0137)
#define IconFactoryTestTwoAddr_eLockSta      ((u16)0x0161)
#define IconFactoryTestTwoAddr_ACMaterSta    ((u16)0x0166)

#define VarFactoryTestTwo_EnviTemp    ((u16)0x0052)
#define VarFactoryTestTwo_Humi        ((u16)0x0053)
#define VarFactoryTestTwo_Temp        ((u16)0x0054)


#define TextFactoryTestTwoAddr           ((u16)0x4000)


void FactoryTestTwoPaint(void)
{
  //char Str[64] = {0};
  u16 TempU16;

  LcdShowData16(BtnFactoryTestTwoAddr_IdeLed, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_DcOutNeg, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_Dehumidifier, 0);
  LcdShowData16(BtnFactoryTestTwoAddr_eLock, 0);

  if(eSwSta_Off == DoorChkGet())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_DoorSta, TempU16);

  if(eSwSta_On == DcOutNegGet())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_DcOutNegSta, TempU16);

  //if(Dht12Data.ValidFlag)
  if(PillarError.Value.Humiture)
    TempU16 = 0;
  else
    TempU16 = 1;
  LcdShowData16(IconFactoryTestTwoAddr_HumitureSta, TempU16);

  if(0)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_SlaveSysSta, TempU16);

  if(eSwSta_On == LockGet())
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(IconFactoryTestTwoAddr_eLockSta, TempU16);

  if(eMeterSta_Unavail == MeterComm.Status_AC)
    TempU16 = 0;
  else
    TempU16 = 1;
  LcdShowData16(IconFactoryTestTwoAddr_ACMaterSta, TempU16);

  /*snprintf(Str, sizeof(Str), "/¶:%04f/%04f/tʪ:%04f",
    Adc_GetNtcTemp()/100,Dht12Data.Dht12Temp/100,Dht12Data.Dht12Humity/100);
  LcdShowStr(TextFactoryTestTwoAddr, (u8*)Str, strlen(Str)+1);*/
  if(0 != UserParam.ChgFun.Value.Dehumi)
  {
    LcdShowData16(VarFactoryTestTwo_EnviTemp, Adc_GetNtcTemp());
  }
  else
    LcdShowData16(VarFactoryTestTwo_EnviTemp, (u16)(-27300));

  LcdShowData16(VarFactoryTestTwo_Humi, Dht12_GetHumi());
  LcdShowData16(VarFactoryTestTwo_Temp, Dht12_GetTemp());


  LcdShowPage(ScrnFactoryTestTwo);
}

typedef struct
{
  u32 RePaintTick;
}StructFactoryTestTwoUpdate;

void FactoryTestTwoUpdate(StructFactoryTestTwoUpdate *pUpdate)
{
  //char Str[64] = {0};
  u16 TempU16;

  if((GetSystemTick() - pUpdate->RePaintTick) >= 1000)
  {
    pUpdate->RePaintTick = GetSystemTick();
    if(eSwSta_Off == DoorChkGet())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_DoorSta, TempU16);

    if(eSwSta_On == DcOutNegGet())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_DcOutNegSta, TempU16);

    if(Dht12Data.ValidFlag)
    //if(0 != Dht12Error)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestTwoAddr_HumitureSta, TempU16);

    if(0)
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_SlaveSysSta, TempU16);

    if(eSwSta_On == LockGet())
      TempU16 = 1;
    else
      TempU16 = 0;
    LcdShowData16(IconFactoryTestTwoAddr_eLockSta, TempU16);

    if(eMeterSta_Unavail == MeterComm.Status_AC)
      TempU16 = 0;
    else
      TempU16 = 1;
    LcdShowData16(IconFactoryTestTwoAddr_ACMaterSta, TempU16);

    /*snprintf(Str, sizeof(Str), "/¶:%04f/%04f/tʪ:%04f",
      Adc_GetNtcTemp()/100,Dht12Data.Dht12Temp/100,Dht12Data.Dht12Humity/100);
    LcdShowStr(TextFactoryTestTwoAddr, (u8*)Str, strlen(Str)+1);*/
    if(0 != UserParam.ChgFun.Value.Dehumi)
      LcdShowData16(VarFactoryTestTwo_EnviTemp, Adc_GetNtcTemp());
    else
      LcdShowData16(VarFactoryTestTwo_EnviTemp, (u16)(-27300));
    LcdShowData16(VarFactoryTestTwo_Humi, Dht12_GetHumi());
    LcdShowData16(VarFactoryTestTwo_Temp, Dht12_GetTemp());

  }
}

void LcdProFactoryTestTwo(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 ScreenChkTick;
  u32 KeyValue;
  StructFactoryTestTwoUpdate Update;

  IdleLedSet(eSwSta_Off);
  DcOutNegSet(eSwSta_Off);
  DehumidifierSet(eSwSta_Off);
  DrainResistSet(eSwSta_Off);
  LockSet(eSwSta_Off);

  ScreenChkTick = GetSystemTick();
  Update.RePaintTick = GetSystemTick();
  FactoryTestTwoPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnFactoryTestTwo != KeyValue)
              LcdShowPage(ScrnFactoryTestTwo);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnFactoryTestTwo_Cancel:
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTestTwo_Next:
              pLcdCtrl->CurScreen = eLcdPro_FactoryChgSet;
              pLcdCtrl->Param = 0;
              break;
            case BtnFactoryTestTwo_Last:
              pLcdCtrl->CurScreen = eLcdPro_FactoryTest;
              pLcdCtrl->Param = 0;
              break;

            case BtnFactoryTestTwo_IdeLedOff:
              IdleLedSet(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_IdeLedOn:
              IdleLedSet(eSwSta_On);
              break;
            case BtnFactoryTestTwo_DcOutNegOff:
              DcOutNegSet(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_DcOutNegOn:
              DcOutNegSet(eSwSta_On);
              break;
            case BtnFactoryTestTwo_DehOff:
              DehumidifierSet(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_DehOn:
              DehumidifierSet(eSwSta_On);
              break;
            case BtnFactoryTestTwo_eLockOff:
              LockSet(eSwSta_Off);
              break;
            case BtnFactoryTestTwo_eLockOn:
              LockSet(eSwSta_On);
              break;

            default:
              LcdShowPage(ScrnFactoryTestTwo);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - ScreenChkTick) >= CheckSreenTime)
    {
      ScreenChkTick = GetSystemTick();
      LcdGetPage();
    }

    if(eLcdPro_FactoryTestTwo != pLcdCtrl->CurScreen)
    {
      IdleLedSet(eSwSta_Off);
      DcOutNegSet(eSwSta_Off);
      DehumidifierSet(eSwSta_Off);
      LockSet(eSwSta_Off);
      return;
    }

    FactoryTestTwoUpdate(&Update);

    osDelay(100);
  }
}


