
/******************************************************************************
ļ  : Lcd_InforChgRecdLog.c
  : Һʾ棬Aǹˢ
  :
޸  : 2015-04-10      

******************************************************************************/

#include "Thd_Lcd.h"

#define PageInforChgRecdLog            ((u16)46)
#define BtnInforChgRecdLog_Cancel      ((u16)0x4601)

#define BtnInforChgRecdLog_Next        ((u16)0x020A)
#define BtnInforChgRecdLog_Last        ((u16)0x020B)

#define VarInforChgRecd_Num            ((u16)0x0055)
#define VarInforChgRecd_NumTotal       ((u16)0x0056)
#define VarInforChgRecd_Positon        ((u16)0x0057)

#define TextInforChgRecdLog_CardNum    ((u16)0x4020)
#define TextInforChgRecdLog_CardType   ((u16)0x4160)

#define VarInforChgRecd_Energy         ((u16)0x0005)

#define TextInforChgRecdLog_StartTime  ((u16)0x4170)
#define TextInforChgRecdLog_StopTime   ((u16)0x4180)

#define VarInforChgRecd_EmployMoney    ((u16)0x002F)
#define VarInforChgRecd_EnergyMoney    ((u16)0x000F)
#define VarInforChgRecd_ServeMoney     ((u16)0x0010)
#define VarInforChgRecd_TotalMoney     ((u16)0x0007)

#define TextInforChgRecdLog_PaySta     ((u16)0x4190)

void InforChgRecdLogPaint(void)
{
  LcdShowPage(PageInforChgRecdLog);
}

void InforChgRecdLogIdle(void)
{

}

void ChgRecdLogShow(StructChgRecdLog *pRecd, u16 Num, u16 TotalNum)
{
  char Str[32];
  StructTime Time;
  u8 i;
  u32 Temp;

  if((NULL == pRecd) || (0 ==TotalNum))
  {
    LcdShowData16(VarInforChgRecd_Num, 0);
    LcdShowData16(VarInforChgRecd_NumTotal, 0);
    return;
  }

  LcdShowData16(VarInforChgRecd_Num, Num);
  LcdShowData16(VarInforChgRecd_NumTotal, TotalNum);

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",
          pRecd->CardNum[0], pRecd->CardNum[1], pRecd->CardNum[2], pRecd->CardNum[3],
          pRecd->CardNum[4], pRecd->CardNum[5], pRecd->CardNum[6], pRecd->CardNum[7],
          pRecd->CardNum[8], pRecd->CardNum[9]);
  LcdShowStr(TextInforChgRecdLog_CardNum, (u8*)Str, strlen(Str)+1);

  if(0 == pRecd->CardValidFlag)
    snprintf(Str, sizeof(Str), "̨˺");
  else if(2 == pRecd->MoneyDecFlag)
    snprintf(Str, sizeof(Str), "˺ſ");
  else
    snprintf(Str, sizeof(Str), "");
  LcdShowStr(TextInforChgRecdLog_CardType, (u8*)Str, strlen(Str)+1);

  LcdShowData16(VarInforChgRecd_Positon, pRecd->ChgNum);

  Temp = 0;
  for(i=0; i<48; i++)
  {
    Temp += pRecd->ChgEnergySeg[i];
  }
  LcdShowData16(VarInforChgRecd_Energy, Temp);
  //LcdShowData16(VarInforChgRecd_Energy, (pRecd->StopMeterEnergy - pRecd->StartMeterEnergy)/10);

  StampToTime(pRecd->ChgStartTime, &Time);
  snprintf(Str, sizeof(Str), "%02d-%02d %02d:%02d", Time.Mon,
           Time.Day, Time.Hour, Time.Min);
  LcdShowStr(TextInforChgRecdLog_StartTime, (u8*)Str, strlen(Str)+1);

  StampToTime(pRecd->ChgStopTime, &Time);
  snprintf(Str, sizeof(Str), "%02d-%02d %02d:%02d", Time.Mon,
           Time.Day, Time.Hour, Time.Min);
  LcdShowStr(TextInforChgRecdLog_StopTime, (u8*)Str, strlen(Str)+1);

  LcdShowData16(VarInforChgRecd_EmployMoney, pRecd->EmployMoney);

  LcdShowData16(VarInforChgRecd_EnergyMoney, pRecd->EnergyMoney);

  LcdShowData16(VarInforChgRecd_ServeMoney, pRecd->ServeMoney);

  LcdShowData16(VarInforChgRecd_TotalMoney, pRecd->EnergyMoney+pRecd->ServeMoney+pRecd->EmployMoney);

  if(0 == pRecd->MoneyDecFlag)
    snprintf(Str, sizeof(Str), "δ֧");
  else if(1 == pRecd->MoneyDecFlag)
    snprintf(Str, sizeof(Str), "֧");
  else
    snprintf(Str, sizeof(Str), "̨");
  LcdShowStr(TextInforChgRecdLog_PaySta, (u8*)Str, strlen(Str)+1);
}

#define TimeOutTime   (60*1000)

void LcdProInforChgRecdLog(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;

  u16 Num;
  StructChgRecdLog ChgRecord;

  Num = 1;
  if(0 != LogChgRecdParam.Num)
    ChgRecdReadInLog(LogChgRecdParam.Num - Num, &ChgRecord);
  else
    memset(&ChgRecord, 0,sizeof(ChgRecord));
  ChgRecdLogShow(&ChgRecord, Num, LogChgRecdParam.Num);

  TimeOutTick = GetSystemTick();

  InforChgRecdLogPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnInforChgRecdLog_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_MainMenu;
                pLcdCtrl->Param = 0;
                break;

              case BtnInforChgRecdLog_Next:
                TimeOutTick = GetSystemTick();
                if(0 != LogChgRecdParam.Num)
                {
                  Num++;
                  if(Num > LogChgRecdParam.Num)
                    Num = 1;
                  ChgRecdReadInLog(LogChgRecdParam.Num - Num, &ChgRecord);
                  ChgRecdLogShow(&ChgRecord, Num, LogChgRecdParam.Num);
                }
                break;

              case BtnInforChgRecdLog_Last:
                if(0 != LogChgRecdParam.Num)
                {
                  if(Num > 1)
                    Num--;
                  else
                    Num = LogChgRecdParam.Num;
                  ChgRecdReadInLog(LogChgRecdParam.Num - Num, &ChgRecord);

                  ChgRecdLogShow(&ChgRecord, Num, LogChgRecdParam.Num);
                }
                break;

              default:
                LcdShowPage(PageInforChgRecdLog);
                break;
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_InforChgRecdLog != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    InforChgRecdLogIdle();

    osDelay(100);
  }
}








