
#include "Thd_Lcd.h"
#include "Drv_LcdDwin.h"

#define ScrnDcModSelect  ((u16)118)
#define BtnDcModSelect_Enter        ((u16)0x6401)
#define BtnDcModSelect_Cancel        ((u16)0x6402)

#define BtnDcModSelect_Next        ((u16)0x000B)
#define BtnDcModSelect_Last        ((u16)0x000A)

#define BtnDcModSelect_Incre  ((u16)0x0171)
#define BtnDcModSelectValue_IncreOff ((u16)0x0000)
#define BtnDcModSelect_IncreOff      ((u32)BtnDcModSelect_Incre*65536+BtnDcModSelectValue_IncreOff)
#define BtnDcModSelectValue_IncreOn  ((u16)0x0001)
#define BtnDcModSelect_IncreOn       ((u32)BtnDcModSelect_Incre*65536+BtnDcModSelectValue_IncreOn)

#define BtnDcModSelect_Zhongxing ((u16)0x0172)
#define BtnDcModSelectValue_ZhongxingOff ((u16)0x0000)
#define BtnDcModSelect_ZhongxingOff      ((u32)BtnDcModSelect_Zhongxing*65536+BtnDcModSelectValue_ZhongxingOff)
#define BtnDcModSelectValue_ZhongxingOn  ((u16)0x0001)
#define BtnDcModSelect_ZhongxingOn       ((u32)BtnDcModSelect_Zhongxing*65536+BtnDcModSelectValue_ZhongxingOn)

#define BtnDcModSelect_YouYou  ((u16)0x0173)
#define BtnDcModSelectValue_YouYouOff ((u16)0x0000)
#define BtnDcModSelect_YouYouOff      ((u32)BtnDcModSelect_YouYou*65536+BtnDcModSelectValue_YouYouOff)
#define BtnDcModSelectValue_YouYouOn  ((u16)0x0001)
#define BtnDcModSelect_YouYouOn       ((u32)BtnDcModSelect_YouYou*65536+BtnDcModSelectValue_YouYouOn)

#define BtnDcModSelect_YouYouNormal ((u16)0x0174)
#define BtnDcModSelectValue_YouYouNormalOff ((u16)0x0000)
#define BtnDcModSelect_YouYouNormalOff      ((u32)BtnDcModSelect_YouYouNormal*65536+BtnDcModSelectValue_YouYouNormalOff)
#define BtnDcModSelectValue_YouYouNormalOn  ((u16)0x0001)
#define BtnDcModSelect_YouYouNormalOn       ((u32)BtnDcModSelect_YouYouNormal*65536+BtnDcModSelectValue_YouYouNormalOn)


void DcModSelectPaint(void)
{
  u16 TempU16;

  if(eDCModType_Incre == UserParam.Module.DCModType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnDcModSelect_Incre, TempU16);

  if(eDCModType_ZhongXin== UserParam.Module.DCModType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnDcModSelect_Zhongxing , TempU16);

  if(eDCModType_YouYou== UserParam.Module.DCModType)
    TempU16 = 1;
  else
    TempU16 = 0;
  LcdShowData16(BtnDcModSelect_YouYou, TempU16);

  if(eDCModType_YouYouNormal== UserParam.Module.DCModType)
   TempU16 = 1;
  else
   TempU16 = 0;
  LcdShowData16(BtnDcModSelect_YouYouNormal, TempU16);

  LcdShowPage(ScrnDcModSelect);
}


void DCModSelectUpdate(StructDcModUpdate *pUpdate)
{
  u16 TempU16;
  if((GetSystemTick() - pUpdate->MODPaintTick) >= 500)
  {
    pUpdate->MODPaintTick = GetSystemTick();

    if(eDCModType_Incre == pUpdate->DCModType)
        TempU16 = 1;
      else
        TempU16 = 0;
      LcdShowData16(BtnDcModSelect_Incre, TempU16);

      if(eDCModType_ZhongXin== pUpdate->DCModType)
        TempU16 = 1;
      else
        TempU16 = 0;
      LcdShowData16(BtnDcModSelect_Zhongxing , TempU16);

      if(eDCModType_YouYou== pUpdate->DCModType)
        TempU16 = 1;
      else
        TempU16 = 0;
      LcdShowData16(BtnDcModSelect_YouYou, TempU16);

      if(eDCModType_YouYouNormal== pUpdate->DCModType)
        TempU16 = 1;
      else
        TempU16 = 0;
      LcdShowData16(BtnDcModSelect_YouYouNormal, TempU16);
  }
}


#define TimeOutTime   (40*1000)

void LcdProFactoryDcModSelect(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 TimeOutTick;
  u32 KeyValue;
  StructDcModUpdate Update;

  Update.DCModType = UserParam.Module.DCModType;
  Update.Auto_ID = UserParam.Module.Auto_ID;

  TimeOutTick = GetSystemTick();

 DcModSelectPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          if(eLcdRegAddr_Page == Frame.Ctrl.RdReg.Addr)
          {
            KeyValue = Frame.Ctrl.RdReg.Data[0]*256 + Frame.Ctrl.RdReg.Data[1];
            if(ScrnDcModSelect != KeyValue)
              LcdShowPage(ScrnDcModSelect);
          }
          break;
        case eLcdCmd_RdVar:
          KeyValue  = Frame.Ctrl.RdVar.AddrH << 24;
          KeyValue += Frame.Ctrl.RdVar.AddrL << 16;
          KeyValue += Frame.Ctrl.RdVar.Data[0] << 8;
          KeyValue += Frame.Ctrl.RdVar.Data[1];
          switch(KeyValue)
          {
            case BtnDcModSelect_Cancel:  //A ǹ"" 
              TimeOutTick = GetSystemTick();
              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnDcModSelect_Enter:
              TimeOutTick = GetSystemTick();

              UserParam.Module.DCModType = Update.DCModType;
              UserParam.Module.Auto_ID = Update.Auto_ID;

              SaveUserParam((u8*)&UserParam, sizeof(UserParam));
              UserParamInit();

              pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
              pLcdCtrl->Param = 0;
              break;

            case BtnDcModSelect_IncreOff:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_No ;
              break;
            case BtnDcModSelect_IncreOn:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_Incre;
              break;

            case BtnDcModSelect_ZhongxingOff :
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_No ;
              break;
            case BtnDcModSelect_ZhongxingOn:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_ZhongXin ;
              break;

            case BtnDcModSelect_YouYouOff:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_No ;
              break;
            case BtnDcModSelect_YouYouOn:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_YouYou;
              break;
            case BtnDcModSelect_YouYouNormalOff:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_No ;
              break;
            case BtnDcModSelect_YouYouNormalOn:
              TimeOutTick = GetSystemTick();
              Update.DCModType = eDCModType_YouYouNormal;
              break;
            default:
              LcdShowPage(ScrnDcModSelect);
              break;
          }
          break;
        default:
          break;
      }
    }

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    if(eLcdPro_FactoryDcModSelect != pLcdCtrl->CurScreen)
      return;

    DCModSelectUpdate(&Update);

    osDelay(100);
  }
}

