
#include "Thd_Lcd.h"

#define ScrnSetCard            ((u16)39)
#define BtnSetCard_Enter       ((u16)0x3901)
#define BtnSetCard_Cancel      ((u16)0x3902)

#define BtnSetCard_Next        ((u16)0x000B)
#define BtnSetCard_Last        ((u16)0x000A)

#define DataSetCard_Lock       ((u16)0x0018)
#define DataSetCard_BalMoy       ((u16)0x0090)

#define TextSetCard_Key        ((u16)0x3070)

#define TextSetCard_Tip        ((u16)0x4000)

void SetCardPaint(void)
{
  char Str[64];

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X", UserParam.MoneyKey[0],UserParam.MoneyKey[1],
          UserParam.MoneyKey[2], UserParam.MoneyKey[3], UserParam.MoneyKey[4], UserParam.MoneyKey[5]);
  LcdShowStr(TextSetCard_Key, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(DataSetCard_Lock, UserParam.LockCard);
  LcdShowData16(DataSetCard_BalMoy, UserParam.BalanceMoney);

  snprintf(Str, sizeof(Str), "  ");
  LcdShowStr(TextSetCard_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSetCard);
}

void SetCardIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetCard(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  char Key[16];
  u8 KeyLen;
  u16 Lock;
  u16 BalanceMoney;

  char Str[64];
  u8 i;

  KeyLen = 12;
  snprintf(Key, sizeof(Key), "%02X%02X%02X%02X%02X%02X", UserParam.MoneyKey[0], UserParam.MoneyKey[1],
          UserParam.MoneyKey[2], UserParam.MoneyKey[3], UserParam.MoneyKey[4], UserParam.MoneyKey[5]);

  Lock = UserParam.LockCard;
  BalanceMoney = UserParam.BalanceMoney;

  TimeOutTick = GetSystemTick();

  SetCardPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetCard_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetCard_Enter:
                TimeOutTick = GetSystemTick();
                if(0 == KeyLen)
                {
                  snprintf(Str,sizeof(Str),"ԿȲ㣬޷档");
                  LcdWriteVar(TextSetCard_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else
                {
                  for(i=0; i<12; i++)
                  {
                    Temp = Key[i] - '0';
                    if(Temp > 9)
                      Temp -= 7;
                    Key[i] = Temp;
                  }
                  for(i=0; i<6; i++)
                    UserParam.MoneyKey[i] = (Key[2*i] << 4) | (Key[2*i + 1] & 0x0F);

                  UserParam.LockCard = Lock;
                  UserParam.BalanceMoney = BalanceMoney;

                  SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                  UserParamInit();

                  pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
                break;

              case BtnSetCard_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetReader;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetCard_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetIp;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetCard);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetCard);

            if(TextSetCard_Key == Temp)
            {
              KeyLen = 0;
              if((Frame.Ctrl.RdVar.Len < 7) || ((7 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[11])))
              {
                snprintf(Str,sizeof(Str),"ԿȲ㣬䡣");
                LcdWriteVar(TextSetCard_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetCard_Tip, (u8 *)Str, (strlen(Str)+1));
                KeyLen = 12;
                memcpy(Key, Frame.Ctrl.RdVar.Data, 12);
              }
            }
            else if(Temp == DataSetCard_Lock)
              Lock = Frame.Ctrl.RdVar.Data[1];
            else if(Temp == DataSetCard_BalMoy)
              BalanceMoney = Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetCard != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetCardIdle();

    osDelay(100);
  }
}









