
#include "Thd_Lcd.h"

#define ScrnSetEmployRate            ((u16)48)
#define BtnSetEmployRate_Enter       ((u16)0x4801)
#define BtnSetEmployRate_Cancel      ((u16)0x4802)

#define BtnSetEmployRate_Next        ((u16)0x000B)
#define BtnSetEmployRate_Last        ((u16)0x000A)

#define VarSetEmployRate_Rate        ((u16)0x002D)
#define VarSetEmployRate_FreeTime    ((u16)0x002E)

#define TextSetEmployRate_Tip        ((u16)0x4000)


void SetEmployRatePaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str)," ");
  LcdShowStr(TextSetEmployRate_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarSetEmployRate_Rate, UserParam.EmployRate);
  LcdShowData16(VarSetEmployRate_FreeTime, UserParam.FreeTime);

  LcdShowPage(ScrnSetEmployRate);
}

void SetEmployRateIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetEmployRate(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 EmployRateTemp;
  u16 FreeTimeTemp;

  EmployRateTemp = UserParam.EmployRate;
  FreeTimeTemp = UserParam.FreeTime;

  TimeOutTick = GetSystemTick();

  SetEmployRatePaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetEmployRate_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetEmployRate_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.EmployRate = EmployRateTemp;
                UserParam.FreeTime = FreeTimeTemp;

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetEmployRate_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetIp;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetEmployRate_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetTimeRate;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetEmployRate);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetEmployRate);
            if(VarSetEmployRate_Rate == Temp)
              EmployRateTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetEmployRate_FreeTime == Temp)
              FreeTimeTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetEmployRate != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetEmployRateIdle();

    osDelay(100);
  }
}


