
#include "Thd_Lcd.h"

#define ScrnSetMeterAddr            ((u16)57)
#define BtnSetMeterAddr_Enter       ((u16)0x5701)
#define BtnSetMeterAddr_Cancel      ((u16)0x5702)

#define BtnSetMeterAddr_Next        ((u16)0x000B)
#define BtnSetMeterAddr_Last        ((u16)0x000A)

#define TextSetMeterAddr_AddrNum     ((u16)0x30D0)
#define TextSetMeterAddr_AddrNum_B   ((u16)0x30D8)
#define TextSetMeterAddr_AddrNum_AC      ((u16)0x30E0)

#define TextSetMeterAddr_Tip        ((u16)0x4000)



void SetMeterAddrPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"  ");
  LcdShowStr(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr[5],UserParam.MeterAddr[4],
            UserParam.MeterAddr[3], UserParam.MeterAddr[2], UserParam.MeterAddr[1], UserParam.MeterAddr[0]);
  LcdShowStr(TextSetMeterAddr_AddrNum, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr_B[5],UserParam.MeterAddr_B[4],
            UserParam.MeterAddr_B[3], UserParam.MeterAddr_B[2], UserParam.MeterAddr_B[1], UserParam.MeterAddr_B[0]);
  LcdShowStr(TextSetMeterAddr_AddrNum_B, (u8 *)Str, (strlen(Str)+1));

  snprintf(Str, sizeof(Str), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr_AC[5],UserParam.MeterAddr_AC[4],
            UserParam.MeterAddr_AC[3], UserParam.MeterAddr_AC[2], UserParam.MeterAddr_AC[1], UserParam.MeterAddr_AC[0]);
  LcdShowStr(TextSetMeterAddr_AddrNum_AC, (u8 *)Str, (strlen(Str)+1));

  LcdShowPage(ScrnSetMeterAddr);
}

void SetMeterAddrIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (60*1000)

void LcdProSetMeterAddr(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  char MeterAddrTemp[13] = {0};
  u8 MeterAddrTempLen;
  char MeterAddrTemp_B[13] = {0};
  u8 MeterAddrTempLen_B;
  char MeterAddrTemp_AC[13]= {0};
  u8 MeterAddrTempLen_AC;

  char Str[64];
  u8 i;

  MeterAddrTempLen = 12;
  snprintf(MeterAddrTemp, sizeof(MeterAddrTemp), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr[5], UserParam.MeterAddr[4],
            UserParam.MeterAddr[3], UserParam.MeterAddr[2], UserParam.MeterAddr[1], UserParam.MeterAddr[0]);

  MeterAddrTempLen_B = 12;
  snprintf(MeterAddrTemp_B, sizeof(MeterAddrTemp_B), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr_B[5], UserParam.MeterAddr_B[4],
            UserParam.MeterAddr_B[3], UserParam.MeterAddr_B[2], UserParam.MeterAddr_B[1], UserParam.MeterAddr_B[0]);

  MeterAddrTempLen_AC = 12;
  snprintf(MeterAddrTemp_AC, sizeof(MeterAddrTemp_AC), "%02X%02X%02X%02X%02X%02X", UserParam.MeterAddr_AC[5], UserParam.MeterAddr_AC[4],
            UserParam.MeterAddr_AC[3], UserParam.MeterAddr_AC[2], UserParam.MeterAddr_AC[1], UserParam.MeterAddr_AC[0]);

  TimeOutTick = GetSystemTick();

  SetMeterAddrPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetMeterAddr_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetMeterAddr_Enter:
                TimeOutTick = GetSystemTick();
                if(0 == MeterAddrTempLen)
                {
                  snprintf(Str,sizeof(Str),"AַȲ㣬޷档");
                  LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 == MeterAddrTempLen_B)
                {
                  snprintf(Str,sizeof(Str),"BַȲ㣬޷档");
                  LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else if(0 == MeterAddrTempLen_AC)
                {
                  snprintf(Str,sizeof(Str),"ַȲ㣬޷档");
                  LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                }
                else
                {
                  for(i=0; i<6; i++)
                  {
                    UserParam.MeterAddr[5-i] = ((MeterAddrTemp[2*i] - '0') << 4) | ((MeterAddrTemp[2*i + 1] - '0') & 0x0F);
                    UserParam.MeterAddr_B[5-i] = ((MeterAddrTemp_B[2*i] - '0') << 4) | ((MeterAddrTemp_B[2*i + 1] - '0') & 0x0F);
                    UserParam.MeterAddr_AC[5-i] = ((MeterAddrTemp_AC[2*i] - '0') << 4) | ((MeterAddrTemp_AC[2*i + 1] - '0') & 0x0F);
                  }
                  //memcpy(UserParam.MeterAddr, MeterAddrTemp, 12);
                  //memcpy(UserParam.MeterAddr_B, MeterAddrTemp_B, 12);
                  //memcpy(UserParam.MeterAddr_AC, MeterAddrTemp_AC, 12);
                  SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                  UserParamInit();

                  memcpy(MeterComm.Addr, UserParam.MeterAddr, 6);
                  memcpy(MeterComm.Addr_B, UserParam.MeterAddr_B, 6);
                  memcpy(MeterComm.Addr_AC, UserParam.MeterAddr_AC, 6);

                  pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                  pLcdCtrl->Param = 0;
                }
                break;

              case BtnSetMeterAddr_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetRate;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetMeterAddr_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetNum;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetMeterAddr);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetMeterAddr);
            if(TextSetMeterAddr_AddrNum == Temp)
            {
              MeterAddrTempLen = 0;
              if((Frame.Ctrl.RdVar.Len < 6) || ((6 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[15])))
              {
                snprintf(Str,sizeof(Str),"AַȲ㣬䡣");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                MeterAddrTempLen = 12;
                memcpy(MeterAddrTemp, Frame.Ctrl.RdVar.Data, 13);
              }
            }
            else if(TextSetMeterAddr_AddrNum_B == Temp)
            {
              MeterAddrTempLen_B = 0;
              if((Frame.Ctrl.RdVar.Len < 6) || ((6 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[15])))
              {
                snprintf(Str,sizeof(Str),"BַȲ㣬䡣");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                MeterAddrTempLen_B = 12;
                memcpy(MeterAddrTemp_B, Frame.Ctrl.RdVar.Data, 13);
              }
            }
            else if(TextSetMeterAddr_AddrNum_AC == Temp)
            {
              MeterAddrTempLen_AC = 0;
              if((Frame.Ctrl.RdVar.Len < 6) || ((6 == Frame.Ctrl.RdVar.Len) &&  (0xFF == Frame.Ctrl.RdVar.Data[15])))
              {
                snprintf(Str,sizeof(Str),"ַȲ㣬䡣");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
              }
              else
              {
                snprintf(Str,sizeof(Str),"  ");
                LcdWriteVar(TextSetMeterAddr_Tip, (u8 *)Str, (strlen(Str)+1));
                MeterAddrTempLen_AC = 12;
                memcpy(MeterAddrTemp_AC, Frame.Ctrl.RdVar.Data, 13);
              }
            }
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetMeterAddr != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetMeterAddrIdle();

    osDelay(100);
  }
}



