
#include "Thd_Lcd.h"

#define ScrnSetRate            ((u16)35)
#define BtnSetRate_Enter       ((u16)0x3501)
#define BtnSetRate_Cancel      ((u16)0x3502)
#define BtnSetRate_Ratio  ((u16)0x3503)

#define BtnSetRate_Next        ((u16)0x000B)
#define BtnSetRate_Last        ((u16)0x000A)

#define VarSetRate_Energy1     ((u16)0x0013)
#define VarSetRate_Energy2     ((u16)0x0014)
#define VarSetRate_Energy3     ((u16)0x0015)
#define VarSetRate_Energy4     ((u16)0x0016)
#define VarSetRate_Serve       ((u16)0x0017)


#define TextSetRate_Tip        ((u16)0x4000)


void SetRatePaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"0.00~~9.99Ԫʡ");
  LcdShowStr(TextSetRate_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarSetRate_Energy1, UserParam.EnergyRate[0]);
  LcdShowData16(VarSetRate_Energy2, UserParam.EnergyRate[1]);
  LcdShowData16(VarSetRate_Energy3, UserParam.EnergyRate[2]);
  LcdShowData16(VarSetRate_Energy4, UserParam.EnergyRate[3]);

 // LcdShowData16(VarSetRate_Serve, UserParam.ServerRate);

  LcdShowPage(ScrnSetRate);
}

void SetRateIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetRate(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 EnergyRateTemp[4];
  u16 ServeRateTemp;

  u32 BtnRatioTick;
  u8  BtnRatioCounter;

  EnergyRateTemp[0] = UserParam.EnergyRate[0];
  EnergyRateTemp[1] = UserParam.EnergyRate[1];
  EnergyRateTemp[2] = UserParam.EnergyRate[2];
  EnergyRateTemp[3] = UserParam.EnergyRate[3];
 ServeRateTemp = UserParam.ServerRate;

  TimeOutTick = GetSystemTick();

  BtnRatioTick = GetSystemTick();
  BtnRatioCounter = 0;

  SetRatePaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetRate_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRate_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.EnergyRate[0] = EnergyRateTemp[0];
                UserParam.EnergyRate[1] = EnergyRateTemp[1];
                UserParam.EnergyRate[2] = EnergyRateTemp[2];
                UserParam.EnergyRate[3] = EnergyRateTemp[3];
             //   UserParam.ServerRate = ServeRateTemp;

                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;
              case BtnSetRate_Ratio:
                if((GetSystemTick() - BtnRatioTick) >= 1000)
                  BtnRatioCounter = 0;
                else
                {
                  BtnRatioCounter++;
                  if(BtnRatioCounter > 2)
                  {
                    pLcdCtrl->CurScreen = eLcdPro_SetRatio;
                    pLcdCtrl->Param = 0;
                  }
                }
                BtnRatioTick = GetSystemTick();
                break;

              case BtnSetRate_Next:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetTimeRate;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRate_Last:
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_SetMeterAddr;
                pLcdCtrl->Param = 0;
                break;

              default:
                LcdShowPage(ScrnSetRate);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetRate);
            if(VarSetRate_Energy1 == Temp)
              EnergyRateTemp[0] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRate_Energy2 == Temp)
              EnergyRateTemp[1] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRate_Energy3 == Temp)
              EnergyRateTemp[2] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRate_Energy4 == Temp)
              EnergyRateTemp[3] = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRate_Serve == Temp)
              ServeRateTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetRate != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetRateIdle();

    osDelay(100);
  }
}

