
#include "Thd_Lcd.h"

#define ScrnSetRatio            ((u16)63)
#define BtnSetRatio_Enter       ((u16)0x6301)
#define BtnSetRatio_Cancel      ((u16)0x6302)

#define BtnSetRatio_Next        ((u16)0x000B)
#define BtnSetRatio_Last        ((u16)0x000A)

#define VarSetRatio_SOCMAX    ((u16)0x0166)

#define VarSetRatio_EnergyRatio     ((u16)0x0167)
#define VarSetRatio_VoltRatio     ((u16)0x017A)
#define VarSetRatio_CurrtRatio     ((u16)0x017B)

#define TextSetRatio_Tip        ((u16)0x4000)


void SetRatioPaint(void)
{
  char Str[64];

  snprintf(Str,sizeof(Str),"0.000~~2.000ʡ");
  LcdShowStr(TextSetRatio_Tip, (u8 *)Str, (strlen(Str)+1));

  LcdShowData16(VarSetRatio_EnergyRatio, UserParam.EnergyRatio);
  LcdShowData16(VarSetRatio_VoltRatio, UserParam.VoltRatio);
  LcdShowData16(VarSetRatio_CurrtRatio, UserParam.CurrtRatio);
  
  LcdShowData16(VarSetRatio_SOCMAX, UserParam.SOCMAX);
  LcdShowPage(ScrnSetRatio);
}

void SetRatioIdle(void)
{

}

extern void CloseKeyBoard(void);

#define TimeOutTime   (40*1000)

void LcdProSetRatio(StructLcdCtrl *pLcdCtrl)
{
  StructLcdDwinFrame Frame;
  u32 Temp;
  u32 TimeOutTick;
  u16 EnergyRatioTemp;
  u16 VoltRatioTemp;
  u16 CurrtRatioTemp;
  u16 SOCMAX ;

  EnergyRatioTemp = UserParam.EnergyRatio;
  VoltRatioTemp = UserParam.VoltRatio;
  CurrtRatioTemp = UserParam.CurrtRatio;
  SOCMAX        = UserParam.SOCMAX ;
  TimeOutTick = GetSystemTick();

  SetRatioPaint();

  while(1)
  {
    if(TRUE == LcdFrameRecv(&Frame))
    {
      switch(Frame.FrameCmd)
      {
        case eLcdCmd_RdReg:
          break;
        case eLcdCmd_RdVar:
          Temp = Frame.Ctrl.RdVar.AddrH*256 + Frame.Ctrl.RdVar.AddrL;
          if(0x0000 == Temp)
          {
            Temp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            switch(Temp)
            {
              case BtnSetRatio_Cancel:  //A ǹ"" 
                TimeOutTick = GetSystemTick();
                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRatio_Enter:
                TimeOutTick = GetSystemTick();
                UserParam.EnergyRatio = EnergyRatioTemp;
                UserParam.VoltRatio = VoltRatioTemp;
                UserParam.CurrtRatio = CurrtRatioTemp;
                UserParam.SOCMAX = SOCMAX;
                SaveUserParam((u8*)&UserParam, sizeof(UserParam));
                UserParamInit();

                pLcdCtrl->CurScreen = eLcdPro_ManageSelect;
                pLcdCtrl->Param = 0;
                break;

              case BtnSetRatio_Next:
                TimeOutTick = GetSystemTick();
                break;

              case BtnSetRatio_Last:
                TimeOutTick = GetSystemTick();
                break;

              default:
                LcdShowPage(ScrnSetRatio);
                break;
            }
          }
          else
          {
            TimeOutTick = GetSystemTick();
            LcdShowPage(ScrnSetRatio);
            if(VarSetRatio_EnergyRatio == Temp)
              EnergyRatioTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRatio_VoltRatio == Temp)
              VoltRatioTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
            else if(VarSetRatio_CurrtRatio == Temp)
              CurrtRatioTemp = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
			else if(VarSetRatio_SOCMAX == Temp)
              SOCMAX = Frame.Ctrl.RdVar.Data[0]*256 + Frame.Ctrl.RdVar.Data[1];
          }
          break;

        default:
          break;
      }
    }

    if(eLcdPro_SetRatio != pLcdCtrl->CurScreen)
      return;

    if((GetSystemTick() - TimeOutTick) > TimeOutTime)
    {
      CloseKeyBoard();
      pLcdCtrl->CurScreen = eLcdPro_MainMenu;
      pLcdCtrl->Param = 0;
    }

    SetRatioIdle();

    osDelay(100);
  }
}


