
#include "Thd_Charge_B.h"

#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Memory.h"
#include "Drv_Meter.h"
#include "Drv_Adc.h"
#include "Drv_CommuSPI2.h"



u8 ChargeEnable_B = 0;
u8 ChargePauseFlag_B = 0;
s32 StartChgEnergy_B = 0;
s32 StopChgEnergy_B = 0;

EnumChgStopType ChargeStopType_B = eChgStop_None;

u8 CommErrorCount_B = 0;
u32 CommErrFrame_B[4] = {0};

extern void ChgProChgIdle_B(StructChargeCtrl_B *Param);
extern void ChgProShakeHand_B(StructChargeCtrl_B *Param);

extern void ChgProImdCheck_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProChgRecognizeEx_B(StructChargeCtrl_B *pChargeCtrl);

extern void ChgProChgRecognize_B(StructChargeCtrl_B *Param);
extern void ChgProChgConfigure_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProWaitBmsReady_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProWaitPillarReady_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProChgStart_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProChgRun_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProWaitVoltChgRun_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProChgStop_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProCommBeak_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProCommError_B(StructChargeCtrl_B *pChargeCtrl);
extern void ChgProChgBreak_B(StructChargeCtrl_B *pChargeCtrl);

const pChargeCtrlHandle_B ChargeCtrlHandle_B[] =
{
  ChgProChgIdle_B,
  ChgProShakeHand_B,

  ChgProImdCheck_B,
  ChgProChgRecognizeEx_B,

  ChgProChgRecognize_B,
  ChgProChgConfigure_B,
  ChgProWaitBmsReady_B,
  ChgProWaitPillarReady_B,
  ChgProChgStart_B,
  ChgProChgRun_B,
  ChgProWaitVoltChgRun_B,
  ChgProChgStop_B,
  ChgProCommBeak_B,
  ChgProCommError_B,
  ChgProChgBreak_B,
  ChgProChgIdle_B
};

StructChargeCtrl_B ChargeCtrl_B;

osTimerId ChargeTimer_B;
u32 ChargeTimeCount_B;//
u8 ChargeTimeCountEn_B = 0;

void ChargeTimerSet_B(EnumSwitchStatus OnOff)
{
  if(eSwSta_Off == OnOff)
    ChargeTimeCountEn_B = 0;
  else
    ChargeTimeCountEn_B = 1;
}

u16 GetChgMin_B(void)
{
  u32 Temp;

  Temp = ChargeTimeCount_B/60;
  if(Temp > 600)
    Temp = 600;
  return Temp;
}

u32 GetChgSec_B(void)
{
  return ChargeTimeCount_B;
}


void CleanChgTimeCnt_B(void)
{
  ChargeTimeCount_B = 0;
}

void ChargeTimeCountCtrl_B(void const *Param)
{
  if(ChargeTimeCountEn_B)
    ChargeTimeCount_B++;
}

/* the system main thread */
void Thd_Charge_B(void const *parameter)
{
  //DcModuleInit_B();
  //MeterInit_B();
  DcOutInit_B();
  DrainResistInit_B();
  LockInit_B();
  BmsPowerInit_B();
  BmsCommInit_B();

  IdleLedInit_B();
  ChgLedInit_B();
  FaultLedInit_B();


  osDelay(3000);//ȴ߳chargeʼ

  /* Create a Timer */
  osTimerDef(ChargeTimer_B, ChargeTimeCountCtrl_B);
  ChargeTimer_B = osTimerCreate(osTimer(ChargeTimer_B), osTimerPeriodic, (void *)0);
  osTimerStart(ChargeTimer_B, 1000);//һ

  ChargeCtrl_B.CurProcess = eChgPro_B_ChgIdle;
  ChargeCtrl_B.Param = 0;

  osDelay(100);

  while(1)
  {
    if(ChargeCtrl_B.CurProcess < eChgPro_B_Max)
      ChargeCtrlHandle_B[ChargeCtrl_B.CurProcess](&ChargeCtrl_B);
    else
    {
      ChargeCtrl_B.CurProcess = eChgPro_B_ChgIdle;
      ChargeCtrl_B.Param = 0;
    }
    osDelay(5);
  }
}

