
#ifndef __THD_LCD_H__
#define __THD_LCD_H__

#include "Global.h"
#include "Drv_Adc.h"

#include "Drv_ImdJyc.h"



#define CheckSreenTime ((u16)(8*1000))  //8
#define RtcSynTime     ((u32)(10*60*1000)) //60

typedef enum
{
  eLcdPro_MainMenu = 0,
  eLcdPro_GetCard,
  eLcdPro_CardPwd,
  eLcdPro_CardSure,
  eLcdPro_CnctDetect,
  eLcdPro_LockCard,
  eLcdPro_BuildComm,
  eLcdPro_ChargeSummary,
  eLcdPro_ChargeScreen,
  eLcdPro_SingleChargeScreen,
  eLcdPro_BmsInfor,
  eLcdPro_CommuInfor,
  eLcdPro_ChargeStop,
  eLcdPro_SwipeCard,
  eLcdPro_PutBack,
  eLcdPro_ElectLock,
  eLcdPro_PillarError,

  eLcdPro_B_GetCard,
  eLcdPro_B_CardPwd,
  eLcdPro_B_CardSure,
  eLcdPro_B_CnctDetect,
  eLcdPro_B_LockCard,
  eLcdPro_B_BuildComm,
  eLcdPro_B_ChargeSummary,
  eLcdPro_B_ChargeScreen,
  eLcdPro_B_BmsInfor,
  eLcdPro_B_CommuInfor,
  eLcdPro_B_ChargeStop,
  eLcdPro_B_SwipeCard,
  eLcdPro_B_PutBack,
  eLcdPro_B_ElectLock,
  eLcdPro_B_PillarError,

  eLcdPro_AB_GetCard,
  eLcdPro_AB_CardPwd,
  eLcdPro_AB_CardSure,
  eLcdPro_AB_CnctDetect,
  eLcdPro_AB_LockCard,
  eLcdPro_AB_BuildComm,
  eLcdPro_AB_ChargeScreen,
  eLcdPro_AB_BmsInfor,
  eLcdPro_AB_CommuInfor,
  eLcdPro_AB_ChargeStop,
  eLcdPro_AB_SwipeCard,
  eLcdPro_AB_PutBack,
  eLcdPro_AB_ElectLock,
  eLcdPro_AB_PillarError,

  eLcdPro_AB_ChargeSummary,

  eLcdPro_ChgReserve,

  eLcdPro_ManagePwd,
  eLcdPro_ManageSelect,
  eLcdPro_SetRtc,
  eLcdPro_SetNum,
  eLcdPro_SetMeterAddr,
  eLcdPro_SetRate,
  eLcdPro_SetRatio,
  eLcdPro_SetTimeRate,

  eLcdPro_SetEmployRate,

  eLcdPro_SetIp,
  eLcdPro_SetMAC,

  eLcdPro_SetCard,
  eLcdPro_SetReader,
  eLcdPro_SetHumiture,
  eLcdPro_SetTel,
  eLcdPro_SetPassword,
  eLcdPro_SetReboot,
  eLcdPro_SetParamDef,

  eLcdPro_FactoryTest,
  eLcdPro_FactoryTestTwo,
  eLcdPro_FactoryChgSet,
  eLcdPro_FactoryChgInfor,
  eLcdPro_B_FactoryTest,
  eLcdPro_B_FactoryTestTwo,
  eLcdPro_B_FactoryChgSet,
  eLcdPro_B_FactoryChgInfor,
  eLcdPro_FactoryDcModSet,
  eLcdPro_FactoryPillarInputSet,
  eLcdPro_FactoryProtSet,
  eLcdPro_FactoryFunctionSet,

  eLcdPro_CommError,

  eLcdPro_InforChgRecdLog,
  eLcdPro_InforLogClean,
  eLcdPro_SetServerRate,
  eLcdPro_SetServerTimeRate,
  eLcdPro_FactoryDcModSelect,

  eLcdPro_Max,
}EnumLcdProcess;

typedef struct
{
  EnumLcdProcess CurScreen;
  u8 Param;//void *Param;
}StructLcdCtrl;

typedef void (*pLcdCtrlHandle)(StructLcdCtrl *pLcdCtrl);

#include "Memory.h"
#include "Drv_BoardIo.h"
#include "Drv_DcModule.h"
#include "Drv_BmsComm.h"
#include "Thd_Charge.h"
#include "Thd_Charge_B.h"
#include "Drv_Meter.h"
#include "Drv_ReaderActR1.h"
#include "Drv_Buzzer.h"
#include "Drv_LcdDwin.h"
#include "Drv_Dht12.h"
#include "Drv_RtcExt.h"

#include "Drv_CommuUSART3.h"


typedef enum
{
  eCardErr_Ok = 0,
  eCardErr_TimeOut,
  eCardErr_CheckId_0,
  eCardErr_CheckId_1,
  eCardErr_CheckId_2,
  eCardErr_ReadCardNum,
  eCardErr_ReadRight,
  eCardErr_ReadValue,
  eCardErr_ReadStatus,
  eCardErr_ReadPostNum,
  eCardErr_MoneyLess,
  eCardErr_HadLocked,
  eCardErr_WritePostNum,
  eCardErr_WriteStatus,
  eCardErr_CardNumErr,
  eCardErr_ValueDec,
  eCardErr_CardNumDiffer,
  eCardErr_Error = 0xFF
}EnumCardError;

typedef struct
{
  u8 CardUid[6];//uid
  u8 CardNum[16];//
  u8 CardPwd[6];//
  u8 CardStatus;//״̬
//  EnumCardRight CardRight;//Ȩ
//  s32 CardMoney;//Ǯֵ
//  EnumCardStatus CardStatus;//״̬
//  u8 PillarNum[16];//׮
  s32 CardMoney;//Ǯֵ
}StructCardData;
typedef struct
{
  u32 MODPaintTick;
  u8  DCModType;
  u8  Auto_ID;
}StructDcModUpdate;


typedef struct
{
  u32 ErrorCode;
  UnionPillarError PillarErr;

}StructErrorDisplay;

extern StructLcdCtrl LcdCtrl;

extern StructCardData CardData;//ʹõĿϢ
extern StructChgRecd CurChgRecd;

extern StructReserveParam ReserveParam;

extern StructCardData CardData_B;//ʹõĿϢ
extern StructChgRecd CurChgRecd_B;

extern StructReserveParam ReserveParam_B;

extern StructChgRecd *pCurChgRecd_AB;

extern EnumLcdProcess GetLcdProcess(EnumLcdProcess LcdPro);

extern u8 CarNumVerify(u8 *pCarNum);
extern EnumCardError ReaderGetCard(StructCardData *pCarData);
extern EnumCardError ReaderLockCard(StructCardData *pCarData);
extern EnumCardError ReaderMoneyDec(StructChgRecd *pChgRecd);

extern u32 RtcGetTime(void);
extern void RtcSetTime(u32 TimeStamp);
extern void StampToTime(u32 TimeStamp, StructTime *pTimeBlock);
extern u32 TimeToStamp(StructTime *pTimeBlock);
extern u32 GetExtOrLcdStamp(StructTime *pTime);

#endif


